require "nusdas/nusroot"
require "nusdas/nuspath"

=begin
= module Nusdas

NuSDaS ƂʖgB

=end

module Nusdas

=begin
== O
=== NusDefNotFound
w肵 type ɑ΂`t@C݂ȂB
=end

    class NusDefNotFound < StandardError
    end

    class NusRecNotFound < StandardError
    end

=begin
== NX\bh
--- self::root_path (nn)
    0 ȏ 99 ȉ̐l ((|nn|)) ɑ΂ăiX_X[g
    pX𒲂ׂĕԂB
    ϐ ((*NUSDAS*))((|nn|)) ΂̒lA
    Ȃ΃JgfBNg̃fBNg ((*NUSDAS*))((|nn|))
    pB
=end

    def self::root_path(nn)
	nusdas_nn = sprintf('NUSDAS%02d', nn)
	if (e = ENV[nusdas_nn]) then
	    return e if File::directory?(e)
	end
	return nusdas_nn if File::directory?(nusdas_nn)
	nil
    end

=begin
--- self::each_root { |root| ... }
    0  99 ܂ŏԂ ((<Nusdas::NusRoot|URL:nusdas/nusroot.html>)) 
    \z yield B
=end

    def self::each_root
	0.upto 99 do |nn|
	    path = root_path(nn)
	    next if path.nil?
	    yield NusRoot.new(path)
	end
    end

=begin
--- self::find_root (type)
    f[^ ((|type|)) LiX_X[gԂB
    ݂Ȃ nil ԂB
=end

    def self::find_root(type)
	each_root do |root|
	    return root if root.has?(type)
	end
	return nil
    end

=begin
--- self::find_def (type)
    f[^ ((|type|)) L
    `t@C ((<Nusdas::NusDef|URL:nusdas/nusdef.html>))
    \zĕԂB
    `t@C݂Ȃꍇ NusDefNotFound 𓊂B
=end

    FIND_DEF = Hash::new

    def self::find_def(type)
	return FIND_DEF[type] if FIND_DEF[type]
	r = find_root(type)
	raise(NusDefNotFound, "type = #{type}") if r.nil?
	FIND_DEF[type] = r.find_def(type)
    end

=begin
--- self::each_def { |deffile| ... }
    ׂẴiX_X[ĝׂĂ
    `t@C ((<Nusdas::NusDef|URL:nusdas/nusdef.html>))
    \z yield B
=end

    def self::each_def
	each_root do |root|
	    root.each_def do |deffile|
		yield deffile
	    end
	end
    end

=begin
--- self::read path
    pXŎw肳ꂽʃf[^ǂݎ
=end

    def self::read path
        if NusPath === path
 	    np = path
        else
	    np = NusPath::new(path)
	end
	r = find_def(np.nustype).find_rec(np)
        raise(NusRecNotFound, "#{path} not found") if r.nil?
	r.payload.payload
    end

=begin
--- self::read_a path
    pXŎw肳ꂽʃf[^ǂݎāANArray \ẑԂB
    LbVB
=end

    ARR = Hash::new

    def self::read_a(path)
	key = path.to_s
	return ARR[key] if ARR[key]
	ARR[key] = self::read(path).array
    end

=begin
--- self::meta path
    pXŎw肳ꂽʃf[^Ɋւtǂݎ
    ()
=end

=begin
--- self::plel_to_dgrb (plane, elem)
    NuSDaS ̖ ((|plane|)) Ɨvf ((|elem|)) A
    iʕ񎮂 [ʂ̌`AʁAvf] ȂzĕԂB
=end

    def self::plel_to_dgrb(plane, elem)
	e = Elem[elem]
	return nil if e.nil?
	levStyle = e['DGRB-LEV']
	if (levStyle.nil?) then
	    levStyle = 100
	    levStyle = 1 if (plane == 'SURF' || plane == 'ECTOP')
	end
	if (levStyle == 100 || levStyle == 170)
	    if (plane == 'sea') then
		lev = 0
            elsif (plane == 'TROPO') then
                levStyle = 7
                lev = 0
            elsif (plane == 'MXWIND') then
                levStyle = 6
                lev = 0
            elsif (plane == 'CBTOP') then
                levStyle = 3
                lev = 0
	    elsif (plane[0, 1] == 'F') then
		lev = Fl[plane]
	    else
		lev = plane.to_i
		if (lev.to_s != plane)
		    return nil
		end
	    end
	else
	    lev = 0
	end
	return e['DGRB'], levStyle, lev
    end

    Elem = Hash::new
    Elem['PSEA'] = { 'DGRB' => 1, 'DGRB-LEV' => 102 }
    Elem['P'] = { 'DGRB' => 1 }
    Elem['TRPP'] = { 'DGRB' => 1  ,'DGRB-LEV' => 7 }
    Elem['T'] = { 'DGRB' => 4 }
    Elem['STDT'] = { 'DGRB' => 7 }
    Elem['TTD'] = { 'DGRB' => 11 }
    Elem['Q'] = { 'DGRB' => 12 }
    Elem['RH'] = { 'DGRB' => 13 }
    Elem['STDPS'] = { 'DGRB' => 16 }
    Elem['WindD'] = { 'DGRB' => 20 }
    Elem['WindS'] = { 'DGRB' => 21 }
    Elem['U'] = { 'DGRB' => 23 }
    Elem['V'] = { 'DGRB' => 24 }
    Elem['PSI'] = { 'DGRB' => 29 }
    Elem['VOR'] = { 'DGRB' => 30 }
    Elem['DIV'] = { 'DGRB' => 34 }
    Elem['CHI'] = { 'DGRB' => 39 }
    Elem['OMG'] = { 'DGRB' => 42 }
    Elem['TPW'] = { 'DGRB' => 47 }
    Elem['RRC'] = { 'DGRB' => 48 }
    Elem['RAIN'] = { 'DGRB' => 50 }
    Elem['SnowD'] = { 'DGRB' => 51 }
    Elem['RRL'] = { 'DGRB' => 55 }
    Elem['SST'] = { 'DGRB' => 61 }
    Elem['Z'] = { 'DGRB' => 102 }
    Elem['STDZ'] = { 'DGRB' => 105 }
    Elem['CLA'] = { 'DGRB' => 150 }
    Elem['RR3'] = { 'DGRB' => 201 }
    Elem['RR60LV'] = { 'DGRB' => 202 }
    Elem['HIGHLV'] = { 'DGRB' => 203 }
    Elem['POP6'] = { 'DGRB' => 215 }
    Elem['MRR6'] = { 'DGRB' => 216 }
    Elem['ROCA'] = { 'DGRB' => 219 }
    Elem['MRR3'] = { 'DGRB' => 222 }
    Elem['CLH'] = { 'DGRB' => 225 }
    Elem['WCAT'] = { 'DGRB' => 229 }
    Elem['TANKLV'] = { 'DGRB' => 234, 'DGRB-LEV' => 170 }
    Elem['TURB'] = { 'DGRB' => 236 }
    Elem['CSIG'] = { 'DGRB' => 237 }
    Elem['PI10LV'] = { 'DGRB' => 253, 'DGRB-LEV' => 1 }
    Elem['ORDER'] = { 'DGRB' => 254, 'DGRB-LEV' => 170 }

    Fl = Hash::new
    Fl['F010'] = 977 
    Fl['F030'] = 908 
    Fl['F050'] = 843 
    Fl['F070'] = 782
    Fl['F090'] = 724
    Fl['F110'] = 670 
    Fl['F130'] = 619 
    Fl['F150'] = 572 
    Fl['F170'] = 527 
    Fl['F190'] = 485
    Fl['F210'] = 446 
    Fl['F230'] = 410 
    Fl['F250'] = 376 
    Fl['F270'] = 344 
    Fl['F290'] = 315
    Fl['F310'] = 287 
    Fl['F330'] = 262 
    Fl['F350'] = 238 
    Fl['F370'] = 217 
    Fl['F390'] = 197
    Fl['F410'] = 179 
    Fl['F430'] = 162 
    Fl['F450'] = 147 
    Fl['F470'] = 134 
    Fl['F490'] = 122
    Fl['F510'] = 110 
    Fl['F530'] = 100 
    Fl['F550'] = 91 
    Fl['F570'] = 83 
    Fl['F590'] = 75 

end

NuSDaS = Nusdas
# $Id: nusdas.rb,v 1.23 2003/02/10 10:57:30 suuchi39 Exp $
