=begin
= class Nusdas::NusDecode

DATA L^ GPV 𓾂邽߂̃fR[hB
=end

module Nusdas
class NusDecode

    begin
        require 'narray'
	NARRAY = true
    rescue LoadError
	NARRAY = false
    end

=begin
== NX\bh
--- self::new nx, ny, pack, miss, payload
    f[^L^̊iq̑傫 ((|nx|)), ((|ny|)),
    k@ ((|pack|)), l\@ ((|miss|)),
    k+f[^ ((|payload|)) pč\zB
=end

    def initialize nx, ny, pack, miss, payload
	@nx, @ny, @pack, @miss, @payload = nx, ny, pack, miss, payload
    end

=begin
== CX^X\bh
=== \z
--- nx
    ꎟ̊iq
--- ny
    񎟌̊iq
--- pack
    k@
--- miss
    l̕\@
--- payload
    kꂽ񂻂̂
=end

    attr_reader :nx, :ny, :pack, :miss, :payload

=begin
=== lɊւ͌
=end

=begin
--- miss_offset
    ((<miss>))  ((<payload>)) ̌lɊւ闓̃oCg߂B
=end

    def miss_offset
	case @miss
	when 'NONE' then 0
	# elemwidth q
	when 'UDVF' then elemwidth()
	when 'MASK' then @payload.unpack('N').first
	else raise
	end
    end

=begin
--- pbody
    ((<payload>))  ((<miss_offset>)) oCg菜́B
    ̐擪͈kłB
=end

    def pbody 
	@payload[miss_offset .. -1]
    end

=begin
=== kɊւ͌
--- elemwidth
    kꂽ1vfoCg
--- pack_offset
    ((<pack>))  ((<payload>)) ̈kɊւoCg߂B
--- body
    ((<payload>))  ((<miss_offset>))  ((<pack_offset>)) ̍v
    擪̃oCg菜́B
    ͔z񂻂̂̂łB
=end

    def elemwidth;  PACKINFO[@pack][0];  end
    def pack_offset;  PACKINFO[@pack][2];  end

    def body 
	ofs = miss_offset + pack_offset
	@payload[ofs .. -1]
    end

=begin
--- unpack_nt
    ŏ ((<body>)) fR[h邽߂ɗp NArray ^CvR[hB
    cOȂANArray ɂ 16bit, 32bit ̕ȂȂ̂ŁA
    dȂɕtŕ\邱ƂɂȂ̂ɒӁB
--- sgnfix_nt
    킹邽߂ɗp NArray ^CvR[hB
    킹svȏꍇ nil
--- sgnfix_ofs
    킹ɕlɉZItZbg
--- scale_nt
    XP[ϊ邽߂ɗp NArray ^CvR[hB
    ϊȂĂ悢ꍇ nil ԂB
=end

    def unpack_nt;  NAINFO[ PACKINFO[@pack][1] ]; end
    def sgnfix_ofs;  2 ** (elemwidth * 8);  end

    def sgnfix_nt
	abstype = PACKINFO[@pack][3]
	return nil if abstype.nil?
	NAINFO[abstype]
    end

    def scale_nt
	abstype = PACKINFO[@pack][4]
	return nil if abstype.nil?
	NAINFO[abstype]
    end

=begin
--- ary_raw (typecode = nil)
    ((|body|))  ((<unpack_nt>)) ^ (((|nx|)), ((|ny|))) 
    NArray zɕϊB
    ̂BXP[ῗĂȂB
    * ((|typecode|)) w肵ꍇ͂̌^ɕϊB
      sK؂Ȍ^łɕϊ̂ŒӁB
    * oO: RLE k̏ꍇ ArgumentError ɂȂB̑ΏKv
=end

    def ary_raw (typecode = nil)
	if typecode.nil? then
	    NArray::to_na(body, unpack_nt, @nx, @ny).ntoh
	else
	    a = NArray::to_na(body, unpack_nt, @nx, @ny).ntoh
	    b = NArray::new(typecode, @nx, @ny)
	    b[] = a
	    b
	end
    end

=begin
--- ary_sgnfix (typecode = nil)
    ((<ary_raw>)) ƓA̕𐳂B
    * ̓Iɂ ((<pack>))  '2UPC', '4UPC' ̏ꍇłA܂NȂB
    * ((|typecode|))  NArray::FLOAT ̏ꍇ FLOAT ^vB
      łȂ '2UPC' ̏ꍇ SFLOAT ^vB
    * ϊsvȏꍇ ((<ary_raw>))  ((|typecode|)) 
      ̂܂ܓ`B
=end

    def ary_sgnfix (typecode = nil)
	if (nt = sgnfix_nt).nil? then
	    return ary_raw(typecode)
	end
	nt = NArray::FLOAT if (typecode == NArray::FLOAT)
	b = ary_raw(nt)
	c = NArray::new(nt, @nx, @ny)
	c[] = b < 0
	b + c * sgnfix_ofs
    end

=begin
--- packinfo
    XP[k̏ꍇ͍ŒlƃXP[ȂzԂB
    Ak̏ꍇ̓rbgAkőlA̐ȂzԂB
    łȂꍇ nil ԂB
=end

    def packinfo
	case @pack
	when '1PAC', '2PAC', '2UPC'
	    pbody.unpack('g2')
	when '4PAC', '4UPC'
	    pbody.unpack('G2')
	when 'RLEN'
	    pbody.unpack('N3')
	else
	    nil
	end
    end

=begin
--- ary_scale (typecode = nil)
    ((<ary_sgnfix>)) ƓB
    AXP[ksĂAWJB
    * ̏ꍇAI FLOAT B
      ItZbgƒPxł͌N邱ƂB
    * ((<pack>))  'N1I2' ̏ꍇ SFLOAT  0.1 {B
       ((|typecode|))  FLOAT ̏ꍇ FLOAT ƂBB
    * XP[svȏꍇ ((<ary_raw>))  ((|typecode|)) 
      ̂܂ܓ`B
=end

    def ary_scale (typecode = nil)
	if not (snt = scale_nt).nil? then
	    base, amp = packinfo
	    a = ary_sgnfix(NArray::FLOAT) * amp
	    a + base
	elsif @pack == 'N1I2'
	    snt = (typecode == NArray::FLOAT) ? NArray::FLOAT : NArray::SFLOAT
	    ary_sgnfix(snt) * 0.1
	else
	    ary_sgnfix(typecode)
	end
    end

=begin
--- array (typecode = nil)
    ((<ary_scale>)) ƓBA((|typecode|)) ɂϊ
    IɍsB
=end

    def array (typecode = nil)
	a = ary_scale(typecode)
        if (typecode.nil? or a.typecode == typecode) then
	    a
	else
	    b = NArray::new(typecode, @nx, @ny)
	    b[] = a
	    b
	end
    end

=begin
== 萔
--- PACKINFO
    ʏĝł͂ȂBk`KvȏɊւ𓾂\B
--- NAINFO
    ʏĝł͂ȂB
    PACKINFO ̒ۓIȌ^ NArray  ^R[h𓾂\B
    ̗̕LĂ̂ňʖړIɂ͕sKB
=end

    PACKINFO = {
	#  elemwidth unpack	packofs	signfix	scalefix
	'1PAC' => [1, 'byte',	8,	nil,	'sfloat'],
	'2PAC' => [2, 'sint',	8,	nil,	'sfloat'],
	'2UPC' => [2, 'usint',	8,	'sfloat', 'sfloat'],
	'4PAC' => [4, 'lint',	8,	nil,	'float'],
	'4UPC' => [4, 'ulint',	8,	'float', 'sfloat'],
	'I1  ' => [1, 'byte',	0],
	'I2  ' => [2, 'sint',	0],
	'N1I2' => [2, 'sint',	0,	nil,	'sfloat'],
	'I4  ' => [4, 'lint',	0],
	'R4  ' => [4, 'sfloat',	0],
	'R8  ' => [8, 'float',	0],
	'RLEN' => [1, 'byte',	12]
    }

    NAINFO = {
	'byte'		=> NArray::BYTE,
	'sint'		=> NArray::SINT,
	'usint'		=> NArray::SINT,
	'lint'		=> NArray::LINT,
	'ulint'		=> NArray::LINT,
	'sfloat'	=> NArray::SFLOAT,
	'float'		=> NArray::FLOAT
    }

end
end
# $Id: nusdecode.rb,v 1.3 2002/08/01 10:38:27 suuchi43 Exp $
