require "nusdas/nusrecstream"

=begin
= class Nusdas::NusFile
((<NusRecStream|URL:nusrecstream.html>)) pĂB
=end

module Nusdas

class NusFile < NusRecStream

=begin
== ̗O
--- Nusdas::NusFile::FmtError < StandardError
=end

    class FmtError < StandardError
    end

=begin
== NX\bh
--- self::new (filename, mode = "r", perm = 0666)
    ʎĝł͂ȂB
    P NuSDaS t@CJB
    File::open ƓlA؂̃R[hǂ܂ȂB
=end

    def initialize (filename, mode = "r", perm = 0666)
	super
	@filename = @nusd = @cntl = @indx = nil
	self
    end

    def setup filename, nusd, cntl, indx
	@filename, @nusd, @cntl, @indx = filename, nusd, cntl, indx
    end

=begin
--- self::open (filename)
    t@CJANUSD, CNTL, INDX R[hǂŃZbgAbvB
=end

    def self::open(filename)
	r = self::new(filename)
	begin
	    nusd = r.get_record
	    fail FmtError, 'NUSD not found' if nusd === nil
	end until nusd.record_type == 'NUSD'
	begin
	    cntl = r.get_record
	    fail FmtError, 'CNTL not found' if cntl === nil
	end until cntl.record_type == 'CNTL'
	begin
	    indx = r.get_record
	    fail FmtError, 'INDX not found' if indx === nil
	end until indx.record_type == 'INDX'
        r.setup(filename, nusd, cntl, indx)
	return r
    end

=begin
== CX^X\bh
=end

=begin
=== ǗR[h
--- nustype
--- basetime
--- member
--- validtime1
--- validtime2
--- n_member
--- n_valid
--- n_plane
--- n_element
=end

    def nustype; @cntl.record.nustype; end
    def basetime; @cntl.record.basetime; end
    def member; @cntl.record.member; end
    def validtime1; @cntl.record.validtime1; end
    def validtime2; @cntl.record.validtime2; end
    def validtime; @cntl.record.validtime; end
    def plane; @cntl.record.plane; end
    def element; @cntl.record.element; end
    def n_member; @cntl.record.n_member; end
    def n_valid; @cntl.record.n_valid; end
    def n_plane; @cntl.record.n_plane; end
    def n_element; @cntl.record.n_element; end

=begin
=== ̑
--- read_record (im, iv, ip, ie)
    oԍ im, \񎞊Ԕԍ iv, ʔԍ ip, vfԍ ie
    Ŏw肳郌R[h֒ڃV[NēǂݎB
=end

    def read_record(im, iu, ip, ie)
	im = member.index im if im.is_a? String
	raise "member not found" if im.nil?
	iu = validtime.index iu if iu.is_a? NWPL::NwpTime
	raise "validtime not found" if iu.nil?
	ip = plane.index ip if ip.is_a? String
	raise "plane not found" if ip.nil?
	ie = element.index ie if ie.is_a? String
	raise "element not found" if ie.nil?
	ofs = ((im * n_valid + iu) * n_plane + ip) * n_element + ie
	ofs = @indx.record.value[ofs]
	# L^R[hɂ͂Ȃ 0  -1  
	return nil if ofs == 0xffffffff or ofs == 0
	seek(ofs, IO::SEEK_SET)
	get_record
    end

=begin
--- each_index { |im, iv, ip, ie| ... }
    oԍ im, \񎞊Ԕԍ iv, ʔԍ ip, vfԍ ie
    ̂肤lׂĂɂāAINDX R[h𒲂ׂĒlĂ
    Ƃ yield B
=end

    def each_index
	v = @indx.record.value
	v.each_index { |i|
	    next if v[i] == 0xffffffff or v[i] == 0
	    im = i
	    ie = im % n_element;  im /= n_element
	    ip = im % n_plane;  im /= n_plane
	    iv = im % n_valid;  im /= n_valid
	    yield  im, iv, ip, ie
	}
    end

=begin
--- list (nuspath)
    ((<Nusdas::NusPath|URL:nuspath.html>)) ((|nuspath|)) 
    w肳鉽炩̎ɂĈꗗ쐬B
    ʂ String ̔złB
=end

    def list_member(longp)
	mlist = []
	each_index { |im, iv, ip, ie| mlist << im }
	(@cntl.record.member.indices(*mlist.uniq)).collect {|m|
	    if (/^\s*$/.match m) then "none" else m end
	}
    end

    def list_validtime(nuspath, longp)
	im_given = @cntl.record.member.index nuspath.member
	vlist = []
	each_index { |im, iv, ip, ie|
	    next unless im == im_given
	    vlist << iv
	}
	@cntl.record.validtime.indices(*vlist.uniq)
    end

    def list_plane(nuspath, longp)
	im_given = @cntl.record.member.index nuspath.member
	iv_given = @cntl.record.validtime.index nuspath.validtime
	plist = []
	each_index { |im, iv, ip, ie|
	    next unless im == im_given
	    next unless iv == iv_given
	    plist << ip
	}
	@cntl.record.plane.indices(*plist.uniq)
    end

    def list_element(nuspath, longp)
	im_given = @cntl.record.member.index nuspath.member
	iv_given = @cntl.record.validtime.index nuspath.validtime
	ip_given = @cntl.record.plane.index nuspath.plane
	elist = []
	each_index { |im, iv, ip, ie|
	    next unless im == im_given
            next unless iv == iv_given
            next unless ip == ip_given
	    elist << ie
	}
	@cntl.record.element.indices(*elist.uniq)
    end

    def list (nuspath, longp)
	return list_member(longp) if nuspath.member.nil?
	return list_validtime(nuspath, longp) if nuspath.validtime.nil?
	return list_plane(nuspath, longp) if nuspath.plane.nil?
	return list_element(nuspath, longp) if nuspath.element.nil?
	[]
    end

=begin
=== fobO
--- to_s
    fobOóB
--- self::debug
    R}hCŎw肳t@CJăfobOo͂B
=end

    def to_s
	return (<<EOF)
file=#{@filename}
nusd=#{@nusd.to_s}
cntl=#{@cntl.to_s}
  type=#{nustype} base=#{basetime}
  member=#{member.join('/')}
  valid1=#{validtime1.join('/')}
  valid2=#{validtime2.join('/')}
indx=#{@indx.to_s}
EOF
    end

    def self::debug
	f = open(ARGV[0])
	print f
	m = f.member
	u = f.validtime1
	v = f.validtime2
	nplane = f.n_plane
	nelem = f.n_element
	m.each_with_index do |member, im|
            u.each_with_index do |valid1, iu|
	        valid2 = v[iu]
	        print "#{im} #{iu} #{member} #{valid1} #{valid2}\n";
		for ip in 0 .. nplane - 1
		    for ie in 0 .. nelem - 1
			r = f.read_record(im, iu, ip, ie)
			next if r == nil
			print "#{r.payload}\n"
			fail FmtError if r.payload.member != member
			fail FmtError if r.payload.validtime1 != valid1
			fail FmtError if r.payload.validtime2 != valid2
		    end
		end
	    end
	end
    end

end

end
# $Id: nusfile.rb,v 1.13 2002/08/01 10:38:27 suuchi43 Exp $
