require "nusdas/nusdef"

=begin
= class Nusdas::NusRoot
=end

module Nusdas
class NusRoot

=begin
== NX\bh
--- self::new dirname
    fBNg ((|dirname|)) w肵č\zB
    ̂Ȃ (({nusdas_def})) ƂfBNgȂ΂ȂȂB
=end

    def initialize dirname
	@root = dirname
	@defdir = File.join(dirname, 'nusdas_def')
	fail Errno::ENOTDIR, "#{dirname}: 'nusdas_def' not found" \
	    unless File::directory? @defdir
    end

    def to_s; @root; end

=begin
== CX^X\bh
--- each_def { |deffile| ... }
    `t@CׂĂɂ ((<NusDef|URL:nusdef.html>)) 
    \z yield B
=end

    def each_def
	dir = Dir::new(@defdir)
	begin
	    dir.each do |file|
		next unless /\.def$/ =~ file
		yield NusDef::new(File.join(@defdir, file), @root)
	    end
        ensure
	    dir.close
        end
    end

=begin
--- deffile_list
    `t@CׂĂɂ ((<NusDef|URL:nusdef.html>)) 
    \zĔzɓĕԂB
=end

    def deffile_list
	dir = Dir::new(@defdir)
        list = Array::new
	begin
	    dir.each do |file|
		next unless /\.def$/ =~ file
		list.push NusDef::new(File.join(@defdir, file), @root)
	    end
        ensure
	    dir.close
        end
        return list
    end

=begin
--- find_def type
    w肵 ((|type|)) 
    `t@C ((<NusDef|URL:nusdef.html>)) ԂB
    ݂Ȃ nil
=end

    def find_def type
	d = deffile_list
	d.each do |deffile|
	    return deffile if deffile.nustype == type
	end
	nil
    end

=begin
--- has? type
    w肵 ((|type|)) 
    `t@C邩ۂ
=end

    def has? type
	d = deffile_list
	d.each do |deffile|
	    return true if deffile.nustype == type
	end
	false
    end

end
end
# $Id: nusroot.rb,v 1.7 2002/08/01 10:38:28 suuchi43 Exp $
