#!/usr/bin/ruby

=begin
= nusschema

LACTLTD `̃XL[}ĕԂB
=end

require "nusdas"

nustype = ARGV[0]
d = Nusdas::find_def(nustype)

#
# validtime unit
#
case d.vt_unit.upcase
when "MIN"
    vt_unit = 0
when "HOUR"
    vt_unit = 1
when "DAY"
    vt_unit = 2
else
    fail
end

#
# validtime style
#
if (d.vt2 == nil) then
    vtime_code = 1
    vt2list = ("-999 " * d.vt_size)
else
    vtime_code = 2
    vt2list = d.vt2
end

#
# element list
#
pe_list = Array::new
pl2 = d.pl2 || d.pl1
d.el.each do |e|
    (0 ... d.pl_size).each do |ip|
    	next unless e.allowed? ip
	dgElem, dgLevStyle, dgLev = Nusdas::plel_to_dgrb(d.pl1[ip], e.elname)
	next if dgElem.nil?
	pe_list.push("# element #{d.pl1[ip]}/#{pl2[ip]}/#{e}\n" \
	    + sprintf('%3d %3d %5d', dgElem, dgLevStyle, dgLev))
    end
end

print <<END_OF_HEREDOC
# lagpvctltd for type=#{nustype}
# (def at '#{d}')
# GPV type: 1 for int 8bit / 2 for float 32 bit / 3 for int 16 bit
2
# time unit = #{d.vt_unit}
#{vt_unit}
# validtime 2 spec = #{vtime_code == 2 ? "used" : "not-used"}
#{vtime_code}
# number of validtime
#{d.vt_size}
# list of validtime1
#{d.vt1.join(' ')}
# list of validtime2
#{vt2list}
# number of following level-element set
#{pe_list.size}
#{pe_list.join("\n")}
# data size: 32bit
4
# value type: 0 for unknown / 1 for "float" / 2 for "unsigned" / 3 for "int"
1
# EOF
END_OF_HEREDOC

exit 0
# $Id: nusschema.rb,v 1.10 2002/08/01 10:38:27 suuchi43 Exp $
