
module NWPL

    require 'rational'

=begin
== class NWPL::Base60
Z\iB
KvɂAA邢͓k̕𑮐ƂĎƂłB
--- self::new string
    Z\i񂩂琔l𓾂B
    󂯓l /^[+-]?(\d+:)*\d+(\.\d+)[NEWS]?$/i ł̂ŁA
    萔邢(ŵȂ)\gB
    W ܂ S uƕl E ܂ N ɕϊB
    ((|string|)) ɐl𓊓ƂȂׂϊB
    ł Rational gĂ̂ Float ꂽꍇ͕K
    Sł͂ȂAȂׂxb\ł̂悢l𐳊m
    \悤ƂB(60 ** -4 x̑Ό덷)
--- to_r
    IɎĂL (xP)B
--- to_f
    B
--- to_i
    B
--- dms
    Z\iWJ 3 ̐ɂB
    AłȂƂ͍ŏIvf Float ɂB
    Ōɕ\l̂ŁAs4vf̔z񂪕ԂB
--- to_s
    xb̕\L
--- dircode
    nil, "N" ܂ "E"
=end

    class Base60

	def self::float_hack string
	    p = 60 ** 4
	    Rational((string.to_f * p + 0.5).floor, p)
	end

	def initialize string, dircode = ""
	    raise(ArgumentError, "bad dircode #{dircode}") unless \
		/^[NEWS]?$/i.match dircode
	    case string
	    when Integer
		@to_r = string.to_r
		@dircode = dircode
		return
	    when Numeric
		@to_r = self.class.float_hack(string)
		@dircode = dircode
		return
	    end
	    str = string.dup
            raise(ArgumentError, string) unless \
		/^[-+]?(\d+:)*\d+(\.\d*)?[NEWS]?$/i.match str
	    # l̉
            str.sub!(/(\d+)(\.\d*)?([NEWS]?)$/i, "")
	    @dircode = $3
	    if $2.nil? then
		@to_r = $1.to_i.to_r
	    else
		@to_r = Rational((($1 + $2).to_f * 3600 + 0.5).floor, 3600)
	    end
            while str.sub!(/(\d+):$/, "")
		@to_r = $1.to_i + @to_r / 60
	    end
	    @to_r = -@to_r if (str == '-')
	    @dircode = dircode if @dircode.nil?
	ensure
	    # K
            case @dircode
	    when /[Ww]/
		@to_r = -@to_r
		@dircode = "E"
	    when /[Ss]/
		@to_r = -@to_r
		@dircode = "N"
	    when /[ne]/
		@dircode.upcase!
	    end
	end

        attr_reader(:dircode, :to_r)

	def to_i; @to_r.to_i; end
	def to_f; @to_r.to_f; end

	def dircode= val
	    raise ArgumentError unless /^[NE]?$/i.match val
	    @dircode = val.upcase 
	    self
	end

	def dms
	    r = @to_r
	    if (r < 0) then
		sign = -1
		r *= -1
	    else
		sign = 1
	    end
	    h = r.floor
	    r -= h
	    r *= 60
	    m = r.floor
	    r -= m
	    r *= 60
	    if (r.denominator == 1) then
		s = r.to_i
	    else
		s = r.to_f
	    end
	    [h, m, s, sign]
	end

	def to_s
	    h, m, s, sign = self.dms
	    format('%s%d:%02d:%s%s', (sign < 0 ? '-' : ''), h, m, s, @dircode)
	end

	def - other
	    case other
	    when self.class
		if @dircode.empty? then
		    d = other.dircode
		else
		    od = other.dircode
		    d = @dircode
		    raise "different direction" unless (od.empty? or d == od)
		end
		self.class.new(@to_r - other.to_r, d)
	    when Float
		self.class.new(to_f - other, @dircode)
	    when Numeric
		self.class.new(@to_r - other.to_r, @dircode)
	    else raise(TypeError, other.to_s)
	    end
	end

	def == other
	    (self - other).to_r == 0
	end

	def + other
	    case other
	    when self.class
		if @dircode.empty? then
		    d = other.dircode
		else
		    od = other.dircode
		    d = @dircode
		    raise "different direction" unless (od.empty? or d == od)
		end
		self.class.new(@to_r + other.to_r, d)
	    when Float
		self.class.new(to_f + other, @dircode)
	    when Numeric
		self.class.new(@to_r + other.to_r, @dircode)
	    else raise(TypeError, other.to_s)
	    end
	end

	def has_dir?
	    not @dircode.empty?
	end

	def * other
	    case other
	    when Float
		self.class.new(to_f * other, @dircode)
	    when Numeric
		self.class.new(@to_r * other.to_r, @dircode)
	    when self.class
		raise ArgumentError if self.has_dir? and other.has_dir?
		self.class.new(@to_r * other.to_r, @dircode + other.dircode)
	    else raise(TypeError, other.to_s)
	    end
	end

	def / other
	    case other
	    when Float
		self.class.new(to_f / other, @dircode)
	    when Numeric
		self.class.new(@to_r / other.to_r, @dircode)
	    when self.class
		raise ArgumentError if self.has_dir? and other.has_dir?
		self.class.new(@to_r / other.to_r, @dircode + other.dircode)
	    else raise(TypeError, other.to_s)
	    end
	end

	def coerce other
	    [self.class.new(other), self]
	end

    end

