=begin
= iqn̓ɊւNXQ
* ((<class NWPL::Angle>))
* ((<class NWPL::LonLat>))
* ((<class NWPL::Projection>))
* ((<class NWPL::GridSystem>))
* ((<class NWPL::GridSlice>))

gƂ require 'nwpl/gridsystem' ƂB
NWPL::Base60 ̓[hȂƂɂȂB
=end

module NWPL

=begin
== class NWPL::Angle
Z\iB
KvɂAA邢͓k̕𑮐ƂĎƂłB
--- self::new string, dir = 0
    Z\i񂠂邢͐l (fVbpPʂƂ݂Ȃ) ((|string|)) 
    l\zB
    ̏ꍇA󂯓l
    /^[+-]?(\d+:)*\d+(\.\d+)[NEWS]?$/i ł̂ŁA
    萔邢(ŵȂ)\gB
    W ܂ S uƕl E ܂ N ɕϊB
     ((|dir|))  ((|string|)) ̖Ȃ
    ((|string|)) l̏ꍇɎgpA?N ܂ ?E ̐lB
--- self::deg n, dir = 0
    \zAxpPʁB
--- self::min n, dir = 0
    \zApPʁB
--- to_i
    BfVbpPʁB
--- to_f
    Ato_i.to_f łB
--- deg
    xpPʂ̎B
--- dms
    Z\iWJčŌɕ\lA
    s4vf̐̔z񂪕ԂB
--- to_s
    xb̕\L
--- dir
    0 (ʖ`), ?N (k), ?E () łB
--- dircode
    nil, "N" ܂ "E"
=end

    class Angle

	def initialize val, dir = 0
	    if val.is_a? Numeric
		@to_i = val.to_i
		@dir = dir
		return
	    elsif val.is_a? self.class
		@to_i, @dir = val.to_i, val.dir
	    else
		raise(ArgumentError, val.inspect) unless \
		 /^([-+]?)(\d*)(:(\d+)(:(\d+))?)?(\.\d+)?([NEWS]?)$/i.match val
		#  1      2    3 4    5 6        7       8
		# l̉
		sign = $1
		d = $2.to_i
		m = $4.to_i
		s = $6.to_i
		if $7 then
		    if $6 then
			s += $7.to_f
		    elsif $4 then
			m += $7.to_f
		    else
			d += $7.to_f
		    end
		end
		@dir = $8[0].to_i
		@to_i = Integer((s + 60 * (m + 60 * d)) * 10)  
		@to_i = -@to_i if sign == "-"
	    end
	    # ftHg
	    if @dir.zero?
	       @dir = dir.to_i
	    end
	    # K
            case @dir
	    when ?W, ?w
		@to_i = -@to_i
		@dir = ?E
	    when ?S, ?s
		@to_i = -@to_i
		@dir = ?N
	    when ?n
		@dir = ?N
	    when ?e
		@dir = ?E
	    when ?N, ?E, 0
	    else
		raise "bad dir = #{@dir}"
	    end
	end

	def self::deg(val, dir = 0)
	    if val.is_a? Numeric then
	    	self::new(val * 36_000, dir)
	    else
	    	self::new(val, dir)
	    end
	end

	def self::min(val, dir = 0)
	    if val.is_a? Numeric then
	    	self::new(val * 600, dir)
	    else
	    	self::new(val, dir)
	    end
	end

        attr_reader(:dir, :to_i)

	def to_f; @to_i.to_f; end
	def dircode; @dir.zero? ? "" : @dir.chr; end

	def dir= val
            case @dir
	    when ?n, ?N
		@dir = ?N
	    when ?e, ?E
		@dir = ?E
	    end
	    self
	end

	def deg
	    @to_i / 36000.0
	end

	def dms
	    h = @to_i
	    if (h < 0) then
		sign = -1
		h *= -1
	    else
		sign = 1
	    end
	    if (h % 10).zero?
		s = (h % 600) / 10
	    else
		s = h % 600 / 10.0
	    end
	    h /= 600
	    m = h % 60
	    h /= 60
	    [h, m, s, sign]
	end

	def to_s
	    h, m, s, sign = self.dms
	    format('%s%d:%02d:%s%s', (sign < 0 ? '-' : ''), h, m, s, dircode)
	end

	def - other
	    case other
	    when Float
		self.class.new(to_f - other, @dir)
	    when Numeric, self.class
		self.class.new(@to_i - other.to_i, @dir)
	    else raise(TypeError, other.to_s)
	    end
	end

	def == other
	    to_i == other.to_i
	end

	def + other
	    case other
	    when Float
		self.class.new(to_f + other, @dir)
	    when Numeric, self.class
		self.class.new(@to_i + other.to_i, @dir)
	    else raise(TypeError, other.to_s)
	    end
	end

	def has_dir?
	    @dir != 0
	end

	def * other
	    case other
	    when Numeric then self.class.new(@to_i * other, @dir)
	    else raise(TypeError, other.to_s)
	    end
	end

	def / other
	    case other
	    when Integer then self.class.new(@to_i / other.to_i, @dir)
	    when Numeric then self.class.new(@to_i / other.to_f, @dir)
	    when self.class 
		self.class.new(@to_i / other.to_i, @dir + other.dir)
	    else raise(TypeError, other.to_s)
	    end
	end

    end

=begin
== class NWPL::LonLat
oܓxɂn_𓯒肷邽߂̂́B
=end

    class LonLat

=begin
--- self::new lon, lat
    ((|lon|)), ((|lat|)) ͓xPʂ̐lA"30.0N", "140:30:25.9N" ̂悤ɁA
    (x)܂̓R؂(xEEb̕)
     E, N, W, S (ȗ) ́B
=end

        def initialize lon, lat
	    @lon = Angle::deg(lon, ?E)
	    @lat = Angle::deg(lat, ?N)
	    @lat, @lon = @lon, @lat if @lat.dir == ?E && @lon.dir == ?N
	    raise 'lat is longitude' if @lat.dir == ?E
	    raise 'lon is latitude' if @lon.dir == ?N
        end
	attr_accessor(:lon, :lat)

=begin
--- self == other
    ʒuƂēꍇ^ɂȂB
=end

	def == other
	    (self - other) == [0, 0]
	end

=begin
--- to_a
    oxAܓxȂzB
--- to_s
    "(140.0E, 30.0N)" ̂悤ɕ񉻂
=end

	def to_a;  [@lon.deg, @lat.deg];  end
        def to_s;  "(#{@lon}, #{@lat})";  end

=begin
--- self - other
    oܓx̍2vf̔zŕԂB
=end

	def - other
	    raise ArgumentError unless other.is_a? LonLat
	    [@lon.to_i - other.lon.to_i, @lat.to_i - other.lat.to_i]
	end

    end

=begin
== class NWPL::Projection
e@̓s߂̂́B
=end

    class Projection

=begin
--- self::new pjcode, params = nil
    e@\ ((|pjcode|)) ƕWoܐ ((|params|)) 
    (NWPL::LonLat ̔z񂪊҂) 瓊e@𓯒肷
    \zB
    ̃NXł͓e@̂͒PɕƂĕێ邾ł邪A
    NuSDaS \ɂȂ̂ ArgumentError ƂȂB
=end
=begin RT
pjcode, Ӗ, params ̗pr
LL, ܓxox,	gpȂ
LM, xgp~,	
PS, |[[XeI,	
GS, KEXiq,	
MR, Jg,	
YP, ܓx-C,	
XP, ox-C,	
FG, free grid,	
OL, Ύxgp~,	
RD, [_[,	
ST, Xe[V,	
XX, s,	
=end

	def initialize pjcode, params = []
	    @pjcode, @params = pjcode, params
	    raise(ArgumentError, "unknown projection #{pjcode}") \
		unless /^(LL|LM|PS|GS|MR|YP|XP|FG|OL|RD|ST|XX)$/.match pjcode
	end
	attr_reader(:pjcode, :params)

=begin
--- direct?
    esȂꍇAȂ킿AܓxoxW̏ꍇɐ^ƂȂB
=end

        def direct?;  @pjcode == 'LL';  end

=begin
--- self == other
    Kv񂪂ׂēƂ^ƂȂB
=end

	def == other
	    return false unless other.is_a? Projection
	    (self.pjcode == other.pjcode and self.params == other.params)
	end

	def to_s
	    if (@params.empty?) then
	        "proj(#{@pjcode})"
	    else
		"proj(#{@pjcode}, #{@params.join(', ')})"
	    end
	end

    end

=begin
== class NWPL::GridSystem
iqԍňoܓx𓾂邽߂ɕKvȊiqzuǗB
=end


    class GridSystem

=begin
--- self::new proj, basepoint, ofs, gridsize
    e@ ((|proj|)) ɂĒn_ ((|basepoint|)) (((<class NWPL::LonLat>)))
    e_iqԍ ((|ofs|)) (l2̔z) Ƃ
    iqԊu ((|gridsize|)) (l2̔z) ̊iqn\zB
    iqԊu proj.direct? ̎͌oܓxƉ߂AłȂꍇ
    Ɖ߂B
=end

        def initialize proj, basepoint, ofs, gridsize
	    @proj = proj
	    raise ArgumentError unless proj.is_a? Projection
	    @basepoint = basepoint
	    raise ArgumentError unless basepoint.is_a? LonLat
	    @ofs = ofs
	    (0..1).each {|i| raise ArgumentError unless @ofs[i].is_a? Numeric }
	    if @proj.direct? then
	        @gridsize = [NWPL::Angle::deg(gridsize[0], ?E), 
		     NWPL::Angle::deg(gridsize[1], ?N)]
	    else
	        @gridsize = gridsize.collect { |dx| dx.to_f }
	    end
	end
	attr_reader(:proj, :ofs, :gridsize, :basepoint)

=begin
--- dup
    basepoint, ofs  ((<canon!>)) ɔ dup B
=end

        def dup2
	    @basepoint = @basepoint.dup
	    @ofs = @ofs.dup
	    self
	end

	def dup
	    super.dup2
	end

=begin
--- slide! (other)
    self >>= other ̔jI
--- self >> other
    n_ ((|other|)) iqB   
    ofs l other ̕Ɣ΂ɓB
    basepoint l邩邩 gridsize ̕ɂB
    proj.direct? łȂꍇ͗O𓊂B
--- canon!
--- canon
    iqԊuoܓx̏ꍇ 0 <= ofs[((|i|))] < 1 (((|i|)) = 0, 1)
    ƂȂ悤ɐKsB
=end

        def slide! other
	    if @proj.direct? then
		x, y = other
		@ofs[0] -= x
		@ofs[1] -= y
		@basepoint.lon -= x * @gridsize[0]
		@basepoint.lat -= y * @gridsize[1]
	        self
	    else
		raise "slide is not allowed"
	    end
	end

	def >> other;  dup.slide!(other);  end
	def << other;  dup.slide!([-other[0], -other[1]]);  end

	def mod
	    [(@basepoint.lon.to_f / @gridsize[0]).to_i,
	     (@basepoint.lat.to_f / @gridsize[1]).to_i]
	end

        def canon!
	    if @proj.direct? then
		x, y = mod
		@ofs[0] -= x
		@ofs[1] -= y
		@basepoint.lon -= @gridsize[0] * x
		@basepoint.lat -= @gridsize[1] * y
	    end
	    self
	end

	def canon;  dup.canon!;  end

=begin
--- self == other
    ܂: KsƂőSp^vꍇ^ԂB
=end

	def == other
	    return false unless other.is_a? GridSystem
	    return false unless self.proj == other.proj
	    cs = self.canon
	    co = other.canon
	    (cs.gridsize == co.gridsize &&
	     cs.basepoint == co.basepoint &&
	     cs.ofs == co.ofs)
	end

=begin
--- self === other
    Vtg: A
    canon  gridsize  basepoint A
    Ȃ ofs ̍ɂȂĂꍇ^
=end

        def === other
	    return false unless other.is_a? GridSystem
	    return false if (self.proj != other.proj)
	    return false if (self.gridsize != other.gridsize)
	    cs = self.canon
	    co = other.canon
	    return false unless (cs.basepoint - co.basepoint == [0, 0])
	    fs = cs.ofs
	    fo = co.ofs
	    [(fs[0] - fo[0]) % 1.0, (fs[1] - fo[1]) % 1.0] == [0, 0] 
	end

=begin
--- add_ofs!(other)
    self += other ̔jI
--- self + other
    ofs l ((|other|)) ₷B((|other|)) ͐l2̔zB
    Ɠn_ViqnŎw߂̊iqԍ
    ((|other|)) ̐B
    덷 (self + other).canon  self.canon + other Ƃ͓B
=end

	def add_ofs! other
	    iofs, jofs = other
	    @ofs[0] += iofs
	    @ofs[1] += jofs
	    self
	end

	def + other
	    dup.add_ofs!(other)
	end

=begin
--- self * other
    gridsize  ((|other|)) {B
    ((|other|)) ͐l2̔złB
    (self * other).canon  self.canon * other Ƃ͌ʂقȂB
=end

	def * other
	    ifac, jfac = other
            newgridsize = [@gridsize[0] * ifac, @gridsize[1] * jfac]
	    self.class::new(@proj, @basepoint, @ofs, newgridsize)
	end

=begin
--- self / other
    iqԊuZB
    ((|other|)) ͐l(܂Angle)2̔z񂩁AGridSystem.
    O҂ GridSystem ԂA҂͐l2̔zԂB
=end

	def / other
	    if other.is_a? Array then
		idiv, jdiv = other
		newgridsize = [@gridsize[0] / idiv, @gridsize[1] / jdiv]
		self.class::new(@proj, @basepoint, @ofs, newgridsize)
	    elsif other.is_a? self.class
		ogs = other.gridsize
		[@gridsize[0] / ogs[0], @gridsize[1] / ogs[1]]
	    else
		raise TypeError
	    end
	end

=begin
--- self - other
    ofs ̍Ƃē 2 vf̔zԂB
    B + (A - B)  A ƂȂ悤Ɍ߂ĂB
    ((|self|)) === ((|other|)) Ȃꍇ͗O𓊂B
=end

	def - other
	    raise TypeError unless other.is_a? GridSystem
	    raise ArgumentError if (self.proj != other.proj)
	    raise ArgumentError if (self.gridsize != other.gridsize)
	    cs = self.canon
	    co = other.canon
	    raise ArgumentError unless (cs.basepoint - co.basepoint == [0, 0])
	    fs = cs.ofs
	    fo = co.ofs
	    [fs[0] - fo[0], fs[1] - fo[1]] 
	end

=begin
--- ij2lonlat(i, j)
    Yiqnɂ (((|i|)), ((|j|))) Ԋiq̌oܓx𓾂B
    ݂̂ƂoܓxWłȂB
=end

        def ij2lonlat(i, j)
	    raise "LL expected" unless @proj.direct?
	    lon = @basepoint.lon + @gridsize[0] * (i - @ofs[0])
	    lat = @basepoint.lat + @gridsize[1] * (j - @ofs[1])
 	    LonLat::new(lon, lat)
        end

=begin
--- lonlat2ij lonlat
    ^ꂽʒu (((<class NWPL::LonLat>)) IuWFNg) 
    Yiqnɂiqԍ𐮐2̔zŕԂB
    ݂̂ƂoܓxWłȂB
=end

        def lonlat2ij(ll)
	    raise "LL expected" unless @proj.direct?
	    i = (ll.lon - @basepoint.lon) / @gridsize[0] + @ofs[0]
	    j = (ll.lat - @basepoint.lat) / @gridsize[1] + @ofs[1]
 	    [i.to_i, j.to_i]
        end

	def to_s
	    "GridSystem(#{proj}, dx=[" +
	    @gridsize[0].to_s + ", " + 
	    @gridsize[1].to_s + "], " + 
	    "ofs=#{ofs.inspect}, base=#{basepoint})"
	end

    end

=begin
== class NWPL::GridSlice
錈܂iqn ((<class NWPL::GridSystem>)) ̏ł
肳ꂽiq͈ (iqԊuł̊Ԉ) ǗB
=end

    class GridSlice

=begin
--- self::new gridsystem, start, count, stride
    iqn ((|gridsystem|)) (((<class NWPL::GridSystem>))) 
    iqԍl ((|start|)),
    iq ((|count|)),
    iqԊu ((|stride|)) gč\zB
    ((|start|)), ((|count|)), ((|stride|)) ͐2̔zB
    iqłȂŏIiqԍ^Ă
    ((|count|)) vẐʓ|ȏꍇ͂Ƃ肠
    ((|count|))  nil ɂĂāA
     ((<finish=>)) Őݒ肷邱ƂłB
=end

	def initialize gridsystem, start, count = nil, stride = [1, 1]
	    ae = ArgumentError
	    @gridsystem = gridsystem
	    raise ae unless @gridsystem.is_a? GridSystem
	    @start, @count, @stride = start, count, stride
	    raise ae unless @start.is_a? Array and @start.size == 2
	    raise ae unless (@count.is_a? Array and @count.size == 2 or \
		@count.nil?)
	    raise ae unless @stride.is_a? Array and @stride.size == 2
	end
	attr_reader(:gridsystem, :start, :count, :stride)

	def finish
	    [@start[0] + @count[0] * @stride[0],
	     @start[1] + @count[1] * @stride[1]]
	end

	def finish= val
	     @count = [(val[0] - @start[0]) / @stride[0] + 1,
		(val[1] - @start[1]) / @stride[1] + 1]
	end

	def params;  @start + @count + @stride;  end

=begin
--- params
    start + count + stride ƓB
--- self == other
    ܂B
=end

	def == other
	    return false unless other.is_a? GridSlice
	    return false unless self.gridsystem == other.gridsystem
	    return self.params == other.params
	end

        def to_s
	    "GridSlice(#{@gridsystem}, start=#{start.join(',')}, " \
		+ "count=#{count.join(',')}, stride=#{stride.join(',')})"
	end

=begin
--- dup
    iqn dup B
=end

	def dup2;  @gridsystem = @gridsystem.dup;  self;  end
	def dup;  super.dup2;  end

=begin
--- canon!
--- canon
    iqn𐳋KB
    K͊iqԍƒn_̊֌Wς̂ł͂Ȃ̂ŁA
    ((|start|)), ((|count|)), ((|stride|)) ̒l͕ωȂB
=end

        def canon!
	    @gridsystem.canon!
	    self
	end

	def canon;  dup.canon!;  end

    end

end
