=begin
= ԃCu nwpl/nwptime
p邽߂ɂ require 'nwpl/nwptime' ƂꂽB
=end

module NWPL

=begin
== class NWPL::NwpTimeSpan
ԊԊu\NXB
NwpTime gĉZs߂ɎgB
=end

class NwpTimeSpan

    def initialize (factor, units = "MIN")
	@min = @mon = 0
	case factor
	when Array
	    @min, @mon = factor
	    return
	end
	case units
	when 'MIN', 'MINUTE'
	    @min = factor
	when 'HOUR'
	    @min = factor * 60
	when 'DAY'
	    @min = factor * 60 * 24
	when 'WEEK'
	    @min = factor * 60 * 24 * 7
	when 'MON', 'MONTH'
	    @mon = 1
	else
	    raise NwpTime::FmtError, "Bad time units #{units}"
	end
    end

    MIN = NwpTimeSpan::new([1, 0])
    HOUR = NwpTimeSpan::new([60, 0])
    DAY = NwpTimeSpan::new([1440, 0])
    MON = NwpTimeSpan::new([0, 1])

    attr_reader :min, :mon

    def to_s
        if @mon.zero? and @min % 1440 == 0
  	    "#{@min / 1440} DAY"
        elsif @mon.zero? and @min % 60 == 0
  	    "#{@min / 60} HOUR"
        elsif @mon.zero? then
  	    "#{@min} MIN"
        elsif @min.zero? then
  	    "#{@mon} MON"
	else
	    "(#{@min} MIN + #{@mon} MON)"
	end
    end

    def * other
        # other = other.to_i if other.is_a? String and /^\d+$/.match other
        self.class.new([@min * other, @mon * other])
    rescue TypeError => e
	if other.is_a? String and /^\d+$/.match other then
	    STDERR.print "Warning #{$0}: (other=#{other.inspect})\n\t",
		e.backtrace.join("\n\t"), "\n" if $DEBUG
	    other = other.to_i
	    retry
	end
	raise e
    end

    def / other
        self.class.new([@min / other, @mon / other])
    rescue TypeError => e
	if other.is_a? String and /^\d+$/.match other then
	    STDERR.print "Warning #{$0}: (other=#{other.inspect})\n\t",
		e.backtrace.join("\n\t"), "\n" if $DEBUG
	    other = other.to_i
	    retry
	end
	raise e
    end

    def -@
        self.class.new([-@min, -@mon])
    end

    def + other
	case other
	when NwpTimeSpan
	    self.class.new([@min + other.min, @mon + other.mon])
	when NwpTime
	    other + self
	when Numeric
	    self.class.new([@min + other, @mon])
	end
    end

    def - other
	case other
	when NwpTimeSpan
	    self.class.new([@min - other.min, @mon - other.mon])
	when NwpTime
	    other + -self
	when Numeric
	    self.class.new([@min - other, @mon])
	end
    end

end

class NwpTime

=begin
== class NWPL::NwpTime
l\pB
Comparable CN[hĂB
== ŋN肤O
FmtError  StandardError ̌p
=end

    class FmtError < StandardError
    end

    include Comparable

=begin
=== 萔
--- UNDEF
    閧 Integer lŁA\zɕs莞\߂ɗpB
=end

    UNDEF = 1
    UNIX_ERA = 88_885_440

=begin
=== NX\bh
--- new time, quiet = false
    ɉēK؂Ȏ\zB
    * Time IuWFNgȂ΂̂܂ܕϊ
    * Numeric IuWFNgȂ 1801N1100 (? vmF)
      ̒ʎZƂ݂Ȃ to_i Ǝ
    * String IuWFNgȂ ISO `Ƃ݂ȂĎB
      ܂sȂꍇ FmtError 𓊂B
       quiet ^ɂꍇ͓ȒlԂ;
       oob? ɂmFłB
    * ȊǑ^̏ꍇ TypeError
=end

    def initialize arg, quiet = false
        case arg
	when Time
	    @min = arg.tv_sec / 60 + UNIX_ERA
	when Numeric
	    @min = arg.to_i
	when String
	    if (m = /^(\d+)-(\d+)-(\d+)[-Tt](\d\d)(\d*)/.match(arg)) then
		t = Time::utc(m[1], m[2], m[3], m[4], m[5])
		@min = t.tv_sec / 60 + UNIX_ERA
	    elsif (m = /^(\d+)-(\d+)-(\d+)[-Tt](\d)/.match(arg)) then
		t = Time::utc(m[1], m[2], m[3], m[4])
		@min = t.tv_sec / 60 + UNIX_ERA
	    elsif (m = /^(\d+)-(\d+)-(\d+)[-Tt](\d+):(\d+)/.match(arg)) then
		t = Time::utc(m[1], m[2], m[3], m[4], m[5])
		@min = t.tv_sec / 60 + UNIX_ERA
	    elsif (m = /^(\d+)-(\d+)-(\d+)/.match(arg)) then
		t = Time::utc(m[1], m[2], m[3])
		@min = t.tv_sec / 60 + UNIX_ERA
	    elsif (m = /^min(\d+)/.match(arg)) then
		@min = m[1].to_i
            else
		if quiet then
		    @min = nil
		    return
		end
		fail FmtError, "malformatted time #{arg}"
	    end
	else
	    raise(TypeError, arg.inspect)
	end
    end

=begin
--- self::gettime (timecard = 'TIMECARD')
    t@C timecard ̐l\^CJ[hJA
    ǂ݂Ƃ NwpTime \zB
    Ƃ肠 Time::utc oRŎĂ̂ŁA܂̂▢͈ȂB
=end

    def self::gettime(timecard = 'TIMECARD')
	fp = File::open(timecard, "r")
	a = fp.readline.strip.split(/\s+/)
	fp.close
	self::new(Time::utc(*a))
    end

=begin
=== CX^X\bh
--- to_i
    ʎZԂ
--- undef?
    UNDEF l̏ꍇ^
--- unix
    UNIX ̒ʎZbԂB\łȂ͈͂ł̓I[o[t[B
--- time
    unix  Time IuWFNgĕԂB
=end

    def to_i; @min.to_i; end

    def undef?; @min.nil? or @min == UNDEF; end

    def oob?; @min.nil?; end

    def unix; (@min - UNIX_ERA) * 60; end

    def time; Time::at((@min - UNIX_ERA) * 60).utc; end

=begin
--- year
--- mon
--- mday
--- wday
--- hour
--- min
    Time NXƓl̈ӖB
    ƂA܂̂Ƃ Time oRĎĂ̂ŁA
    ͈̔͂łȂB
=end

    def year;  unix.year;  end
    def mon;  unix.mon;  end
    def mday;  unix.mday;  end
    def wday;  unix.wday;  end
    def hour;  unix.hour;  end
    def min;  unix.min;  end

=begin
--- to_s
    pandora W̏ (ISO) sB܂̂ƂAtime \bh
    IɎgpĂ̂ŁAUNIX \łȂ͈͂̎ɂĂ
    ONB
=end

    def to_s
	return sprintf('min%d', @min) if @min < 10
	time.strftime '%Y-%m-%dt%H%M'
    end

=begin
--- narrow
    NuSDaS Iɗpt@Ĉ߂̏sB
=end

    def narrow
	time.strftime '%Y%m%d%H%M'
    end

=begin
--- time <=> other
    召rsB
    Comparable ɂAEsEbetween? g悤ɂȂB
=end

    def <=> (other)
	case other
	when Time
	    return unix <=> other
	when Numeric
	    return @min
	when NwpTime
	    return @min <=> other.to_i
	else
	    fail "NwpTime <=> #{other.type} (#{other.inspect})"
	end
    end

=begin
--- time - other
    ̌ZsB
    NwpTime ɕϊ^ NwpTimeSpan ԂB
    NwpTimeSpan  NwpTime ԂB
    Numeric  NwpTimeSpan::new(((|other|))) ̂ƓB
--- time + other
    ̉ZsB
    ʂɒĂ͌ZƓlB
=end

    def - (other)
        case other
        when Time, String
	     NwpTimeSpan::new(self.to_i - NwpTime::new(other).to_i)    
        when NwpTime
	     NwpTimeSpan::new(self.to_i - other.to_i)    
        when Numeric
	     NwpTime::new(self.to_i - other)    
        when NwpTimeSpan
	     raise if not other.mon.zero?
	     NwpTime::new(self.to_i - other.min) 
	else
	     raise ArgumentError, other.inspect
        end
    end

    def + (other)
        case other
        when Time, String
	     NwpTimeSpan::new(self.to_i + NwpTime::new(other).to_i)    
        when Numeric
	     NwpTime::new(self.to_i + other)    
        when NwpTimeSpan
	     raise if not other.mon.zero?
	     NwpTime::new(self.to_i + other.min) 
	else
	     raise ArgumentError, other.inspect
        end
    end

=begin
=== foOpNX\bh
--- self::debug
    R}hCׂĂɂāANwpTime \z to_s  p B
=end

    def self::debug
	ARGV.each do |arg|
	    p NwpTime::new(arg).to_s
	end
    end

end

end
# $Id: nwptime-rb.rb,v 1.3 2002/09/10 01:29:07 suuchi43 Exp $
