
require 'nwplraw.so'

print <<EOF
--- test 1: round trip test String -> NwpTime -> String
EOF

def check_round(year, mon)
	s1 = format("%04d-%02d-01t0000", year, mon)
	nt = NWPL::NwpTime::new(s1)
	s2 = nt.to_s
	return if s1 == s2
	raise "mismatch #{s1} -> #{nt.to_i} -> #{s2}\n"
end

def check_round3(year, mon, day)
	s1 = format("%04d-%02d-%02dt0000", year, mon, day)
	nt = NWPL::NwpTime::new(s1)
	s2 = nt.to_s
	return if s1 == s2
	raise "mismatch #{s1} -> #{nt.to_i} -> #{s2}\n"
end

1.upto(24) do |day|
	check_round3(5884, 1, day)
end
31.downto(9) do |day|
	check_round3(-2283, 12, day)
end

-2282.upto(5883) do |year|
	1.upto(12) do |mon|
		check_round(year, mon)
	end
end
check_round(5884, 1)
begin check_round3(5884, 1, 25); rescue => e; print "expected " + e; end
begin check_round3(-2283, 12, 8); rescue => e; print "expected " + e; end
