require 'nwplraw.so'

print <<EOF
--- test 2: month length test
EOF

def check_monlen(year, mon)
	year2 = year
	mon2 = mon + 1
	if mon2 > 12
		year2 += 1
		mon2 -= 12
	end
	s1 = format("%04d-%02d-01t0000", year, mon)
	s2 = format("%04d-%02d-01t0000", year2, mon2)
	n1 = NWPL::NwpTime::new(s1)
	n2 = NWPL::NwpTime::new(s2)
	dt = n2 - n1
	di = n2.to_i - n1.to_i
	raise "#{n1}: dt=#{dt} != di=#{di}\n" if dt.min != di
	case mon
	when 2
	    if (year % 400 == 0) then
		raise "#{n1} must have 29 years" if di != 29 * 1440
	    elsif (year % 100 == 0) then
		raise "#{n1} must have 28 years" if di != 28 * 1440
	    elsif (year % 4 == 0) then
		raise "#{n1} must have 29 years" if di != 29 * 1440
	    else
		raise "#{n1} must have 28 years" if di != 28 * 1440
	    end
	when 4, 6, 9, 11
		raise "#{n1} must have 30 years" if di != 30 * 1440
	else
		raise "#{n1} must have 31 years" if di != 31 * 1440
	end
end

-2282.upto(5883) do |year|
	p year if year % 100 == 0
	1.upto(12) do |mon|
		check_monlen(year, mon)
	end
end
