class ElementMap

  class SlicedBitMap

    def initialize i, j, arr = nil
      @i = i
      @j = j
      a = Array::new
      (0..(i - 1)).each{ a.push(Array::new(j, "1")) }
      @value = a
      self.arr_val_set(arr) unless arr.nil?
    end
    attr_reader(:value)

    def value= arr
      return nil if arr.nil? || arr[0].nil? || arr.size != @i ||
	arr[0][0].nil? || arr[0].size != @j
      (0..(@i - 1 )).each {|ii|
	(0..(@j - 1)).each {|jj|
	  @value[ii][jj] = arr[ii][jj]
	}
      }
      @value
    end
    alias arr_val_set value=

    def valset i, j, val
      @value[i][j] = val
    end

  end

  class ElementBitMap

    def initialize n_member, n_vt, n_pl, stmt = nil
      unless stmt.nil?
	elclass = stmt.shift.to_i
	fail("unimplemented elementmap class = #{elclass}") unless
	  [ 0, 1, 2, 3 ].include? elclass
	@value = elmap_tenkai(3, elclass, [n_member, n_vt, n_pl], stmt)
      end
    end
    attr_accessor(:value)
    
    def elmap_tenkai depth, elclass, arg, stmt
      n = arg.shift
      if (depth == 1)
	(elclass == 0) ? Array::new(n, "1") : stmt.slice!(0, n)
      else
	arr = Array::new(n)
	i = 0
	while i < n
	  count = (elclass == depth)? stmt.shift.to_i : n
	  nelc = (elclass == 3) && (depth == 3) ? stmt.shift.to_i : elclass
	  arr.fill(elmap_tenkai(depth - 1, nelc, arg.flatten, stmt), i, count)
	  i += count
	end
	arr
      end
    end
    private :elmap_tenkai
    
  end

  def same_as? element
    return false if element.nil?
    return false if element.elname != @elname
    return false if (modified = element.modified).size != @modified.size
    modified.each_index{|i|
      return false if modified[i] != @modified[i]
    }
    return false if 
      element.n_member != @n_member ||
      element.n_vt     != @n_vt     ||
      element.n_pl     != @n_pl
    (0..(@n_member - 1)).each {|im|
      (0..(@n_vt - 1)).each {|iv|
	(0..(@n_pl - 1)).each {|il|
	  return false if element.elmap[im][iv][il] != @elmap[im][iv][il]
	}
      }
    }
    return true
  end
  
  def initialize nusdef, m_n = nil, vt_n = nil, pl_n = nil
    @nusdef = nusdef
    @elname = ""
    @n_vt = @n_pl = 1
    @n_member = 1
    @elmap = [[["1"]]]
    @modified = Array::new
    self.n_member = m_n  unless m_n.nil?
    self.n_vt     = vt_n unless vt_n.nil?
    self.n_pl     = pl_n unless pl_n.nil?
    @modified.fill(false)
    @size = 1
  end
  attr_accessor(:elname, :modified, :elmap, :size)
  attr_reader(:n_member, :n_vt, :n_pl)
  alias modified? modified

  def slice_member_at im
#    SlicedBitMap::new(@n_vt, @n_pl, @elmap[im]).value
    a = Array::new
    @elmap[im].each_index {|iv|
      a.push @elmap[im][iv]
    }
    a
  end

  def slice_valid_at iv
    a = Array::new
    @elmap.each_index {|im|
      a.push @elmap[im][iv]
    }
    a
  end

  def slice_plane_at ip
    a = Array::new
    @elmap.each_index {|im|
      pl = Array::new
      @elmap[im].each_index {|iv|
	pl.push @elmap[im][iv][ip]
      }
      a.push pl
    }
    a
  end

  def delete_member_at im
    @elmap.delete_at(im)
    @modified.delete_at(im)
    @n_member -= 1
  end

  def delete_valid_at del_iv
    e = ElementMap::new(@nusdef, @n_member, @n_vt - 1, @n_pl).elmap
    e.each_index{|im|
      e[im].each_index{|iv|
	v_idx = (iv < del_iv) ? iv : iv + 1
	e[im][iv].each_index{|ip|
	  e[im][iv][ip] = @elmap[im][v_idx][ip]
	}
      }
    }
    @elmap = e
    @n_vt -= 1
  end

  def delete_plane_at del_ip
    e = ElementMap::new(@nusdef, @n_member, @n_vt, @n_pl - 1).elmap
    e.each_index{|im|
      e[im].each_index{|iv|
	e[im][iv].each_index{|ip|
	  p_idx = (ip < del_ip) ? ip : ip + 1
	  e[im][iv][ip] = @elmap[im][iv][p_idx]
	}
      }
    }
    @elmap = e
    @n_pl -= 1
  end

  def push_member sliced
    e = ElementMap::new(@nusdef, @n_member + 1, @n_vt, @n_pl).elmap
    e.each_index{|im|
      e[im].each_index{|iv|
	e[im][iv].each_index{|ip|
	  e[im][iv][ip] = (im < @n_member)? @elmap[im][iv][ip] : sliced[iv][ip]
	}
      }
    }
    @elmap = e
    @modified[@n_member] = true
    @n_member += 1
  end

  def push_valid sliced
    e = ElementMap::new(@nusdef, @n_member, @n_vt + 1, @n_pl).elmap
    e.each_index{|im|
      e[im].each_index{|iv|
	e[im][iv].each_index{|ip|
	  e[im][iv][ip] = (iv < @n_vt)? @elmap[im][iv][ip] : sliced[im][ip]
	}
      }
    }
    @elmap = e
    @n_vt += 1
  end

  def push_plane sliced
    e = ElementMap::new(@nusdef, @n_member, @n_vt, @n_pl + 1).elmap
    e.each_index{|im|
      e[im].each_index{|iv|
	e[im][iv].each_index{|ip|
	  e[im][iv][ip] = (ip < @n_pl)? @elmap[im][iv][ip] : sliced[im][iv]
	}
      }
    }
    @elmap = e
    @n_pl += 1
  end

  def neworder axis, order
    em = ElementMap::new(@nusdef, @n_member, @n_vt, @n_pl)
    e = em.elmap
    e.each_index{|im|
      e[im].each_index{|iv|
	e[im][iv].each_index{|ip|
	  case axis
	  when "member"
	    val = @elmap[order[im]][iv][ip]
	    em.modified[im] = @modified[order[im]]
	  when "valid"
	    val = @elmap[im][order[iv]][ip]
	    em.modified[im] = @modified[im]
	  when "plane"
	    val = @elmap[im][iv][order[ip]]
	    em.modified[im] = @modified[im]
	  end
	  e[im][iv][ip] = val
	}
      }
    }
    @elmap = e
    @modified = em.modified
  end

  def fill_member_at sliced, member_i
    a = Array::new
    (0..(@n_member - 1)).each {|im|
      a[im] = (im == member_i) ? sliced : @elmap[im]
    }
    @elmap = a
    @modified[member_i] = true
  end

  def n_member= nm
    return nil if @elmap.nil? || nm == @n_member
    @elmap = @elmap[0..(nm - 1)]
    (@n_member..(nm - 1)).each {|im|
      a = Array::new
      (0..(@n_vt - 1)).each { a.push(Array::new(@n_pl, "1")) }
      @elmap << a
      @modified[im] = nil
    }
    @n_member = nm
  end

  def n_vt= nv
    return nil if @elmap.nil? || nv == @n_vt
    @elmap.each_index{|im|
      @elmap[im] = @elmap[im][0..(nv - 1)]
      (@n_vt..(nv - 1)).each{ @elmap[im] << @elmap[im][@n_vt - 1].flatten }
      @modified[im] = nil if nv > @n_vt
    }
    @n_vt = nv
  end

  def n_pl= np
    return nil if @elmap.nil? || np == @n_pl
    @elmap.each_index{|im|
      @elmap[im].each_index{|iv|
	@elmap[im][iv] = @elmap[im][iv][0..(np - 1)]
	(@n_pl..(np - 1)).each{ @elmap[im][iv] << @elmap[im][iv][@n_pl - 1] }
      }
      @modified[im] = nil if np > @n_pl
    }
    @n_pl = np
  end

  def decode stmt
    @n_member = @nusdef.cell("member", "n_dc").value.to_i
    @n_vt     = @nusdef.cell("validtime", "n_vt").value.to_i
    @n_pl     = @nusdef.cell("plane", "n_lv").value.to_i
    @elname   = stmt.shift
    @elmap    = ElementBitMap::new(@n_member, @n_vt, @n_pl, stmt).value
    (0..(@n_member - 1)).each {|i| 
      @modified[i] = false 
    }
  end

  def valid?
    nm = @nusdef.cell("member", "n_dc").value.to_i
    nv = @nusdef.cell("validtime", "n_vt").value.to_i
    np = @nusdef.cell("plane", "n_lv").value.to_i
    return @elname != "" && ! @modified.include?(nil) &&
      nm == @n_member && nv == @n_vt && np == @n_pl
  end

  def ip_allowed? ip
    @elmap.each { |elv|
      elv.each { |elp|
	return ture if elp[ip] == "1"
      }
    }
    return false
  end

  def ipiv_allowed? ip, iv = nil
    return ip_allowed?(ip) if iv.nil?
    @elmap.each { |elv|
      return true if evl[iv][ip] == "1"
    }
    return false
  end
  private (:ipiv_allowed?, :ip_allowed?)

  def allowed? (ip, iv = nil, im = nil)
    return ip_allowed?(ip) if iv.nil?
    return ipiv_allowed?(ip, iv) if im.nil?
    @elmap[im][iv][ip] == "1"
  end

  def elmap_compress header, valid
    valid_uniq = valid.uniq
    if valid_uniq.size == 1
      sprintf("%s%s", header[1], valid_uniq[0])
    else
      a = Array::new
      vu = valid[0]
      count = 0
      valid.each_index { |i|
	if vu == valid[i]
	  count += 1
	else
	  a.push sprintf("%3d  %s", count, vu)
	  count = 1
	  vu = valid[i]
	end
      }
      a.push sprintf("%3d  %s", count, vu)
      sprintf("%s%s", header[0], a.join("\n"))
    end
  end
  private :elmap_compress
  
  def to_s
    el_arr = Array::new
    @elmap.each do |m|
      valid = Array::new
      m.each { |v| valid.push v.join(" ") }
      el_arr.push valid
    end
    larr = Array::new
    el_str = elmap_compress(["3 ", ""],
		  el_arr.map { |el| elmap_compress(["2 ", "1      "], el) })
    el_str.each_line do |l|
      l.strip!
      l = "0" if (l =~ /^[ 1]+$/ && l =~ /^1      /)
      larr.push l
    end
    str = sprintf("\nelementmap  %-6s %s", @elname, larr[0])
    fmt = sprintf("\n                   %%%ds", larr[0].length)
    larr.each_index { |i|
      str += sprintf(fmt, larr[i]) if i > 0
    }
    str
  end

  def allowed_size
    num = 0
    (0..(@n_member - 1)).each {|im|
      (0..(@n_vt - 1)).each {|iv|
	(0..(@n_pl - 1)).each {|ip|
	  num += 1 if @elmap[im][iv][ip] == "1"
	}
      }
    }
    num
  end
      
end
