require "DynTbl"

class NusDef <DynTbl

=begin

= NusDef

NusDas `t@C̃NXB

== X[p[NX:

*((<DynTbl>))

=end

  require "ElemMap"

  class InOut_Unit

    InOutValid = [ "in", "out" ]
    UnitValid = [ "MIN", "HOUR", "DAY", "PEN", "MON", "WEEK", "JUN" ]

    def initialize arg
      arg.each { |a|
	@inout = a if InOutValid.include? (a.downcase)
	@unit  = a if UnitValid.include? (a.upcase)
      }
    end
    attr_accessor(:inout, :unit)

    def size
      return 2 if @inout && @unit
      return 0
    end

    def valid?
      return @inout && @unit
    end

    def to_s
      sprintf("%s %s", @inout, @unit)
    end

  end

  class SubCntl

    def initialize a
      @value = a
    end

    def value= val
	@value = val.strip.split
    end

    def size
      return @value.size
    end

    def valid?
      return @value[0] =~ /^.+$/ && @value[1] =~ /^\d+$/
    end

    def to_s
      @value.flatten.join " "
    end

  end

=begin

== NX\bh:

--- NusDef::new(filename, rootdir)
      VK NusDef 𐶐Ae`ڂƂ̏ƃftHglݒ肷B
      filename ^ꂽꍇAfilename ǂݍŃfR[hA
      ftHgl㏑B
=end
  def initialize filename = nil, rootdir = nil
    super()
    default
    nusdef_read(filename, rootdir) if filename
  end

=begin
== CX^X\bh:

--- NusDef#nusdef_read(filename, rootdir)
      rootdir/filename  NusDef ǂݍŃfR[hAݕێĂ
      l㏑B
=end

  def nusdef_read(filename, rootdir = nil)
    @deffile = filename
    @rootdir = rootdir
    fail Errno::ENOENT, "#{filename} not a file" unless File::file? filename
    a = Array::new
    begin
      input = open(filename, "r")
      input.each_line do |line|
	w = line.gsub(/#.*/, '').split
	next if /^\s*$/.match line
	if index?(w.first.downcase) then
	  a.push w
	elsif (a.size > 0) then
	  a[a.size - 1].concat w
	else
	  a.push w
	end
      end
    ensure
      input.close
    end
    a.each do |stmt|
      decode stmt
    end
  end
  attr_reader(:deffile)

  def decode stmt
    begin
      self.notify_mode = FALSE
      cn = (l = line(ln = stmt.shift)).cellnames.first
#      return nil if cn.nil? || cn.size == 0
      begin
	sz = (c = cell(ln, cn)).size
	sz = stmt.size if sz == 0 || (ln == 'memberlist' && cn == 'member')
	if (c.validform.class == Class)
	  case c.validform.name
	  when "NusDef::SubCntl"
	    a = Array::new
	    while sz > 0
	      a.push SubCntl::new(stmt.slice!(0, 2))
	      sz -= 2
	    end
	    c.value = a
	  when "NusDef::InOut_Unit"
	    c.value = InOut_Unit::new(stmt.slice!(0, 2))
	  when "ElementMap"
	    e = ElementMap::new(self)
	    map = Array::new
	    stmt.each do |word|
	      if word.downcase == "elementmap"
		next if map.empty?
		e.decode map
		c.value.push e
		e = ElementMap::new(self)
		map.clear
	      else
		map.push word
	      end
	    end
	    if map.size > 0
	      e.decode map
	      c.value.push e
	    end
	  end
	elsif c.value.is_a? Array
	  c.value = stmt.slice!(0, sz)
	else
	  c.value = (sz == 1) ? stmt.shift : stmt.slice!(0, sz)  
	end
	cn = l.nextcellname(cn)
      end until cn.nil? || stmt.empty?
    ensure
      self.notify_mode = TRUE
    end 
  end
  private :decode

  def vt_unit
    return cell("validtime", "in|out unit").value.unit
  end

  def vt2
    return line("validtime2").to_s
  end

  def default

    self.notify_mode = FALSE

    # --------------------------------------------------------
    l = store("nusdas")
    l.comment = <<-END
nusdas <version>

    NuSDaS ̃o[WԍLq܂B
    ȗꍇ 1.0 z肳܂B
    END
    l.comment_en = <<-END
nusdas <version>

    Version of NuSDaS. If not omitted, it must be "1.0".
    In future versions of NuSDaS, there may be incompatible extension to
    the definition file, and this version will describe what version
    of NuSDaS you are using.
    END
    l.omit = proc { cell("nusdas", "version").value == "1.0" }
    c = l.store("version")
    c.value = "1.0"
    c.validform = /^[0-9]\.[0-9]*$/

    # --------------------------------------------------------
    l = store("path")
    l.comment = <<-END
path ...

    NuSDaS [g̃fBNg\\w܂B
    ̓Iɂ͎̂悤ɂȂĂ܂B
    
    path relative_path template
    template ϐuʂfBNgƂ܂B
    ftHg "/_model/_attribute/_space/_time/_name" łB
    
    path nwp_path_s
    "path relative_path /_3d_name"  "filename _validtime" 
    w肷̂ƓłB
    
    path nwp_path_vm
    "path relative_path /_3d_name"  "filename _member" w肷̂
    łB
    
    path nwp_path_m
    "path relative_path /_3d_name/_member"  "filename _validtime" 
    w肷̂ƓłB
    
    path nwp_path_bs
    "path relative_path /_3d_name/_basetime"  "filename _validtime" 
    w肷̂ƓłB
    END

    l.comment_en = <<-END
path ...

  specifies the directory at which data files will be located.
  It is relative path from NRD.
  One of following syntax list is used for.

  path relative_path <template>
      The relative path will be <template>.
      See "Pathname Expansion" section of "NuSDas User's Guid" (file 
      "doc/nusdetail-en.html") for special symbols. By default this style is 
      assumed and "/_model/_attribute/_space/_time/_name" as <template>.

  path nwp_path_s
      Equivalent to statements "relative_path /_3d_name" and 
      "filename _validtime".

  path nwp_path_vm
      Equivalent to statements "path relative_path /_3d_name" and 
      "filename _member".

  path nwp_path_m
      Equivalent to statements "path relative_path /_3d_name/_member" and 
      "filename _validtime".

  path nwp_path_bs
      Equivalent to statements "path relative_path /_3d_name/_basetime" and 
      "filename _validtime".

  path nwp_esf
      In this special case, internal file I/O will be done through ES 
      interface, not by standard C library.

    END
    c = l.store("path_style")
    c.value = "nwp_path_m"
    c.validform = [ "relative_path", "nwp_path_s", "nwp_path_vm",
      "nwp_path_m", "nwp_path_bs", "nwp_esf" ]
    
    c = l.store("template")
    c.value = "a"
    c.validform = /.*/
    c.effective = proc{ cell("path", "path_style").value == "relative_path" }
    c.width = 36
    
    # --------------------------------------------------------
    l = store("filename")
    l.comment = <<-END
filename <filename>

    f[^t@C̖OA <filename> ϐûɂ܂B
    ftHgł "_basename" łB
    END
    l.comment_en = <<-END
filename <filename>

  Name of data file will be <filename>.
  See "Pathname Expansion" section of "NuSDas User's Guid" (file 
  "doc/nusdetail-en.html") for special symbols. 
  By default, "_basename" is assumed.
    END
    l.omit  = proc { cell("filename", "filename").value == "_basetime" }
    l.needed = proc { v = cell("path", "path_style").value
      v == "relative_path" || v == "nwp_esf"
    }
    c = l.store("filename")
    c.value = "_basetime"
    c.validform = /^[0-9A-Za-z_\-\.]+$/
    c.width = 24

    # --------------------------------------------------------
    l = store("creator")
    l.comment = <<-END
creator <creator>

    f[^Zbg̍쐬҂w܂B
    zXgE[Ut NUSD R[hɋL^܂B
    END
    l.comment_en = <<-END
creator <creator>

  Specifies information on creator of the data.
  It will written in NUSD record after prepending user name and host name.
    END
    c = l.store("creator")
    c.value = ""
    c.validform = /^.+$/
    c.width = 32
    
    # --------------------------------------------------------
    l = store("type1")
    l.comment = <<-END
type1 <_model> <_2d> <_3d>

    <_model> ͐l\\񃂃fʂ 4 ̖OA
    <_2d> ͓o͂̒PʂƂȂʂԂ̎ނw 2 ̖OA
    <_3d> ͖ʂʂW̎ނw 2 ̖OłB
    END
    l.comment_en = <<-END
type1 <_model> <_2d> <_3d>

  This statement cannot be omitted.
  Word <_model> is four name characters (alphabet, number, and underline)
  representing model name or creation process.
  Word <_2d> is two name characters representing horizontal grid name.
  Word <_3d> is two name characters representing vertical grid name.
  See Reference Manual (file "doc/nusref.html") for table of possible values.
    END
    l.needed = TRUE
    
    c = l.store("_model")
    c.value = "_GSM"
    c.validform = /^\w{4}$/
    
    c = l.store("_2d")
    c.value = "LM"
    c.validform = /^\w{2}$/
    
    c = l.store("_3d")
    c.value = "LY"
    c.validform = /^\w{2}$/

    # --------------------------------------------------------
    l = store("type2")
    l.comment = <<-END
type2 <_attribute> <_time>

    <_attribute> ͗\\ÁAϑȂǂ̃f[^̑\\ 2 ̖OA
    <_time> ͏uԒlAϒlANlȂǂ̎ԕ̑\\\\ 2 ̖OłB
    END
    l.comment_en = <<-END
type2 <_attribute> <_time>

  This statement cannot be omitted.
  Word <_attribute> is two name characters representing data attribute.
  Word <_time> is two name characters representing time attribute.
  See Reference Manual (file "doc/nusref.html") for table of possible values.
    END
    l.needed = TRUE
    
    c = l.store ("_attribute")
    c.value = "FC"
    c.validform = /^\w{2}$/
    
    c = l.store ("_time")
    c.value = "SV"
    c.validform = /^\w{2}$/

    # --------------------------------------------------------
    l = store("type3")
    l.comment = <<-END
type3 <_name>

    <_name>  4 ̔Cӂ̖OłB
    [`ł "STD1" WIɎgĂ܂B
    END
    l.comment_en = <<-END
type3 <_name>

  This statement cannot be omitted.
  Word <_name> is four name characters.
  You can use arbitrary name for this field;
  it does not affect behaviour of library nor conventional meaning.
  Name "STD1" is used for the most typical operational dataset.
    END
    l.needed = TRUE

    c = l.store("_name")
    c.value = "STD1"
    c.validform = /^\w{4}$/

    # --------------------------------------------------------
    l = store("member")
    l.comment = <<-END
member <n_dc> <in|out>

    <n_dc> ̓o̐w܂B
    3ꂪ "out" ̂ƂAõf[^͕ʁX̃t@CɊi[A 
    "in" ̂Ƃ͓t@CɊi[܂B
    END
    l.comment_en = <<-END
member <n_dc> <in|out>

  Word <n_dc> is number of members (1 assumed by default).
  When <in|out> is "in", records for different members are stored in one file, 
  and when <in|out> is "out", records for different members are stored in 
  separated files.
    END
    l.omit  = proc{ cell("memberlist", "member").value == [""] }

    c = l.store("n_dc")
    c.value = "1"
    c.validform = /^\d+$/
    c.chkproc = proc{|v| v.to_i > 0  }
    c.refresh_func = proc{|rewrite, refresh|
      if (rewrite == cell("memberlist", "member") && (v = rewrite.value))
	v.is_a?(Array) ? refresh.value = v.size : 1
      end
    }
    c.auto = TRUE
    
    c = l.store("in|out")
    c.value = "in"
    c.validform = ["in", "out"]
    c.nocase = TRUE

    # --------------------------------------------------------
    l = store("memberlist")
    l.comment = <<-END
memberlist <member> <member> ...

    o񋓂܂B
    END
    l.comment_en = <<-END
memberlist <member> <member> ...

  lists up members.
    END
    l.omit  = proc{ cell("memberlist", "member").value == [""] }
    l.needed = proc{
      cell("member", "n_dc").valid? &&
      cell("memberlist", "member").value != [""]
    }

    c = l.store("member")
    c.value = [""]
    c.validform = /^.*$/
    c.num     = proc{ cell("member", "n_dc").value.to_i }
    c.chkproc = proc{ |v| v.size > 0 }
    c.nocase = TRUE
    c.width = 48
  
    # --------------------------------------------------------
    l = store("basetime")
    l.comment = <<-END
basetime <YYYmmddHHMM>

    QƎw܂B
    <YYYYmmddHHMM> ̏ UNIX R}h date(1) p 
    "date '+%Y%m%d%H%M'" ƂƂƓlłB
    END
    l.comment_en = <<-END
basetime <YYYmmddHHMM>

  This statement is omitted in most cases. It specifies base time.
  Format of <YYYYmmddHHMM> is same as "%Y%m%d%H%M" in UNIX "date"(1) or 
  "strftime"(3).
    END

    c = l.store("YYYYmmddHHMM")
    c.value = ""
    c.validform = /^\d{12}$/

    # --------------------------------------------------------
    l = store("validtime")
    l.comment = <<-END
validtime <n_vt> <in|out> <unit>

    Ώێ̐ <n_vt> ƒP <unit> w܂B 
    <unit>  MIN, HOUR, DAY, PEN, MON, WEEK, JUN ̂ꂩ
    Ȃ΂Ȃ܂B 
    3ꂪ "out" ̂ƂAΏێ͕ʂ̃t@CɊi[A 
    "in" ̂ƂΏێ͓t@CɊi[܂B
    END
    l.comment_en = <<-END
validtime <n_vt> <in|out> <unit>

  This statement cannot be omitted.
  This specifies number of valid times <n_vt> and <unit>, units of validtime1
  statements.
  Word <unit> should be one of (min, hour, day, pen, mon, week, jun).
  When <in|out> is "in", records for different valid times are stored in 
  one file, and when <in|out> is "out", records for different valid times
  are stored in separated files.
    END
    l.needed = TRUE

    c = l.store("n_vt")
    c.value = 1
    c.validform = /^\d+$/
    c.refresh_func = 	proc{|rewrite, refresh|
      if (rewrite == cell("validtime1", "vt_list"))
	refresh.value = rewrite.value.size if rewrite.value
      elsif (rewrite == cell("validtime2", "vt_list"))
	v = rewrite.value
	refresh.value = v.size if (v && v[0] && v[0] > 0)
      end
    }
    c.auto = proc { cell("validtime1", "vt_style").value == "ALL_LIST" }
    
    c = l.store("in|out unit")
    c.value = InOut_Unit::new(["in", "HOUR"])
    c.validform = InOut_Unit
    
    # --------------------------------------------------------
    l = store("validtime1")
    l.comment = <<-END
validtime1 arithmetic <initial> <step>
܂
validtime1 all_list <vt_1> <vt_2> ... <vt_n_vt>

    ǂ炩̌`K{łB "arithmetic" ͗\\񎞊 (ΏێƎQƎ̍) 
     <initial>,  <step> ̓ł邱Ƃ܂B 
    "all_list"  ("validtime" Gg̑1JŎw肳ꂽ) <n_vt> 
    \\񎞊Ԃ̃Xg ɑƂ܂B
    END
    l.comment_en = <<-END
validtime1 arithmetic <initial> <step>
or
validtime1 all_list <vt1> <vt2> <vt3> ...

       This statement cannot be omitted. At least and just one of
       above two formes should appear. This statement specifies list
       of the first part of valid time, called valid1 in Reference
       Manual. When the second word is "arithmetic", the valid1 is an
       arithmetical series with specified <initial> and <step> value. 
       When the second word is "all_list", following words are interpreted 
       as list of valid times. Usually the list is written in ascending
       order. All of the arguments <initial>, <step>, <vt1>, ... are in
       units declared in previous "validtime" statement.
    END
    l.needed = TRUE

    c = l.store("vt_style")
    c.value = "ARITHMETIC"
    c.validform =  [ "ARITHMETIC", "ALL_LIST" ]
    c.nocase = TRUE
    
    c = l.store("initial-step")
    c.value = [0, 0]
    c.validform = /^-?\d+$/
    c.num = 2
    c.effective = proc{ cell("validtime1", "vt_style").value == "ARITHMETIC" }
    
    c = l.store("vt_list")
    c.value = []
    c.validform = /^-?\d+$/
    c.num = proc{ cell("validtime", "n_vt").value }
    c.effective = proc{ cell("validtime1", "vt_style").value == "ALL_LIST" }
    c.width = 32
    c.refresh_func = proc{|rewrite, refresh|
      v = rewrite.value
      if (rewrite == cell("validtime1", "vt_style") &&
	  v == "ALL_LIST" && refresh.value.size == 0)
	n = cell("validtime", "n_vt").value.to_i
	i_s = cell("validtime1", "initial-step").value
	unless (i_s.nil? || n.nil?)
	  initial = i_s[0].to_i
	  step = i_s[1].to_i
	  a = Array::new
	  (0..(n-1)).each {|i|
	    a.push((initial + i * step).to_s)
	  }
	  refresh.value = a
	end
      end
    }
  
    # --------------------------------------------------------
    l = store("validtime2")
    l.comment = <<-END
validtime2 <ft1> <ft2> <ft3> ...
܂
validtime2 <-dt>
    <n_vt> ̐̒l̃Xg <ft1> <ft2> <ft3> .. A 1 ̒̕l <-dt> 
    w肵܂B
    ̒l̏ꍇ <vt1> <vt2> <vt3> ... ɂꂼΉ鏇Ԃ value 
    ̂Ώێ2ƂȂ܂B 
    ̒l̏ꍇ <vt1> <vt2> <vt3> ... ɂꂼ <-dt> ̂
    Ώێ2ƂȂ܂B
    END
    l.comment_en = <<-END
validtime2 <ft1> <ft2> <ft3> ...
or
validtime2 <-dt>

       At least and just one of above two formes should appear. This
       statement specifies list of the second part of valid time,
       called valid2 in Reference Manual. When the former form is
       used, the list of valid2 will be (vt1 + ft1), (vt2 + ft2), (vt3
       + ft3), and so on. Usually the list is written in ascending
       order. When the latter form is used, the list of valid2 will be
       (vt1 + dt), (vt2 + dt), (vt3 + dt), and so on. All of the
       arguments dt, ft1, ft2, ... are in units declared in previous
       validtime statement. If this statement is omitted, the special
       value -1 is assumed as valid2.
    END

    c = l.store("vt_list")
    c.value = []
    c.validform = /^-?\d+$/
    c.num = proc{
      vl   = cell("validtime2", "vt_list").value
      n_vt = cell("validtime", "n_vt").value
      if (vl.nil? || vl[0].nil?)
	n_vt > 0 ? n_vt : nil
      else
	vl[0] < 0 ? 1 : n_vt
      end
    }
    c.width = 32

    # --------------------------------------------------------
    l = store("plane")
    l.comment = <<-END
plane <n_lv>

    ʂ̐w܂B
    END
    l.comment_en = <<-END
plane <n_lv>

    This statement cannot be omitted. Specifies the number of planes.
    END

    c = l.store("n_lv")
    c.value = ""
    c.validform = /^\d+$/
    c.refresh_func = proc{|rewrite, refresh|
      v = rewrite.value
      if (v && (rewrite == cell("plane1", "name") || 
		rewrite == cell("plane2", "name")))
	v.is_a?(Array) ? refresh.value = v.size : 1
      end
    }
    c.auto = TRUE

    # --------------------------------------------------------
    l = store("plane1")
    l.comment = <<-END
plane1 <name> <name> ...

    ʂ̖O <name>  <n_lv> 񋓂܂B
    END
    l.comment_en = <<-END
plane1 <name> <name> ...

    This statement cannot be omitted. Specifies the list of first plane. 
    The list should have <n_lv> items. Usually the list is written in 
    ascending order in height. It looks like descending order if pressure 
    coordinate is used, (e.g. SURF 1000 950 900 ...).
    END
    l.needed = proc {cell("plane", "n_lv").value.to_i > 0 }

    c = l.store("name")
    c.value = []
    c.validform = /^.+$/
    c.num = proc{ 
     proc{ |number| number > 0 && number == cell("plane", "n_lv").value.to_i }
    }
    c.width = 56

    # --------------------------------------------------------
    l = store("plane2")
    l.comment = <<-END
plane2 <name>, <name>, ...

    ʊԃf[^Ŏgp邽߂̑ʂ̖O <name>  <n_lv> 񋓂܂B 
    ȗ "plane1" ƓXgɂȂ܂B
    END
    l.comment_en = <<-END
plane2 <name>, <name>, ...

    Specifies the list of second plane. The list should have <n_lv> items. 
    If this statement is omitted, the same list to that in "plane1" is assumed.
    END

    c = l.store("name")
    c.value = []
    c.validform = /^.+$/
    c.num = proc{
      proc{ |number| number > 0 && number == cell("plane", "n_lv").value.to_i }
    }
    c.chkproc = proc{ |v| v.size == cell("plane", "n_lv").value.to_i }
    c.width = 56

    # --------------------------------------------------------
    l = store("element")
    l.comment = <<-END
element <n_el>
elementmap <elemname> <elementmap>
elementmap <elemname> <elementmap>
...

    vf̐ <n_el> сA<n_el>  elementmap Lq܂B
    "elementmap" ́Avf <elemname> ƗvfƂɋʁEΏێEʕ
    gݍ킹wrbg}bv <elementmap> Ȃ܂B
    END
    l.comment_en = <<-END
element <n_el>

    This statement cannot be omitted. Specifies the number of elements.


elementmap <elemname> <elementmap>
elementmap <elemname> <elementmap>
...

    This statement cannot be omitted, and will appear <n_el> times. 
    It describes where is the element <elemname> allowed to write. 
    See section "Elementmap" of "NuSDas User's Guid" (file 
    "doc/nusdetail-en.html") for detail.
    END
    l.needed = TRUE

    c = l.store("n_el")
    c.value = 0
    c.validform = /^\d+$/
    c.refresh_func = proc{|rewrite, refresh|
      if (rewrite == cell("element", "elementmap"))
	refresh.value = rewrite.size
      end
    }
    c.auto = TRUE

    c = l.store("elementmap")
    c.value = []
    c.validform = ElementMap
    c.num = proc{ cell("element", "elementmap").value.size }
    c.chkproc {|number|
      cell("element", "elementmap").each {|elem|
	elem.each{ |member| return false if elem.modified[member].nil? }
      }
      true
    }
    c.refresh_func = proc{|rewrite, refresh|
      if (rewrite == cell("member", "n_dc"))
	refresh.value.each {|elem| elem.n_member = rewrite.value.to_i }
      end
      if (rewrite == cell("validtime", "n_vt"))
	refresh.value.each {|elem| elem.n_vt = rewrite.value.to_i }
      end
      if (rewrite == cell("plane", "n_lv"))
	refresh.value.each {|elem| elem.n_pl = rewrite.value.to_i }
      end
    }
    
    # --------------------------------------------------------
    l = store("size")
    l.comment = <<-END
size <nx> <ny>

    ʂ̊iq(<nx>, <ny>) w܂B
    END
    l.comment_en = <<-END
size <nx> <ny>

    This statement cannot be omitted, It indicates that the number of 
    grid points is nx in X direction, and ny in Y direction. In most 
    cases X is taken eastward and Y northward, although that is dependent 
    to what coordinate system (<_2d> in "type1" statement) you use.
    END
    l.needed = TRUE

    c = l.store("nx-ny")
    c.num = 2
    c.value = [ 0, 0 ]
    c.validform = /^-?\d+(\.\d*)?$/
    c.width = 12

    # --------------------------------------------------------
    l = store("basepoint")
    l.comment = <<-END
basepoint <ix> <iy> <lon> <lat>

    _ (<ix>, <iy>) ̌oܓx (<lon>, <lat>) w܂Boܓx͐
    N, E, W, S ̂ꂩûłBʂʂłȂꍇɂ SUBC 
    R[h̋Lq𕹗p܂B
    END
    l.comment_en = <<-END
basepoint <ix> <iy> <lon> <lat>

    This statement indicates that the location of grid numbered (<ix>, <iy>) 
    is positioned (<lon>, <lat>). Both of <ix>, <iy> must be real number, 
    <lon> must be real number with 'E' or 'W' appended, <lat> must be real 
    number with 'N' or 'S' appended, Note that this statement is used with 
    the geographical meaning shown above even if the 2D grid is taken 
    vertically. In order to describe vertical grid point locations, 
    SUBC record might be used.
    END

    c = l.store("ix-iy")
    c.value = [ 0, 0 ]
    c.validform = /^-?\d+(\.\d*)?$/
    c.num = 2
    c.width = 12

    c = l.store("lon-lat")
    c.value = [ 0, 0 ]
    c.validform = /^-?\d+(\.\d*)?[NEWS]$/
    c.num = 2
    c.width = 12

    # --------------------------------------------------------
    l = store("distance")
    l.comment = <<-END
distance <dx> <dy>

    iqԊuw܂BʂoܓxԊuiqłꍇ͒Pʂ͓xA
    ȊO̊iqłꍇ͒n}㋗(m)BʂʂłȂꍇɂ́A
    <dx>  <dy> ̂ǂ炩܂B
    END
    l.comment_en = <<-END
distance <dx> <dy>

    Indicates horizontal grids. The units is degree when the grids is 
    latitude-longitude grids, and is meter when map projection is applied. 
    When the 2D grid is taken vertically, one of <dx>, <dy> shall be ignored.
    END

    c = l.store("dx-dy")
    c.value = [ 0, 0 ]
    c.validform = /^-?\d+(\.\d*)?$/
    c.num = 2
    c.width = 12

    # --------------------------------------------------------
    l = store("standard")
    l.comment = <<-END
standard <lon> <lat> <lon2> <lat2>

    n}e@ɈˑӖWoܓxw܂B
    ʂʂłȂꍇ̏u͖łB
    END
    l.comment_en = <<-END
standard <lon> <lat> <lon2> <lat2>

    Specifies standard longitude/latitude. They are parameters of map 
    projection, and only a part of them is used in some cases. 
    It is dependent to horizontal grid style whether this statement is 
    required or not.
    END
    l.omit = proc{
      cell("standard", "lon-lat").value   == [ 0, 0 ] &&
      cell("standard", "lon2-lat2").value == [ 0, 0 ]
    }

    c = l.store("lon-lat")
    c.value = [ 0, 0 ]
    c.validform = /^-?\d+(\.\d*)?[NEWS]$/
    c.num = 2
    c.width = 12

    c = l.store("lon2-lat2")
    c.value = [ 0, 0 ]
    c.validform = /^-?\d+(\.\d*)?[NEWS]$/
    c.num = 2
    c.width = 12

    # --------------------------------------------------------
    l = store("others")
    l.comment = <<-END
others <lon> <lat> <lon2> <lat2>

    n}e@ɈˑӖWoܓxw܂B
    ʂʂłȂꍇ̏u͖łB
    END
    l.comment_en = <<-END
others <lon> <lat> <lon2> <lat2>

    Specifies 3rd or 4th longitude/latitude. Meaning of parameters is 
    dependent to projection. It is also dependent to horizontal grid 
    style whether this statement is required or not.
    END
    l.omit = proc{
      cell("others", "lon-lat").value   == [ 0, 0 ] &&
      cell("others", "lon2-lat2").value == [ 0, 0 ]
    }

    c = l.store("lon-lat")
    c.value = [ 0, 0 ]
    c.validform = /^-?\d+(\.\d*)?[NEWS]$/
    c.num = 2
    c.width = 12

    c = l.store("lon2-lat2")
    c.value = [ 0, 0 ]
    c.validform = /^-?\d+(\.\d*)?[NEWS]$/
    c.num = 2
    c.width = 12

    # --------------------------------------------------------
    l = store("value")
    l.comment = <<-END
value <representation>

    iqɑ΂l̑\\w܂B
    "PVAL" ͊iq_lA"MEAN" ͕ϒlA"REPR" ͑\\lw܂B
    END
    l.comment_en = <<-END
value <representation>

    Describes how gridded data represents field. Word <representation> 
    should be one of them:

    PVAL
        values at grid point. This is the default.

    MEAN
        average over volume/area around grid point

    REPR
        representative value obtained with another method

    END
    l.omit = proc { cell("value", "representation").value == "PVAL" }

    c = l.store("representation")
    c.value = "PVAL"
    c.validform = [ "PVAL", "MEAN", "REPR" ]
    c.nocase = TRUE

    # --------------------------------------------------------
    l = store("packing")
    l.comment = <<-END
packing <pack_mode>

    k <pack_mode> w܂BftHg͖ʂƂ16rbgk "2PAC" łB
    END
    l.comment_en = <<-END
packing <pack_mode>

    Describes encoding scheme to be used in DATA record. 
   See Reference Manual (file "doc/nusref.html") for table of possible values.
   By default, "2PAC" is assumed.

    END

    c = l.store("pack_mode")
    c.value = "2PAC"
    c.validform = [ "1PAC", "2PAC", "2UPC", "4PAC", "I1", "I2", "N1I2", "I4", 
      "R4", "R8", "RLEN", "GRIB", "DGRB" ]
    c.nocase = TRUE

    # --------------------------------------------------------
    l = store("missing")
    l.comment = <<-END
missing <miss_mode>

    l̕\\@w܂B 
    "NONE" ͌l܂BꂪftHgłB
    "UDFV" ̏ꍇ̓f[^ݑOɌlݒ肵Ȃ΂Ȃ܂B
    "MASK" ̏ꍇ̓f[^ݑOɌ͈̓rbg}bvݒ肵Ȃ
    Ȃ܂B
    END
    l.comment_en = <<-END
missing <miss_mode>

    Describes how missing value is to be represented. Word <miss_mode> 
    should be one of them:

    NONE
        There is no method for missing value in this case. This is the default.

    UDFV
        A certain value is missing value, and grids with the value should be 
        regarded missing.

    MASK
        Grid points with valid data are indicated with bitmap for each 
        DATA record. See NUSDAS_MAKE_MASK() in Reference Manual (file 
        "doc/nusref.html")for detail.

    END
    l.omit = proc { cell("missing", "miss_mode").value == "NONE" }

    c = l.store("miss_mode")
    c.value = "NONE"
    c.validform = [ "NONE", "UDFV", "MASK" ]
    c.nocase = TRUE

    # --------------------------------------------------------
    l = store("information")
    l.comment = <<-END
information <group> <filename>

    {Xe[ggƁAef[^t@Cɏ񕔃R[h쐬܂B
    񕔃R[h̑傫Ɠe͑΃pX <filename> ƓɂȂ܂B
    <group> ͏񕔃R[h肷邽߂ 4 ̖OłB
    END
    l.comment_en = <<-END
information <group> <filename>

    If the definition file has this statement, INFO record will be written 
    at the time of data file creation. Size and contents of the INFO record 
    will be that of file specified with a relative path <filename>. 
    Word <group> should be a four-character name that identifies the INFO 
    record.
    END

    c = l.store("group-filename")
    c.value = ""
    c.validform = /^.+/
    c.width = 48

    # --------------------------------------------------------
    l = store("subcntl")
    l.comment = <<-END
subcntl <num> <group> <size> <group> <size> ...

    {Xe[ggƁAef[^t@Cɕ⏕ǗR[h쐬܂B
    e⏕ǗR[h́Aʂ 4̖O <group> œ肳A<size> 
    傫ɂȂ܂B<num>  <group>-<size> ̑g̐w܂B
    END
    l.comment_en = <<-END
subcntl <num> <group> <size> <group> <size> ...

    If the definition file has this statement, SUBC records are allocated 
    at the time of data file creation. Each SUBC record is secified with 
    a pair of <group> (four-character name that identifies the SUBC record)
    and <size> (size of the SUBC record).
    Word <num> specifies the number of <group>-<size> pairs.

    END
#    l.needed = true
    l.omit = proc { cell("subcntl", "num").value.to_i == 0 }

    c = l.store("num")
    c.value = 0
    c.validform = /^\d+/
    c.refresh_func = proc{|rewrite, refresh|
      if (rewrite == cell("subcntl", "group-size") && (v = rewrite.value))
	refresh.value = v.size
      end
    }
    c.auto = TRUE

    c = l.store("group-size")
    c.value = []
    c.validform = SubCntl
    c.num = proc{ cell("subcntl", "group-size").value.size }

    # --------------------------------------------------------
    l = store("forcedlen")
    l.comment = <<-END
forcedlen <size>

    {Xe[gǵAES C^tF[X𗘗pۂɕKvƂȂ܂B
    {Xe[ggꍇAf[^t@C̊eR[h <size> oCg
    傫ɃpfBO܂BR[h <size> zƃG[ƂȂ܂B
    ftHgł́ApfBO͍sȂ܂B
    END
    l.comment_en = <<-END
forcedlen <size>

    This statement is required if you use ES interface. If the definition 
    file has this statement, each records in data file will have <size> bytes. 
    Padding of (<size> - (payload size)) bytes is used after record payload. 
    Error occurs if a record exceeds the specified <size>. By default, records 
    are aligned contiguously (without padding between record payload and 
    4-byte record trailer).
    END
    l.needed = proc { cell("path", "path_style").value == "nwp_esf" }

    c = l.store("size")
    c.value = ""
    c.validform = /^\d+$/
    c.width = 8
    c.chkproc = proc {|v| v.to_i > 0 && 
	cell("path", "path_style").value == "nwp_esf"}
    c.refresh_func = proc{|rewrite, refresh|
      if (cell("path", "path_style").value == "nwp_esf" &&
	  (rewrite == cell("path", "path_style") ||
	   rewrite == cell("size", "nx-ny") ||
	   rewrite == cell("missing", "miss_mode") ||
	   rewrite == cell("packing", "pack_mode")))
	nxny = cell("size", "nx-ny").value
	x = nxny[0].to_i
	y = nxny[1].to_i
	cmp = cell("packing", "pack_mode").value
	case cmp
	when "1PAC", "2PAC", "2UPC"
	  b = 8
	when "4PAC"
	  b = 16
	when "RLEN"
	  b = 12
	else
	  b = 0
	end
	case cell("missing", "miss_mode").value
	when "NONE"
	  a = 0
	when "UDFV"
	  case cmp
	  when "1PAC", "I1"
	    a = 1
	  when "2PAC", "2UPC", "I2", "N1I2"
	    a = 2
	  when "4PAC", "I4", "R4"
	    a = 4
	  when "R8"
	    a = 8
	  else 
	    a = 0
	  end
	when "MASK"
	  a = 4 + (x * y - 1)/8 + 1
	end
	refresh.value = x * y * pack_size + 17 * 4 + a + b
      end
    }

    self.notify_mode = TRUE
    
  end
  private :default

  def pack_size
    case cell("packing", "pack_mode").value
    when "1PAC", "I1"
      scale = 1
    when "2PAC", "2UPC", "I2", "N1I2"
      scale = 2
    when "4PAC", "I4", "R4"
      scale = 4
    when "R8"
      scale = 8
    when "RLEN", "GRIB", "DGRB"
      scale = nil
    else
      scale = nil
    end
    scale
  end

end
