$LOAD_PATH.unshift '../libexec'
require 'nusdas/nusrecstream'
require 'digest/md5'

def hexdump(str)
	ofs = 0
	while ofs < str.size
		buf = str[ofs, 16]
		pbuf = buf.gsub(/[^ -~]/, '.')
		fmt1 = format(" %08X  %23s - %23s  %-16s\n", ofs, '', '', pbuf)
		for i in 0 ... buf.size
		    	cofs = 11 + i * 3
			cofs += 2 if i >= 8
			fmt1[cofs, 2] = format('%02X', buf[i])
		end
		print fmt1
		fmt2 = format(" %8d  %23s - %23s\n", ofs, '', '')
		for i in 0 ... (buf.size / 4)
			iconv = buf[i * 4, 4].unpack('N').first
		    	cofs = 11 + i * 12
			cofs += 2 if i >= 2
			fmt2[cofs,11] = format('%11u', iconv)
		end
		print fmt2
		ofs += 16
	end
end

for fnam in ARGV
	print "#{fnam}\n"
	fp = Nusdas::NusRecStream.open(fnam)
	while true
		recpos = fp.pos
		hdr, payload = fp.get_record_str
		break if hdr.nil?
		printf "%4s size %7d md5 %s at %8d\n",
			hdr[4..7].dump, payload.size,
			Digest::MD5.hexdigest(payload), recpos
		if hdr[4..7] == 'INDX'
			a = payload.unpack('N*')
			a.each_index { |i|
				v = a[i]
				next if v.zero? or v == 0xFFFFFFFF
				printf "\t%7d %7d\n", i, v
			}
		else
			hexdump payload if $VERBOSE
		end
	end
	printf "eof at %8d\n", fp.pos
	fp.close
end
