#include <stdio.h>
#include <stdlib.h>
#include <nusdas.h>

	void
c2fcopy(char *dst, const char *src, size_t count)
{
	char *p;
	strncpy(dst, src, count);
	dst[count] = '\0';
	for (p = dst + strlen(dst); p < dst + count; p++) {
		*p = ' ';
	}
}

	int
basetime()
{
	int	y, m, d, h, n;
	return nwp_gettime("TIMECARD", &y, &m, &d, &h, &n);
}

	int
main(int argc, char **argv)
{
	int	nrd, ft0, dft, nft, gridsize[2], r;
	N_SI4	bt, bufsiz, vt;
	char	type1[9], type2[5], type3[5], memb[5], plane[7], elem[7];
	float	*buf;
	if (argc < 11) {
		puts("usage: test-write NRD TYPE1 TYPE2 TYPE3 MEMB PLANE ELEM FT0 DFT NFT");
		return 1;
	}
	nrd = atoi(argv[1]);
	c2fcopy(type1, argv[2], 8);
	c2fcopy(type2, argv[3], 4);
	c2fcopy(type3, argv[4], 4);
	c2fcopy(memb, argv[5], 4);
	c2fcopy(plane, argv[6], 6);
	c2fcopy(elem, argv[7], 6);
	ft0 = atoi(argv[8]);
	dft = atoi(argv[9]);
	nft = atoi(argv[10]);

	bt = basetime();
	if (bt < 0)
		return 2;
	printf("nrd=%d type=<%.8s.%.4s.%.4s> memb=<%.4s> plane=<%.6s>\n",
		nrd, type1, type2, type3, memb, plane);
	printf(" elem=<%.6s> ft0=%d dft=%d nft=%d bt=%d\n",
		elem, ft0, dft, nft, (int)bt);

#if 0
	r = nusdas_iocntl(N_IO_W_FCLOSE, N_OFF);
	if (r < 0) {
		printf("Error %d nusdas_iocntl\n", r);
		return -r;
	}

	r = nusdas_iocntl(N_IO_WARNING_OUT, N_OFF);
	if (r < 0) {
		printf("Error %d nusdas_iocntl\n", r);
		return -r;
	}
#endif

	r = nusdas_parameter_change(N_PC_ID_SET, &nrd);
	if (r < 0) {
		printf("Error %d nusdas_parameter_change\n", r);
		return -r;
	}

	bufsiz = 2;
	r = nusdas_inq_def(type1, type2, type3, N_GRID_SIZE, gridsize, &bufsiz);
	if (r < 0) {
		printf("Error %d\n", r);
		return -r;
	}
	printf("gridsize %d x %d\n", gridsize[0], gridsize[1]);

	bufsiz = gridsize[0] * gridsize[1];
	buf = malloc(sizeof(float) * bufsiz);
	if (buf == NULL) {
		perror(argv[0]);
		return 4;
	}

	for (r = 0; r < bufsiz; r++)
		buf[r] = 0.0;

	for (vt = bt + ft0; vt < bt + ft0 + dft * nft; vt += dft) {
		r = nusdas_write(type1, type2, type3, &bt, memb, &vt,
			plane, elem, buf, N_R4, &bufsiz);
		if (r < 0) {
			printf("Error %d nusdas_write %d\n", r, (int)(vt - bt));
			return -r;
		} else {
			printf("nusdas_write %d %d\n", r, (int)(vt - bt));
		}
	}

#if 0
	r = nusdas_allfile_close(N_FOPEN_ALL);
	if (r < 0) {
		printf("Error %d nusdas_allfile_close\n", r);
		return -r;
	} else {
		printf("%d files closed\n", r);
	}
#endif


	return 0;
}
