#include <stdio.h>
#include <memory.h>
#include "nusdas_sys.h"
unsigned char d[10000000];

void data_add(unsigned char d[], int atime)
{
int *vt;

  vt = (int *)(&d[4]); *vt += atime;
/*
  vt = (int *)(&d[8]); *vt += atime;
*/
}
void cntl_add(unsigned char d[], int atime)
{
int *bt, iy,im,id,ih,in, n_dc, n_vt, *vt, i, vp;
char stamp[13];

  bt = (int *)(&d[28]);
  *bt += atime;
  nwp_seq2ymdhm(&iy,&im,&id,&ih,&in,*bt);
  sprintf(stamp, "%4.4d%2.2d%2.2d%2.2d%2.2d", iy,im,id,ih,in);
  memcpy(&d[16], stamp, 12);
  memcpy(&n_dc, &d[36], 4);
  memcpy(&n_vt, &d[40], 4);
  vp = 28+28+100+n_dc*4;
  for(i=0; i<n_vt; i++) {
printf("i=%d\t", i);
    vt = (int *)(&d[vp+4*i]);
printf("vt=%d\t->", *vt);
   *vt += atime;
printf("%d\n", *vt);
/*
    vt = (int *)(&d[vp+8*i+4]); *vt += atime;
*/
  }
}
void main(int argc, char *argv[])
{
FILE *fp, *fp2;
char f2name[256];
N_ST_RI ri;
int i, atime, n_sr, n_info, n_dat;

  if (argc<=2) {
    printf("usage: nusdas_add_time targetfile addtime\n");
    printf("nusdas_add_time make a new file whose name is targetfile.+-tttt\n");
    printf("The time in a new file is added (addtime) minutes to that of\n");
    printf(" targetfile\n");
    exit(1);
  }

  atime = atol(argv[2]);

  printf("source file : %s\n", argv[1]);
  if ((fp=fopen(argv[1], "r"))==NULL) {
    printf("source file <%s> : open failed\n", argv[1]); exit(1);
  }
  sprintf(f2name, "%s.%+-d", argv[1], atime);
  printf("destination file : %s\n", f2name);
  if ((fp2=fopen(f2name, "w"))==NULL) {
    printf("destination file <%s> : open failed\n", f2name); exit(1);
  }
  printf("add time : %d (min)\n", atime);

  if (n_search_record(fp, "NUSD", 1, &ri)<0) {
    printf("targetfile may not be a NuSDaS file!?\n");
    exit(1);
  }
  fwrite(&ri, sizeof(N_ST_RI), 1, fp2);
  fread(d, ri.length_s-sizeof(N_ST_RI), 1, fp);
  fwrite(d, ri.length_s-sizeof(N_ST_RI), 1, fp2);
  printf("NUSD size=%d\n", ri.length_s);
  n_info = d[95];
  n_sr = d[99];
  n_dat = d[91]; n_dat -= (4+n_sr+n_info);

  if (n_search_record(fp, "CNTL", 1, &ri)<0) {
    printf("targetfile may not be a NuSDaS file!?\n");
    exit(1);
  }
  fwrite(&ri, sizeof(N_ST_RI), 1, fp2);
  fread(d, ri.length_s-sizeof(N_ST_RI), 1, fp);
  cntl_add(d, atime);
  fwrite(d, ri.length_s-sizeof(N_ST_RI), 1, fp2);
  printf("CNTL size=%d\n", ri.length_s);

  if (n_search_record(fp, "INDX", 1, &ri)<0) {
    printf("targetfile may not be a NuSDaS file!?\n");
    exit(1);
  }
  fwrite(&ri, sizeof(N_ST_RI), 1, fp2);
  fread(d, ri.length_s-sizeof(N_ST_RI), 1, fp);
  fwrite(d, ri.length_s-sizeof(N_ST_RI), 1, fp2);
  printf("INDX size=%d\n", ri.length_s);

for(i=1; i<=n_sr; i++) {
  if (n_search_record(fp, "SUBC", i, &ri)<0) break;
  fwrite(&ri, sizeof(N_ST_RI), 1, fp2);
  fread(d, ri.length_s-sizeof(N_ST_RI), 1, fp);
  fwrite(d, ri.length_s-sizeof(N_ST_RI), 1, fp2);
  printf("SUBC size=%d\n", ri.length_s);
}

for(i=1; i<=n_dat; i++) {
  if (n_search_record(fp, "DATA", i, &ri)<0) break;
  fwrite(&ri, sizeof(N_ST_RI), 1, fp2);
  fread(d, ri.length_s-sizeof(N_ST_RI), 1, fp);
  data_add(d, atime);
  fwrite(d, ri.length_s-sizeof(N_ST_RI), 1, fp2);
  printf("DATA size=%d\n", ri.length_s);
}

for(i=1; i<=n_sr; i++) {
  if (n_search_record(fp, "INFO", 1, &ri)<0) break;
  fwrite(&ri, sizeof(N_ST_RI), 1, fp2);
  fread(d, ri.length_s-sizeof(N_ST_RI), 1, fp);
  fwrite(d, ri.length_s-sizeof(N_ST_RI), 1, fp2);
  printf("INFO size=%d\n", ri.length_s);
}

  if (n_search_record(fp, "END ", 1, &ri)<0) {
    printf("targetfile may not be a NuSDaS file!?\n");
    exit(1);
  }
  fwrite(&ri, sizeof(N_ST_RI), 1, fp2);
  fread(d, ri.length_s-sizeof(N_ST_RI), 1, fp);
  fwrite(d, ri.length_s-sizeof(N_ST_RI), 1, fp2);
  printf("END  size=%d\n", ri.length_s);

  fclose(fp);
  fclose(fp2);

}
