#include "nusdas_sys.h"
#include <errno.h>

int  kw_num = 29;
char kw[][20]={ "nusdas","path","filename","creator","path","type1","type2",
    "type3","basetime","member","memberlist","validitme",
    "validtime1","validtime2","plane","plane1","plane2","element",
    "elementmap","size","basepoint","distance","standard","others",
    "value","packing","missing","information","subcntl"};

int main(int argc, char *argv[])
{
FILE *fp;
N_ST_DEF def;
N_SI4 rt;
char sin[80];
int i;

  if ((fp=fopen(argv[1],"r"))==NULL) {
    printf("define file <%s> can not be opened!\n", argv[1]);
    perror(""); return;
  }
  rt = n_read_def(fp, &def);
  printf("#################################################################\n");
  if (rt == 0) {
    printf("Necessary items are all defined in <%s>.\n", argv[1]);
  } else if (rt>0) {
    printf("!? Following necessary items are no defined or insufficient in <%s>\n", argv[1]);
    if (rt&N_F_TYPE1)  printf("!? type1\n"); 
    if (rt&N_F_TYPE2)  printf("!? type2\n");
    if (rt&N_F_TYPE3)  printf("!? type3\n");
    if (rt&N_F_NVALID) printf("!? validtime\n");
    if (rt&N_F_VALIDL) printf("!? validtime1 (validtime list)\n");
    if (rt&N_F_NPLANE) printf("!? plane\n");
    if (rt&N_F_PLANEL) printf("!? plane1 (plane list)\n");
    if (rt&N_F_NELEM)  printf("!? element\n");
    if (rt&N_F_ELEML)  printf("!? elementmap\n");
    if (rt&N_F_GRIDS)  printf("!? size\n");
  } else {
    printf("!? define file <%s> format error!\n", argv[1]);
  }
  fclose(fp);

  printf("#################################################################\n");
  printf("version       : %d\n", def.version);
  printf("path          : %s", (def.path==N_NWP_PATH_S) ? "nwp_path_s" : (def.path==N_NWP_PATH_M) ? "nwp_path_m" : (def.path==N_RELATIVE_PATH) ? "relative_path" : "default_path");
  if (def.path==N_RELATIVE_PATH) printf("(%s)\n", def.pathname);
  else                            printf("\n");
  printf("filename      : %s\n", def.filename);
  printf("type1         : %s\n", def.type1);
  printf("type2         : %s\n", def.type2);
  printf("type3         : %s\n", def.type3);
  printf("creator       : %s\n", def.creator);
  printf("member        : %d, %s-file\n", def.n_dc, (def.infile_dc==N_OUT_FILE) ? "out" : "in");
  printf("memberlist    : ");
  for(i=0; i<def.n_dc; i++)  printf("%4.4s ", (char *)(def.dc+i));
  printf("\n");
  printf("validtime     : %d, %s-file\n", def.n_vt, (def.infile_vt==N_OUT_FILE) ? "out" : "in");
  printf("valid1        : ");
  for(i=0; i<def.n_vt; i++)  printf("%-d ", *(def.vt1+i));
  printf("\n");
  printf("valid2        : ");
  for(i=0; i<def.n_vt; i++)  printf("%-d ", *(def.vt2+i));
  printf("\n");
  printf("plane         : %d\n", def.n_lv);
  printf("plane1        : ");
  for(i=0; i<def.n_lv; i++)  printf("%6.6s ", (char *)(def.lv1+i));
  printf("\n");
  printf("plane2        : ");
  for(i=0; i<def.n_lv; i++)  printf("%6.6s ", (char *)(def.lv2+i));
  printf("\n");
  printf("element       : %d\n", def.n_el);
  printf("elementlist   : ");
  for(i=0; i<def.n_el; i++)  printf("%6.6s ", (char *)(def.el+i));
  printf("\n");
  printf("-------------------------------------------------------------\n");
  printf("projection    : %4.4s\n", (char *)(&(def.projection)));
  printf("grid size     : %-dx%-d\n", def.xs, def.ys);
  printf("base point    : (%-f,%-f)=(%-f,%-f)\n", def.x0, def.y0, def.lon_0, def.lat_0);
  printf("grid distance : %-fx%-f\n", def.xd, def.yd);
  printf("standard ll   : 1=(%-f,%-f) 2=(%-f,%-f)\n", def.lon_s1, def.lat_s1, def.lon_s2, def.lat_s2);
  printf("other    ll   : 1=(%-f,%-f) 2=(%-f,%-f)\n", def.lon_1, def.lat_1, def.lon_2, def.lat_2);
  printf("gpv mean      : %4.4s\n", (char *)(&(def.gpv_mean)));
  printf("packing       : %4.4s\n", (char *)(&(def.pack)));
  printf("missing       : %4.4s\n", (char *)(&(def.miss)));
  for(i=0; i<def.n_subc; i++)
    printf("subc group    : name<%4.4s> size<%d>\n", (char *)(&(def.subc[i])), def.subc_size[i]);
  for(i=0; i<def.n_infoc; i++)
    printf("information   : %s\n", def.info_file[i]);
  printf("forced rlen   : %d\n", def.forced_rlen);
  return 0;
}
