#include "n2g.h"
extern int pflag, dflag, pnum, mnum, thing;
extern unsigned char s2d[];
extern ST_PARM pt[];
extern ST_MODEL mt[];

int dgrib_enc_sect2(float *d, int dnum, int *nbit, int *bsf, unsigned char uc[])
{
int i, j, k, l, n, nn, n4, pms;
unsigned char *wc;
unsigned short us, ws=0x8000;
unsigned int ui, *w, wi, ui2;
float amp, sf, ref;

  for(i=1, ref=d[0], amp=d[0]; i<dnum; i++)  {
    if (d[i]<ref)  ref = d[i];
    if (d[i]>amp)  amp = d[i];
  }
  amp -= ref;
  if (amp==0.0)  amp = 1.0;
  if (*bsf==-999 && *nbit==-999)  return(-2);
  else if (*nbit==-999) *nbit = (int)(log((double)amp)/log(2.0))-(*bsf)+1;
  else if (*bsf==-999)  *bsf = (int)(log((double)amp)/log(2.0))-(*nbit)+1;

  if (*bsf<0) { us = (unsigned short)((-1)*(*bsf)); us = us | ws;
  } else {      us = (unsigned short)*bsf; }
  memcpy(&uc[34], &us, 2);
  if (ref>=0.0) { wi = 0x00000000; pms = 1;
  } else {        wi = 0x80000000; pms = (-1); }
  if (ref==0.0) {
    ui = 0; ui2 = 0;
  } else {
    ui = (unsigned int)ceil(log((double)ref*pms)/log(16.0)+64);
    ui2 = (unsigned int)(ref*pms*pow(16.0,(double)(70-ui)));
  }
  ui = ui << 24;
  ui = ui | ui2 | wi;
  memcpy(&uc[36], &ui, 4);
  us = *nbit; memcpy(&uc[32], &us, 2);

  w = (unsigned int *)malloc(sizeof(unsigned int)*(dnum*(*nbit)/8/4+2));
  for(i=0; i<dnum*(*nbit)/8/4+2; i++)  w[i] = 0;  /* keep one reserved area */
  sf = (float)(1.0/pow((double)2.0,(double)(*bsf)));
  for(i=0, j=0, k=0; i<dnum; i++)  {
    ui = (d[i]-ref)*sf;
    l = sizeof(unsigned int)*8-j-(*nbit);
    if (l>=0)  ui = ui << l;
    else       ui = ui >> (l*(-1));
    w[k] |= ui;
    j += (*nbit);
    if (j>=sizeof(unsigned int)*8)  { k++;  j -= sizeof(unsigned int)*8; }
    if (l<0) {
      ui = (d[i]-ref)*sf;
      l = sizeof(unsigned int)*8-j;
      if (l>=0)  ui = ui << l;
      else       ui = ui >> (l*(-1));
      w[k] |= ui;
    }
  }
  n = (int)((float)(dnum*(*nbit)-1)/8+1); /* total bytes */
  nn = (int)((n-1)/2+1)*2+1;              /* to adjust odd bytes */
  if (n%2==0) j+=8;
  uc[3] = 32-j; while (uc[3]>=16) uc[3] -= 16;
  if (pflag!=0) {
    fprintf((pflag==1) ? stdout : stderr,
            " n=%7.2f,x=%7.2f,B=%2.2d,", ref, ref+amp, *nbit);
    fflush((pflag==1) ? stdout : stderr);
  }
  memcpy(&uc[11], w, nn); 
  free(w);
  n4 = nn+11; i = n4 << 8;
  memcpy(&uc[0], &i, 3);
return(n4);
}

int set_proj(unsigned char uc[], ST_TARGET *tl, char *proj,
             int gs[], float ginfo[], int ltn[])
{
unsigned char wc=0x80;
unsigned short us;
unsigned int ui, wi=0x80000000;
int n2, xs, xe, ys, ye, xd, yd, i, ii, k;
double *lat[1000], *lon[1000], dels, slate, slatp, slon, xi, xj, olat, xlon, wk;

  xs = (tl->xs==-999) ? 1 : tl->xs;
  xe = (tl->xe==-999) ? gs[0] : tl->xe;
  xd = (tl->xd==-999) ? 1 : tl->xd;
  ys = (tl->ys==-999) ? 1 : tl->ys;
  ye = (tl->ye==-999) ? gs[1] : tl->ye;
  yd = (tl->yd==-999) ? 1 : tl->yd;
  if (memcmp(proj,"LL  ",4)==0 || memcmp(proj,"GS  ",4)==0) {
    n2 = (thing==0) ? 32 : 32+((ye-ys)/yd+1)*2; i = n2 << 8;
    memcpy(&uc[0], &i, 3);
    uc[3] = 0; uc[4] = (thing==0) ? 0xff : 33;
    uc[5] = (memcmp(proj,"LL  ",4)==0) ? 0 : 4;
    us = (thing==0) ? (xe-xs)/xd+1 : 0xffff;
    memcpy(&uc[6], &us, 2);
    if (pflag!=0) fprintf((pflag==1) ? stdout : stderr, "N=%-d", us);
    us = (ye-ys)/yd+1;
    memcpy(&uc[8], &us, 2);
    if (pflag!=0) fprintf((pflag==1) ? stdout : stderr, "x%-d", us);
    ii = sisha_gonyu((ginfo[2]+(ginfo[1]-ys)*ginfo[5])*1000);
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[10], &ui, 3);
    ii = sisha_gonyu((ginfo[3]-(ginfo[0]-xs)*ginfo[4])*1000);
    while (ii>180*1000) ii -= 360*1000;
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[13], &ui, 3);
    ii = sisha_gonyu((ginfo[2]+(ginfo[1]-ye)*ginfo[5])*1000);
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    uc[16] = 0x80;
    memcpy(&uc[17], &ui, 3);
    ii = sisha_gonyu((ginfo[3]-(ginfo[0]-xe)*ginfo[4])*1000);
    while (ii>180*1000) ii -= 360*1000;
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[20], &ui, 3);
    us = (thing==0) ? (short)(ginfo[4]*1000*xd) : 0xffff;
    memcpy(&uc[23], &us, 2);
    us = (memcmp(proj,"LL  ",4)==0) ? (short)(ginfo[5]*1000*yd)
                                    : (short)((gs[1]/yd+1)/2);
    memcpy(&uc[25], &us, 2);
    uc[27] = 0;
    for(i=28; i<32; i++) uc[i] = 0;
    if (thing==1) {
      for(k=0, i=ys; i<=ye; i+=yd, k++) {
        us = ltn[k];
        memcpy(&uc[32+k*2], &us, 2);
      }
    }
  } else if (memcmp(proj,"LMN ",4)==0 || memcmp(proj,"LMS ",4)==0) {
    n2 = 42; i = n2 << 8;
    memcpy(&uc[0], &i, 3);
    uc[3] = 0; uc[4] = 0xff; uc[5] = 3;
    us = (xe-xs)/xd+1; memcpy(&uc[6], &us, 2);
    if (pflag!=0) fprintf((pflag==1) ? stdout : stderr, "N=%-d", us);
    us = (ye-ys)/yd+1; memcpy(&uc[8], &us, 2);
    if (pflag!=0) fprintf((pflag==1) ? stdout : stderr, "x=%-d", us);
    dels = ginfo[4];
    slate = (ginfo[8]>=ginfo[6]) ? ginfo[8] : ginfo[6];
    slatp = (ginfo[8]>=ginfo[6]) ? ginfo[6] : ginfo[8];
    slon = ginfo[7]; xi = ginfo[0]; xj = ginfo[1];
    olat = ginfo[2]; xlon = ginfo[3];
    for(i=0; i<gs[1]; i++) {
      lat[i] = (double *)malloc(sizeof(double)*gs[0]);
      lon[i] = (double *)malloc(sizeof(double)*gs[0]);
    }
    i = nwp_mproj_lm2ll(lat, lon, gs[0], gs[1], dels, slate, slatp, slon,
                        xi, xj, olat, xlon);
    ii = (int)(lat[ys-1][xs-1]*1000);
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[10], &ui, 3);
    ii = sisha_gonyu(lon[ys-1][xs-1]*1000);
    while (ii>180*1000) ii -= 360*1000;
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[13], &ui, 3);
    for(i=0; i<gs[1]; i++) { free(lat[i]); free(lon[i]); }
    uc[16] = 0x80;
    ii = sisha_gonyu(slon*1000);
    while (ii>180*1000) ii -= 360*1000;
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[17], &ui, 3);
    ii = sisha_gonyu((double)ginfo[4]*xd); ui = (unsigned int)ii; ui = ui << 8;
    memcpy(&uc[20], &ui, 3);
    ii = sisha_gonyu((double)ginfo[5]*yd); ui = (unsigned int)ii; ui = ui << 8;
    memcpy(&uc[23], &ui, 3);
    uc[26] = (memcmp(proj,"LMN ",4)==0) ? 0x00 : 0x80;
    uc[27] = 0;
    ii = sisha_gonyu(slatp*1000);
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[28], &ui, 3);
    ii = sisha_gonyu(slate*1000);
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[31], &ui, 3);
    for(i=34; i<42; i++) uc[i] = 0;
  }
return(n2);
}

int dgrib_enc(int dg_cf, float *d, int gn, ST_TARGET *tl, float *eta_b, int pln,
             int iy, int im, int id, int ih, int in, char *vtu,
             char *proj, int gs[], float ginfo[], unsigned char uc[])
{
unsigned char xc=0x01, wc;
unsigned short us, ws=0x8000;
unsigned int n, n0, n1, n2, n4;
int i, j, ii, i1, i2, k, l, nbit, bsf, dv, xs, xe, ys, ye, xd, yd;
int gn2, ltn[256];
float *d2, lat, ix, w1, w2, omg;

/* section 0 */
  if (dg_cf==1) {
    n0 = 4;  us=0;
    memcpy(&uc[0], &us, 2);
    memcpy(&uc[2], &us, 2);
  } else {
    n0 = 0;
  }

/* section 1 */
  n1 = 44; us = n1;
  memcpy(&uc[n0+0], &us, 2);
  us = 0xff00;
  memcpy(&uc[n0+2], &us, 2);
  if (memcmp(tl->type1,"_GSM",4)==0 || memcmp(tl->type1,"_RSM",4)==0 ||
      memcmp(tl->type1,"_MSM",4)==0 || memcmp(tl->type1,"_TYM",4)==0 ||
      memcmp(tl->type1,"_WFM",4)==0)     wc = 1;
  else if memcmp(tl->type1,"_SRF",4)==0) wc = 2;
  else if memcmp(tl->type1,"_SF",3)==0)  wc = 33;
  uc[n0+4] = wc;
  for(i=0; i<mnum; i++) if (memcmp(mt[i].name, tl->type1, 4)==0)  break;
  uc[n0+5] = (i==mnum) ? s2d[5] : (unsigned char)mt[i].mn;
/* section 2 */
  if (memcmp(proj,"LL  ",4)==0 && thing==1) {
    xs = (tl->xs==-999) ? 1 : tl->xs;
    xe = (tl->xe==-999) ? gs[0] : tl->xe;
    xd = (tl->xd==-999) ? 1 : tl->xd;
    ys = (tl->ys==-999) ? 1 : tl->ys;
    ye = (tl->ye==-999) ? gs[1] : tl->ye;
    yd = (tl->yd==-999) ? 1 : tl->yd;
    for(gn2=0, k=0, j=ys; j<=ye; j+=yd, k++) {
      lat = ginfo[2]-(j-1)*ginfo[4];
      ltn[k] = (int)(2+cos((double)lat*PAI)*(ye-ys));
      if (lat==0.0) ltn[k]--;
      gn2 += ltn[k];
    }
  }
  n2 = set_proj(&uc[n0+n1], tl, proj, gs, ginfo, ltn);
/* */
  for(i=0; i<pnum; i++) if (strcmp(pt[i].name, tl->elem)==0)  break;
  uc[n0+8] = (i==pnum) ? s2d[8] : (unsigned char)pt[i].pn;

  set_level(&uc[n0+9], tl, eta_b, pln);

  uc[n0+12] = (unsigned char)(iy-2000);
  uc[n0+13] = im; uc[n0+14] = id; uc[n0+15] = ih; uc[n0+16] = in;

  set_period(&uc[n0+17], tl, vtu);

  uc[n0+23] = (memcmp(tl->type1,"_SRF",4)==0) ? 1 : 0;

  us = tl->xs; memcpy(&uc[n0+24], &us, 2);
  us = tl->ys; memcpy(&uc[n0+26], &us, 2);
  us = tl->xe; memcpy(&uc[n0+28], &us, 2);
  us = tl->ye; memcpy(&uc[n0+30], &us, 2);

  if (pflag!=0) {
    fprintf((pflag==1) ? stdout : stderr,
            "   <%2.2d%2.2d%2.2d%2.2d:F%3.3d,E%2.2d,",
            iy-2000,im,id,ih,uc[n0+18],uc[n0+8]);
    fflush((pflag==1) ? stdout : stderr);
  }

/* section 2 */
  omg = (memcmp(tl->elem, "OMG", 3)==0) ? 1.0/36.0 : 1.0;
  if (memcmp(proj,"LL  ",4)==0 && thing==1) {
    d2 = (float *)malloc(sizeof(float)*gn2);
    for(k=0, l=0, j=ys; j<=ye; j+=yd, l++)
    for(i=0; i<ltn[l]; i++, k++) {
      ix = xs+(float)(xe-xs)/(ltn[l]-1)*i;
      i1 = (int)ix;    
      i2 = (int)(ix+1);
      w1 = i2-ix; w2 = ix-i1;
      i1 = (i1>gs[0]) ? i1-gs[0] : i1;
      i2 = (i2>gs[0]) ? i2-gs[0] : i2;
      d2[k] = (d[i1-1+gs[0]*(j-1)]*w1+d[i2-1+gs[0]*(j-1)]*w2)*omg;
    }
  } else if (tl->xs==-999 && tl->xe==-999 && tl->ys==-999 && tl->ye==-999 &&
             tl->xd==-999 && tl->yd==-999) {
    d2 = d; gn2 = gn;
    if (memcmp(tl->elem, "OMG", 3)==0) {
      for(j=0; j<gs[1]; j++)
      for(i=0; i<gs[0]; i++)  d2[i+gs[0]*j] *= omg;
    }
  } else {
    xs = (tl->xs==-999) ? 1 : tl->xs;
    xe = (tl->xe==-999) ? gs[0] : tl->xe;
    xd = (tl->xd==-999) ? 1 : tl->xd;
    ys = (tl->ys==-999) ? 1 : tl->ys;
    ye = (tl->ye==-999) ? gs[1] : tl->ye;
    yd = (tl->yd==-999) ? 1 : tl->yd;
    gn2 = ((xe-xs)/xd+1)*((ye-ys)/yd+1);
    d2 = (float *)malloc(sizeof(float)*gn2);
    for(k=0, j=ys; j<=ye; j+=yd, k++)
    for(l=0, i=xs; i<=xe; i+=xd, l++) {
      ii = (i>gs[0]) ? i-gs[0] : i;
      d2[l+k*((xe-xs)/xd+1)] = d[ii-1+gs[0]*(j-1)]*omg;
    }
  }
  nbit = (tl->bec=='B') ? tl->be : -999;
  bsf = (tl->bec=='E') ? tl->be : -999;
  n2 = dgrib_enc_sect2(d2, gn2, &nbit, &bsf, &uc[n0]);
  if (gn2=!gn) free(d2);

/* size re-set */
  us = n1+n2; memcpy(&uc[n0+0], &us, 2);
  n = n0+n1+n2;

  if (pflag!=0) {
    fprintf((pflag==1) ? stdout : stderr, "size=%d>\n", n);
    fflush((pflag==1) ? stdout : stderr);
  }
return(n);
}
