#include "nusdas_sys.h"
/* ************************************************************************** */
void vt_set(N_ST_DEF *n_def, N_SI4 *basetime)
{
N_SI4   i, j;
N_SI4   py, pm, pd, ph, pn, pp, ky, kp, kd;

  for(i=0; i<n_tunit_num; i++)
    if (memcmp(&n_def->time_unit, n_tunit_string[i], 4)==0)  break;
  if (i<=3 || i==n_tunit_num) {
    for(j=0; j<n_def->n_vt; j++)
      *(n_def->vt1+j) = *basetime+*(n_def->vt1+j)*n_tunit_min[i];
  } else if (i==4) {
    nwp_seq2ymdhm(&py,&pm,&pd,&ph,&pn, *basetime);
    pp = n_calc_pent(pm, pd);
    for(j=0; j<n_def->n_vt; j++) {
      kd = n_calc_addday(py, pp, *(n_def->vt1+j), i);
      *(n_def->vt1+j) = *basetime+kd*60*24;
    }
  }
}

/* ************************************************************************** */
void path_set(char *path, char *nrd, N_ST_DEF *n_def,
              N_ST_DEF *n_def2, N_SI4 *basetime, N_SI4 m, N_SI4 l)
{
char dname[256], fname[256], flag, type1[9], type2[5], type3[5];
char dum[256], c0[8], c1[8], c2[8], c3[8];
N_SI4  validtime;
N_UI4  member;

  sscanf(n_def->type1, "%s %s %s %s", dum, c0, c1, c2);
  sprintf(type1, "%4.4s%2.2s%4.4s%2.2s", c0, c1, c2);
  sscanf(n_def->type2, "%s %s %s", dum, c0, c1);
  sprintf(type2, "%2.2s%2.2s", c0, c1);
  sscanf(n_def->type3, "%s %s %s", dum, c0, c1);
  sprintf(type3, "%4.4s", c0);
  flag = 'r';
  memcpy(&member, (char *)(n_def->dc+m), 4);
  n_setpath(flag, nrd, n_def2, type1, type2, type3, basetime,
            (char *)(&member), (N_SI4 *)(n_def->vt1+l), dname, fname);
  sprintf(path, "%s/%s", dname, fname);
}

/* ************************************************************************** */
N_SI4 check_def(char *s)
{
N_SI4  i;
  i = strlen(s);
  while(*(s+(--i))!='.') continue;
  if (strncmp((char *)(s+i+1),"def",3)==0||strncmp((char *)(s+i+1),"DEF",3)==0)
    return(1);
  else
    return(0);
}

/* ************************************************************************** */
int main(int argc, char *argv[])
{
FILE  *fp;
N_ST_DEF  n_def, n_def2;
N_ST_INDX n_indx;
N_ST_CNTL n_cntl;
N_SI4  *p, rt, np, basetime;
int  i, j, k, l, m, me, n, ne, df_flag, i2, j2, k2, l2, c;
int  py, pm, pd, ph, pn;
char  s[5], path[256], nrd[256], *c1, *c2;
s[4]='\0';

  if (argc <= 7) {
    printf("nusdas_dump_indx n_root_dir define_file base_time(year month day hour min)\n");
    printf("                           <target_file(path from nrd)>\n");
    exit(0);
  }

  nusdas_iocntl(N_IO_WARNING_OUT, N_OFF);

  strcpy(nrd, argv[1]);
  py = atoi(argv[3]); pm = atoi(argv[4]); pd = atoi(argv[5]);
  ph = atoi(argv[6]); pn = atoi(argv[7]);
  basetime = nwp_ymdhm2seq(py, pm, pd, ph, pn);
  df_flag = check_def(argv[2]);
  if (df_flag) {
    sprintf(path, "%s/nusdas_def/%s", nrd, argv[2]);
    if ((fp=fopen(path, "r"))==NULL) {
      printf("nusdas_dump_indx: Error! define file <%s> open failed\n", path);
      exit(0);
    }
    if (n_read_def(fp, &n_def)<0) {
      printf("nusdas_dump_indx: Error! define file <%s> read error\n", path);
      exit(0);
    }
    rewind(fp);
    n_read_def(fp, &n_def2);
    fclose(fp);
    vt_set(&n_def, &basetime);
    np = n_def.n_dc*n_def.n_vt*n_def.n_lv*n_def.n_el;
    p = (N_SI4 *)malloc(sizeof(N_SI4)*np);
    for(i=0; i<np; i++)  *(p+i) = -9;
    ne = n_def.n_dc;
    me = n_def.n_vt;
  } else {
    ne = 1;
    me = 1;
  }

for(n=0, c=1; n<ne; n++)
for(m=0; m<me; m++, c++) {
  if (df_flag) {
    path_set(path, nrd, &n_def, &n_def2, &basetime, n, m);
  } else {
    sprintf(path, "%s/%s", nrd, argv[2]);
  }
  if ((fp=fopen(path, "r"))==NULL)  continue;
  if ((rt=n_read_cntl(fp, &n_cntl))<0) {
    printf("nusdas_dump_indx: Warning! read CNTL in file <%s>\n", path);
    continue;
  }
  np = n_cntl.f.n_dc*n_cntl.f.n_vt*n_cntl.f.n_lv*n_cntl.f.n_el;
  if ((rt=n_read_indx(fp, &n_indx, np))<0) {
    printf("nusdas_dump_indx: Warning! read INDX in file <%s>\n", path);
    continue;
  }
  if (!df_flag) {
    n_def.n_dc = n_cntl.f.n_dc; n_def.n_vt = n_cntl.f.n_vt;
    n_def.n_lv = n_cntl.f.n_lv; n_def.n_el = n_cntl.f.n_el;
    n_def.dc = (N_UI4 *)malloc(sizeof(N_UI4)*n_def.n_dc);
    n_def.vt1 = (N_SI4 *)malloc(sizeof(N_SI4)*n_def.n_vt);
    n_def.lv1 = (N_UI8 *)malloc(sizeof(N_UI8)*n_def.n_lv);
    n_def.el = (N_UI8 *)malloc(sizeof(N_UI8)*n_def.n_el);
    for(i=0; i<n_def.n_dc; i++)  *(n_def.dc+i)  = *(n_cntl.dc+i);
    for(i=0; i<n_def.n_vt; i++)  *(n_def.vt1+i) = *(n_cntl.vt1+i);
    for(i=0; i<n_def.n_lv; i++)  *(n_def.lv1+i) = *(n_cntl.lv1+i);
    for(i=0; i<n_def.n_el; i++)  *(n_def.el+i)  = *(n_cntl.el+i);
    np = n_def.n_dc*n_def.n_vt*n_def.n_lv*n_def.n_el;
    p = (N_SI4 *)malloc(sizeof(N_SI4)*np);
    for(i=0; i<np; i++) *(p+i) = -9;
  }

  for(l=0; l<n_cntl.f.n_dc; l++) {
    for(l2=0; l2<n_def.n_dc; l2++)  if (*(n_cntl.dc+l)==*(n_def.dc+l2)) break;
    if (l2==n_def.n_dc) {
      printf("nusdas_dump_indx: Error! member not consistent.\n"); exit(0);
    }
  for(k=0; k<n_cntl.f.n_vt; k++) {
    for(k2=0; k2<n_def.n_vt; k2++)  if (*(n_cntl.vt1+k)==*(n_def.vt1+k2)) break;
    if (k2==n_def.n_vt) {
      printf("nusdas_dump_indx: Error! validtime not consistent.\n"); exit(0);
    }
  for(j=0; j<n_cntl.f.n_lv; j++) {
    for(j2=0; j2<n_def.n_lv; j2++)
      if (memcmp((char *)(n_cntl.lv1+j), (char *)(n_def.lv1+j2), 6)==0) break;
    if (j2==n_def.n_lv) {
      printf("nusdas_dump_indx: Error! level not consistent.\n"); exit(0);
    }
  for(i=0; i<n_cntl.f.n_el; i++) {
    for(i2=0; i2<n_def.n_el; i2++)
      if (memcmp((char *)(n_cntl.el+i), (char *)(n_def.el+i2), 6)==0) break;
    if (i2==n_def.n_el) {
      printf("nusdas_dump_indx: Error! element not consistent.\n");
      for(i2=0; i2<n_def.n_el; i2++)
        printf("cntl[%-d]:%6.6s\tdef[%-d]:%6.6s\n",
                i, (char *)(n_cntl.el+i), i2, (char *)(n_def.el+i2));
      exit(0);
    }
    if(*(n_indx.offset+i+n_cntl.f.n_el*(j+n_cntl.f.n_lv*(k+n_cntl.f.n_vt*l)))>0)
      *(p+i2+n_def.n_el*(j2+n_def.n_lv*(k2+n_def.n_vt*l2))) = c;
    else
      *(p+i2+n_def.n_el*(j2+n_def.n_lv*(k2+n_def.n_vt*l2))) =
         *(n_indx.offset+i+n_cntl.f.n_el*(j+n_cntl.f.n_lv*(k+n_cntl.f.n_vt*l)));
  }}}}
  fclose(fp);
  free(n_indx.offset);
  free(n_cntl.dc);
  free(n_cntl.vt1);
  free(n_cntl.lv1);
  free(n_cntl.el);
}

  for(l=0; l<n_def.n_el; l++)
  for(k=0; k<n_def.n_dc; k++) {
    memcpy(s, (char *)(n_def.dc+k), 4);
    printf("\n======= %s <%s> ========\n",(char *)(n_def.el+l), s);
    for(j=0; j<n_def.n_lv; j++) {
      printf("%6s ", (char *)(n_def.lv1+j));
      for(i=0; i<n_def.n_vt; i++) {
        np = l+n_def.n_el*(j+n_def.n_lv*(i+n_def.n_vt*k));
        if (*(p+np)==-9)     printf(" .");
        else if (*(p+np)<0)  printf(" x");
        else if (*(p+np)==0) printf(" -");
        else                 printf(" O");
      }
      printf("\n");
    }
  }
  return 0;
}
