#include "nusdas_sys.h"
#include <unistd.h>
#include <errno.h>
extern int errno;
#define N_PATH_MAX 10000
char  path[N_PATH_MAX][256];

/* ************************************************************************** */
void vt_set(N_ST_DEF *n_def, N_SI4 *basetime)
{
N_SI4   i, j;
N_SI4   py, pm, pd, ph, pn, pp, ky, kp, kd;

  for(i=0; i<n_tunit_num; i++)
    if (memcmp(&n_def->time_unit, n_tunit_string[i], 4)==0)  break;
  if (i<=3 || i==n_tunit_num) {
    for(j=0; j<n_def->n_vt; j++)
      *(n_def->vt1+j) = *basetime+*(n_def->vt1+j)*n_tunit_min[i];
  } else if (i==4) {
    nwp_seq2ymdhm(&py,&pm,&pd,&ph,&pn, *basetime);
    pp = n_calc_pent(pm, pd);
    for(j=0; j<n_def->n_vt; j++) {
      kd = n_calc_addday(py, pp, *(n_def->vt1+j), i);
      *(n_def->vt1+j) = *basetime+kd*60*24;
    }
  }
}

/* ************************************************************************** */
void path_set(char *path, char *nrd, N_ST_DEF *n_def, N_ST_DEF *n_def2,
              N_SI4 *basetime, N_SI4 m, N_SI4 l)
{
char dname[256], fname[256], flag, type1[9], type2[5], type3[5];
char dum[256], c0[8], c1[8], c2[8], c3[8];
N_SI4  validtime;
N_UI4  member;

  sscanf(n_def->type1, "%s %s %s %s", dum, c0, c1, c2);
  sprintf(type1, "%4.4s%2.2s%2.2s", c0, c1, c2);
  sscanf(n_def->type2, "%s %s %s", dum, c0, c1);
  sprintf(type2, "%2.2s%2.2s", c0, c1);
  sscanf(n_def->type3, "%s %s %s", dum, c0, c1);
  sprintf(type3, "%4.4s", c0);
  flag = 'v';
  memcpy(&member, (char *)(n_def->dc+m), 4);
  n_setpath(flag, nrd, n_def2, type1, type2, type3, basetime,
            (char *)(&member), (N_SI4 *)(n_def->vt1+l), dname, fname);
  sprintf(path, "%s/%s", dname, fname);
}

/* ************************************************************************** */
int main(int argc, char *argv[])
{
FILE  *fp;
N_ST_DEF  n_def, n_def2;
N_SI4  rt, basetime;
int  i, j, k, c, n_path=0;
int  py, pm, pd, ph, pn;
char  s[5], p[256], nrd[256], *c1, *c2, ss[256];
s[4]='\0';

  if (argc <= 7) {
    fprintf(stderr, "nusdas_file_del n_root_dir define_file basetime<yy mm dd hh nn>\n");
    exit(1);
  }

  nusdas_iocntl(N_IO_WARNING_OUT, N_OFF);

  strcpy(nrd, argv[1]);
  py = atoi(argv[3]); pm = atoi(argv[4]); pd = atoi(argv[5]);
  ph = atoi(argv[6]); pn = atoi(argv[7]);
  basetime = nwp_ymdhm2seq(py, pm, pd, ph, pn);
  sprintf(p, "%s/nusdas_def/%s", nrd, argv[2]);
  if ((fp=fopen(p, "r"))==NULL) {
    fprintf(stderr, "nusdas_file_del: Error! define file <%s> open failed\n",p);
    exit(1);
  }
  if (n_read_def(fp, &n_def)<0) {
    fprintf(stderr, "nusdas_file_del: Error! define file <%s> read error\n",p);
    exit(1);
  }
  rewind(fp);
  n_read_def(fp, &n_def2);
  fclose(fp);
  vt_set(&n_def, &basetime);

  for(i=0, n_path=0; i<n_def.n_dc; i++)
  for(j=0; j<n_def.n_vt; j++) {
    path_set(p, nrd, &n_def, &n_def2, &basetime, i, j);
    for(k=0; k<n_path; k++) if (strcmp(p, path[k])==0)  break;
    if (k==n_path)  {
      strcpy(path[k], p);
      n_path++;
    }
  }

  fprintf(stdout, "********************************************************\n");
  fprintf(stdout, "* nusdas_file_del execution log\n");
  fprintf(stdout, "********************************************************\n");
  fprintf(stdout, "* NuSDaS root directory : %s\n", argv[1]);
  fprintf(stdout, "* NuSDaS define file    : %s\n", argv[2]);
  fprintf(stdout, "********************************************************\n");
  fflush(stdout);
  for(k=0, j=0; k<n_path; k++) {
    strcpy(ss, path[k]);
    i = unlink(ss);
    if (i==0) {
      fprintf(stdout,"%3.3d :Succeed !!               %s\n", ++j, path[k]);
    } else if (errno==ENOENT)
      fprintf(stdout,"xxx :Fail? No Entry           %s\n", path[k]);
    else if (errno==EPERM)
      fprintf(stdout,"xxx :Fail? Not super user %s\n", path[k]);
    else if (errno==EACCES)
      fprintf(stdout,"xxx :Fail? Permission denied  %s\n", path[k]);
    else
      fprintf(stdout,"xxx :Fail? errno=%3.3d      %s\n", errno, path[k]);
    while(1) {
      for(i=strlen(ss)-1; i>0; i--) if (ss[i]=='/')  { ss[i]='\0';  break; }
      if (strcmp(nrd, ss)==0)  break;
      i = rmdir(ss);
      if (i==0)
        fprintf(stdout,"Dir :Succeed !!               %s\n", ss);
      else
        break;
    }
  }

  rt = n_path-j;
  if (rt>255) rt=255;
return(rt);
}
