#include "nusgrib.h"
extern int vm;

int grib_set_erb(unsigned char ud[], short *eamp, float *fref, int *nbit)
{
unsigned int   wki;
unsigned short wks, ww;
int            pm, sisuu, kasuu, len4;

  memcpy(&wki, ud, 4);  len4 = (wki>>8);
  memcpy(&wks, &ud[4], 2);
  ww =wks&0x8000;
  *eamp = (ww==0x8000) ? (wks&0x7fff)*(-1) : wks;
  pm = ((ud[6]&0x80)==0x80) ? -1 : 1;
  sisuu = (ud[6]&0x7f);
  memcpy(&wki, &ud[7], 4); kasuu = (wki>>8);
  *fref = (float)(pow(2.0,-24.0)*pow(16.0,(double)(sisuu-64))*pm*kasuu);
  *nbit = ud[10];
return(len4);
}

int grib_dec_sect1_5(unsigned char ud[], struct sect1 *s1, struct sect2 *s2,
                     float **d)
{
int len13, len4, nbit, i, j, k;
unsigned char *uc;
unsigned int   ui, uw, mask;
short          eamp;
float          fref;

  len13 = grib_dec_sect1_3(ud, s1, s2);
  if (d==NULL) return(0);

  len4 = grib_set_erb(&ud[len13], &eamp, &fref, &nbit);
  SOUT("%-d,%.1f,%-d,", eamp, fref, nbit);
  *d = (float *)malloc(sizeof(float)*s2->xs*s2->ys);
  uc = &ud[len13+11];
  for(i=0, mask=0; i<nbit; i++)  mask += (unsigned int)pow(2.0,(double)i);

  if ((s2->scan&0x40)==0x00) {
    for(j=0, k=0; j<s2->ys; j++) {
      if ((s2->scan&0x80)==0x00) {
        for(i=0; i<s2->xs; i++, k++) {
          memcpy(&uw, &uc[(nbit*k)/8], 4);
          ui = (uw>>(32-nbit-(nbit*k)%8))&mask;
          *(*d+i+s2->xs*j) = (float)((fref+pow(2.0,(double)eamp)*ui)
                                      /pow(10.0,s1->amp));
        }
      } else {
        for(i=s2->xs-1; i>=0; i--, k++) {
          memcpy(&uw, &uc[(nbit*k)/8], 4);
          ui = (uw>>(32-nbit-(nbit*k)%8))&mask;
          *(*d+i+s2->xs*j) = (float)((fref+pow(2.0,(double)eamp)*ui)
                                      /pow(10.0,s1->amp));
        }
      }
    }
  } else {
    for(j=s2->ys-1, k=0; j>=0; j--) {
      if ((s2->scan&0x80)==0x00) {
        for(i=0; i<s2->xs; i++, k++) {
          memcpy(&uw, &uc[(nbit*k)/8], 4);
          ui = (uw>>(32-nbit-(nbit*k)%8))&mask;
          *(*d+i+s2->xs*j) = (float)((fref+pow(2.0,(double)eamp)*ui)
                                      /pow(10.0,s1->amp));
        }
      } else {
        for(i=s2->xs-1; i>=0; i--, k++) {
          memcpy(&uw, &uc[(nbit*k)/8], 4);
          ui = (uw>>(32-nbit-(nbit*k)%8))&mask;
          *(*d+i+s2->xs*j) = (float)((fref+pow(2.0,(double)eamp)*ui)
                                      /pow(10.0,s1->amp));
        }
      }
    }
  }
  SOUT("%.1f>", *(*d+s2->xs*s2->ys/2));
return(0);
}

int grib_dec_sect1_3(unsigned char ud[], struct sect1 *s1, struct sect2 *s2)
{
unsigned int mask=0x00ffffff, wk;
unsigned short wamp, ww=0x8000;
int len1, len2, len3;

  memcpy(&wk, ud, 4);
  len1 = (wk>>8) & mask;
  s1->vers   = ud[3];
  s1->center = ud[4];
  s1->proc   = ud[5];
  s1->grid   = ud[6];
  s1->flag   = ud[7];
  s1->parm   = ud[8];
  s1->lindx  = ud[9];
  memcpy(&(s1->levl), &ud[10], 2);
  s1->year   = ud[12];
  s1->month  = ud[13];
  s1->date   = ud[14];
  s1->hour   = ud[15];
  s1->min    = ud[16];
  s1->pindx1 = ud[17];
  s1->p1     = ud[18];
  s1->p2     = ud[19];
  s1->pindx2 = ud[20];
  memcpy(&(s1->numav), &ud[21], 2);
  s1->numng  = ud[23];
  s1->century= ud[24];
  s1->subcent= ud[25];
  memcpy(&wamp, &ud[26], 2);
  ww =wamp&0x8000;
  s1->amp = (ww==0x8000) ? (wamp&0x7fff)*(-1) : wamp;
  len2 = ((s1->flag&0x80)==0x80) ? grib_dec_sect2(&ud[len1], s2) : 0;
  len3 = ((s1->flag&0x40)==0x40) ? grib_dec_sect3(&ud[len1+len2]) : 0;
  SOUT(" %2.2d%2.2d%2.2d%2.2d%2.2d<%-d,%-d<%1d:%3d,%3d/%3d/%3d,%4d<%-d:%3d<%-d,",
        s1->year, s1->month, s1->date, s1->hour, s1->min,
        s1->center, s1->proc,
        s2->proj, s2->xs, s2->ys, s1->parm, s1->lindx, s1->levl,
	s1->pindx1, s1->p1, s1->amp);
return(len1+len2+len3);
}

int grib_dec_sect0(unsigned char ud[])
{
int tlen;
unsigned int mask=0x00ffffff, work;
  if (memcmp(ud, "GRIB", 4)!=0)  return(-1);
  memcpy(&work, &ud[3], 4);
  tlen = work & mask;
  if (ud[7]!=0 && ud[7]!=1)  return(-1);
return(tlen);
}

int grib_dec_sect2(unsigned char ud[], struct sect2 *s2)
{
int len;
unsigned int wk;
  memcpy(&wk, ud, 4);
  len = wk>>8 ;
  s2->proj = ud[5];
  s2->scan = ud[27];
  if (s2->proj==0 || s2->proj==1 || s2->proj==3 || s2->proj==5) {
    memcpy(&(s2->xs), &ud[6], 2);
    memcpy(&(s2->ys), &ud[8], 2);
    memcpy(&wk, &ud[10], 4); s2->x0 = (wk>>8);
    memcpy(&wk, &ud[13], 4); s2->y0 = (wk>>8);
    if (s2->proj==0) {
      memcpy(&wk, &ud[23], 2); s2->xd = (wk>>16);
      memcpy(&wk, &ud[25], 2); s2->yd = (wk>>16);
    } else if (s2->proj==5) {
      memcpy(&wk, &ud[20], 3); s2->xd = (wk>>8);
      memcpy(&wk, &ud[23], 3); s2->yd = (wk>>8);
      memcpy(&wk, &ud[17], 3); s2->lon1 = (wk>>8);
      s2->lat1 = 60*1000;
    } else if (s2->proj==1) {
      memcpy(&wk, &ud[28], 3); s2->xd = (wk>>8);
      memcpy(&wk, &ud[31], 3); s2->yd = (wk>>8);
      memcpy(&wk, &ud[23], 3); s2->lat1 = (wk>>8);
      s2->lon2 = 180*1000;
    } else if (s2->proj==3) {
      memcpy(&wk, &ud[20], 3); s2->xd = (wk>>8);
      memcpy(&wk, &ud[23], 3); s2->yd = (wk>>8);
      memcpy(&wk, &ud[17], 3); s2->lon1 = (wk>>8);
      s2->lon2 = s2->lon1;
      memcpy(&wk, &ud[28], 3); s2->lat1 = (wk>>8);
      memcpy(&wk, &ud[31], 3); s2->lat2 = (wk>>8);
    }
  }
return(len);
}

int grib_dec_sect3(unsigned char ud[])
{
int len;
unsigned int work;
  memcpy(&work, ud, 4);
  len = work>>8 ;
return(len);
}
