#include "n2g.h"
#include "nusdas.h"
extern int pflag, dflag, pnum, mnum, thing, bflag;
extern unsigned char s2d[];
extern char dname[];
extern ST_PARM pt[];
extern ST_MODEL mt[];
float gs_lon[640], gs_lat[320];
int  gs_read_flag=0;

int sisha_gonyu(double d)
{
  return((d>=0) ? (int)(d+0.5) : (int)(d-0.5));
}

int grib_enc_sect4(float *d, int dnum, int *nbit, int *bsf, unsigned char uc[])
{
int i, j, k, l, n, nn, n4, pms;
int ti, tj;
unsigned char *wc;
unsigned short us, ws=0x8000;
unsigned int ui, *w, wi, ui2, *uiv;
float amp, sf, ref, pamp[8], pref[8];

  ti = dnum/8;
/*poption parallel*/
  for(j=0; j<8; j++) {
    tj = (j==7) ? dnum : ti*(j+1);
    for(i=ti*j, pref[j]=d[i], pamp[j]=d[i]; i<tj; i++)  {
      if (d[i]<pref[j])  pref[j] = d[i];
      if (d[i]>pamp[j])  pamp[j] = d[i];
    }
  }
  for(j=1, ref=pref[0], amp=pamp[0]; j<8; j++) {
    if (pref[j]<ref)  ref = pref[j];
    if (pamp[j]>amp)  amp = pamp[j];
  }
  amp -= ref;
  if (amp==0.0)  amp = 1.0;
  if (*bsf==-999 && *nbit==-999)  return(-2);
  else if (*nbit==-999) *nbit = (int)(log((double)amp)/log(2.0))-(*bsf)+1;
  else if (*bsf==-999)  *bsf = (int)(log((double)amp)/log(2.0))-(*nbit)+1;
  if (*bsf!=(int)(log((double)amp+0.5*pow(2.0,(double)*bsf))/log(2.0))-(*nbit)+1)
    (*bsf)++;
  if (*bsf<0) { us = (unsigned short)((-1)*(*bsf)); us = us | ws;
  } else {      us = (unsigned short)*bsf; }
  memcpy(&uc[4], &us, 2);
  if (ref>=0.0) { wi = 0x00000000; pms = 1;
  } else {        wi = 0x80000000; pms = (-1); }
  if (ref==0.0) {
    ui = 0; ui2 = 0;
  } else {
    ui = (unsigned int)ceil(log((double)ref*pms)/log(16.0)+64);
    ui2 = (unsigned int)(ref*pms*pow(16.0,(double)(70-ui)));
  }
  ui = ui << 24;
  ui = ui | ui2 | wi;
  memcpy(&uc[6], &ui, 4);
  uc[10] = (unsigned char)(*nbit);
  w = (unsigned int *)malloc(sizeof(unsigned int)*(dnum*(*nbit)/8/4+2));
  if (w==NULL) {
    fprintf(stderr, "malloc failed!! size=%d\n", (dnum*(*nbit)/8/4+2)*4);
    exit(1);
  }
  ti = dnum*(*nbit)/8/4+2; /* keep one reserved area */
/*poption parallel*/
  for(i=0; i<ti; i++)  w[i] = 0;
  sf = (float)(1.0/pow((double)2.0,(double)(*bsf)));

  uiv = (unsigned int *)malloc(sizeof(unsigned int)*dnum);
  if (uiv==NULL) {
    fprintf(stderr, "malloc failed!! size=%d\n", dnum*4);
    exit(1);
  }
/*poption parallel*/
  for(i=0; i<dnum; i++)  {
    uiv[i] = (unsigned int)((d[i]-ref)*sf+0.5);
  }
  ti = sizeof(unsigned int)*8-(*nbit);
  for(i=0, j=0, k=0; i<dnum; i++)  {
    ui = uiv[i];
    l = ti-j;
    if (l>=0)  ui = ui << l;
    else       ui = ui >> (l*(-1));
    w[k] |= ui;
    j += (*nbit);
    if (j>=sizeof(unsigned int)*8)  { k++;  j -= sizeof(unsigned int)*8; }
    if (l<0) {
      ui = uiv[i];
      l = sizeof(unsigned int)*8-j;
      if (l>=0)  ui = ui << l;
      else       ui = ui >> (l*(-1));
      w[k] |= ui;
    }
  }
  free(uiv);
  n = (int)((float)(dnum*(*nbit)-1)/8+1); /* total bytes */
  nn = (int)(n/2)*2+1;                /* to adjust odd bytes */
  uc[3] = (n%2==0) ? 8+j%8 : j%8;
/*
  uc[3] = (n%2!=0) ? 8-j%8 : 8-j%8+8;
  if (uc[3]==16) uc[3]=0;
*/
  if (pflag!=0) {
    fprintf((pflag==1) ? stdout : stderr,
            " n=%7.2f,x=%7.2f,B=%2.2d,", ref, ref+amp, *nbit);
    fflush((pflag==1) ? stdout : stderr);
  }
  memcpy(&uc[11], w, nn); 
  free(w);
  n4 = nn+11; i = n4 << 8;
  memcpy(&uc[0], &i, 3);
return(n4);
}

void set_period(unsigned char uc[], ST_TARGET *tl, char *vtu)
{
int i;
float pamp;
unsigned short *us;
char cw[4];

  for(i=0; i<mnum; i++) if (memcmp(mt[i].name, tl->type1, 4)==0)  break;
  if (strcmp(vtu,"MIN ")==0)       uc[0] = 0;
  else if (strcmp(vtu,"HOUR")==0)  uc[0] = 1;
  else if (strcmp(vtu,"DAY ")==0)  uc[0] = 2;
  if (memcmp(tl->type2,"AA",2)==0 || memcmp(tl->type2,"EA",2)==0) {
    if (tl->elem[0]=='_') {
      uc[1] = 0; uc[2] = tl->vt;
      uc[3] = (memcmp(&(tl->type2[2]),"AV",2)==0) ? 4 : 3;
    } else if (memcmp(&(tl->type2[2]),"AV",2)==0) {
      uc[1] = tl->vt;
      uc[2] = (tl->vt2!=-1) ? (tl->vt+tl->vt2) : tl->vt; uc[3] = 4;
    } else if (memcmp(&(tl->type2[2]),"MV",2)==0) {
      uc[1] = tl->vt;
      uc[2] = (tl->vt2!=-1) ? (tl->vt+tl->vt2) : tl->vt; uc[3] = 3;
    } else {
      uc[1] = 0; uc[2] = 0; uc[3] = 0;
    }
  } else if (memcmp(tl->type2,"FC",2)==0 || memcmp(tl->type2,"EF",2)==0 ||
             memcmp(tl->type2,"AF",2)==0) {
    if (strncmp(tl->elem, "RR", 2)==0 && isdigit(tl->elem[2])) {
      uc[3] = 4; uc[2] = tl->vt;
      if (tl->elem[3]=='H')  {
        if (strcmp(vtu,"MIN ")==0)       pamp = 60;
        else if (strcmp(vtu,"HOUR")==0)  pamp = 1;
        else if (strcmp(vtu,"DAY ")==0)  pamp = 1.0/24;
        strncpy(cw, &tl->elem[2], 1);
        uc[1] = uc[2]-(unsigned char)(atoi(cw)*pamp);
      } else if (tl->elem[3]=='D') {
        if (strcmp(vtu,"MIN ")==0)       pamp = 1440;
        else if (strcmp(vtu,"HOUR")==0)  pamp = 24;
        else if (strcmp(vtu,"DAY ")==0)  pamp = 1;
        strncpy(cw, &tl->elem[2], 1);
        uc[1] = uc[2]-(unsigned char)(atoi(cw)*pamp);
      } else if (isdigit(tl->elem[3])) {
        if (strcmp(vtu,"MIN ")==0)       pamp = 1;
        else if (strcmp(vtu,"HOUR")==0)  pamp = 1.0/60;
        strncpy(cw, &tl->elem[2], 2);
        uc[1] = uc[2]-(unsigned char)(atoi(cw)*pamp);
      }
    } else if (strcmp(tl->elem,"RAIN  ")==0 && i!=mnum
               && mt[i].rflag==1 && memcmp(&(tl->type2[2]),"SV",2)==0) {
      uc[1] = 0; uc[2] = tl->vt; uc[3] = 4;  /* for NWP ROUTINE */
    } else {
      if (tl->elem[0]=='_') {
        uc[1] = 0; uc[2] = tl->vt;
        uc[3] = (memcmp(&(tl->type2[2]),"AV",2)==0) ? 4 : 3;
      } else if (memcmp(&(tl->type2[2]),"AV",2)==0) {
        uc[1] = tl->vt;
        uc[2] = (tl->vt2!=-1) ? (tl->vt+tl->vt2) : tl->vt; uc[3] = 4;
      } else if (memcmp(&(tl->type2[2]),"MV",2)==0) {
        uc[1] = tl->vt;
        uc[2] = (tl->vt2!=-1) ? (tl->vt+tl->vt2) : tl->vt; uc[3] = 3;
      } else {
        uc[3] = (tl->vt==0) ? 1 : 0;
        if (tl->vt<255) {
          uc[1] = tl->vt; uc[2] = 0;
        } else {
          uc[3] = 10;
          us = (unsigned short *)&uc[1];
          *us = tl->vt;
        }
      }
    }
  }
  uc[4] = uc[5] = uc[6] = 0;
}

void set_level(unsigned char uc[], ST_TARGET *tl, float *eta_b, int pln)
{
int i;
unsigned short *us, us0=0;

  for(i=0; i<mnum; i++) if (memcmp(mt[i].name, tl->type1, 4)==0)  break;
  us = (unsigned short *)&uc[1];
  if (memcmp(&(tl->type1[6]),"PP",2)==0) {
    if (strcmp(tl->elem,"PSEA  ")==0 || strstr(tl->elem,"SLP")!=NULL) {
      uc[0] = 102;
      *us = us0;
    } else if (strcmp(tl->levl,"SURF  ")==0) {
      if (strcmp(tl->elem,"U     ")==0 || strcmp(tl->elem,"V     ")==0 ||
          strcmp(tl->elem,"WindS ")==0) {
        uc[0] = 105;
        *us = (i==mnum) ? 10 : mt[i].usfc;
      } else if (strcmp(tl->elem,"T     ")==0 || strcmp(tl->elem,"TTD   ")==0 ||
                 strcmp(tl->elem,"RH    ")==0){
        uc[0] = 105;
        *us = (i==mnum) ? 2 : mt[i].tsfc;
      } else {
        uc[0] = 1;
        *us = us0;
      }
    } else {
      uc[0] = 100;
      *us = (unsigned short)atoi(tl->levl);
    }
  } else if (memcmp(&(tl->type1[6]),"SF",2)==0) {
    if (strcmp(tl->elem,"PSEA  ")==0) {
      uc[0] = 102;
      *us = us0;
    } else if (strcmp(tl->levl,"SURF  ")==0) {
      if (strcmp(tl->elem,"U     ")==0 || strcmp(tl->elem,"V     ")==0 ||
          strcmp(tl->elem,"WindS ")==0) {
        uc[0] = 105;
        *us = (i==mnum) ? 10 : mt[i].usfc;
      } else if (strcmp(tl->elem,"T     ")==0 || strcmp(tl->elem,"TTD   ")==0 ||
                 strcmp(tl->elem,"RH    ")==0){
        uc[0] = 105;
        *us = (i==mnum) ? 2 : mt[i].tsfc;
      } else {
        uc[0] = 1;
        *us = us0;
      }
    } else {
      uc[0] = 1;
      *us = us0;
    }
  } else if (memcmp(&(tl->type1[6]),"LY",2)==0) {
    if (strcmp(tl->elem,"PSEA  ")==0) {
      uc[0] = 102;
      *us = us0;
    } else if ((memcmp(tl->elem,"RL",2)==0 || memcmp(tl->elem,"RS",2)==0)
               && (tl->elem[3]=='B' || tl->elem[3]=='T')) {
      uc[0] = (tl->elem[3]=='B') ? 1 : 8;
      *us = us0;
    } else if ((memcmp(tl->elem,"_RL",3)==0 || memcmp(tl->elem,"_RS",3)==0)
               && (tl->elem[4]=='B' || tl->elem[4]=='T')) {
      uc[0] = (tl->elem[3]=='B') ? 1 : 8;
      *us = us0;
    } else if (strcmp(tl->levl,"SURF  ")==0) {
      if (strcmp(tl->elem,"U     ")==0 || strcmp(tl->elem,"V     ")==0 ||
          strcmp(tl->elem,"WindS ")==0) {
        uc[0] = 105;
        *us = (i==mnum) ? 10 : mt[i].usfc;
      } else if (strcmp(tl->elem,"T     ")==0 || strcmp(tl->elem,"TTD   ")==0 ||
                 strcmp(tl->elem,"RH    ")==0){
        uc[0] = 105;
        *us = (i==mnum) ? 2 : mt[i].tsfc;
      } else {
        uc[0] = 1;
        *us = us0;
      }
    } else {
      uc[0] = 0;
      *us = (unsigned short)atoi(tl->levl);
    }
  } else if (memcmp(&(tl->type1[6]),"ET",2)==0) {
    uc[0] = 109;
    *us = (unsigned short)atoi(tl->levl);
/*
    uc[0] = 119;
    *us = eta_b[atoi(tl->levl)-1]*10000;
*/
  }
}

int set_proj(unsigned char uc[], ST_TARGET *tl, char *proj,
             int gs[], float ginfo[], int ltn[])
{
unsigned char wc=0x80;
unsigned short us;
unsigned int ui, wi=0x80000000;
int n2, xs, xe, ys, ye, xd, yd, i, ii, k;
double *lat[1000], *lon[1000], dels, slate, slatp, slon, xi, xj, olat, xlon, wk;
FILE *fp;
char fname[240];

  xs = (tl->xs==-999) ? 1 : tl->xs;
  xe = (tl->xe==-999) ? gs[0] : tl->xe;
  xd = (tl->xd==-999) ? 1 : tl->xd;
  ys = (tl->ys==-999) ? 1 : tl->ys;
  ye = (tl->ye==-999) ? gs[1] : tl->ye;
  yd = (tl->yd==-999) ? 1 : tl->yd;
  if (memcmp(proj,"GS  ",4)==0 && gs_read_flag==0) {
    sprintf(fname, "%sgauss_lon%3d.dat", dname, gs[0]);
    if ((fp=fopen(fname, "r"))==NULL) {
      fprintf(stderr, "%s open failed!!\n", fname); gs_read_flag = -1;
    } else {
      gs_read_flag = 1;
      if (fread_native(gs_lat, 4, gs[1], fp)!=gs[1]) {
        fprintf(stderr, "%s read failed!!\n", fname); gs_read_flag = -1;
      }
      if (fread_native(gs_lon, 4, gs[0], fp)!=gs[0]) {
        fprintf(stderr, "%s read failed!!\n", fname); gs_read_flag = -1;
      }
      fclose(fp);
    }
  }
  if (memcmp(proj,"LL  ",4)==0 || memcmp(proj,"GS  ",4)==0) {
    n2 = (thing==0) ? 32 : 32+((ye-ys)/yd+1)*2; i = n2 << 8;
    memcpy(&uc[0], &i, 3);
    uc[3] = 0; uc[4] = (thing==0) ? 0xff : 33;
    uc[5] = (memcmp(proj,"LL  ",4)==0) ? 0 : 4;
    us = (thing==0) ? (xe-xs)/xd+1 : 0xffff;
    memcpy(&uc[6], &us, 2);
    if (pflag!=0) fprintf((pflag==1) ? stdout : stderr, "N=%-d", us);
    us = (ye-ys)/yd+1;
    memcpy(&uc[8], &us, 2);
    if (pflag!=0) fprintf((pflag==1) ? stdout : stderr, "x%-d", us);
    ii = (memcmp(proj,"LL  ",4)==0) ?
           sisha_gonyu((ginfo[2]+(ginfo[1]-ys)*ginfo[5])*1000) :
           sisha_gonyu(gs_lat[ys-1]*1000);
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[10], &ui, 3);
    ii = (memcmp(proj,"LL  ",4)==0) ?
           sisha_gonyu((ginfo[3]-(ginfo[0]-xs)*ginfo[4])*1000) :
           sisha_gonyu(gs_lon[xs-1]*1000);
    while (ii>180*1000) ii -= 360*1000;
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[13], &ui, 3);
    uc[16] = 0x80;
    ii = (memcmp(proj,"LL  ",4)==0) ?
           sisha_gonyu((ginfo[2]+(ginfo[1]-ye)*ginfo[5])*1000) :
           sisha_gonyu(gs_lat[ye-1]*1000);
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[17], &ui, 3);
    ii = (memcmp(proj,"LL  ",4)==0) ?
           sisha_gonyu((ginfo[3]-(ginfo[0]-xe)*ginfo[4])*1000) :
           sisha_gonyu(gs_lon[xe-1]*1000);
    while (ii>180*1000) ii -= 360*1000;
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[20], &ui, 3);
    us = (thing==0) ? (short)(ginfo[4]*1000*xd) : 0xffff;
    memcpy(&uc[23], &us, 2);
    us = (memcmp(proj,"LL  ",4)==0) ? (short)(ginfo[5]*1000*yd)
                                    : (short)((gs[1]/yd+1)/2);
    memcpy(&uc[25], &us, 2);
    uc[27] = 0;
    for(i=28; i<32; i++) uc[i] = 0;
    if (thing==1) {
      for(k=0, i=ys; i<=ye; i+=yd, k++) {
        us = ltn[k];
        memcpy(&uc[32+k*2], &us, 2);
      }
    }
  } else if (memcmp(proj,"LMN ",4)==0 || memcmp(proj,"LMS ",4)==0) {
    n2 = 42; i = n2 << 8;
    memcpy(&uc[0], &i, 3);
    uc[3] = 0; uc[4] = 0xff; uc[5] = 3;
    us = (xe-xs)/xd+1; memcpy(&uc[6], &us, 2);
    if (pflag!=0) fprintf((pflag==1) ? stdout : stderr, "N=%-d", us);
    us = (ye-ys)/yd+1; memcpy(&uc[8], &us, 2);
    if (pflag!=0) fprintf((pflag==1) ? stdout : stderr, "x=%-d", us);
    dels = ginfo[4];
    slate = (ginfo[8]>=ginfo[6]) ? ginfo[8] : ginfo[6];
    slatp = (ginfo[8]>=ginfo[6]) ? ginfo[6] : ginfo[8];
    slon = ginfo[7]; xi = ginfo[0]; xj = ginfo[1];
    olat = ginfo[2]; xlon = ginfo[3];
    for(i=0; i<gs[1]; i++) {
      lat[i] = (double *)malloc(sizeof(double)*gs[0]);
      lon[i] = (double *)malloc(sizeof(double)*gs[0]);
      if (lat[i]==NULL || lon[i]==NULL) {
        fprintf(stderr, "malloc failed!! size=%d\n", gs[0]*8);
        exit(1);
      }
    }
    i = nwp_mproj_lm2ll(lat, lon, gs[0], gs[1], dels, slate, slatp, slon,
                        xi, xj, olat, xlon);
    ii = (int)(lat[ys-1][xs-1]*1000);
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[10], &ui, 3);
    ii = sisha_gonyu(lon[ys-1][xs-1]*1000);
    while (ii>180*1000) ii -= 360*1000;
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[13], &ui, 3);
    for(i=0; i<gs[1]; i++) { free(lat[i]); free(lon[i]); }
    uc[16] = 0x80;
    ii = sisha_gonyu(slon*1000);
    while (ii>180*1000) ii -= 360*1000;
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[17], &ui, 3);
    ii = sisha_gonyu((double)ginfo[4]*xd); ui = (unsigned int)ii; ui = ui << 8;
    memcpy(&uc[20], &ui, 3);
    ii = sisha_gonyu((double)ginfo[5]*yd); ui = (unsigned int)ii; ui = ui << 8;
    memcpy(&uc[23], &ui, 3);
    uc[26] = (memcmp(proj,"LMN ",4)==0) ? 0x00 : 0x80;
    uc[27] = 0;
    ii = sisha_gonyu(slatp*1000);
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[28], &ui, 3);
    ii = sisha_gonyu(slate*1000);
    if (ii<0) { ui = (unsigned int)((-1)*ii); ui = (ui << 8) | wi;
    } else {    ui = (unsigned int)ii;        ui = ui << 8; }
    memcpy(&uc[31], &ui, 3);
    for(i=34; i<42; i++) uc[i] = 0;
  }
return(n2);
}

int grib_enc(float *d, int gn, ST_TARGET *tl, float *eta_b, int pln,
             int iy, int im, int id, int ih, int in, char *vtu,
             char *proj, int gs[], float ginfo[], unsigned char uc[])
{
unsigned char xc=0x01, wc;
unsigned char beki[]={0x7f,0xbf,0xdf,0xef,0xf7,0xfb,0xfd,0xfe};
unsigned short us, ws=0x8000;
unsigned int n, n0, n1, n2, n3, n4, nn;
int i, j, ii, jj, i1, i2, k, l, nbit, bsf, dv, xs, xe, ys, ye, xd, yd;
int gn2, ltn[256], maf;
float *d2, *d3, lat, ix, w1, w2, omg;

/* section 0 */
  n0 = 8;
  memcpy(&uc[0], "GRIB", 4);
  memcpy(&uc[4], "dum", 3);
  memcpy(&uc[7], &xc, 1);

/* section 1 */
  n1 = 28; i = n1 << 8;
  memcpy(&uc[n0+0], &i, 3);
  for(i=3; i<=7; i++) uc[n0+i] = s2d[i];
  for(i=0; i<mnum; i++) if (memcmp(mt[i].name, tl->type1, 4)==0)  break;
  uc[n0+5] = (i==mnum) ? s2d[5] : (unsigned char)mt[i].mn;
  for(i=0; i<pnum; i++) if (strcmp(pt[i].name, tl->elem)==0)  break;
  uc[n0+8] = (i==pnum) ? s2d[8] : (unsigned char)pt[i].pn;
  set_level(&uc[n0+9], tl, eta_b, pln);
  uc[n0+12] = iy%100;  if (uc[n0+12]==0)  uc[n0+12] = 100;
  uc[n0+13] = im; uc[n0+14] = id; uc[n0+15] = ih; uc[n0+16] = in;
  set_period(&uc[n0+17], tl, vtu);
  uc[n0+24] = (unsigned char)(((iy-1)/100)+1);
  uc[n0+25] = 0;
  dv = (i==pnum) ? 0 : pt[i].pd;
  if (dv<0) { us = (unsigned short)((-1)*dv); us = us | ws;
  } else {    us = (unsigned short)dv; }
  memcpy(&uc[n0+26], &us, 2);
  if (pflag!=0) {
    fprintf((pflag==1) ? stdout : stderr,
            "   <%2.2d%2.2d%2.2d%2.2d:F%3.3d,E%2.2d,",
            iy-2000,im,id,ih,uc[n0+18],uc[n0+8]);
    fflush((pflag==1) ? stdout : stderr);
  }

/* section 2 */
  if (memcmp(proj,"LL  ",4)==0 && thing==1) {
    xs = (tl->xs==-999) ? 1 : tl->xs;
    xe = (tl->xe==-999) ? gs[0] : tl->xe;
    xd = (tl->xd==-999) ? 1 : tl->xd;
    ys = (tl->ys==-999) ? 1 : tl->ys;
    ye = (tl->ye==-999) ? gs[1] : tl->ye;
    yd = (tl->yd==-999) ? 1 : tl->yd;
    for(gn2=0, k=0, j=ys; j<=ye; j+=yd, k++) {
      lat = ginfo[2]-(j-1)*ginfo[4];
      ltn[k] = (int)(2+cos((double)lat*PAI)*(ye-ys));
      if (lat==0.0) ltn[k]--;
      gn2 += ltn[k];
    }
  }
  n2 = set_proj(&uc[n0+n1], tl, proj, gs, ginfo, ltn);

/* data array set */
  if (memcmp(tl->elem, "OMG", 3)==0) {
    omg = 1.0/36.0;
    for(i=0; i<gn; i++)  if (d[i]!=N_MV_R4)  d[i] *= omg;
  }
  if (memcmp(proj,"LL  ",4)==0 && thing==1) {
    d2 = (float *)malloc(sizeof(float)*gn2);
    if (d2==NULL) {
      fprintf(stderr, "malloc failed!! size=%d\n", gn2*4);
      exit(1);
    }
    maf = 1;
    for(k=0, l=0, j=ys; j<=ye; j+=yd, l++)
    for(i=0; i<ltn[l]; i++, k++) {
      ix = xs+(float)(xe-xs)/(ltn[l]-1)*i;
      i1 = (int)ix;    
      i2 = (int)(ix+1);
      w1 = i2-ix; w2 = ix-i1;
      i1 = (i1>gs[0]) ? i1-gs[0] : i1;
      i2 = (i2>gs[0]) ? i2-gs[0] : i2;
      d2[k] = d[i1-1+gs[0]*(j-1)]*w1+d[i2-1+gs[0]*(j-1)]*w2;
    }
  } else if (tl->xs==-999 && tl->xe==-999 && tl->ys==-999 && tl->ye==-999 &&
             tl->xd==-999 && tl->yd==-999) {
    d2 = d; gn2 = gn; maf = 0;
  } else {
    xs = (tl->xs==-999) ? 1 : tl->xs;
    xe = (tl->xe==-999) ? gs[0] : tl->xe;
    xd = (tl->xd==-999) ? 1 : tl->xd;
    ys = (tl->ys==-999) ? 1 : tl->ys;
    ye = (tl->ye==-999) ? gs[1] : tl->ye;
    yd = (tl->yd==-999) ? 1 : tl->yd;
    gn2 = ((xe-xs)/xd+1)*((ye-ys)/yd+1);
    d2 = (float *)malloc(sizeof(float)*gn2);
    if (d2==NULL) {
      fprintf(stderr, "malloc failed!! size=%d\n", gn2*4);
      exit(1);
    }
    maf = 1;
/*poption parallel*/
    for(k=0, j=ys; j<=ye; j+=yd, k++) {
      jj = k*((xe-xs)/xd+1);
      for(l=0, i=xs; i<=xe; i+=xd, l++) {
        ii = (i>gs[0]) ? i-gs[0] : i;
        d2[l+jj] = d[ii-1+gs[0]*(j-1)];
      }
    }
  }

/* section 3 */
  n3 = 0; nn = n0+n1+n2;
  if (bflag==1) {
    d3 = (float *)malloc(sizeof(float)*gn2);
    if (d3==NULL) {
      fprintf(stderr, "malloc failed!! size=%d\n", gn2*4);
      exit(1);
    }
    uc[n0+7] |= 0x40;
    uc[nn+3] = 8-gn2%8;  if (uc[nn+3]==8) uc[nn+3] = 0;
    uc[nn+4] = 0; uc[nn+5] = 0;
    for(i=0, j=0, l=0; i<gn2; i+=8, j++) {
      for(k=0, wc=255; k<8; k++) {
        if (d2[i+k]==N_MV_R4 || i+k>=gn2)  wc &= beki[k];
        else                               d3[l++] = d2[i+k];
      }
      uc[nn+6+j] = wc;
    }
    n3 = 6+j;
    i = n3 << 8;
    memcpy(&uc[nn+0], &i, 3);

    gn2 = l;
    memcpy(d2, d3, sizeof(float)*gn2);
    free(d3);
  }

/* section 4 */
  nbit = (tl->bec=='B') ? tl->be : -999;
  bsf = (tl->bec=='E') ? tl->be : -999;
  n4 = grib_enc_sect4(d2, gn2, &nbit, &bsf, &uc[n0+n1+n2+n3]);
  if (maf==1) free(d2);

/* section 5 */
  memcpy(&uc[n0+n1+n2+n3+n4], "7777", 4);
  n = n0+n1+n2+n3+n4+4; i = n<<8;
  memcpy(&uc[4], &i, 3);

  if (pflag!=0) {
    fprintf((pflag==1) ? stdout : stderr, "size=%d>\n", n);
    fflush((pflag==1) ? stdout : stderr);
  }
return(n);
}
