#include <stdio.h>
#include <time.h>
int main(int argc, char *argv[])
{
unsigned char ud;
FILE  *fp, *fpo;
int  rlens, rlene, alen, systime, offset, lflag=0, ladd;
int  y, m, d, h, f, vt1, vt2, xs, ys, miss, size;
int  n_data=0, frlen=0, eflag=0, i, j;
char  rname[5], member[5], level1[7], level2[7], element[7], pack[5], sname[5];
char type[17], info[21];
short dum;
struct tm *tp;
float base, amp;
double dbase, damp;

  if (argc==1)  {
    fprintf(stderr, "usage: nusdas_dump_rec filename (-l) (forced_rlen)\n");
    fprintf(stderr, "    if -l specified and the record in the file is ?PAC\n");
    fprintf(stderr, "    or ?UPC, base and amp values are printed!!\n");
    exit(1);
  }
  rname[4]='\0'; member[5]='\0'; pack[5]='\0';
  level1[6]='\0'; level2[6]='\0'; element[6]='\0'; type[16]='\0';
  if ((fp=fopen(argv[1], "r"))==NULL) {
    fprintf(stderr, "Can not open file <%s>\n", argv[1]);
    exit(1);
  }
  for(i=2; i<argc; i++) {
    if (argv[i][0]=='-') {
      if (argv[i][1]=='l')  lflag = 1;
    } else {
      for(j=0; j<strlen(argv[i]); j++)  if (!isdigit(argv[i][j]))  break;
      if (j==strlen(argv[i])) {
        frlen = atoi(argv[i]);
        printf(" frlen : %d\n", frlen);
      }
    }
  }
  printf(" name  length create-clock member  valid-time   level1:element  pack  size-x,y\n");
  offset = 0;
  while(1) {
    if (fread_native(&rlens, 4, 1, fp)!=1) break;
    fread_native(rname, 1, 4, fp);
    if (frlen!=0 && rlens==0) {
      rlens=frlen;
      strcpy(rname, "DATA");
      eflag=1;
    }
    fread_native(&alen, 4, 1, fp);
    fread_native(&systime, 4, 1, fp);
    tp = gmtime((time_t*)&systime);
    printf("<%4s> %6d %4.4d%2.2d%2.2d%2.2d%2.2d",rname, rlens, tp->tm_year+1900,
      tp->tm_mon+1, tp->tm_mday, tp->tm_hour, tp->tm_min);
    if (strcmp(rname, "DATA")==0) {
      n_data++;
      fread_native(member, 1, 4, fp);
      fread_native(&vt1, 4, 1, fp); fread_native(&vt2, 4, 1, fp);
      nwp_seq2ymdhm(&y, &m, &d, &h, &f, vt1);
      fread_native(level1, 1, 6, fp); fread_native(level2, 1, 6, fp);
      fread_native(element, 1, 6, fp);
      fread_native(&dum, 2, 1, fp);
      fread_native(&xs, 4, 1, fp); fread_native(&ys, 4, 1, fp);
      fread_native(pack, 1, 4, fp);
      fread_native(&miss, 4, 1, fp);
      if (lflag==1) {
        if (strncmp(pack,"1PAC",4)==0 || strncmp(pack,"2PAC",4)==0 ||
            strncmp(pack,"2UPC",4)==0)  {
          fread_native(&base, 4, 1, fp);
          fread_native(&amp, 4, 1, fp);
          ladd = 8;
        } else if (strncmp(pack,"4PAC",4)==0) {
          fread_native(&dbase, 8, 1, fp);  base = dbase;
          fread_native(&damp, 8, 1, fp);   amp = damp;
          ladd = 16;
        } else {
          ladd = 0;
        }
      } else
        ladd = 0;
      if (memcmp(&miss,"UDFV",4)==0 || memcmp(&miss,"MASK",4)==0 ||
	  memcmp(&miss,"NONE",4)==0) {
        printf(" <%4s> %4.4d%2.2d%2.2d%2.2d%2.2d <%6s:%6s> <%4s> <%-d,%-d>",
                member, y, m, d, h, f, level1, element, pack, xs, ys);
      } else {
	memcpy(pack, &xs, 4);
        printf(" <%4s> %4.4d%2.2d%2.2d%2.2d%2.2d <%6s:%6s> <%4s>",
                member, y, m, d, h, f, level1, element, pack);
      }
      if (lflag==1 && (strncmp(&pack[1],"PAC",3)==0 ||
                       strncmp(&pack[1],"UPC",3)==0))  {
        printf(" <base:%f, amp:%f>",  base, amp);
      }
      offset = rlens-32-36-ladd;
    } else if (strcmp(rname, "CNTL")==0) {
      fread_native(type, 1, 16, fp);
      printf(" <%16s>", type);
      offset = rlens-20-16;
    } else if (strcmp(rname, "SUBC")==0) {
      fread_native(sname, 1, 4, fp);
      printf(" <%4s>", sname);
      fread_native(&size, 4, 1, fp);
      printf(" %d", size);
      fread_native(&size, 4, 1, fp);
      printf(" %d", size);
      offset = rlens-20-4*3;
    } else if (strcmp(rname, "INFO")==0) {
      fread_native(sname, 1, 4, fp);
      printf(" <%4s>", sname);
      fread_native(info, 1, 20, fp); info[20]='\0';
      printf(" %s", info);
      offset = rlens-20-4-20;
    } else {
      offset = rlens-20;
    }
    fseek(fp, offset, SEEK_CUR);
    fread_native(&rlene, 4, 1, fp);
    if (frlen==0 && rlens!=rlene) {
      fprintf(stderr, " !!!! inconsistent record length <s:%d,e:%d>\n", rlens, rlene);
      fclose(fp);
      exit(0);
    } else {
      printf("\n");
    }
  }
  printf("<<<  total DATA record = %d  >>>\n", n_data);
  fclose(fp);
  return 0;
}
