#include "n2g.h"
#include "nusdas_sys.h"
#include "elemsub.h"
#define MAX_SIZE 1000*1000*50
int pflag=0, dflag=0, thing=0, cflag=0, eflag=0, bflag=0;
unsigned char uc[MAX_SIZE];
unsigned char s2d[28]={0x00,0x00,0x00,0x03,0x22, 0x00,0xff,0x80,0x00,0x00,
                       0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,
                       0x00,0x00,0x00,0x00,0x15, 0x00,0x00,0x00};
char histfile[240][50];
char dname[240];
int pnum=0, mnum=0, hfnum=0;
ST_PARM pt[256];
ST_MODEL mt[256];
char attr[]="BIN", rjtd[10], ttaaii[10], bch[20], header[20], fproj[20]="--";
int  kind=65, annum=19;
double **lat, **lon, **fi, **fj, **fsin, **fcos;
int    ma_flag=0, latn, lonn;
float  lat0, lon0, latd, lond;

extern FILE *n_fp[];

int convert_coordinate(char *cctfile, float *d, float *d2,
                float **dd, float **dd2, char *proj,
                int gs[], float ginfo[], char *cproj, int cgs[], float cginfo[])
{
char sl[240];
int i, j, i1, i2, j1, j2, ia, ib, ja, jb;
double dels, slate, slatp, slon, xi, xj, xlat, xlon;
double **plat, **plon, **pi, **pj, wl;
float ddw;
FILE *fp;

  dels = ginfo[4]; slate = ginfo[8]; slatp = ginfo[6]; slon = ginfo[7];
  xi = ginfo[0]; xj = ginfo[1]; xlat = ginfo[2]; xlon = ginfo[3];
  if (ma_flag==0) {
    if ((fp=fopen(cctfile, "r"))!=NULL) {
      while(fgets(sl, 240, fp)!=NULL) {
        if (sl[0]=='#')  continue;
        if (sscanf(sl, "%s %d %d %f %f %f %f",
                   fproj,&lonn,&latn,&lon0,&lat0,&lond,&latd)!=7)  {
          fprintf(stderr, "nus2grib: cctfile<%s> is incorrect!\n", cctfile);
          return(1);
        } else break;
      }
      fclose(fp);
    } else {
      fprintf(stderr, "nus2grib: Can not open cctfile!\n");
      fprintf(stderr, "          Prepare the file<%s>!\n", cctfile);
      return(1);
    }
    if (strncmp(proj, "LMN", 3)!=0 || strncmp(fproj, "LL", 2)!=0) {
      fprintf(stderr,"nus2grib:coordinate conversion support only LM to LL!\n");
      return(1);
    }
    lat = (double **)malloc(sizeof(double *)*latn);
    lon = (double **)malloc(sizeof(double *)*latn);
    fi  = (double **)malloc(sizeof(double *)*latn);
    fj  = (double **)malloc(sizeof(double *)*latn);
    for(i=0; i<latn; i++)  lat[i] = (double *)malloc(sizeof(double)*lonn);
    for(i=0; i<latn; i++)  lon[i] = (double *)malloc(sizeof(double)*lonn);
    for(i=0; i<latn; i++)  fi[i]  = (double *)malloc(sizeof(double)*lonn);
    for(i=0; i<latn; i++)  fj[i]  = (double *)malloc(sizeof(double)*lonn);
    for(j=0; j<latn; j++)
    for(i=0; i<lonn; i++) {
      lat[j][i] = lat0-j*latd;
      lon[j][i] = lon0+i*lond;
    }
    i = nwp_mproj_ll2lm(fi,fj,lat,lon,lonn,latn,dels,slate,slatp,slon,
                    xi, xj, xlat, xlon);
    pi = (double **)malloc(sizeof(double *)*1);
    pj = (double **)malloc(sizeof(double *)*1);
    pi[0] = (double *)malloc(sizeof(double *)*1);
    pj[0] = (double *)malloc(sizeof(double *)*1);
    plat = (double **)malloc(sizeof(double *)*1);
    plon = (double **)malloc(sizeof(double *)*1);
    plat[0] = (double *)malloc(sizeof(double *)*1);
    plon[0] = (double *)malloc(sizeof(double *)*1);
    plat[0][0] = 90.0; plon[0][0] = 140.0;
    i = nwp_mproj_ll2lm(pi,pj,plat,plon,1,1,dels,slate,slatp,slon,
                    xi, xj, xlat, xlon);
    fsin = (double **)malloc(sizeof(double *)*latn);
    fcos = (double **)malloc(sizeof(double *)*latn);
    for(i=0; i<latn; i++)  fsin[i] = (double *)malloc(sizeof(double)*lonn);
    for(i=0; i<latn; i++)  fcos[i] = (double *)malloc(sizeof(double)*lonn);
    for(j=0; j<latn; j++)
    for(i=0; i<lonn; i++) {
      wl = sqrt(pow((fi[j][i]-pi[0][0]),2.0)+pow((fj[j][i]-pj[0][0]),2.0));
      fsin[j][i] = (fi[j][i]-pi[0][0])/wl;
      fcos[j][i] = (fj[j][i]-pj[0][0])/wl;
    }
    ma_flag++;
  }

  *dd = (float *)malloc(sizeof(float)*latn*lonn);
  *dd2= (float *)malloc(sizeof(float)*latn*lonn);
  if (*dd==NULL || *dd2==NULL) {
    fprintf(stderr, "malloc failed!! size=%d\n", latn*lonn*4);
    exit(1);
  }
  for(j=0; j<latn; j++)
  for(i=0; i<lonn; i++) {
    i1 = (int)fi[j][i]; i2 = i1+1; ia = i1; ib = i2;
    if (i1<1) i1=1; if (i1>gs[0]) i1=gs[0];
    if (i2<1) i2=1; if (i2>gs[0]) i2=gs[0];
    j1 = (int)fj[j][i]; j2 = j1+1; ja = j1; jb = j2;
    if (j1<1) j1=1; if (j1>gs[1]) j1=gs[1];
    if (j2<1) j2=1; if (j2>gs[1]) j2=gs[1];
    *(*dd+i+lonn*j) = (*(d+(i1-1)+gs[0]*(j1-1))*(ib-fi[j][i])+
                       *(d+(i2-1)+gs[0]*(j1-1))*(fi[j][i]-ia))*(jb-fj[j][i])
                     +(*(d+(i1-1)+gs[0]*(j2-1))*(ib-fi[j][i])+
                       *(d+(i2-1)+gs[0]*(j2-1))*(fi[j][i]-ia))*(fj[j][i]-ja);
  }
  if (d2!=NULL) {
    for(j=0; j<latn; j++)
    for(i=0; i<lonn; i++) {
      i1 = (int)fi[j][i]; i2 = i1+1; ia = i1; ib = i2;
      if (i1<1) i1=1; if (i1>gs[0]) i1=gs[0];
      if (i2<1) i2=1; if (i2>gs[0]) i2=gs[0];
      j1 = (int)fj[j][i]; j2 = j1+1; ja = j1; jb = j2;
      if (j1<1) j1=1; if (j1>gs[1]) j1=gs[1];
      if (j2<1) j2=1; if (j2>gs[1]) j2=gs[1];
      ddw =(*(d2+(i1-1)+gs[0]*(j1-1))*(ib-fi[j][i])+
            *(d2+(i2-1)+gs[0]*(j1-1))*(fi[j][i]-ia))*(jb-fj[j][i])
           +(*(d2+(i1-1)+gs[0]*(j2-1))*(ib-fi[j][i])+
            *(d2+(i2-1)+gs[0]*(j2-1))*(fi[j][i]-ia))*(fj[j][i]-ja);
      *(*dd2+i+lonn*j) = -*(*dd+i+lonn*j)*fsin[j][i]+ddw*fcos[j][i];
      *(*dd+i+lonn*j) = *(*dd+i+lonn*j)*fcos[j][i]+ddw*fsin[j][i];
    }
  }
  cgs[0] = lonn; cgs[1] = latn; cginfo[0] = 1.0; cginfo[1] = 1.0;
  cginfo[2] = lat0; cginfo[3] = lon0; cginfo[4] = lond; cginfo[5] = latd;
  strcpy(cproj, "LL  ");

return(0);
}

int set_dname2(char dname[], ST_TARGET *tl, float *ginfo,
                int iy, int im, int id, int ih, int in, char *vtu, char *aname)
{
char s[80];
int i;
  sprintf(dname, "%8s%4s", tl->type1, tl->type2);
  if (strncmp(fproj, "LL", 2)==0)  { dname[4]='L'; dname[5]='L'; }
  else if (thing==1)               { dname[4]='T'; dname[5]='G'; }
  if (strcmp(tl->levl,"SURF  ")==0){ dname[6]='L'; dname[7]='Y'; }
  for(i=strlen(aname); i<4; i++) aname[i]='_'; aname[i]='\0';
  sprintf(s, "%4.4s", aname);  strcat(dname, s);
  strcat(dname, (tl->type1[1]=='G' || tl->type1[1]=='W'
                                   || tl->type1[1]=='S') ? "G" : "R");
  i = (tl->xd==-999) ? 1 : tl->xd;
  sprintf(s, "%3.3d", (int)(ginfo[5]*100*i));  strcat(dname, s);
  strcat(dname, tl->memb);
  sprintf(s, "%4.4d%2.2d%2.2d%2.2d%2.2d", iy,im,id,ih,in);  strcat(dname, s);
  if (strcmp(vtu,"MIN ")==0)       sprintf(s, "MIN%3.3d", tl->vt);
  else if (strcmp(vtu,"HOUR")==0)  sprintf(s, "%6.6d", tl->vt);
  else if (strcmp(vtu,"DAY ")==0)  sprintf(s, "DAY%3.3d", tl->vt);
  else if (strcmp(vtu,"MON ")==0)  sprintf(s, "MON%3.3d", tl->vt);
  strcat(dname, s); strcat(dname, "      ");
  if (strcmp(tl->levl, "SURF  ")==0)  strcat(dname, "__SURF");
  else {
    sprintf(s, "%6.6d", atoi(tl->levl)*10);  strcat(dname, s);
  }
  strcat(dname, "      ");
  strcpy(s, tl->elem);
  for(i=0; i<6; i++) if (s[i]==' ') s[i]='\0';
  for(i=0; i<6-strlen(s); i++)  strcat(dname, "_");
  strcat(dname, s);
  strcat(dname, "        ");
  if (strstr(tl->fname,"RJTD")==NULL)  strcat(dname, "      ");
  else                                 strncat(dname, tl->fname, 6);
return(strlen(dname));
}

void set_dname(char dname[], ST_TARGET *tl)
{
char are[8],fcs[8],phy[8],lev[8],enm[8];
int i;

  sprintf(fcs,"%3.3d", tl->vt);
  if (strncmp(tl->elem,"PSEA",4)==0 || strncmp(tl->elem,"P   ",4)==0)
    strcpy(phy, "P__");
  else if (strncmp(tl->elem,"RAIN",4)==0)
    strcpy(phy, "RRT");
  else {
    strncpy(phy, tl->elem, 3); phy[3]='\0';
    for(i=0; i<3; i++)  if (phy[i]==' ')  phy[i]='_';
  }
  if (strncmp(tl->elem,"RAIN",4)==0)
    strcpy(lev,"");
  else if (strncmp(tl->levl,"SURF",4)==0)
    strcpy(lev,(strncmp(tl->elem,"PSEA",4)==0) ? "MSL" : "SFC");
  else {
    sprintf(lev, "%4d", atoi(tl->levl));
    for(i=0; i<4; i++)  if (lev[i]==' ')  lev[i]='_';
  }

  if (memcmp(tl->type1,"_GSM",4)==0) {
    are[0]=tl->fname[2]; are[1]='\0';
    strcpy(dname,"GSM_");
    strcat(dname,are); strcat(dname,fcs); strcat(dname,phy); strcat(dname,lev);
  } else if (memcmp(tl->type1,"_WFM",4)==0) {
    strcpy(enm, tl->memb);
    for(i=0; i<4; i++)  if (enm[i]==' ')  enm[i]='_';
    are[0] = tl->fname[0]; are[1] = '\0';
    strcpy(dname,"WFM_"); strcat(dname,enm);
    strcat(dname,are); strcat(dname,fcs); strcat(dname,phy); strcat(dname,lev);
  }
}

int main(int argc, char *argv[])
{
int i, j, k, l, n, rt, ic, bn;
int bt, vt, vt2, iy, im, id, ih, in;
int gs[2], cgs[2], gn, cgn, pln;
int fpn, esf, newp;
long offset, sto_offset=0;
float ginfo[14], cginfo[14], *d, *d2, *dd, *dd2, *eta_a, *eta_b, eta_c;
char outfile[240], tfile[240], proj[5], gmean[5], sl[240], ss[80], vtu[5];
char opfile[240], fname[240], cctfile[240], hostname[240], cproj[5];
char aname[240];
FILE *fp, *fpo;
ST_TARGET tl, tlo, tld;
N_ST_CNTL s_cntl;
N_ST_NUSD s_nusd;
eta_a=NULL; eta_b=NULL; fpo=NULL;
vtu[4]='\0'; proj[4]='\0'; cctfile[0]='\0'; aname[0]='\0';
strcpy(opfile, "");

/* ************** */
/* argument check */
/* ************** */
  strcpy(outfile, "");
  for(i=1, j=0; i<argc; i++) {
    if (strcmp(argv[i], "-v")==0)       pflag = 1;
    else if (strcmp(argv[i], "-V")==0)  pflag = 2;
    else if (strcmp(argv[i], "-J")==0)  dflag = 1;
    else if (strcmp(argv[i], "-B")==0)  dflag = 2;
    else if (strcmp(argv[i], "-F")==0)  cflag = 1;
    else if (strcmp(argv[i], "-E")==0)  eflag = 1;
    else if (strcmp(argv[i], "-M")==0)  bflag = 1;
    else if (strncmp(argv[i], "-R", 2)==0)
                                      { dflag = 3;
                                        sscanf(argv[i], "-R%s", aname);
                                        if (strlen(aname)==0) {j=0; i=argc;} }
    else if (strcmp(argv[i], "-T")==0)  thing = 1;
    else if (strncmp(argv[i], "-C", 2)==0)
                                      { sscanf(argv[i], "-C%s", cctfile);
                                        if (strlen(cctfile)==0) {j=0; i=argc;} }
    else if (j==0)                    { strcpy(tfile, argv[i]); j++; }
    else if (j==1)                    { strcpy(outfile, argv[i]); j++; }
  }
  if (j==0) {
    fprintf(stderr,"nus2grib targetfile (outputfile) (-B,-J,-Rarea) (-T,-Ccctfile) (-v,-V) (-F)\n");
    fprintf(stderr," targetfile: NuSDaS parameter table for each GRIB\n");
    fprintf(stderr," outputfile: priority 1 = specified as the argument\n");
    fprintf(stderr,"                      2 = specified in the targetfile\n");
    fprintf(stderr,"                      3 = \"defaults.grib\"\n");
    fprintf(stderr,"             if stdout is specified as outputfile,\n");
    fprintf(stderr,"             output binary data to stdout. Be Caution!\n");
    fprintf(stderr," -v : verbose mode (output to stdout)\n");
    fprintf(stderr," -V : verbose mode (output to stderr)\n");
    fprintf(stderr," -B : Add a BCH and bulletin header. Specify outputfile\n");
    fprintf(stderr,"      and set TTAAii RJTD in the targetfile\n");
    fprintf(stderr," -J : Make JMBSC format dataset. Specify outputfile\n");
    fprintf(stderr," -R : Make MDRS format dataset. Specify outputfile\n");
    fprintf(stderr,"      and area!\n");
    fprintf(stderr," -T : remake grid from LatLon to Thinned Grid\n");
    fprintf(stderr," -C : Convert grid coordinate from orignal to specified\n");
    fprintf(stderr,"      in cctfile by simple interpolation. Now, only \n");
    fprintf(stderr,"      Lambert to LatLon conversion is supportted!\n");
    fprintf(stderr," -F : calculate data from another data\n");
    fprintf(stderr,"      ( Ex. RH from T & TTd )\n");
    fprintf(stderr," -E : if any error occured, then exit nus2grib!!\n");
    fprintf(stderr,"      ( Default is the case of only fatal error)\n");
    fprintf(stderr," -M : add the third section(bitmap section)\n");
    exit(1);
  }

/* ************* */
/* read TIMECARD */
/* ************* */
  if ((bt=nwp_gettime("TIMECARD",&iy,&im,&id,&ih,&in))==-1) {
    fprintf(stderr, "nus2grib: TIMECARD read error!!\n"); exit(1);
  }

/* ******************* */
/* GRIB defaults table */
/* ******************* */
  if ((fp=fopen("GRIBDEF", "r"))!=NULL) {
    while(fgets(sl, 240, fp)!=NULL) {
      if (sl[0]=='#')  continue;
      if (sscanf(sl, "%d %d", &i, &j)!=2)  continue;
      if (i<1 || i>28 || j<0 || j>255)  continue;
      s2d[i] = (unsigned char)j;
    }
    fclose(fp);
  }

/* ******** */
/* hostname */
/* ******** */
  strcpy(dname, "./");

/* ******************** */
/* GRIB parameter table */
/* ******************** */
  sprintf(fname, "%sgrib_elemtab.txt", dname);
  if ((fp=fopen("GRIBPARM", "r"))==NULL && (fp=fopen(fname,"r"))==NULL){
    fprintf(stderr, "nus2grib: Can not open grib element parameter table!\n");
    fprintf(stderr, "          Prepare GRIBPARM file on the current dir!\n");
    exit(1);
  }
  while(fgets(sl, 240, fp)!=NULL) {
    if ((k=sscanf(sl, "%d %s %d", &i, ss, &j))>=2)  {
      pt[pnum].pn = i;
      for(i=strlen(ss); i<6; i++) ss[i] = ' '; ss[6]='\0';
      strcpy(pt[pnum].name, ss);
      pt[pnum++].pd = (k==3) ? j : 0;
    }
  }
  fclose(fp);

/* **************** */
/* GRIB model table */
/* **************** */
  sprintf(fname, "%s/grib_modeltab.txt", dname);
  if ((fp=fopen("GRIBMODEL", "r"))==NULL && (fp=fopen(fname,"r"))==NULL){
    fprintf(stderr, "nus2grib: Can not open grib model table!\n");
    fprintf(stderr, "          Prepare GRIBMODEL file on the current dir!\n");
    exit(1);
  }
  while(fgets(sl, 240, fp)!=NULL) {
    if ((n=sscanf(sl, "%s %d %d %d %d", ss, &i, &j, &k, &l))==5)  {
      mt[mnum].mn = i;
      mt[mnum].usfc = j;
      mt[mnum].tsfc = k;
      mt[mnum].rflag = l;
      for(i=strlen(ss); i<4; i++) ss[i] = ' '; ss[4]='\0';
      strcpy(mt[mnum++].name, ss);
    }
  }
  fclose(fp);

/* ************************************ */
/* target file open & initialize struct */
/* ************************************ */
  if ((fp=fopen(tfile, "r"))==NULL) {
    fprintf(stderr, "nus2grib: target list file open error!!\n"); exit(1);
  }
  clear_tl(&tl,outfile); clear_tl(&tlo,outfile);
  if (strlen(outfile)==0)  clear_tl(&tld, "defaults.grib");
  else                     clear_tl(&tld, outfile);
  ic = 0;

/* ********* */
/* main loop */
/* ********* */
  while((i=rdtarget(fp, &tl, &tld, outfile))>=0) {
    if (i==0)  continue;
/* ------------------- */
/* case of type change */
/* ------------------- */
    if (strcmp(tl.type1,tlo.type1)!=0 || strcmp(tl.type2,tlo.type2)!=0 ||
        strcmp(tl.type3,tlo.type3)!=0 || strcmp(tl.memb,tlo.memb)!=0 ||
        tl.vt != tlo.vt)  {
      j = 1;
      if ((rt=nusdas_inq_def(tl.type1,tl.type2,tl.type3,
                             N_VALIDTIME_UNIT,vtu,(N_SI4 *)&j))<=0)  {
        fprintf(stderr, "nus2grid: nusdas_inq_def error <%d> for %s%s%s\n", rt,tl.type1,tl.type2,tl.type3);
        if (eflag) exit(1);
        else       continue;
      }
      if (strcmp(vtu,"MIN ")==0)       vt = bt+tl.vt;
      else if (strcmp(vtu,"HOUR")==0)  vt = bt+tl.vt*60;
      else if (strcmp(vtu,"DAY ")==0)  vt = bt+tl.vt*60*24;
      vt2 = (tl.vt2==-1) ? 1 : tl.vt2;
      if ((rt=nusdas_grid(tl.type1,tl.type2,tl.type3,(N_SI4 *)&bt,tl.memb,
                     (N_SI4 *)&vt,proj,(N_SI4 *)gs,ginfo,gmean,"get"))<0)  {
        fprintf(stderr, "nus2grid: nusdas_grid error <%d> for %s%s%s<%d,%d>\n",
                         rt,tl.type1,tl.type2,tl.type3,bt,vt);
        if (eflag) exit(1);
        else       continue;
      }
      gn = gs[0]*gs[1];
      if (memcmp(&(tl.type1[6]),"ET",2)==0)  {
        if ((rt=nusdas_inq_cntl(tl.type1,tl.type2,tl.type3,(N_SI4 *)&bt,tl.memb,
                     (N_SI4 *)&vt,N_PLANE_NUM,&pln,(N_SI4 *)&j))<0)  {
          fprintf(stderr,"nus2grid: nusdas_inq_cntl error <%d> for %s%s%s<%d,%d>\n", rt,tl.type1,tl.type2,tl.type3,bt,vt);
          if (eflag) exit(1);
          else       continue;
        }
        if (eta_a!=NULL) free(eta_a); eta_a =(float *)malloc(sizeof(float)*pln);
        if (eta_b!=NULL) free(eta_b); eta_b =(float *)malloc(sizeof(float)*pln);
        if ((rt=nusdas_subc_eta(tl.type1,tl.type2,tl.type3,(N_SI4 *)&bt,tl.memb,
                  (N_SI4 *)&vt,(N_SI4 *)&pln,eta_a,eta_b,&eta_c,"get"))<0)  {
          fprintf(stderr,"nus2grid: nusdas_subc_eta error <%d> for %s%s%s<%d,%d>\n", rt,tl.type1,tl.type2,tl.type3,bt,vt);
          if (eflag) exit(1);
          else       continue;
        }
      } else {
        if (eta_a!=NULL) { free(eta_a); eta_a = NULL; }
        if (eta_b!=NULL) { free(eta_b); eta_b = NULL; }
      }
    }
/* --------- */
/* read data */
/* --------- */
    if ((d=(float *)malloc(sizeof(float)*gn))==NULL ||
        (d2=(float *)malloc(sizeof(float)*gn))==NULL)  {
      fprintf(stderr, "nus2grid: malloc error. size=%d\n", gn);
      if (eflag) exit(1);
      else       continue;
    }
    if (cflag==1 && strcmp(tl.elem,"RH    ")==0) {
      if ((rt=nusdas_read2(tl.type1,tl.type2,tl.type3,(N_SI4 *)&bt,tl.memb,
                           (N_SI4 *)&vt,(N_SI4 *)&vt2,tl.levl,tl.levl,
                           "T     ",d,N_R4,(N_SI4 *)&gn))!=gn
        ||(rt=nusdas_read2(tl.type1,tl.type2,tl.type3,(N_SI4 *)&bt,tl.memb,
                           (N_SI4 *)&vt,(N_SI4 *)&vt2,tl.levl,tl.levl,
                           "TTD   ",d2,N_R4,(N_SI4 *)&gn))!=gn) {
        fprintf(stderr,"nus2grid:nusdas_read error rt=%d.%s%s%s<%d,%d>%s%s%s\n",
                rt,tl.type1,tl.type2,tl.type3,bt,vt,tl.memb,tl.levl,tl.elem);
        free(d); free(d2);
        if (eflag) exit(1);
        else       continue;
      }
      for(i=0; i<gn; i++)
        d[i] = (float)nwp_td2rh((double)(d[i]-d2[i]),(double)d[i]);
      free(d2); d2 = NULL;
    } else if (strlen(cctfile)>0 &&
               (strcmp(tl.elem,"U     ")==0 || strcmp(tl.elem,"V     ")==0)) {
      if ((rt=nusdas_read2(tl.type1,tl.type2,tl.type3,(N_SI4 *)&bt,tl.memb,
                           (N_SI4 *)&vt,(N_SI4 *)&vt2,tl.levl,tl.levl,
                           "U     ",d,N_R4,(N_SI4 *)&gn))!=gn
        ||(rt=nusdas_read2(tl.type1,tl.type2,tl.type3,(N_SI4 *)&bt,tl.memb,
                           (N_SI4 *)&vt,(N_SI4 *)&vt2,tl.levl,tl.levl,
                           "V     ",d2,N_R4,(N_SI4 *)&gn))!=gn) {
        fprintf(stderr,"nus2grid:nusdas_read error rt=%d.%s%s%s<%d,%d>%s%s%s\n",
                rt,tl.type1,tl.type2,tl.type3,bt,vt,tl.memb,tl.levl,tl.elem);
        free(d); free(d2);
        if (eflag) exit(1);
        else       continue;
      }
    } else {
      if ((rt=nusdas_read2(tl.type1,tl.type2,tl.type3,(N_SI4 *)&bt,tl.memb,
                           (N_SI4 *)&vt,(N_SI4 *)&vt2,tl.levl,tl.levl,
                           tl.elem,d,N_R4,(N_SI4 *)&gn))!=gn) {
        fprintf(stderr,"nus2grid:nusdas_read error rt=%d.%s%s%s<%d,%d,%d>%s%s%s\n", rt,tl.type1,tl.type2,tl.type3,bt,vt,vt2,tl.memb,tl.levl,tl.elem);
        free(d); free(d2);
        if (eflag) exit(1);
        else       continue;
      }
      free(d2); d2 = NULL;
    }
/* ------------------ */
/* convert coordinate */
/* ------------------ */
    if (strlen(cctfile)>0) {
      if (convert_coordinate(cctfile, d, d2, &dd, &dd2,
                             proj, gs, ginfo, cproj, cgs, cginfo)!=0)  exit(1);
    }
/* -------------- */
/* encode to grib */
/* -------------- */
    if (strlen(cctfile)>0) {
      cgn = cgs[0]*cgs[1];
      if (strcmp(tl.elem,"V     ")==0)
       n=grib_enc(dd2,cgn,&tl,eta_b,pln,iy,im,id,ih,in,vtu,cproj,cgs,cginfo,uc);
      else
       n=grib_enc(dd,cgn,&tl,eta_b,pln,iy,im,id,ih,in,vtu,cproj,cgs,cginfo,uc);
      free(dd); free(dd2);
      if (strcmp(tl.elem,"U     ")==0 || strcmp(tl.elem,"V     ")==0) free(d2);
    } else  {
      n = grib_enc(d,gn,&tl,eta_b,pln,iy,im,id,ih,in,vtu,proj,gs,ginfo,uc);
    }
    free(d);
/* -------------- */
/* output to file */
/* -------------- */
    if (n>0) {
      if (sscanf(tl.fname,"%6s_%4s",ttaaii,rjtd)==2 && strcmp(rjtd,"RJTD")==0) {
        strcpy(fname, (strlen(outfile)==0) ? ttaaii : outfile);
      } else {
        strcpy(fname, tl.fname);
      }
      if (strcmp(opfile,fname)!=0) {
        for(i=0; i<hfnum; i++)  if (strcmp(fname,histfile[i])==0)  break;
        if (i==hfnum++)  strcpy(histfile[i], fname);
        if (fpo!=stdout && fpo!=NULL)  fclose(fpo);
        if (strcmp(fname, "stdout")==0)
          fpo = stdout;
        else {
          if ((fpo=fopen(fname,"r+"))==NULL) 
            if ((fpo=fopen(fname,"w"))==NULL)  {
              fprintf(stderr,"nus2grib:output file <%s> open fail!\n",tl.fname);
              if (eflag) exit(1);
              else       continue;
            }
          fseek(fpo,(long)0,SEEK_END);
        }
        strcpy(opfile, fname);
      }
      if (dflag==2) {          /* bulletin case (add BCH and HEADER) */
        if (sscanf(tl.fname, "%s %s", ttaaii, rjtd)==2 &&
            strcmp(rjtd, "RJTD")==0) {
          makebch(attr, kind, annum, bch);
          bn = 4+20+19+n;
          fwrite_native(&bn, 4, 1, fpo);
          fwrite_native(bch, sizeof(char), 20, fpo);
          sprintf(header,"\n%6.6s %4.4s %2.2d%2.2d%2.2d", ttaaii,rjtd,id,ih,in);
          fwrite_native(header, 1, 19, fpo);
          if (fpo==stdout)  sto_offset+=(4+20+19);
        } else {
          fprintf(stderr,"nus2grib: set -B, but no RJTD header in target file");
          if (eflag) exit(1);
          else       continue;
        }
      } else if (dflag==1 || dflag==3) {   /* JMBSC or MDRS case */
        if ((fpo==stdout && sto_offset==0) ||
            (fpo!=stdout && (offset=ftell(fpo))==0)) {
          fpn = (int)n_set_fpn(tl.type1,tl.type2,tl.type3,(N_SI4 *)&bt,tl.memb,
                   (N_SI4 *)&vt,(N_SI4 *)&vt2,'r',(N_SI4 *)&esf,(N_SI4 *)&newp);
          if ((rt=n_read_nusd(n_fp[fpn], &s_nusd))<0)
            fprintf(stderr, "nus2grib: n_read_nusd error!!\n");
          s_nusd.h.length_s -=8; s_nusd.length_e = s_nusd.h.length_s;
          memcpy(&(s_nusd.h.recname),"VREC", 4);
          s_nusd.version = 1;
          fwrite_native(&s_nusd,  1, s_nusd.h.length_s+8, fpo);
          if (fpo==stdout)  sto_offset+=(s_nusd.h.length_s+8);
          if (dflag==1) {
            if ((rt=n_read_cntl(n_fp[fpn], &s_cntl))<0)
              fprintf(stderr, "nus2grib: n_read_cntl error!!\n");
            s_cntl.f.h.available = 156+12;
            s_cntl.f.h.length_s  = s_cntl.f.h.available;
            s_cntl.length_e    = s_cntl.f.h.length_s;
            fwrite_native(&s_cntl,  1, s_cntl.f.h.length_s+4, fpo);
            fwrite_native(&s_cntl.length_e, 4, 1, fpo);
            if (fpo==stdout)  sto_offset+=(s_cntl.f.h.length_s+4+4);
          }
        } else if (fpo!=stdout && offset!=0 && ic==0)  {
            offset = -28;
            fseek(fpo, offset, SEEK_END);
        }
        ic++;
        l = (dflag==1) ? 12+20+12+n : 12+74+6+n;
        fwrite_native(&l, 4, 1, fpo);
        fwrite_native("DATA", 1, 4, fpo);
        fwrite_native(&l, 4, 1, fpo);
        i = 0; fwrite_native(&i, 4, 1, fpo);
        if (fpo==stdout)  sto_offset+=(4+4+4+4);
        if (dflag==1) {
          set_dname(dname, &tl);
          fwrite_native(dname, 1, strlen(dname), fpo);
          for(i=strlen(dname); i<20; i++)  fwrite_native(" ", 1, 1, fpo);
          if (strstr(tl.fname,"RJTD")==NULL)
            for(i=0; i<12; i++)  fwrite_native(" ", 1, 1, fpo);
          else
            fwrite_native(tl.fname, 1, 12, fpo);
          if (fpo==stdout)  sto_offset+=(20+12);
        } else if (dflag==3) {
          if (set_dname2(dname, &tl, (strlen(cctfile)>0) ? cginfo : ginfo,
                     iy, im, id, ih, in, vtu, aname)!=80)  {
            fprintf(stderr, "nus2grib: set dname2 error!!\n");
          }
          fwrite_native(dname, 1, 80, fpo);
          if (fpo==stdout)  sto_offset+=80;
        }
      }
      
      fwrite_native(uc, sizeof(unsigned char), n, fpo);
      if (fpo==stdout)  sto_offset+=n;

      if (dflag==1 || dflag==3)  {
        fwrite_native(&l, 4, 1, fpo);
        if (fpo==stdout)  sto_offset+=4;
      }
    }
    tlo = tl;
/* ---------------- */
/* end of main loop */
/* ---------------- */
  }
  if (fpo!=stdout && fpo!=NULL)  fclose(fpo);
  if (dflag==1 || dflag==3)  {
    l=20; k=0;
    for(i=0; i<hfnum; i++) {
      if (strcmp(histfile[i],"stdout")==0) {
        fpo = stdout;
        offset = sto_offset;
      } else {
        fpo = fopen(histfile[i], "a");
        offset = ftell(fpo);
      }
      offset += 28;
      fwrite_native(&l, 4, 1, fpo);
      fwrite_native("END ", 1, 4, fpo);
      fwrite_native(&l, 4, 1, fpo);
      fwrite_native(&k, 4, 1, fpo);
      fwrite_native(&offset, 4, 1, fpo);
      fwrite_native(&k, 4, 1, fpo);
      fwrite_native(&l, 4, 1, fpo);
      if (fpo!=stdout)  fclose(fpo);
    }
  }
  fclose(fp);
  return 0;
}
