#include <stdio.h>
#include "nusdas_sys.h"
extern int n_nrd_num;
int esflag=0, rcflag=0, btflag=0;

int n_defcheck(N_ST_DEF *defin, N_ST_DEF *defout)
{
FILE *fpin, *fpout;
int  cnt=0, i;

  if ((fpin=fopen("NUSDEF_IN", "r"))==NULL) {
    fprintf(stderr, "nusdas_duplicate : NUSDEF_IN open failed!\n"); return(-1);
  } else if (n_read_def(fpin, defin)!=0) {
    fprintf(stderr, "nusdas_duplicate : NUSDEF_IN define file has no necessary item!\n");
    return(-2);
  }
  if ((fpout=fopen("NUSDEF_OUT", "r"))==NULL) {
    fprintf(stderr, "nusdas_duplicate : NUSDEF_OUT open failed!\n"); return(-1);
  } else if (n_read_def(fpout, defout)!=0) {
    fprintf(stderr, "nusdas_duplicate : NUSDEF_OUT define file has no necessary item!\n");
    return(-2);
  }
  if (defin->version!=defout->version)                cnt++;
if (rcflag==0) {
  if (strcmp(defin->type1, defout->type1)!=0)         cnt++;
  if (strcmp(defin->type2, defout->type2)!=0)         cnt++;
  if (strcmp(defin->type3, defout->type3)!=0)         cnt++;
}
  if (defin->basetime_t!=defout->basetime_t)          cnt++;
  if (defin->time_unit!=defout->time_unit)            cnt++;
if (rcflag==0) {
  if (defin->n_dc!=defout->n_dc)                      cnt++;
  if (defin->n_vt!=defout->n_vt)                      cnt++;
  if (defin->n_lv!=defout->n_lv)                      cnt++;
  if (defin->n_el!=defout->n_el)                      cnt++;
}
  if (defin->projection!=defout->projection)          cnt++;
  if (defin->xs!=defout->xs || defin->ys!=defout->ys) cnt++;
  if (defin->x0!=defout->x0 || defin->y0!=defout->y0) cnt++;
  if (defin->xd!=defout->xd || defin->yd!=defout->yd) cnt++;
  if (defin->lat_0!=defout->lat_0 || defin->lon_0!=defout->lon_0) cnt++;
  if (defin->lat_1!=defout->lat_1 || defin->lon_1!=defout->lon_1) cnt++;
  if (defin->lat_2!=defout->lat_2 || defin->lon_2!=defout->lon_2) cnt++;
  if (defin->lat_s1!=defout->lat_s1 || defin->lon_s1!=defout->lon_s1) cnt++;
  if (defin->lat_s2!=defout->lat_s2 || defin->lon_s2!=defout->lon_s2) cnt++;
  if (defin->gpv_mean!=defout->gpv_mean)  cnt++;
  if (defin->pack!=defout->pack)          cnt++;
/*
  if (memcmp(&defin->pack, "2PAC", 4)!=0) {
    fprintf(stderr, "nusdas_duplicate : only support 2PAC packing\n");
    fprintf(stderr, "                target file packing is %4.4s\n",
                    (char *)&defin->pack);
    return(1);
  }
*/
  if (defin->miss!=defout->miss)          cnt++;
  if (cnt!=0)  return(cnt);
if (rcflag==0) {
  for(i=0; i<defin->n_dc; i++)  if (defin->dc[i]!=defout->dc[i])    cnt++;
  for(i=0; i<defin->n_vt; i++)  if (defin->vt1[i]!=defout->vt1[i])  cnt++;
  for(i=0; i<defin->n_vt; i++)  if (defin->vt2[i]!=defout->vt2[i])  cnt++;
  for(i=0; i<defin->n_lv; i++)
    if (memcmp(&defin->lv1[i],&defout->lv1[i],6)!=0)  cnt++;
  for(i=0; i<defin->n_lv; i++)
    if (memcmp(&defin->lv2[i],&defout->lv2[i],6)!=0)  cnt++;
  for(i=0; i<defin->n_el; i++) 
    if (memcmp(&defin->el[i],&defout->el[i],6)!=0)  cnt++;
  for(i=0; i<defin->n_dc*defin->n_vt*defin->n_lv*defin->n_el; i++)
    if (defin->elmap[i]!=defout->elmap[i])  cnt++;
}
  if (cnt!=0)  return(cnt+1000);
  if (defin->n_subc!=defout->n_subc)                            cnt++;
  if (cnt!=0)  return(cnt+10000);
  for(i=0; i<defin->n_subc; i++)  if (defin->subc[i]!=defout->subc[i])  cnt++;
  for(i=0; i<defin->n_subc; i++)
    if (defin->subc_size[i]!=defout->subc_size[i])  cnt++;
  if (cnt!=0)  return(cnt+20000);

  fclose(fpin); fclose(fpout);
return(0);
}

int main(int argc, char *argv[])
{
char s1[80], s2[80], tp1in[9], tp2in[5], tp3in[5], s3[80];
char tp1out[9], tp2out[5], tp3out[5], keyw[80], keyv[80], dtype[5];
char *argv1, *argv2, *argv3;
unsigned char *d, *mb;
int rt, rt2, i, j, k, l, m, ds, ecnt=0, ocnt=0;
int iy, im, id, ih, in, ms;
int nrdin, nrdout;
int s_lv, bst, bt, vt, vt2=1, tun, gs, gs2;
int ispc[128];
float *a, *b, c;
N_ST_DEF defi, defo, *defb;
FILE *fp;
mb=NULL;

argv1 = argv[1];
argv2 = argv[2];
argv3 = argv[3];

printf("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n");
printf("@@@@ nusdas_duplicate START!!                       @@@@\n");

  if ((bst=nwp_gettime("TIMECARD", &iy,&im,&id,&ih,&in))<0) {
    fprintf(stderr, "nusdas_duplicate : TIMECARD error!\n"); return(1);
  }
  if (strcmp(argv1,"RECONST")==0 || strcmp(argv1,"reconst")==0 ||
      strcmp(argv2,"RECONST")==0 || strcmp(argv2,"reconst")==0 ||
      strcmp(argv3,"RECONST")==0 || strcmp(argv3,"reconst")==0)  rcflag=1;

  if ((rt=n_defcheck(&defi, &defo))<0) return(2);
  else if (rt>0) {
    fprintf(stderr,"nusdas_duplicate: NUSDEF_OUT is different to NUSDEF_IN!\n");
    fprintf(stderr, "cnt=%d\n", rt);
    return(3);
  }
  if (strcmp(argv1,"IN_BASE")==0 || strcmp(argv1,"in_base")==0 ||
      strcmp(argv2,"IN_BASE")==0 || strcmp(argv2,"in_base")==0 ||
      strcmp(argv3,"IN_BASE")==0 || strcmp(argv3,"in_base")==0)   defb = &defi;
  else                                                            defb = &defo;
  if (strcmp(argv1,"BT_FILE")==0 || strcmp(argv1,"bt_file")==0 ||
      strcmp(argv2,"BT_FILE")==0 || strcmp(argv2,"bt_file")==0 ||
      strcmp(argv3,"BT_FILE")==0 || strcmp(argv3,"bt_file")==0)   btflag = 1;

printf("@@@@ check define file O.K.                         @@@@\n");
fflush(stdout);
  esflag = (defi.path==N_NWP_ESF ||defo.path==N_NWP_ESF) ? 1 : 0;
  if (esflag) {
    ds = (defi.forced_rlen>defo.forced_rlen) ? defi.forced_rlen
                                             : defo.forced_rlen;
  } else {
    ds = defi.xs*defo.xs*sizeof(short)+2*sizeof(float);
  }
  if (ds<=0)  ds = defi.xs*defo.xs*sizeof(short)+2*sizeof(float);
  if ((d=(unsigned char *)malloc(sizeof(unsigned char)*ds*4))==NULL) {
    fprintf(stderr, "nusdas_duplicate : malloc error!\n"); return(4);
  }

  nrdin = 99;  nrdout = 1;

  nusdas_iocntl(N_IO_R_FCLOSE, N_OFF);
  nusdas_iocntl(N_IO_W_FCLOSE, N_OFF);
  nusdas_iocntl(N_IO_WARNING_OUT, N_OFF);

  sscanf(defi.type1, "%s %s %s %s", s1, s1, s2, s3);
  strcpy(tp1in, s1); strcat(tp1in, s2); strcat(tp1in, s3);
  sscanf(defi.type2, "%s %s %s", s1, s1, s2);
  strcpy(tp2in, s1); strcat(tp2in, s2);
  sscanf(defi.type3, "%s %s %s", s1, s1, s2);
  strcpy(tp3in, s1);
  sscanf(defo.type1, "%s %s %s %s", s1, s1, s2, s3);
  strcpy(tp1out, s1); strcat(tp1out, s2); strcat(tp1out, s3);
  sscanf(defo.type2, "%s %s %s", s1, s1, s2);
  strcpy(tp2out, s1); strcat(tp2out, s2);
  sscanf(defo.type3, "%s %s %s", s1, s1, s2);
  strcpy(tp3out, s1);

  for(tun=0; tun<n_tunit_num; tun++)
    if (memcmp(&(defb->time_unit), n_tunit_string[tun], 4)==0)  break;
  gs = defo.xs*defo.ys;

  for(l=0; l<defb->n_dc; l++)
  for(k=0; k<defb->n_vt; k++)  {
    vt = bst+defb->vt1[k]*n_tunit_min[tun];
    n_timeprint(s1, bst); n_timeprint(s2, vt);
    for(i=0; i<defb->n_lv; i++)
    for(j=0; j<defb->n_el; j++) {
      if (defb->elmap[j+defb->n_el*(i+defb->n_lv*(k+defb->n_vt*l))]==0)
        continue;
      if (strcmp(&defb->el[j],"LAT   ")==0 || strcmp(&defb->el[j],"LON   ")==0
       || strcmp(&defb->el[j],"HIGH  ")==0)  continue;
      bt = (btflag==0) ? bst : -1;
      rt = nusdas_parameter_change(N_PC_ID_SET, &nrdin);
      if (memcmp(&defb->pack, "RLEN", 4)==0) {
        gs2 = nusdas_read(tp1in,tp2in,tp3in,&bt,&defb->dc[l],&vt,
                         &defb->lv1[i],&defb->el[j],d,N_NC,&gs);
        rt = nusdas_subc_srf(tp1in,tp2in,tp3in,&bt,&defb->dc[l],&vt,
                       &defb->lv1[i],&defb->el[j],&defb->subc[0],ispc,"get");
        if (rt!=0) {
          fprintf(stderr,"nusdas_duplicate: nusdas_subc_srf failed.rt=%d\n",rt);
          if (rcflag==0)  return(77);
        }
      } else if (memcmp(&defb->pack, "2PAC", 4)==0 &&
                 strcmp(&defb->el[j],"CONT  ")!=0) {
        gs2 = nusdas_read(tp1in,tp2in,tp3in,&bt,&defb->dc[l],&vt,
                         &defb->lv1[i],&defb->el[j],d,N_R4,&gs);
      } else {
        if (strcmp(&defb->el[j],"NUM   ")==0)        strcpy(dtype,"I4");
        else if (strcmp(&defb->el[j],"SSfr0 ")==0)   strcpy(dtype,"I1");
        else                                         strcpy(dtype,"I2");
        gs2 = nusdas_read(tp1in,tp2in,tp3in,&bt,&defb->dc[l],&vt,
                         &defb->lv1[i],&defb->el[j],d,dtype,&gs);
      }
      if (gs2<=0)  {
        if (gs2<0) {
          fprintf(stderr,"nusdas_duplicate: read failed(%d) ", gs2);
          fprintf(stderr, "%8.8s%4.4s%4.4s<%s:%s><%4.4s><%6.6s:%6.6s>\n",
                tp1in,tp2in,tp3in,s1,s2,(char *)&defb->dc[l],
                (char *)&defb->lv1[i],(char *)&defb->el[j]);
        }
        if (rcflag==0)  return(77);
        ecnt++;
        continue;
      }
      bt = (btflag==0) ? bst : ((bst-5)/1440)*1440;
      nusdas_parameter_change(N_PC_ID_SET, &nrdout);
      if (memcmp(&defo.miss,"MASK",4)==0) {
        ms = (gs2-1)/8+1;
        if (mb==NULL) mb=(unsigned char *)malloc(sizeof(unsigned char)*ms);
        if (strcmp(&defb->el[j],"CONT  ")==0)
          nusdas_make_mask(d,N_I2,&gs2,mb,&ms);
        else
          nusdas_make_mask(d,N_R4,&gs2,mb,&ms);
        nusdas_parameter_change(N_PC_MASK_BIT,mb);
      }
      if (memcmp(&defo.pack, "RLEN", 4)==0) {
        rt = nusdas_write(tp1out,tp2out,tp3out,&bt,&defb->dc[l],
                          &vt,&defb->lv1[i],&defb->el[j],d,N_NC,&gs2);
        rt2= nusdas_subc_srf(tp1in,tp2in,tp3in,&bt,&defb->dc[l],&vt,
                       &defb->lv1[i],&defb->el[j],&defb->subc[0],ispc,"put");
        if (rt2!=0) {
          fprintf(stderr,"nusdas_duplicate:nusdas_subc_srf failed.rt=%d\n",rt2);
          if (rcflag==0)  return(88);
        }
      } else if (memcmp(&defb->pack, "2PAC", 4)==0) {
        if (strcmp(&defb->el[j],"CONT  ")==0) {
          nusdas_parameter_change(N_PC_PACKING, N_P_I2);
          rt = nusdas_write(tp1out,tp2out,tp3out,&bt,&defb->dc[l],
                            &vt,&defb->lv1[i],&defb->el[j],d,N_I2,&gs2);
        } else {
          nusdas_parameter_change(N_PC_PACKING, N_P_2PAC);
          rt = nusdas_write(tp1out,tp2out,tp3out,&bt,&defb->dc[l],
                            &vt,&defb->lv1[i],&defb->el[j],d,N_R4,&gs2);
        }
      } else {
        nusdas_parameter_change(N_PC_SIZEX, &gs2);
        if (strcmp(&defb->el[j],"NUM   ")==0)
          nusdas_parameter_change(N_PC_PACKING, N_P_I4);
        else if (strcmp(&defb->el[j],"SSfr0 ")==0)
          nusdas_parameter_change(N_PC_PACKING, N_P_I1);
        else if (strcmp(&defb->el[j],"RRfr0 ")==0 ||
                 strcmp(&defb->el[j],"WindS ")==0 ||
                 strcmp(&defb->el[j],"T     ")==0)
          nusdas_parameter_change(N_PC_PACKING, N_P_N1I2);
        else
          nusdas_parameter_change(N_PC_PACKING, N_P_I2);
        rt = nusdas_write(tp1out,tp2out,tp3out,&bt,&defo.dc[l],
                          &vt,&defb->lv1[i],&defb->el[j],d,dtype,&gs2);
      }
      if (rt<=0)  {
        fprintf(stderr,"nusdas_duplicate: nusdas_write failed. rt=%d gs=%d\n",
                        rt, gs2);
        fprintf(stderr, "%8.8s%4.4s%4.4s<%s:%s><%4.4s><%6.6s:%6.6s>\n",
                tp1out,tp2out,tp3out,s1,s2,(char *)&defb->dc[l],
                (char *)&defb->lv1[i],(char *)&defb->el[j]);
        if (rcflag==0)  return(88);
      } else
        ocnt++;
    }
  }
  if (memcmp(&defo.miss,"MASK",4)==0) free(mb);
  printf("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n");
  rt = nusdas_allfile_close(N_FOPEN_READ);
  if (rt<0) {
    fprintf(stderr,"nusdas_duplicate: nusdas_allfile_close failed. rt=%d\n",rt);
    return(99);
  }
  printf("@@@@ nusdas_duplicate : number of source file is %2.2d @@@@\n", rt);
  rt = nusdas_allfile_close(N_FOPEN_WRITE);
  if (rt<0) {
    fprintf(stderr,"nusdas_duplicate: nusdas_allfile_close failed. rt=%d\n",rt);
    return(99);
  }
  printf("@@@@                         duplication file is %2.2d @@@@\n",rt);
  if (ecnt==0) {
    printf("@@@@ NORMAL END !!                                  @@@@\n");
    printf("@@@@ number of copy SUCCESS record is %4.4d          @@@@\n", ocnt);
  } else {
    printf("@@@@ number of copy SUCCESS record is %4.4d          @@@@\n", ocnt);
    printf("@@@@ number of copy FAILED  record is %4.4d          @@@@\n", ecnt);
    printf("@@@@      see stderr for more detail!!              @@@@\n");
  }

return(0);
}
