#include <stdio.h>
#include "nusdas.h"
#define BUF_SIZE 80*5
struct rf_table_sub {
  char t1[9], t2[5], t3[5];
  char mb[6], lv[7], el[7];
};
struct rf_table {
  struct rf_table_sub in;
  struct rf_table_sub out;
} *rft;

int rd_table()
{
FILE *fp;
char buf[BUF_SIZE];
int  ic=0;
long offset=0;
  if ((fp=fopen("TF_TABLE","r"))==NULL) {
    fprintf(stderr, "grib_reform: can not open TF_TABLE!!\n");
    return(-1);
  }
  while(fgets(buf, BUF_SIZE, fp)!=NULL) {
    if (buf[0]=='#') continue;
    ic++;
  }
  if ((rft=(struct rf_table *)malloc(sizeof(struct rf_table)*ic))==NULL) {
    fprintf(stderr, "grib_reform: malloc for rft failed. size=%d\n",
                    sizeof(struct rf_table)*ic);
    fclose(fp);
    return(-1);
  }
  fseek(fp, offset, SEEK_SET);
  ic = 0;
  while(fgets(buf, BUF_SIZE, fp)!=NULL) {
    if (buf[0]=='#') continue;
    memcpy(rft[ic].in.t1, &buf[0], 8); rft[ic].in.t1[8]='\0';
    memcpy(rft[ic].in.t2, &buf[9], 4); rft[ic].in.t2[4]='\0';
    memcpy(rft[ic].in.t3,&buf[14], 4); rft[ic].in.t3[4]='\0';
    memcpy(rft[ic].in.mb,&buf[19], 4); rft[ic].in.mb[4]='\0';
    memcpy(rft[ic].in.lv,&buf[24], 6); rft[ic].in.lv[6]='\0';
    memcpy(rft[ic].in.el,&buf[31], 6); rft[ic].in.el[6]='\0';
    memcpy(rft[ic].out.t1,&buf[38], 8); rft[ic].out.t1[8]='\0';
    memcpy(rft[ic].out.t2,&buf[47], 4); rft[ic].out.t2[4]='\0';
    memcpy(rft[ic].out.t3,&buf[52], 4); rft[ic].out.t3[4]='\0';
    memcpy(rft[ic].out.mb,&buf[57], 4); rft[ic].out.mb[4]='\0';
    memcpy(rft[ic].out.lv,&buf[62], 6); rft[ic].out.lv[6]='\0';
    memcpy(rft[ic].out.el,&buf[69], 6); rft[ic].out.el[6]='\0';
/*
    sscanf(buf, "%8c %4c %4c %4c %6c %6c %8c %4c %4c %4c %6c %6c",
                 rft[ic].in.t1, rft[ic].in.t2, rft[ic].in.t3,
                 rft[ic].in.mb, rft[ic].in.lv, rft[ic].in.el,
                 rft[ic].out.t1, rft[ic].out.t2, rft[ic].out.t3,
                 rft[ic].out.mb, rft[ic].out.lv, rft[ic].out.el);
*/
    ic++;
  }
  fclose(fp);
return(ic);
}

int get_vtlist(int **vtlist, int i)
{
char vtunit[4];
int rt, vtn, n=1, unit;
  if ((rt=nusdas_inq_def(rft[i].in.t1,rft[i].in.t2,rft[i].in.t3,
                         N_VALIDTIME_NUM, &vtn, &n))<=0)  {
    fprintf(stderr, "grib_reform: nusdas_inq_def VALIDTIME_NUM error. rt=%d\n", rt);
    return(-1);
  }
  if (vtn==0) return(0);
  if ((*vtlist=(int *)malloc(sizeof(int *)*vtn))==NULL)  {
    fprintf(stderr, "grib_reform: malloc for vtlist failed. size=%d\n",vtn*sizeof(int *));
    return(-1);
  }
  if ((rt=nusdas_inq_def(rft[i].in.t1,rft[i].in.t2,rft[i].in.t3,
                         N_VALIDTIME_LIST, *vtlist, &vtn))<=0)  {
    fprintf(stderr, "grib_reform: nusdas_inq_def VALIDTIME_LIST error. rt=%d\n", rt);
    return(-1);
  }
  if ((rt=nusdas_inq_def(rft[i].in.t1,rft[i].in.t2,rft[i].in.t3,
                         N_VALIDTIME_UNIT, vtunit, &n))<=0)  {
    fprintf(stderr, "grib_reform: nusdas_inq_def VALIDTIME_UNIT error. rt=%d\n", rt);
    return(-1);
  }
  if (memcmp(vtunit, "HOUR", 4)==0)      unit=60;
  else if (memcmp(vtunit, "DAY ", 4)==0) unit=60*24;
  else if (memcmp(vtunit, "WEEK", 4)==0) unit=60*24*7;
  else                                   unit=1;
  for(n=0; n<vtn; n++)  *(*vtlist+n) *= unit;

return(vtn);
}

void main(int argc, char *argv[])
{
char proj[4],gmean[4];
int gsize[2], gs;
float ginfo[14], *dat;
int rfn, i, j, rt, vtn, bt, vt;
int iy, im, id, ih, in;
int *vtlist;

  if ((bt=nwp_gettime("TIMECARD", &iy, &im, &id, &ih, &in))==-1)  {
    fprintf(stderr, "grib_reform: TIMECARD read error!!\n");
    exit(1);
  }
  if ((rfn=rd_table())<0) exit(1);
  for(i=0; i<rfn; i++) {
    if ((vtn=get_vtlist(&vtlist, i))<=0)  continue;
    printf("%s %s %s %s %s %s %s %s %s %s %s %s\n",
                 rft[i].in.t1, rft[i].in.t2, rft[i].in.t3,
                 rft[i].in.mb, rft[i].in.lv, rft[i].in.el,
                 rft[i].out.t1, rft[i].out.t2, rft[i].out.t3,
                 rft[i].out.mb, rft[i].out.lv, rft[i].out.el);
    for(j=0; j<vtn; j++)  {
      printf("%d -> %d  ", bt, vtlist[j]);
      vt = bt+vtlist[j];
      if ((rt=nusdas_grid(rft[i].in.t1, rft[i].in.t2, rft[i].in.t3,
                          (N_SI4 *)&bt, rft[i].in.mb, (N_SI4 *)&vt,
                          proj, gsize, ginfo, gmean, N_IO_GET))<0) {
        fprintf(stderr, "grib_reform: nusdas_grid error. rt=%d\n", rt);
        continue;
      }
      gs = gsize[0]*gsize[1];
      if ((dat=(float *)malloc(sizeof(float)*gs))==NULL) {
        fprintf(stderr, "grib_reform: malloc for dat failed. size=%d\n",
                        sizeof(float)*gs);
        continue;
      }
      if ((rt=nusdas_read(rft[i].in.t1, rft[i].in.t2, rft[i].in.t3,
                          (N_SI4 *)&bt, rft[i].in.mb, (N_SI4 *)&vt,
                          rft[i].in.lv, rft[i].in.el, dat, N_R4,
                          (N_SI4 *)&gs))!=gs) {
        fprintf(stderr, "grib_reform: nusdas_read error. rt=%d(gs=%d)\n",rt,gs);
        free(dat); continue;
      }
      if ((rt=nusdas_write(rft[i].out.t1, rft[i].out.t2, rft[i].out.t3,
                          (N_SI4 *)&bt, rft[i].out.mb, (N_SI4 *)&vt,
                          rft[i].out.lv, rft[i].out.el, dat, N_R4,
                          (N_SI4 *)&gs))!=gs) {
        fprintf(stderr, "grib_reform: nusdas_write error. rt=%d\n",rt);
        printf("Failed@@\n");
      } else {
        printf("Succeeded!!\n");
      }
      free(dat);
    }
    free(vtlist);
  }
  free(rft);
exit(0);
}
