#include "nusdas_sys.h"
#define N_PATH_MAX 2000

/* ************************************************************************** */
void vt_set(N_ST_DEF *n_def, N_SI4 *basetime)
{
N_SI4   i, j;
N_SI4   py, pm, pd, ph, pn, pp, ky, kp, kd;

  for(i=0; i<n_tunit_num; i++)
    if (memcmp(&n_def->time_unit, n_tunit_string[i], 4)==0)  break;
  if (i<=3 || i==n_tunit_num) {
    for(j=0; j<n_def->n_vt; j++)
      *(n_def->vt1+j) = *basetime+*(n_def->vt1+j)*n_tunit_min[i];
  } else if (i==4) {
    nwp_seq2ymdhm(&py,&pm,&pd,&ph,&pn, *basetime);
    pp = n_calc_pent(pm, pd);
    for(j=0; j<n_def->n_vt; j++) {
      kd = n_calc_addday(py, pp, *(n_def->vt1+j), i);
      *(n_def->vt1+j) = *basetime+kd*60*24;
    }
  }
}

/* ************************************************************************** */
void path_set(char *path, char *nrd, N_ST_DEF *n_def, N_ST_DEF *n_def2,
              N_SI4 *basetime, N_SI4 m, N_SI4 l)
{
char dname[256], fname[256], flag, type1[9], type2[5], type3[5];
char dum[256], c0[8], c1[8], c2[8], c3[8];
N_SI4  validtime;
N_UI4  member;

  sscanf(n_def->type1, "%s %s %s %s", dum, c0, c1, c2);
  sprintf(type1, "%4.4s%2.2s%2.2s", c0, c1, c2);
  sscanf(n_def->type2, "%s %s %s", dum, c0, c1);
  sprintf(type2, "%2.2s%2.2s", c0, c1);
  sscanf(n_def->type3, "%s %s %s", dum, c0, c1);
  sprintf(type3, "%4.4s", c0);
  flag = 'v';
  memcpy(&member, (char *)(n_def->dc+m), 4);
  n_setpath(flag, nrd, n_def2, type1, type2, type3, basetime,
            (char *)(&member), (N_SI4 *)(n_def->vt1+l), dname, fname);
  sprintf(path, "%s/%s", dname, fname);
}

/* ************************************************************************** */
int main(int argc, char *argv[])
{
FILE  *fp;
N_ST_DEF  n_def, n_def2;
N_SI4  rt, basetime;
int  i, j, k, c, n_path=0;
int  py, pm, pd, ph, pn;
char  s[5], path[N_PATH_MAX][256], p[256], nrd[256], *c1, *c2;
s[4]='\0';

  if (argc <= 2) {
    printf("nusdas_vfsys_dsp n_root_dir define_file\n"); exit(0);
  }

  nusdas_iocntl(N_IO_WARNING_OUT, N_OFF);

  strcpy(nrd, argv[1]);
  py = 2000; pm = 3; pd = 1; ph = 0; pn = 0;
  basetime = nwp_ymdhm2seq(py, pm, pd, ph, pn);
  sprintf(p, "%s/nusdas_def/%s", nrd, argv[2]);
  if ((fp=fopen(p, "r"))==NULL) {
    printf("nusdas_vfsys_dsp: Error! define file <%s> open failed\n", p);
    exit(0);
  }
  if (n_read_def(fp, &n_def)<0) {
    printf("nusdas_vfsys_dsp: Error! define file <%s> read error\n", p);
    exit(0);
  }
  rewind(fp);
  n_read_def(fp, &n_def2);
  fclose(fp);
  vt_set(&n_def, &basetime);

  for(i=0, n_path=0; i<n_def.n_dc; i++)
  for(j=0; j<n_def.n_vt; j++) {
    path_set(p, nrd, &n_def, &n_def2, &basetime, i, j);
    for(k=0; k<n_path; k++) if (strcmp(p, path[k])==0)  break;
    if (k==n_path)  {
      strcpy(path[k], p);
      n_path++;
    }
  }

  printf("*****************************************************************\n");
  printf("* NuSDaS directory tree for <%s>\n", argv[2]);
  printf("*****************************************************************\n");
  for(k=0; k<n_path; k++)  printf("%3.3d %s\n", k, path[k]);
  return 0;
}
