/* nuspnm.c
 * 2001-07-04 TOYODA Eizi
 */

#include <stdio.h>
#include <stdlib.h> /* for malloc */
#include <nusdas.h>
#include "nusdim.h"
#include "textout.h"

static char rcsid[] = "$Id: getgrids.c,v 1.5 2003/03/07 02:30:37 tabito Exp $";

/* dp Ŏw肳 NuSDaS ʂQbg */

	int
nusdims_get_grids(struct nus_dims_t *dp, struct grids_t *gp)
{
	N_SI4	n;
	int	i, r;

	gp->xysize[0] = 0;
	gp->xysize[1] = 0;
	gp->ibuf = NULL, gp->fbuf = NULL, gp->dbuf = NULL;

	n = 2;
	r = nusdas_inq_def(dp->type.type1, dp->type.type2, dp->type.type3,
		N_GRID_SIZE, gp->xysize, &n);
	if (r < 0) {
		eprintf(HTTP_ERR, "nusdas_inq_def: %d\n", r);
		return r;
	}
	n = gp->xysize[0] * gp->xysize[1];

#define NUSDAS_ENOMEM -32

try_float32:
	/* 4oCgœǂł݂ */
	if ((gp->fbuf = malloc(n * sizeof(float))) == NULL)
		return NUSDAS_ENOMEM;
	r = nusdas_read(dp->type.type1, dp->type.type2, dp->type.type3,
		&(dp->base), dp->member, &(dp->valid), dp->plane, dp->element,
		gp->fbuf, N_R4, &n);
	if (r == -5)
		goto try_int32;
	if (r <= 0)
		eprintf(HTTP_ERR, "nusdas_read.float32 %d\n", r);
	return r;

try_int32:
	/* 4oCgœǂł݂ */
	gp->ibuf = (int *)gp->fbuf;
	gp->fbuf = NULL;
	r = nusdas_read(dp->type.type1, dp->type.type2, dp->type.type3,
		&(dp->base), dp->member, &(dp->valid), dp->plane, dp->element,
		gp->ibuf, N_I4, &n);
	if (r == -5)
		goto try_float64;
	if (r <= 0)
		eprintf(HTTP_ERR, "nusdas_read.int32 %d\n", r);
	return r;

try_float64:
	/* 8oCgœǂł݂ */
	free(gp->ibuf);
	if ((gp->dbuf = malloc(n * sizeof(double))) == NULL)
		return NUSDAS_ENOMEM;
	r = nusdas_read(dp->type.type1, dp->type.type2, dp->type.type3,
		&(dp->base), dp->member, &(dp->valid), dp->plane, dp->element,
		gp->dbuf, N_R8, &n);
	if (r <= 0) {
		eprintf(HTTP_ERR, "nusdas_read.float64 %d\n", r);
		free(gp->dbuf);
	}
	return r;
}

	int
nusdims_get_grids_uint8(struct nus_dims_t *dp, struct grids_t *gp)
{
	N_SI4	n;
	int	i, r;

	gp->xysize[0] = 0;
	gp->xysize[1] = 0;
	gp->ucbuf = NULL, gp->ibuf = NULL, gp->fbuf = NULL, gp->dbuf = NULL;

	n = 2;
	r = nusdas_inq_def(dp->type.type1, dp->type.type2, dp->type.type3,
		N_GRID_SIZE, gp->xysize, &n);
	if (r < 0) {
		eprintf(HTTP_ERR, "nusdas_inq_def: %d\n", r);
		return r;
	}
	n = gp->xysize[0] * gp->xysize[1];

#define NUSDAS_ENOMEM -32

	if ((gp->ucbuf = malloc(n * sizeof(char))) == NULL)
		return NUSDAS_ENOMEM;
	r = nusdas_read(dp->type.type1, dp->type.type2, dp->type.type3,
		&(dp->base), dp->member, &(dp->valid), dp->plane, dp->element,
		gp->ucbuf, N_I1, &n);
	if (r <= 0)
		eprintf(HTTP_ERR, "nusdas_read.I1 %d\n", r);
	return r;
}
/*--------------------------------------------------------------------*/
	int
nusdims_get_grids_int32(struct nus_dims_t *dp, struct grids_t *gp)
{
	N_SI4	n;
	int	i, r;

	gp->xysize[0] = 0;
	gp->xysize[1] = 0;
	gp->ucbuf = NULL, gp->ibuf = NULL, gp->fbuf = NULL, gp->dbuf = NULL;

	n = 2;
	r = nusdas_inq_def(dp->type.type1, dp->type.type2, dp->type.type3,
		N_GRID_SIZE, gp->xysize, &n);
	if (r < 0) {
		eprintf(HTTP_ERR, "nusdas_inq_def: %d\n", r);
		return r;
	}
	n = gp->xysize[0] * gp->xysize[1];

#define NUSDAS_ENOMEM -32

	if ((gp->ibuf = malloc(n * sizeof(int))) == NULL)
		return NUSDAS_ENOMEM;
	r = nusdas_read(dp->type.type1, dp->type.type2, dp->type.type3,
		&(dp->base), dp->member, &(dp->valid), dp->plane, dp->element,
		gp->ibuf, N_I4, &n);
	if (r <= 0)
		eprintf(HTTP_ERR, "nusdas_read.I4 %d\n", r);
	return r;
}
/*-----------------------------------------------------------------------*/
	int
nusdims_get_grids_double64(struct nus_dims_t *dp, struct grids_t *gp)
{
	N_SI4	n;
	int	i, r;

	gp->xysize[0] = 0;
	gp->xysize[1] = 0;
	gp->ucbuf = NULL, gp->ibuf = NULL, gp->fbuf = NULL, gp->dbuf = NULL;

	n = 2;
	r = nusdas_inq_def(dp->type.type1, dp->type.type2, dp->type.type3,
		N_GRID_SIZE, gp->xysize, &n);
	if (r < 0) {
		eprintf(HTTP_ERR, "nusdas_inq_def: %d\n", r);
		return r;
	}
	n = gp->xysize[0] * gp->xysize[1];

#define NUSDAS_ENOMEM -32

	if ((gp->dbuf = malloc(n * sizeof(double))) == NULL)
		return NUSDAS_ENOMEM;
	r = nusdas_read(dp->type.type1, dp->type.type2, dp->type.type3,
		&(dp->base), dp->member, &(dp->valid), dp->plane, dp->element,
		gp->dbuf, N_R8, &n);
	if (r <= 0)
		eprintf(HTTP_ERR, "nusdas_read.R8 %d\n", r);
	return r;
}
/*-------------------------------------------------------------------------*/
