@Common = ();
%Created = ();
%Opened = ();
$Output = undef;

while (<>) {
    if (/^#common/) {
	push @Common, "#line $. \"$ARGV\"\n";
	$Output = undef;
    } elsif (/^#output +(\S+)/) {
	$candidate = $1;
	if ($Output) {
		close($Output);
		$Opened{$Output} = 0;
	}
	$Output = $candidate;
	unless ($Created{$Output}) {
	    unless (open($Output, ">$Output")) {
		warn "$Output: $!\n";
		next;
	    }
	    foreach $line (@Common) {
		print $Output $line;
	    }
	    $Created{$Output} = 1;
	} else {
	    unless ($Opened{$Output}) {
		unless (open($Output, ">>$Output")) {
		    warn "$Output: $!\n";
		    next;
		}
		$Opened{$Output} = 1;
	    }
	}
	print $Output "#line $. \"$ARGV\"\n";
    } else {
	if (/fortran:([A-Za-z]\w*)/) {
		$pre = $`;
		$kwd = $1;
		$post = $';
		$pre =~ s/\s*//;  $pre = "$pre\n" if $pre;
		$post =~ s/\s*//;  $post = "$post\n" if $post;
		$uprkwd = $kwd;
		$lwrkwd = $kwd;
		$uprkwd =~ tr/a-z/A-Z/;
		$lwrkwd =~ tr/A-Z/a-z/;
		$next = sprintf("#line %d \"%s\"", $. + 1, $ARGV);
		$_ = <<EOF
$pre
#ifdef C_FORTRAN_UPPER
$uprkwd
#else
#  ifdef C_FORTRAN_LOWER_
${lwrkwd}_
#  else
f${lwrkwd}
#  endif
#endif
$post
$next
EOF
	}
	if (defined $Output) {
	    print $Output $_;
	} else {
	    push @Common, $_;
	}
    }
}

exit 0;
