#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "nusdas.h"
#include "recursive.h"
#include "binarytree.h"

/*
 * === malloc Ăꔭ^C^[tFCX ===
 */

struct getlist {
	size_t		count;
	int	query;
	const struct nus_dims_t	*cond;
	struct nus_dims_t	tmp;
	struct binary_tree	*btree;
};

	int
getlist_record(const char *fnam, const unsigned char *rec, void *info)
{
	struct getlist *gp;
	gp = (struct getlist *)info;
	if (memcmp(rec, "CNTL", 4) == 0) {
		N_SI4	base;
		/* ʂw肳ĂĈĂȂfBNg𔲂 */
		if ((gp->cond->stat & NUSDIM_TYPE) &&
			(memcmp(&(gp->cond->type), rec + 12, 16) != 0)) {
			return RET_BADDIR;
		}
		/* w肳ĂĂȂt@C𔲂 */
		base = btol(rec + 40);
		if ((gp->cond->stat & NUSDIM_BASE) &&
			(gp->cond->base != base)) {
			return RET_SKIPFILE;
		}
		/* Ώۂ̎ʂƊۑ */
		memcpy(&(gp->tmp.type), rec + 12, 16);
		gp->tmp.base = base;
	} else if (memcmp(rec, "DATA", 4) == 0) {
		const unsigned char	*member, *plane, *plane2, *element;
		N_SI4	valid, valid2;

		member = rec + 12;
		if ((gp->cond->stat & NUSDIM_MEMBER) &&
			(memcmp(gp->cond->member, member, 4) != 0)) {
			return 0;
		}

		valid = btol(rec + 16);
		if ((gp->cond->stat & NUSDIM_VALID) &&
			(gp->cond->valid != valid)) {
			return 0;
		}

		valid2 = btol(rec + 20);
		if ((gp->cond->stat & NUSDIM_VALID2) &&
			(gp->cond->valid2 != valid2)) {
			return 0;
		}

		plane = rec + 24;
		if ((gp->cond->stat & NUSDIM_PLANE) &&
			(memcmp(gp->cond->plane, plane, 4) != 0)) {
			return 0;
		}

		plane2 = rec + 30;
		if ((gp->cond->stat & NUSDIM_PLANE2) &&
			(memcmp(gp->cond->plane2, plane2, 4) != 0)) {
			return 0;
		}

		element = rec + 36;
		if ((gp->cond->stat & NUSDIM_ELEMENT) &&
			(memcmp(gp->cond->element, element, 4) != 0)) {
			return 0;
		}

		memcpy(&(gp->tmp.member), member, 4);
		gp->tmp.valid = valid;
		gp->tmp.valid2 = valid2;
		memcpy(&(gp->tmp.plane), plane, 6);
		memcpy(&(gp->tmp.plane2), plane2, 6);
		memcpy(&(gp->tmp.element), element, 6);
		bt_cmp_dims = gp->query;

		gp->btree = btree_add(gp->btree, BS_DIMS, &(gp->tmp));
		gp->count++;
	}
	return 0;
}

	int
nusdas_getlist_bydims(const struct nus_dims_t *dp,
	int query,			/* NUSDIMS }N̘_a */
	struct nus_dims_t **dimslist,	/* malloc ĕԂ */
	int	debug)
{
	struct getlist	g;
	char	*rootname, *nusdir;
	int	r, n;

	r = nusdas_find_root(&(dp->type), &rootname);
	if (r != 0) {
		errprintf("nusdas_find_root: %d\n", r);
		return NUSERR_NODEF;
	}
	nusdir = replace_path_bydims(dp, rootname);
	g.cond = dp;
	g.query = query;
	g.count = 0;
	g.btree = NULL;
	r = recursive_search(nusdir, &g, getlist_record);
	free(rootname);
	if (r == RET_BADSUBDIR) 
		r = 0;
	if (r != 0)
	 	return r;

	n = btree_count(g.btree);
	if (dimslist == NULL)
		return n;

	*dimslist = (struct nus_dims_t *)malloc(n * sizeof(struct nus_dims_t));
	if (*dimslist == NULL) {
		btree_dispose(g.btree);
		return NUSERR_NOMEM;
	}

	r = btree_dump(g.btree, BS_DIMS, (char *)*dimslist);
	if (r)
		return r;

	return n;
}
