/*
 * ꗗȂǂ̖₢킹sȂB
 * API ڍׂ nusdas.h QƁB
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "nusdas.h"
#include "recursive.h"
#include "binarytree.h"

/*
 * === internal: query about member ===
 */

struct inq_member_check {
	N_UI4			count;
	const struct nus_dims_t	*dimsp;
	struct binary_tree	*btree;
};

	static int
check_member(const char *fnam, const unsigned char *rec, void *mcp)
{
	struct inq_member_check *mcq;
	mcq = (struct inq_member_check *)mcp;
	if (memcmp(rec, "CNTL", 4) == 0) {
		if (memcmp(&mcq->dimsp->type, rec + 12, 16) != 0)
			return RET_BADDIR;
	} else if (memcmp(rec, "DATA", 4) == 0) {
		mcq->btree = btree_add(mcq->btree, BS_CHAR4, rec + 12);
		mcq->count++;
	}
	return 0;
}

	static int
inq_member_count(const char *rootname, const struct nus_dims_t *dp, 
	N_UI4 *buf, size_t size)
{
	int	r;
	N_UI4	count;
	struct inq_member_check	mcq;

	/* core */
	mcq.dimsp = dp;
	mcq.btree = NULL;
	r = recursive_search(rootname, (void *)&mcq, check_member);
	if (r != 0 && r != RET_BADSUBDIR)
		return r;
	if (mcq.count == 0)
		return NUSERR_NODATA;
	*(N_UI4 *)buf = count = btree_count(mcq.btree);
	if (count == 0)
		return NUSERR_INTERNAL;
	return 1;
}

/*
 * === internal: query about time unit ===
 */

struct inq_tunit_t {
	int	written;
	char	unit[5];
	const struct nus_type_t	*type;
};

	static int
check_ftime_unit(const char *fnam, const unsigned char *rec, void *vtp)
{
	struct inq_tunit_t *tp;
	tp = vtp;
	if (memcmp(rec, "CNTL", 4) != 0)
		return 0;
	if (memcmp(tp->type, rec + 12, 16) != 0)
		return RET_BADDIR;
	if (tp->written == 0) {
		memcpy(tp->unit, rec + 44, 4);
		tp->written = 1;
		return 0;
	} else if (memcmp(tp->unit, rec + 44, 4) == 0) {
		return 0;
	} else {
		errprintf("inconsistent time unit [%.4s] [%.4s]\n", tp->unit, rec + 44);
		return NUSERR_NOTUNIQUE;
	}
}

	static int
inq_ftime_unit(const char *rootname, const struct nus_dims_t *dp, 
	char *buf, size_t size)
{
	struct inq_tunit_t	tunitq;
	int	r;
	
	/* core */
	tunitq.written = 0;
	strcpy(tunitq.unit, "????");
	tunitq.type = &dp->type;
	r = recursive_search(rootname, (void *)&tunitq, check_ftime_unit);
	if (r != 0 && r != RET_BADSUBDIR)
		return r;
	memcpy(buf, tunitq.unit, 4);
	if (tunitq.written == 0)
		return NUSERR_NODATA;
	return 1;
}

/*
 * === public interface ===
 */

	int
nusdas_inq_bydims(const struct nus_dims_t *dp,
	int query, /* nusdas_inq_ ` */
	void *buf,
	size_t size)
{
	char	*rootname;
	int	r;

	r = nusdas_find_root(&(dp->type), &rootname);
	if (r != 0) {
		errprintf("nusdas_find_root: %d\n", r);
		return NUSERR_NODEF;
	}

	switch (query) {
case N_VALIDTIME_UNIT:
		r = inq_ftime_unit(rootname, dp, buf, size);
		break;
case N_MEMBER_NUM:
		r = inq_member_count(rootname, dp, buf, size);
		break;
default:
		r = NUSERR_BADQUERY;
		break;
	}
	free(rootname);

	return r;
}
