!
! ----------------------------------------------------------------
!
subroutine N_ESF_OPEN(mt, sp_data, is_data, js_data, lrec, maxrec, &
                      irw_flag, icflag, irt, nid, filename, ic)
!
integer(kind=4) :: mt, is_data, irec, lrec, maxrec, irw_flag, nid
integer(kind=4) :: irt, ic, icode, i, icflag, js_data
integer(kind=4) :: sp_data(is_data)
integer(kind=4),dimension(:),allocatable :: cp_data
character(len=4) :: sss
character(len=ic) :: filename
character(len=80) :: vfname, vfwork1, vfwork2


if (irw_flag .eq. 1) then
  if (ic.eq.0) then
    if (nid.lt.10) then
      write(vfwork1, '(a7,i1)') 'NUSDAS0',nid
    else
      write(vfwork1, '(a6,i2)') 'NUSDAS',nid
    end if
    if (mt.lt.10) then
      write(vfwork2, '(a7,i1)') '/esnus0',mt
    else
      write(vfwork2, '(a6,i2)') '/esnus',mt
    end if
    vfname = vfwork1(1:8)//vfwork2(1:8)
    ! untested:  originally there was "maxrec=amxrec, clear='no'".
    open(mt,status='unknown',action='readwrite',access='direct', &
            recl=lrec,file=vfname,form='unformatted', &
            err=900,iostat=icode)
  else
    open(mt,status='unknown',action='readwrite',access='direct', &
            recl=lrec,file=filename,form='unformatted', &
            err=900,iostat=icode)
  end if
  irec=1
  if (js_data.ne.0) then
    call movec(sss,1,sp_data(is_data),1,js_data)
    write(mt, rec=irec,err=901,iostat=icode) (sp_data(i),i=1,is_data-1),sss(1:js_data)
  else
    write(mt, rec=irec,err=901,iostat=icode) sp_data
  end if

  allocate(cp_data(is_data))
  do i=1,is_data
    cp_data(i) = 0
  end do

  if (js_data.ne.0) then
    call movec(sss,1,cp_data(1),1,js_data)
    do irec=2,maxrec
      write(mt, rec=irec,err=901,iostat=icode) (cp_data(i),i=1,is_data-1),sss(1:js_data)
    end do
  else
    do irec=2,maxrec
      write(mt, rec=irec,err=901,iostat=icode) cp_data
    end do
  end if

  deallocate(cp_data)

else

  if (ic.eq.0) then
    if (nid.lt.10) then
      write(vfwork1, '(a7,i1)') 'NUSDAS0',nid
    else
      write(vfwork1, '(a6,i2)') 'NUSDAS',nid
    end if
    if (mt.lt.10) then
      write(vfwork2, '(a7,i1)') '/esnus0',mt
    else
      write(vfwork2, '(a6,i2)') '/esnus',mt
    end if
    vfname = vfwork1(1:8)//vfwork2(1:8)
    open(mt,status='old',action='readwrite',access='direct', &
            file=vfname,form='unformatted',recl=lrec,err=900,iostat=icode)
  else
    open(mt,status='old',action='readwrite',access='direct', &
            file=filename,form='unformatted',recl=lrec,err=900,iostat=icode)
  end if
  irec=1
    if (js_data.ne.0) then
      read(mt, rec=irec,err=902,iostat=icode) (sp_data(i),i=1,is_data-1),sss(1:js_data)
    else
      read(mt, rec=irec,err=902,iostat=icode) sp_data
    end if
    if (js_data.ne.0)  call movec(sp_data(is_data),1,sss,1,js_data)
    if (sp_data(2).ne. transfer('CNTL', sp_data(2))) then
      close(mt)
      goto 900
    end if

end if
irt=0; return
!
900 irt=70; goto 999
901 irt=71; goto 999
902 irt=72; goto 999
999 if (icflag.eq.0) then
      write(6,*) 'NuSDaS ESF_OPEN error!!! rt=',irt
      write(6,*) 'iostat  :',icode
      write(6,*) 'mt      :',mt
      write(6,*) 'irw_flag:',irw_flag
      if (ic.eq.0) then
        write(6,*) 'filename:',vfname
      else
        write(6,*) 'filename:',filename
      end if
      write(6,*) 'recl    :',lrec
      write(6,*) 'irec    :',irec
      write(6,*) 'is_data :',is_data
      write(6,*) 'js_data :',js_data
    end if
return
! 
end subroutine N_ESF_OPEN
!
! ----------------------------------------------------------------
!
subroutine N_ESF_WRITE(mt, irec, sp_data, is, js, irt)
!
integer(kind=4) :: mt, irec, is, js, irt, i
integer(kind=4) :: sp_data(is)
character(len=4) :: sss
!
if (is.gt.0 .or. js.gt.0) then
  if (js.ne.0)  call movec(sss,1,sp_data(is),1,js)
  if (js.ne.0) then
    write(mt, rec=irec,err=901) (sp_data(i),i=1,is-1),sss(1:js)
  else
    write(mt, rec=irec,err=901) sp_data
  end if
end if
irt=0; return
!
901 irt=71; return
end subroutine N_ESF_WRITE
!
! ----------------------------------------------------------------
!
subroutine N_ESF_READ(mt, irec, sp_data, is, js, irt)
!
integer(kind=4) :: mt, irec, is, js, irt, i
integer(kind=4) :: sp_data(is)
character(len=4) :: sss
!
if (is.gt.0 .or. js.gt.0) then
  if (js.ne.0) then
    read(mt, rec=irec,err=902) (sp_data(i),i=1,is-1),sss(1:js)
    call movec(sp_data(is),1,sss,1,js)
  else
    read(mt, rec=irec,err=902) sp_data
  end if
end if
irt=0; return
!
902 irt=72; return
end subroutine N_ESF_READ
!
! ----------------------------------------------------------------
!
subroutine N_ESF_CLOSE(mt, irt)
!
integer(kind = 4):: irt, mt
!
close(mt,err=903)
irt=0; return
!
903 irt=73; return
end subroutine N_ESF_CLOSE
