#define N_DEF_ESFSUB_SOURCE
#include "nusdas_sys.h"

/* -------------------------------------------------------------------------- */
N_SI4 n_set_spinfo(N_ST_INFO * s_info, N_UI1 ** sp_info)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, j, sps = 0;
    N_UI1 uc = 0;

    *sp_info = (N_UI1 *) malloc(sizeof(N_UI1) * (s_info->h.length_s));
    memcpy((N_UI1 *) (*sp_info + sps), &s_info->h, sizeof(N_ST_RI));
    sps += sizeof(N_ST_RI);
    memcpy((N_UI1 *) (*sp_info + sps), &s_info->gname, sizeof(N_UI4));
    sps += sizeof(N_UI4);
    memcpy((N_UI1 *) (*sp_info + sps), (N_UI1 *) (s_info->d),
	   sizeof(N_UI1) * s_info->size);
    sps += sizeof(N_UI1) * s_info->size;
    j = s_info->h.available;
    for (i = j; i < s_info->h.length_s - sizeof(N_SI4); i++)
	memcpy((N_UI1 *) (*sp_info + sps++), &uc, 1);
    memcpy((N_UI1 *) (*sp_info + sps), &s_info->length_e, sizeof(N_SI4));
    sps += 4;

    return (sps);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_set_spsubc(N_ST_SUBC * s_subc, N_UI1 ** sp_subc)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, j, sps = 0, *sp_int;
    N_UI1 uc = 0;

    *sp_subc = (N_UI1 *) malloc(sizeof(N_UI1) * (s_subc->h.length_s));
    memcpy((N_UI1 *) (*sp_subc + sps), &s_subc->h, sizeof(N_ST_RI));
    sps += sizeof(N_ST_RI);
    memcpy((N_UI1 *) (*sp_subc + sps), &s_subc->gname, sizeof(N_UI4));
    sps += sizeof(N_UI4);
    memcpy((N_UI1 *) (*sp_subc + sps), (N_UI1 *) (s_subc->d),
	   sizeof(N_UI1) * s_subc->size);
    sps += sizeof(N_UI1) * s_subc->size;
    j = sps;
    for (i = j; i < s_subc->h.length_s - sizeof(N_SI4); i++)
	memcpy((N_UI1 *) (*sp_subc + sps++), &uc, 1);
    memcpy((N_UI1 *) (*sp_subc + sps), &s_subc->length_e, sizeof(N_SI4));
    sps += 4;

    return (sps);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_set_spcntl(N_ST_CNTL * s_cntl, N_UI1 ** sp_cntl)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, j, sps = 0;
    N_UI1 uc = 0;

    *sp_cntl = (N_UI1 *) malloc(sizeof(N_UI1) * s_cntl->f.h.length_s);
    memcpy((N_UI1 *) (*sp_cntl + sps), &s_cntl->f, sizeof(N_ST_CF));
    sps += sizeof(N_ST_CF);
    memcpy((N_UI1 *) (*sp_cntl + sps), (N_UI4 *) (s_cntl->dc),
	   sizeof(N_UI4) * s_cntl->f.n_dc);
    sps += sizeof(N_UI4) * s_cntl->f.n_dc;
    memcpy((N_UI1 *) (*sp_cntl + sps), (N_UI4 *) (s_cntl->vt1),
	   sizeof(N_UI4) * s_cntl->f.n_vt);
    sps += sizeof(N_UI4) * s_cntl->f.n_vt;
    memcpy((N_UI1 *) (*sp_cntl + sps), (N_UI4 *) (s_cntl->vt2),
	   sizeof(N_UI4) * s_cntl->f.n_vt);
    sps += sizeof(N_UI4) * s_cntl->f.n_vt;
    for (i = 0; i < s_cntl->f.n_lv; i++) {
	memcpy((N_UI1 *) (*sp_cntl + sps), (N_UI8 *) (s_cntl->lv1 + i), 6);
	sps += 6;
    }
    for (i = 0; i < s_cntl->f.n_lv; i++) {
	memcpy((N_UI1 *) (*sp_cntl + sps), (N_UI8 *) (s_cntl->lv2 + i), 6);
	sps += 6;
    }
    for (i = 0; i < s_cntl->f.n_el; i++) {
	memcpy((N_UI1 *) (*sp_cntl + sps), (N_UI8 *) (s_cntl->el + i), 6);
	sps += 6;
    }
    j = s_cntl->f.h.available + sizeof(N_SI4);
    for (i = j; i < s_cntl->f.h.length_s - sizeof(N_SI4); i++)
	memcpy((N_UI1 *) (*sp_cntl + sps++), &uc, 1);
    memcpy((N_UI1 *) (*sp_cntl + sps), &s_cntl->length_e, sizeof(N_SI4));
    sps += 4;

    return (sps);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_get_spcntl(N_ST_CNTL * s_cntl, N_UI1 * sp_cntl)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, j, sps = 0;
    N_UI1 uc = 0;

    memcpy(&s_cntl->f, (N_UI1 *) (sp_cntl + sps), sizeof(N_ST_CF));
    sps += sizeof(N_ST_CF);
    s_cntl->dc = (N_UI4 *) malloc(sizeof(N_UI4) * s_cntl->f.n_dc);
    memcpy((N_UI4 *) (s_cntl->dc), (N_UI1 *) (sp_cntl + sps),
	   sizeof(N_UI4) * s_cntl->f.n_dc);
    sps += sizeof(N_UI4) * s_cntl->f.n_dc;
    s_cntl->vt1 = (N_SI4 *) malloc(sizeof(N_SI4) * s_cntl->f.n_vt);
    memcpy((N_SI4 *) (s_cntl->vt1), (N_UI1 *) (sp_cntl + sps),
	   sizeof(N_SI4) * s_cntl->f.n_vt);
    sps += sizeof(N_SI4) * s_cntl->f.n_vt;
    s_cntl->vt2 = (N_SI4 *) malloc(sizeof(N_SI4) * s_cntl->f.n_vt);
    memcpy((N_SI4 *) (s_cntl->vt2), (N_UI1 *) (sp_cntl + sps),
	   sizeof(N_SI4) * s_cntl->f.n_vt);
    sps += sizeof(N_SI4) * s_cntl->f.n_vt;
    s_cntl->lv1 = (N_UI8 *) malloc(sizeof(N_UI8) * s_cntl->f.n_lv);
    for (i = 0; i < s_cntl->f.n_lv; i++) {
	memcpy((N_UI8 *) (s_cntl->lv1 + i), (N_UI1 *) (sp_cntl + sps), 6);
	sps += 6;
    }
    s_cntl->lv2 = (N_UI8 *) malloc(sizeof(N_UI8) * s_cntl->f.n_lv);
    for (i = 0; i < s_cntl->f.n_lv; i++) {
	memcpy((N_UI8 *) (s_cntl->lv2 + i), (N_UI1 *) (sp_cntl + sps), 6);
	sps += 6;
    }
    s_cntl->el = (N_UI8 *) malloc(sizeof(N_UI8) * s_cntl->f.n_el);
    for (i = 0; i < s_cntl->f.n_el; i++) {
	memcpy((N_UI8 *) (s_cntl->el + i), (N_UI1 *) (sp_cntl + sps), 6);
	sps += 6;
    }
    j = s_cntl->f.h.available + sizeof(N_SI4);
    for (i = j; i < s_cntl->f.h.length_s - sizeof(N_SI4); i++, sps++)
	continue;
    memcpy(&s_cntl->length_e, (N_UI1 *) (sp_cntl + sps), sizeof(N_SI4));
    sps += 4;

    return (sps);
}
