#define N_DEF_NUSDAS_SOURCE
#include "nusdas_sys.h"
#include "nusdas_com.h"

N_SI4 n_nrd_num = -1, n_esf_xx = -1;
FILE *n_fp[N_FOPEN_MAX];
N_UI1 *n_ed[N_FOPEN_MAX];
N_SI4 n_esf_bufsize[N_FOPEN_MAX], n_esf_nowbuf[N_FOPEN_MAX];
N_SI4 n_fopen_type[N_FOPEN_MAX];
char n_opened_file[N_FOPEN_MAX][N_LINE_MAX * 2] = {
    N_FOPEN_STRING_INIT
};


char n_def_type1[N_DEF_MAX][8] = {
    N_DEF_STRING_INIT
};


char n_def_type2[N_DEF_MAX][4] = {
    N_DEF_STRING_INIT
};


char n_def_type3[N_DEF_MAX][4] = {
    N_DEF_STRING_INIT
};


char n_nrd[N_DEF_MAX][N_LINE_MAX] = {
    N_DEF_STRING_INIT
};


N_SI4 n_nid[N_DEF_MAX], n_frlen[N_FOPEN_MAX];
N_SI4 n_esf[N_FOPEN_MAX], *n_esf_irec[N_FOPEN_MAX];
long n_next_offset[N_FOPEN_MAX];
N_SI4 n_subc_flag = N_OFF, n_n_subc[N_FOPEN_MAX];
N_SI4 n_sizex_override = N_OFF, n_sizey_override = N_OFF;
N_UI4 n_pack[N_FOPEN_MAX], n_miss[N_FOPEN_MAX], n_pack_override = N_OFF;
N_ST_NUSD n_nusd[N_FOPEN_MAX];
N_ST_CNTL n_cntl[N_FOPEN_MAX];
N_ST_INDX n_indx[N_FOPEN_MAX];
N_ST_END n_end[N_FOPEN_MAX];
N_ST_SUBC n_w_subc[N_FOPEN_MAX][N_SUBC_MAX];
N_ST_DEF n_def[N_DEF_MAX];

/* -------------------------------------------------------------------------- */
N_SI4
n_init_write(const char *utype1, const char *utype2, const char *utype3,
	     N_SI4 * basetime, const char *udescriptor, N_SI4 * validtime1,
	     N_SI4 * validtime2, const char *ulevel1, const char *ulevel2,
	     const char *uelement, void *data, const char *dtype,
	     const N_SI4 * dnum, const char *action)
/* -------------------------------------------------------------------------- */
{
    char path[N_LINE_MAX], flag, fname[N_LINE_MAX];
    char type1[9], type2[5], type3[5], type[17], descriptor[5];
    char level1[7], level2[7], element[7];
    N_UI1 *sp_cntl, *sp_subc, *sp_info, *sp_data;
    N_SI4 rt, i, j, k, l, m, fpn, defn, offp, offnum, rtnum, icflag;
    N_SI4 use_offset, maxrec, recnum, rw_flag, bufrec;
    N_SI4 sp_cntl_size, sp_subc_size, sp_info_size, csize, csize2;
    N_SI4 is_cntl, js_cntl, is_subc, js_subc, is_info, js_info, is_data,
	js_data;
    N_ST_SUBC s_subc;
    N_ST_INFO s_info;
    FILE *fp;

    strcpy(n_routine_name[n_routine_d++], "nusdas_write");

    n_copy_type(utype1, utype2, utype3, udescriptor,
		type1, type2, type3, descriptor);
    n_copy_char(ulevel1, ulevel2, uelement, level1, level2, element);
    if ((defn = n_set_defn(type1, type2, type3)) < 0) {
	N_ERTN(defn);
    }
    if (n_nid[defn] >= 50) {
	N_ERP2("no write permission for NUSDAS%2.2d\n",
	       n_nid[defn]);
	errprintf( "NUSDAS50 - NUSDAS99 is read only!\n");
	N_ERTN(-69);
    }

    flag = 'c';
    if ((rt = n_setpath(flag, n_nrd[defn], &n_def[defn], type1, type2,
			type3,
			basetime, descriptor, validtime1, path,
			fname)) < 0) {
	N_ERTN(-49 + rt);
    }
    if ((rt = n_check_fileopen(path, fname, &fpn)) < 0) {
	N_ERTN(-52);
    }

    if (strcmp(path, "n_nwp_esf") == 0) {
	if (rt == 0 && n_fopen_type[fpn] == N_FOPEN_READ) {
	    n_check_esfclose(fpn, N_FOPEN_READ);
	    if ((rt = n_check_fileopen(path, fname, &fpn)) < 0) {
		N_ERTN(-52);
	    }
	}
	if (rt > 0) {		/* new open ESF */
	    if (strlen(fname) == 2 && isdigit((int) fname[0]) &&
		isdigit((int) fname[1])) {
		n_esf[fpn] = atoi(fname);
		csize = 0;
	    } else {
		if (n_esf_xx == -1) {
		    if ((fp = fopen("NUSDAS_FTXX", "r"))
			== NULL || fscanf(fp, "%d", &n_esf_xx) != 1) {
			N_ERP2( "Can't read ESF device number from NUSDAS_FTXX!\n");
			errprintf( "fp=%x xx=%d\n", fp, n_esf_xx);
			N_ERTN(-77);
		    } else
			fclose(fp);
		}
		n_esf[fpn] = n_esf_xx;
		csize = strlen(fname);
	    }
	    if (n_esf[fpn] < 1 || n_esf[fpn] > 99 || n_esf[fpn]
		== 5 || n_esf[fpn] == 6) {
		N_ERP2( "filename=FTXX <%d> for ESF is not permitted!",
		       n_esf[fpn]);
		N_ERTN(-76);
	    }

	    n_frlen[fpn] = n_def[defn].forced_rlen;
	    n_miss[fpn] = n_def[defn].miss;
	    n_pack[fpn] = n_def[defn].pack;
	    if ((recnum = n_set_esfirec(&n_esf_irec[fpn], &n_def[defn])) <
		0) {
		N_ERTN(-79);
	    }
	    n_esf_bufsize[fpn] =
		n_set_bufsize(n_frlen[fpn], recnum, &maxrec);

	    rw_flag = 0;
	    icflag = 1;
	    if ((n_ed[fpn] = (N_UI1 *) calloc(sizeof(N_UI1),
					      n_esf_bufsize[fpn])) == NULL) {
		N_ERP2("malloc failed for esf_buffer <%d>\n",
		       n_esf_bufsize[fpn]);
		N_ERTN(-79);
	    }
	    is_data = (n_esf_bufsize[fpn] - 1) / 4 + 1;
	    js_data = n_esf_bufsize[fpn] % 4;
	    N_ESF_OPEN(&n_esf[fpn], (N_SI4 *) n_ed[fpn], &is_data,
		       &js_data,
		       &n_esf_bufsize[fpn], &maxrec, &rw_flag, &icflag,
		       &rt, &(n_nid[defn]), fname, &csize, &csize);
	    if (rt == 0) {	/* already exist */
		n_get_spcntl(&n_cntl[fpn], n_ed[fpn]);
		n_esf_nowbuf[fpn] = 1;
		n_indx[fpn].offset = (N_SI4 *) malloc(sizeof(N_SI4) * 1);	/* dummy alloc */
		n_fopen_type[fpn] = N_FOPEN_WRITE;
	    } else {		/* new creation */
		n_cntl[fpn].dc = NULL;
		n_cntl[fpn].vt1 = NULL;
		n_cntl[fpn].vt2 = NULL;
		n_cntl[fpn].lv1 = NULL;
		n_cntl[fpn].lv2 = NULL;
		n_cntl[fpn].el = NULL;
		s_subc.size = 0;
		s_info.size = 0;
		n_fopen_type[fpn] = N_FOPEN_WRITE;
		strcpy(type, type1);
		strcat(type, type2);
		strncat(type, type3, 4);
		if ((rt = init_nusdas_file(NULL, &n_def[defn],
					   defn, type, basetime,
					   (N_UI4 *) descriptor,
					   validtime1, &n_nusd[fpn],
					   &n_cntl[fpn], &n_indx[fpn],
					   &n_end[fpn], &s_subc,
					   &s_info)) < 0) {
		    N_ERP2("file <%s> initialization failed.\n",
			   n_opened_file[fpn]);
		    n_check_fileclose(fpn, N_FOPEN_WRITE);
		    N_ERTN(-59 - rt);
		}
		sp_cntl_size = n_set_spcntl(&n_cntl[fpn], &sp_cntl);
		is_cntl = (sp_cntl_size - 1) / 4 + 1;
		js_cntl = sp_cntl_size % 4;
		if (s_subc.size > 0) {
		    sp_subc_size = n_set_spsubc(&s_subc, &sp_subc);
		} else {
		    s_subc.h.length_s = n_frlen[fpn];
		    s_subc.h.available = 20;
		    s_subc.h.creattime = 0;
		    s_subc.length_e = n_frlen[fpn];
		    s_subc.size = 0;
		    memcpy(&s_subc.h.recname, "SUBC", 4);
		    sp_subc_size = n_set_spsubc(&s_subc, &sp_subc);
		}
		is_subc = (sp_subc_size - 1) / 4 + 1;
		js_subc = sp_subc_size % 4;
		if (s_info.size > 0) {
		    sp_info_size = n_set_spinfo(&s_info, &sp_info);
		} else {
		    s_info.h.length_s = n_frlen[fpn];
		    s_info.h.available = 20;
		    s_info.h.creattime = 0;
		    s_info.length_e = n_frlen[fpn];
		    s_info.size = 0;
		    memcpy(&s_info.h.recname, "INFO", 4);
		    sp_info_size = n_set_spinfo(&s_info, &sp_info);
		}
		is_info = (sp_info_size - 1) / 4 + 1;
		js_info = sp_info_size % 4;

		l = 0;
		n_esf_nowbuf[fpn] = 1;
		memcpy((void *) (n_ed[fpn] + l), sp_cntl, n_frlen[fpn]);
		l += n_frlen[fpn];
		memcpy((void *) (n_ed[fpn] + l), sp_subc, n_frlen[fpn]);
		l += n_frlen[fpn];
		memcpy((void *) (n_ed[fpn] + l), sp_info, n_frlen[fpn]);
		if (s_subc.size > 0)
		    free(s_subc.d);
		if (s_info.size > 0)
		    free(s_info.d);
		is_data = (n_esf_bufsize[fpn] - 1) / 4 + 1;
		js_data = n_esf_bufsize[fpn] % 4;
		rw_flag = 1;
		icflag = 0;
		N_ESF_OPEN(&n_esf[fpn], (N_SI4 *) n_ed[fpn],
			   &is_data, &js_data,
			   &n_esf_bufsize[fpn], &maxrec, &rw_flag,
			   &icflag, &rt, &(n_nid[defn]),
			   fname, &csize, &csize);
		switch (rt) {
		case 70:
		    N_ERP2("ESF <%d:%s> open failed.\n",
			   n_esf[fpn], fname);
		    N_ERTN(-70);
		case 71:
		    N_ERP2( "ESF <%d:%s> write for initialize failed.\n",
			   n_esf[fpn], fname);
		    N_ERTN(-71);
		}
	    }
	}
	if (strcmp(action, "write") == 0) {
	    if ((sp_data = (N_UI1 *) malloc(sizeof(N_UI1) *
					    n_frlen[fpn])) == NULL) {
		N_ERP2("malloc for sp_data failed. size=%d\n",
		       n_frlen[fpn]);
		N_ERTN(-10);
	    }
	    if ((rtnum = n_write_data(basetime, descriptor,
				      validtime1, validtime2,
				      level1, level2, element, data, dtype,
				      dnum, fpn, &use_offset,
				      sp_data)) < 0) {
		N_ERTN(rtnum);
	    }
	    bufrec =
		(use_offset - 1) / (n_esf_bufsize[fpn] / n_frlen[fpn]) + 1;
	    if (bufrec != n_esf_nowbuf[fpn]) {
		is_data = (n_esf_bufsize[fpn] - 1) / 4 + 1;
		js_data = n_esf_bufsize[fpn] % 4;
		N_ESF_WRITE(&n_esf[fpn], &n_esf_nowbuf[fpn],
			    (N_SI4 *) n_ed[fpn], &is_data, &js_data, &rt);
		if (rt == 71) {
		    N_ERP2("ESF <%d:%s> write failed. recnum=%d\n",
			   n_esf[fpn],
			   &n_opened_file[fpn][10], n_esf_nowbuf[fpn]);
		    N_ERTN(-71);
		}
		n_esf_nowbuf[fpn] = bufrec;
		N_ESF_READ(&n_esf[fpn], &n_esf_nowbuf[fpn],
			   (N_SI4 *) n_ed[fpn], &is_data, &js_data, &rt);
		if (rt == 72) {
		    N_ERP2("ESF <%d:%s> read failed. recnum=%d\n",
			   n_esf[fpn],
			   &n_opened_file[fpn][10], n_esf_nowbuf[fpn]);
		    N_ERTN(-72);
		}
	    }
	    bufrec = use_offset - (bufrec - 1) * (n_esf_bufsize[fpn]
						  / n_frlen[fpn]);
	    memcpy((void *) (n_ed[fpn] + n_frlen[fpn] * (bufrec
							 - 1)),
		   (const void *) sp_data, n_frlen[fpn]);
	    free(sp_data);
	}
    } else {
	if (rt == 0 && n_fopen_type[fpn] == N_FOPEN_READ) {
	    n_check_fileclose(fpn, N_FOPEN_READ);
	    if ((rt = n_check_fileopen(path, fname, &fpn)) < 0) {
		N_ERTN(-52);
	    }
	}
	if (rt > 0) {		/* new open */
	    if ((n_fp[fpn] = fopen(n_opened_file[fpn], "r+")) == NULL) {
		if ((n_fp[fpn] = fopen(n_opened_file[fpn], "w")) == NULL) {
		    errsys("");
		    N_ERP2("file <%s> new creation failed.\n",
			   n_opened_file[fpn]);
		    N_ERTN(-53);
		} else {
		    fclose(n_fp[fpn]);	/* for fseek(SEEK_END) */
		    n_fp[fpn] = fopen(n_opened_file[fpn], "r+");
		    n_fopen_type[fpn] = N_FOPEN_WRITE;
		}
		n_cntl[fpn].dc = NULL;
		n_cntl[fpn].vt1 = NULL;
		n_cntl[fpn].vt2 = NULL;
		n_cntl[fpn].lv1 = NULL;
		n_cntl[fpn].lv2 = NULL;
		n_cntl[fpn].el = NULL;
		strcpy(type, type1);
		strcat(type, type2);
		strncat(type, type3, 4);
		if ((rt = init_nusdas_file(n_fp[fpn], &n_def[defn],
					   defn, type, basetime,
					   (N_UI4 *) descriptor,
					   validtime1, &n_nusd[fpn],
					   &n_cntl[fpn], &n_indx[fpn],
					   &n_end[fpn], &s_subc,
					   &s_info)) < 0) {
		    N_ERP2("file <%s> initializatioin failed.\n",
			   n_opened_file[fpn]);
		    n_check_fileclose(fpn, N_FOPEN_WRITE);
		    N_ERTN(-59 - rt);
		}
	    } else {		/* file exists */
		n_fopen_type[fpn] = N_FOPEN_WRITE;
		if (n_read_nusd(n_fp[fpn], &n_nusd[fpn]) != 0) {
		    N_ERP2("file <%s> read NUSD failed.\n",
			   n_opened_file[fpn]);
		    n_check_fileclose(fpn, N_FOPEN_WRITE);
		    N_ERTN(-54);
		}
		if (n_read_cntl(n_fp[fpn], &n_cntl[fpn]) != 0) {
		    N_ERP2("file <%s> read CNTL failed.\n",
			   n_opened_file[fpn]);
		    n_check_fileclose(fpn, N_FOPEN_WRITE);
		    N_ERTN(-55);
		}
		offnum = n_cntl[fpn].f.n_dc * n_cntl[fpn].f.n_vt
		    * n_cntl[fpn].f.n_lv * n_cntl[fpn].f.n_el;
		if (
		    (rt =
		     n_read_indx(n_fp[fpn], &n_indx[fpn], offnum) != 0)) {
		    N_ERP2("file <%s> read INDX failed. rt=%d\n",
			   n_opened_file[fpn], rt);
		    n_check_fileclose(fpn, N_FOPEN_WRITE);
		    N_ERTN(-56);
		}
	    }
	    if ((n_next_offset[fpn] = n_set_next_offset(n_fp[fpn],
							&(n_end[fpn]),
							N_OFF)) < 2) {
		N_ERTN(-57);
	    }
	    n_frlen[fpn] = n_def[defn].forced_rlen;
	    n_miss[fpn] = n_def[defn].miss;
	    n_pack[fpn] = n_def[defn].pack;
	}

	if (strcmp(action, "write") == 0) {
	    if ((rtnum = n_write_data(basetime, descriptor,
				      validtime1, validtime2,
				      level1, level2, element, data, dtype,
				      dnum, fpn, &use_offset, NULL)) < 0) {
		N_ERTN(rtnum);
	    }
	}

	if (n_io_cntl & N_IO_MARK_END && use_offset == 1)
	    if ((i = n_mark_end(fpn)) < 0) {
		N_ERTN(-64 + i);
	    }
	if ((n_io_cntl & N_IO_W_FCLOSE) == N_IO_W_FCLOSE)
	    n_check_fileclose(fpn, N_FOPEN_WRITE);
    }
    n_routine_d--;

    return (rtnum);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_write2(const char *utype1, const char *utype2, const char *utype3,
	      N_SI4 * basetime, const char *udescriptor,
	      N_SI4 * validtime1, N_SI4 * validtime2, const char *ulevel1,
	      const char *ulevel2, const char *uelement, void *data,
	      const char *dtype, const N_SI4 * dnum)
/* -------------------------------------------------------------------------- */
/*  input:  type1, type2, type3, basetime, descriptor, validtime1, validtime2 */
/*          level1, level2, element                                           */
/*                = target parameters                                         */
/*          data  = user data pointer for write the nusdas file               */
/*          dtype = variable type for user data pointer                       */
/*          dnum  = item number of user data array (not byte)                 */
/*  return  ng    = number of write data                                      */
/* -------------------------------------------------------------------------- */
{
    return (n_init_write(utype1, utype2, utype3, basetime, udescriptor,
			 validtime1,
			 validtime2, ulevel1, ulevel2, uelement, data,
			 dtype, dnum, "write"));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_write(const char *utype1, const char *utype2, const char *utype3,
	     N_SI4 * basetime, const char *descriptor, N_SI4 * validtime1,
	     const char *ulevel1, const char *uelement, void *data,
	     const char *dtype, const N_SI4 * dnum)
/* -------------------------------------------------------------------------- */
{
    N_SI4 validtime2 = 1;
    return (nusdas_write2(utype1, utype2, utype3, basetime, descriptor,
			  validtime1,
			  &validtime2, ulevel1, ulevel1, uelement, data,
			  dtype, dnum));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_read_direct2(char *descriptor, N_SI4 * validtime1,
		    N_SI4 * validtime2, char *level1, char *level2,
		    char *element, void *data, const char *dtype,
		    const N_SI4 * dnum, N_SI4 fpn, FILE * fpin, N_SI4 esf)
/* -------------------------------------------------------------------------- */
/*  input:  descriptor, validtime1, validtime2, level1, level2, element       */
/*                  = target parameters                                       */
/*  both:   data    = user data pointer for house data                        */
/*  input:  dtype   = variable type for user data pointer                     */
/*          dnum    = item number of user data array (not byte)               */
/*          fpn     = target file number                                      */
/*                  = -1: not controled by def-file. fp must be specified     */
/*          fpin    = file pointer if fpn==-1                                 */
/*  return: <0      =  read DATA error                                        */
/*          0       = not registered or recorded                              */
/*          ng      = number of set data to (N_UI1 *)data                     */
/* -------------------------------------------------------------------------- */
{
    FILE *fp;
    N_ST_CNTL *p_cntl, s_cntl;
    N_ST_INDX *p_indx, s_indx;
    N_SI4 n, p, rt, irec, is_buf, js_buf, bufrec;
    char s1[256], s2[256];
    long offset;

    fp = (fpn == -1) ? fpin : n_fp[fpn];
    if (fpn == -1) {
	if (n_read_cntl(fp, &s_cntl) < 0) {
	    N_ERP2("your opened file, read CNTL failed.\n");
	    return (-7);
	}
	n = s_cntl.f.n_dc * s_cntl.f.n_vt * s_cntl.f.n_lv * s_cntl.f.n_el;
	if (n_read_indx(fp, &s_indx, n) < 0) {
	    N_ERP2("your opened file, read INDX failed.\n");
	    n_clear_cntl_mem(&s_cntl);
	    return (-7);
	}
    }
    p_cntl = (fpn == -1) ? &s_cntl : &n_cntl[fpn];
    p_indx = (fpn == -1) ? &s_indx : &n_indx[fpn];
    if ((p = n_indx_p(p_cntl, "your opened file", descriptor, validtime1,
		      validtime2, level1, level2, element, esf)) < 0) {
	rt = -2;
    }
	else if ((esf == N_OFF && (offset = *(p_indx->offset + p)) <=
		  0) || (esf == N_ON
			 && (offset = *(n_esf_irec[fpn] + p)) <= 0)) {
	if (offset == 0)
	    N_ERP1("requested data is not recorded yet.\n");
	else
	    N_ERP1("requested data is not registered.\n");
	if (n_io_cntl & N_IO_WARNING_OUT) {
	    n_timeprint(s1, *validtime1);
	    n_timeprint(s2, *validtime2);
	    errprintf( "member      : %4.4s\n", descriptor);
	    errprintf( "validtime1,2: %s,%s\n", s1, s2);
	    errprintf( "level1,2    : %6.6s,%6.6s\n", level1, level2);
	    errprintf( "element     : %6.6s\n", element);
	}
	rt = (offset == 0) ? 0 : -2;
    } else {
	if (esf == N_OFF)
	    rt = n_get_data(fp, offset, p_cntl, descriptor,
			    validtime1, validtime2,
			    level1, level2, element, data, dtype, dnum);
	else {
	    is_buf = (n_esf_bufsize[fpn] - 1) / 4 + 1;
	    js_buf = n_esf_bufsize[fpn] % 4;
	    bufrec = (n_esf_irec[fpn][p] - 1) / (n_esf_bufsize[fpn]
						 / n_frlen[fpn]) + 1;
	    irec = (n_esf_irec[fpn][p] - 1) - (bufrec - 1) *
		(n_esf_bufsize[fpn] / n_frlen[fpn]);
	    if (bufrec != n_esf_nowbuf[fpn]) {
		N_ESF_READ(&n_esf[fpn], &bufrec, (N_SI4 *) n_ed[fpn],
			   &is_buf, &js_buf, &rt);
		if (rt != 0) {
		    N_ERP2("ESF <%d:%s> read failed.\n",
			   n_esf[fpn], &n_opened_file[fpn][10]);
		    rt *= (-1);
		    return (rt);
		}
		n_esf_nowbuf[fpn] = bufrec;
	    }
	    rt = n_get_esf((N_UI1 *) (n_ed[fpn] + irec * n_frlen[fpn]),
			   p_cntl,
			   descriptor, validtime1, validtime2,
			   level1, level2, element, data, dtype, dnum);
	}
    }
    if (fpn == -1) {
	n_clear_cntl_mem(&s_cntl);
	free(s_indx.offset);
    }

    return (rt);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_read2(const char *utype1, const char *utype2, const char *utype3,
	     N_SI4 * ubasetime, const char *udescriptor,
	     N_SI4 * validtime1, N_SI4 * validtime2, const char *ulevel1,
	     const char *ulevel2, const char *uelement, void *data,
	     const char *dtype, const N_SI4 * dnum)
/* -------------------------------------------------------------------------- */
/*  input:  utype1, utype2, type3, ubasetime, udescriptor, validtime1,        */
/*          validtime2, level1, level2, element                               */
/*                = target parameters                                         */
/*          data  = user data pointer for write the nusdas file               */
/*          dtype = variable type for user data pointer                       */
/*          dnum  = item number of user data array (not byte)                 */
/*  return: ng    = number of set data to (N_UI1 *)data                       */
/* -------------------------------------------------------------------------- */
{
    FILE *fp;
    N_SI4 i, ie, j, rt, defn, fpn, offnum, basetime, esfflag, newop;
    char path[N_LINE_MAX], filename[N_LINE_MAX], flag[3];
    char type1[9], type2[5], type3[5], descriptor[5];
    char level1[7], level2[7], element[7];

    strcpy(n_routine_name[n_routine_d++], "nusdas_read");

    n_copy_type(utype1, utype2, utype3, udescriptor,
		type1, type2, type3, descriptor);
    n_copy_char(ulevel1, ulevel2, uelement, level1, level2, element);

    if ((fpn = n_set_fpn(utype1, utype2, utype3, ubasetime, udescriptor,
			 validtime1, validtime2, 'r', &esfflag,
			 &newop)) < 0) {
	N_ERTN(fpn);
    }

    rt = nusdas_read_direct2(descriptor, validtime1, validtime2, level1,
			     level2,
			     element, data, dtype, dnum, fpn, NULL,
			     esfflag);

    if ((n_io_cntl & N_IO_R_FCLOSE) == N_IO_R_FCLOSE)
	if (esfflag == N_ON)
	    n_check_esfclose(fpn, n_fopen_type[fpn]);
	else if (esfflag == N_OFF)
	    n_check_fileclose(fpn, N_FOPEN_READ);

    n_routine_d--;

    return (rt);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_read(const char *utype1, const char *utype2, const char *utype3,
	    N_SI4 * basetime, const char *descriptor, N_SI4 * validtime1,
	    const char *ulevel1, const char *uelement, void *data,
	    const char *dtype, const N_SI4 * dnum)
/* -------------------------------------------------------------------------- */
{
    N_SI4 validtime2 = 1;
    return (nusdas_read2(utype1, utype2, utype3, basetime, descriptor,
			 validtime1,
			 &validtime2, ulevel1, ulevel1, uelement, data,
			 dtype, dnum));
}


/* -------------------------------------------------------------------------- */
N_SI4 nusdas_iocntl(N_SI4 param, N_SI4 flag)
/* -------------------------------------------------------------------------- */
{
    if (param <= 0 || param > N_IO_MAX || (flag != N_ON && flag != N_OFF))
	return (-1);
    if (flag)
	n_io_cntl |= param;
    else
	n_io_cntl &= ~param;
    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4 nusdas_parameter_change(N_SI4 n_switch, void *param)
/* -------------------------------------------------------------------------- */
/* change a switch for nusdas interface                                       */
/*  input:  n_switch = switch name                                            */
/*          param    = parameter for change switch                            */
/* -------------------------------------------------------------------------- */
{
    N_UI1 uparam;
    N_SI2 sparam;
    N_SI4 rt = 0, iparam;
    float fparam;
    double dparam;

    if (param != NULL) {
	memcpy(&uparam, param, 1);
	memcpy(&sparam, param, 2);
	memcpy(&iparam, param, 4);
	memcpy(&fparam, param, 4);
	memcpy(&dparam, param, 8);
    }
    switch (n_switch) {
    case N_PC_MISSING_UI1:
	n_miss_uc1 = (param == NULL) ? UCHAR_MAX : uparam;
	break;
    case N_PC_MISSING_SI2:
	n_miss_si2 = (param == NULL) ? SHRT_MIN : sparam;
	break;
    case N_PC_MISSING_SI4:
	n_miss_si4 = (param == NULL) ? LONG_MIN : iparam;
	break;
    case N_PC_MISSING_R4:
	n_miss_r4 = (param == NULL) ? FLT_MAX : fparam;
	break;
    case N_PC_MISSING_R8:
	n_miss_r8 = (param == NULL) ? DBL_MAX : dparam;
	break;
    case N_PC_MASK_BIT:
	n_mask_bit = (param == NULL) ? NULL : (N_UI1 *) param;
	break;
    case N_PC_ID_SET:
	n_nrd_num = (param == NULL) ? -1 : iparam;
	break;
    case N_PC_PACKING:
	n_pack_override = (param == NULL) ? N_OFF : iparam;
	break;
    case N_PC_SIZEX:
	n_sizex_override = (param == NULL) ? N_OFF : iparam;
	break;
    case N_PC_SIZEY:
	n_sizey_override = (param == NULL) ? N_OFF : iparam;
	break;
      defaults:
	rt = -1;
	break;
    }

    return (rt);
}


/* -------------------------------------------------------------------------- */
N_SI4 nusdas_allfile_close(N_SI4 param)
/* -------------------------------------------------------------------------- */
/* close all files ( if necessary, write a END record)                        */
/*  input:  param = target file open type                                     */
/*  return:  >=0  = number of closed files                                    */
/*           <0   =  number of close failed files                             */
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, j, k, is_buf, js_buf, irt;
    long rt;
    N_ST_END s_end;

    for (i = 0, j = 0, k = 0; i < N_FOPEN_MAX; i++) {
	if (param != N_FOPEN_ALL && n_fopen_type[i] != param)
	    continue;
	if (n_fp[i] != NULL) {
	    if ((rt = n_set_next_offset(n_fp[i], &s_end, N_ON)) == -1) {
		k--;
		continue;
	    } else if (rt == 1) {
		if (n_mark_end(i) < 0) {
		    k--;
		    continue;
		}
	    }
	    n_check_fileclose(i, n_fopen_type[i]);
	    j++;
	} else if (n_ed[i] != NULL) {
	    is_buf = (n_esf_bufsize[i] - 1) / 4 + 1;
	    js_buf = n_esf_bufsize[i] % 4;
	    N_ESF_WRITE(&n_esf[i], &n_esf_nowbuf[i], (N_SI4 *) n_ed[i],
			&is_buf, &js_buf, &irt);
	    if (irt == 71) {
		N_ERP2( "ESF <%d:%s> flush write for close failed. recnum=%d\n",
		       n_esf[i], &n_opened_file[i][10], n_esf_nowbuf[i]);
		k--;
	    }
	    n_check_esfclose(i, n_fopen_type[i]);
	    j++;
	}
    }

    return ((k != 0) ? k : j);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_close_esfflush(const char *utype1, const char *utype2,
		      const char *utype3, N_SI4 * basetime,
		      const char *udescriptor,
		      N_SI4 * validtime1, N_SI4 * validtime2, char fflag)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, fpn, esfflag, is_buf, js_buf, irt, csize, newop;
    long rt;
    N_ST_END s_end;
    char fname[N_LINE_MAX];

    strcpy(n_routine_name[n_routine_d++], "nusdas_file_close");

    fpn = n_set_fpn(utype1, utype2, utype3, basetime,
		    udescriptor, validtime1, validtime2, 'c', &esfflag,
		    &newop);
    if (fpn == -52) {
	N_ERTN(1);
    } else if (fpn < 0) {
	N_ERTN(fpn);
    }

    if (esfflag == N_OFF) {

	if (fflag == 'f') {
	    N_ERP1("target file <%s> is not ES file!\n",
		   &n_opened_file[fpn][10]);
	    N_ERTN(-78);
	}
	if (n_fopen_type[fpn] == N_FOPEN_WRITE) {
	    if ((rt = n_set_next_offset(n_fp[fpn], &s_end, N_ON)) == -1) {
		N_ERTN(-57);
	    } else if (rt == 1 && (i = n_mark_end(fpn)) < 0) {
		N_ERTN(-64 + i);
	    }
	}
	n_check_fileclose(fpn, n_fopen_type[fpn]);

    } else if (esfflag == N_ON) {

	strcpy(fname, &n_opened_file[fpn][10]);
	if (n_fopen_type[fpn] == N_FOPEN_WRITE) {
	    is_buf = (n_esf_bufsize[fpn] - 1) / 4 + 1;
	    js_buf = n_esf_bufsize[fpn] % 4;
	    N_ESF_WRITE(&n_esf[fpn], &n_esf_nowbuf[fpn],
			(N_SI4 *) n_ed[fpn], &is_buf, &js_buf, &irt);
	    if (irt == 71) {
		N_ERP2( "ESF <%d:%s> flush write failed. recnum=%d\n",
		       n_esf[fpn], &n_opened_file[fpn][10],
		       n_esf_nowbuf[fpn]);
		N_ERTN(-71);
	    }
	}
	if (fflag == 'c')
	    n_check_esfclose(fpn, n_fopen_type[fpn]);

    }

    n_routine_d--;

    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_onefile_close2(const char *utype1, const char *utype2,
		      const char *utype3, N_SI4 * basetime,
		      const char *udescriptor,
		      N_SI4 * validtime1, N_SI4 * validtime2)
/* -------------------------------------------------------------------------- */
/* close a specified file ( if necessary, write a END record)                 */
/* -------------------------------------------------------------------------- */
{
    return (nusdas_close_esfflush
	    (utype1, utype2, utype3, basetime, udescriptor, validtime1,
	     validtime2, 'c'));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_onefile_close(const char *utype1, const char *utype2,
		     const char *utype3, N_SI4 * basetime,
		     const char *descriptor, N_SI4 * validtime1)
/* -------------------------------------------------------------------------- */
{
    N_SI4 vt2 = 1;
    return (nusdas_onefile_close2
	    (utype1, utype2, utype3, basetime, descriptor, validtime1,
	     &vt2));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_esf_flush2(const char *utype1, const char *utype2,
		  const char *utype3, N_SI4 * basetime,
		  const char *udescriptor,
		  N_SI4 * validtime1, N_SI4 * validtime2)
/* -------------------------------------------------------------------------- */
{
    return (nusdas_close_esfflush
	    (utype1, utype2, utype3, basetime, udescriptor, validtime1,
	     validtime2, 'f'));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_esf_flush(const char *utype1, const char *utype2,
		 const char *utype3, N_SI4 * basetime,
		 const char *descriptor, N_SI4 * validtime1)
/* -------------------------------------------------------------------------- */
{
    N_SI4 vt2 = 1;
    return (nusdas_esf_flush2(utype1, utype2, utype3, basetime, descriptor,
			      validtime1, &vt2));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_subc_preset1(const char *utype1, const char *utype2,
		    const char *utype3, char *ugname, N_SI4 * s_lv,
		    float *a, float *b, float *c)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, j, k, s, dsize, defn;
    N_UI1 *uc;
    char type1[9], type2[5], type3[5], descriptor[5], gname[256];
    strcpy(n_routine_name[n_routine_d++], "nusdas_subc_preset1");

    strcpy(gname, ugname);
    n_char_upper(gname);
    if (n_subc_flag == N_OFF) {	/* initialize pointer when first call */
	for (j = 0; j < N_FOPEN_MAX; j++)
	    for (i = 0; i < N_SUBC_MAX; i++)
		n_w_subc[j][i].d = NULL;
	for (j = 0; j < N_FOPEN_MAX; j++)
	    n_n_subc[j] = 0;
	n_subc_flag = N_ON;
    }

    n_copy_type(utype1, utype2, utype3, "    ", type1, type2, type3,
		descriptor);
    if ((defn = n_set_defn(type1, type2, type3)) < 0) {
	N_ERTN(defn);
    }
    if (n_nid[defn] >= 50) {
	N_ERP2("no write permission for NUSDAS%2.2d\n",
	       n_nid[defn]);
	errprintf( "NUSDAS50 - NUSDAS99 is read only!\n");
	N_ERTN(-69);
    }
    for (i = 0; i < n_def[defn].n_subc; i++)
	if (memcmp(gname, n_def[defn].subc, 4) == 0)
	    break;
    if (i == n_def[defn].n_subc) {
	N_ERP2("group <%4.4s> is not defined in def file!", gname);
	N_ERTN(-1);
    }
    for (i = 0; i < n_n_subc[defn]; i++)
	if (memcmp(gname, &n_w_subc[defn][i].gname, 4) == 0)
	    break;
    if (i == n_n_subc[defn]) {
	if (++n_n_subc[defn] > N_SUBC_MAX) {
	    N_ERP2("number of subc group exceed nusdas limit!");
	    N_ERTN(-2);
	}
	i = n_n_subc[defn] - 1;
	memcpy(&n_w_subc[defn][i].gname, gname, 4);
	n_w_subc[defn][i].size = 0;
    }

    dsize = sizeof(N_SI4) + sizeof(float) * (2 * (*s_lv + 1) + 1);
    if ((uc = (N_UI1 *) malloc(dsize)) == NULL) {
	N_ERP2("malloc error!");
	N_ERTN(-10);
    }
    k = 0;
    s = sizeof(N_SI4);
    memcpy(uc, s_lv, s);
    k += s;
    s = sizeof(float) * (*s_lv + 1);
    memcpy((N_UI1 *) (uc + k), a, s);
    k += s;
    s = sizeof(float) * (*s_lv + 1);
    memcpy((N_UI1 *) (uc + k), b, s);
    k += s;
    s = sizeof(float);
    memcpy((N_UI1 *) (uc + k), c, s);

    if (dsize > n_w_subc[defn][i].size) {
	if (n_w_subc[defn][i].d != NULL)
	    free(n_w_subc[defn][i].d);
	if ((n_w_subc[defn][i].d = (N_UI1 *) malloc(dsize)) == NULL) {
	    N_ERP2("malloc error!\n");
	    free(uc);
	    N_ERTN(-10);
	}
    }
    memcpy(n_w_subc[defn][i].d, uc, dsize);
    n_w_subc[defn][i].size = dsize;
    free(uc);

    n_routine_d--;
    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_subc_eta2(const char *utype1, const char *utype2,
		 const char *utype3, N_SI4 * basetime,
		 const char *udescriptor, N_SI4 * validtime1,
		 N_SI4 * validtime2, N_SI4 * s_lv,
		 float *a, float *b, float *c, char *action)
/* -------------------------------------------------------------------------- */
{
    return (n_subc_eta_sigm(utype1, utype2, utype3, basetime, udescriptor,
			    validtime1, validtime2, "ETA ", s_lv, a, b, c,
			    action));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_subc_eta(const char *utype1, const char *utype2, const char *utype3,
		N_SI4 * basetime, const char *udescriptor,
		N_SI4 * validtime1, N_SI4 * s_lv, float *a, float *b,
		float *c, char *action)
/* -------------------------------------------------------------------------- */
{
    N_SI4 validtime2 = 1;
    return (nusdas_subc_eta2(utype1, utype2, utype3, basetime, udescriptor,
			     validtime1, &validtime2, s_lv, a, b, c,
			     action));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_subc_sigm2(const char *utype1, const char *utype2,
		  const char *utype3,
		  N_SI4 * basetime, const char *udescriptor,
		  N_SI4 * validtime1, N_SI4 * validtime2, N_SI4 * s_lv,
		  float *a, float *b, float *c, char *action)
/* -------------------------------------------------------------------------- */
{
    return (n_subc_eta_sigm(utype1, utype2, utype3, basetime, udescriptor,
			    validtime1, validtime2, "SIGM", s_lv, a, b, c,
			    action));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_subc_sigm(const char *utype1, const char *utype2,
		 const char *utype3,
		 N_SI4 * basetime, const char *udescriptor,
		 N_SI4 * validtime1, N_SI4 * s_lv, float *a, float *b,
		 float *c, char *action)
/* -------------------------------------------------------------------------- */
{
    N_SI4 validtime2 = 1;
    return (nusdas_subc_sigm2
	    (utype1, utype2, utype3, basetime, udescriptor, validtime1,
	     &validtime2, s_lv, a, b, c, action));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_subc_tdif2(const char *utype1, const char *utype2,
		  const char *utype3, N_SI4 * basetime,
		  const char *udescriptor, N_SI4 * validtime1,
		  N_SI4 * validtime2, N_SI4 * tdif, N_SI4 * tsum,
		  char *action)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, j, m, s, k, fpn, rt, esfflag, newop;
    N_UI1 *uc;
    char flag;
    strcpy(n_routine_name[n_routine_d++], "nusdas_subc_tdif2");

    flag = (strncmp(action, "PUT", 3) == 0 || strncmp(action, "put",
						      3) == 0) ? 'w'
	: (strncmp(action, "GET", 3) == 0 || strncmp(action, "get", 3)
	   == 0) ? 'r' : 'a';
    if (flag == 'a') {
	N_ERP2("action parameter <%s> is invalid!\n", action);
	N_ERTN(-5);
    }
    fpn = n_set_fpn(utype1, utype2, utype3, basetime,
		    udescriptor, validtime1, validtime2, flag, &esfflag,
		    &newop);
    if (fpn < 0) {
	N_ERTN(fpn);
    }

    if ((i = n_check_register(&n_cntl[fpn], N_CNTL_MEMBER,
			      (char *) udescriptor, NULL)) < 0) {
	N_ERTN(-2);
    }
    if ((j = n_check_register(&n_cntl[fpn], N_CNTL_VALIDTIME,
			      validtime1, validtime2)) < 0) {
	N_ERTN(-2);
    }
    m = j + n_cntl[fpn].f.n_vt * i;

    s = sizeof(N_SI4) * n_cntl[fpn].f.n_dc * n_cntl[fpn].f.n_vt;
    if ((uc = (N_UI1 *) malloc(s * 2)) == NULL) {
	N_ERP2("malloc error!");
	N_ERTN(-10);
    }
    if (strncmp(action, "PUT", 3) == 0 || strncmp(action, "put", 3) == 0) {
	rt = n_read_subc(n_fp[fpn], "TDIF", s * 2, uc, fpn);
	memcpy((N_UI1 *) (uc + m * sizeof(N_SI4)), tdif, sizeof(N_SI4));
	memcpy((N_UI1 *) (uc + m * sizeof(N_SI4) + s), tsum,
	       sizeof(N_SI4));
	rt = n_write_subc(n_fp[fpn], "TDIF", s * 2, uc, fpn);
	if ((n_io_cntl & N_IO_W_FCLOSE) == N_IO_W_FCLOSE)
	    n_check_fileclose(fpn, N_FOPEN_WRITE);
    }
	else if (strncmp(action, "GET", 3) == 0
		 || strncmp(action, "get", 3) == 0) {
	rt = n_read_subc(n_fp[fpn], "TDIF", s * 2, uc, fpn);
	memcpy(tdif, (N_UI1 *) (uc + m * sizeof(N_SI4)), sizeof(N_SI4));
	memcpy(tsum, (N_UI1 *) (uc + m * sizeof(N_SI4) + s),
	       sizeof(N_SI4));
	if ((n_io_cntl & N_IO_R_FCLOSE) == N_IO_R_FCLOSE)
	    if (esfflag == N_ON)
		n_check_esfclose(fpn, n_fopen_type[fpn]);
	    else if (esfflag == N_OFF)
		n_check_fileclose(fpn, N_FOPEN_READ);
    }
    free(uc);

    n_routine_d--;
    return (rt);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_subc_tdif(const char *utype1, const char *utype2,
		 const char *utype3, N_SI4 * basetime,
		 const char *udescriptor, N_SI4 * validtime1,
		 N_SI4 * tdif, N_SI4 * tsum, char *action)
/* -------------------------------------------------------------------------- */
{
    N_SI4 validtime2 = 1;
    return (nusdas_subc_tdif2
	    (utype1, utype2, utype3, basetime, udescriptor, validtime1,
	     &validtime2, tdif, tsum, action));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_subc_srf2(const char *utype1, const char *utype2,
		 const char *utype3, N_SI4 * basetime,
		 const char *udescriptor, N_SI4 * validtime1,
		 N_SI4 * validtime2, const char *ulevel1,
		 const char *ulevel2, const char *uelement,
		 const char *ugname, N_SI4 * rinfo, char *action)
/* -------------------------------------------------------------------------- */
{
    N_SI4 s, fpn, rt, unit, i, j, k, l, m, esfflag, newop;
    N_UI1 *uc;
    char flag, gname[256];
    strcpy(n_routine_name[n_routine_d++], "nusdas_subc_srf2");

    strcpy(gname, ugname);
    n_char_upper(gname);
    unit = (strcmp(gname, "radr") == 0 || strcmp(gname, "RADR") == 0) ?
	1
	: (strcmp(gname, "ispc") == 0 || strcmp(gname, "ISPC") == 0) ?
	128
	: (strcmp(gname, "dprd") == 0 || strcmp(gname, "DPRD") == 0) ?
	8
	: (strcmp(gname, "thun") == 0
	   || strcmp(gname, "THUN") == 0) ? 1 : 0;
    if (unit == 0) {
	N_ERTN(-4);
    }
    flag = (strncmp(action, "PUT", 3) == 0 || strncmp(action, "put",
						      3) == 0) ? 'w'
	: (strncmp(action, "GET", 3) == 0 || strncmp(action, "get", 3)
	   == 0) ? 'r' : 'a';
    if (flag == 'a') {
	N_ERP2("action parameter <%s> is invalid!\n", action);
	N_ERTN(-5);
    }
    fpn = n_set_fpn(utype1, utype2, utype3, basetime,
		    udescriptor, validtime1, validtime2, flag, &esfflag,
		    &newop);
    if (fpn < 0) {
	N_ERTN(fpn);
    }

    if ((i = n_check_register(&n_cntl[fpn], N_CNTL_MEMBER,
			      (char *) udescriptor, NULL)) < 0) {
	N_ERTN(-2);
    }
    if ((j = n_check_register(&n_cntl[fpn], N_CNTL_VALIDTIME,
			      validtime1, validtime2)) < 0) {
	N_ERTN(-2);
    }
    if ((k = n_check_register(&n_cntl[fpn], N_CNTL_PLANE,
			      (char *) ulevel1, (char *) ulevel2)) < 0) {
	N_ERTN(-2);
    }
    if ((l = n_check_register(&n_cntl[fpn], N_CNTL_ELEMENT,
			      (char *) uelement, NULL)) < 0) {
	N_ERTN(-2);
    }

    m =
	l + n_cntl[fpn].f.n_el * (k +
				  n_cntl[fpn].f.n_lv * (j +
							n_cntl[fpn].
							f.n_vt * i));
    s =
	unit * sizeof(N_SI4) * n_cntl[fpn].f.n_dc * n_cntl[fpn].f.n_vt *
	n_cntl[fpn].f.n_lv * n_cntl[fpn].f.n_el;
    if ((uc = (N_UI1 *) malloc(s)) == NULL) {
	N_ERP2("malloc error!");
	N_ERTN(-10);
    }

    if (strncmp(action, "PUT", 3) == 0 || strncmp(action, "put", 3) == 0) {
	rt = n_read_subc(n_fp[fpn], gname, s, uc, fpn);
	memcpy((N_UI1 *) (uc + m * unit * sizeof(N_SI4)), rinfo,
	       unit * sizeof(N_SI4));
	rt = n_write_subc(n_fp[fpn], gname, s, uc, fpn);
	if ((n_io_cntl & N_IO_W_FCLOSE) == N_IO_W_FCLOSE)
	    n_check_fileclose(fpn, N_FOPEN_WRITE);
    }
	else if (strncmp(action, "GET", 3) == 0
		 || strncmp(action, "get", 3) == 0) {
	rt = n_read_subc(n_fp[fpn], gname, s, uc, fpn);
	memcpy(rinfo, (N_UI1 *) (uc + m * unit * sizeof(N_SI4)),
	       unit * sizeof(N_SI4));
	if ((n_io_cntl & N_IO_R_FCLOSE) == N_IO_R_FCLOSE)
	    if (esfflag == N_ON)
		n_check_esfclose(fpn, n_fopen_type[fpn]);
	    else if (esfflag == N_OFF)
		n_check_fileclose(fpn, N_FOPEN_READ);
    }
    free(uc);

    n_routine_d--;
    return (rt);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_subc_srf(const char *utype1, const char *utype2,
		const char *utype3, N_SI4 * basetime,
		const char *udescriptor, N_SI4 * validtime1,
		const char *ulevel1, const char *uelement,
		const char *gname, N_SI4 * rinfo, char *action)
/* -------------------------------------------------------------------------- */
{
    N_SI4 validtime2 = 1;
    return (nusdas_subc_srf2(utype1, utype2, utype3, basetime, udescriptor,
			     validtime1, &validtime2, ulevel1, ulevel1,
			     uelement, gname, rinfo, action));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_info2(const char *utype1, const char *utype2, const char *utype3,
	     N_SI4 * basetime, const char *udescriptor, N_SI4 * validtime1,
	     N_SI4 * validtime2, char *uigname, char *info, N_SI4 * ibyte,
	     const char *action)
/* -------------------------------------------------------------------------- */
/* read or write information record                                           */
/*  input : igname = group name of information                                */
/*  both  : info   = information character pointer                            */
/*  input : ibyte  = allocated size of info                                   */
/*          action = "put" or "get"                                           */
/*  return: >0     = read or write character size (byte)                      */
/*          -1     = file I/O error                                           */
/*          -2     = target file is not correct format                        */
/* -------------------------------------------------------------------------- */
{
    N_ST_INFO s_info;
    N_SI4 i, j, k, fpn, rt, esfflag, is_buf, js_buf, irec, ap, newop;
    long offset;
    N_UI4 sgname;
    char flag, igname[256];
    strcpy(n_routine_name[n_routine_d++], "nusdas_info");

    strcpy(igname, uigname);
    n_char_upper(igname);
    flag = (strncmp(action, "PUT", 3) == 0 || strncmp(action, "put",
						      3) == 0) ? 'w'
	: (strncmp(action, "GET", 3) == 0 || strncmp(action, "get", 3)
	   == 0) ? 'r' : 'a';
    if (flag == 'a') {
	N_ERP2("action parameter <%s> is invalid!\n", action);
	N_ERTN(-5);
    }
    fpn = n_set_fpn(utype1, utype2, utype3, basetime,
		    udescriptor, validtime1, validtime2, flag, &esfflag,
		    &newop);
    if (fpn < 0) {
	N_ERTN(fpn);
    }

    if (strncmp(action, "PUT", 3) == 0 || strncmp(action, "put", 3) == 0) {
	time(&n_systime);
	i = 1;
	while (1) {
	    if (n_search_record(n_fp[fpn], "INFO", i, &s_info.h) != 0) {
		j = 0;
		break;
	    }
	    fread_swab(&sgname, sizeof(N_UI4), 1, n_fp[fpn]);
	    if (memcmp((char *) &sgname, igname, 4) == 0) {
		j = 1;
		break;
	    }
	    i++;
	}
	if (j == 0) {
	    if (newop == N_ON) {
		if ((offset = n_set_next_offset(n_fp[fpn],
						&n_end[fpn], N_OFF)) <= 1) {
		    N_ERP2("target file format is wrong!\n");
		    N_ERTN(-2);
		}
	    } else
		offset = n_next_offset[fpn];
	    if (n_frlen[fpn] > 0) {
		j = n_frlen[fpn] - sizeof(N_SI4) * 5 - sizeof(N_UI4);
		k = (*ibyte > j) ? j : *ibyte;
	    } else
		k = *ibyte;
	    memcpy(&(s_info.h.recname), "INFO", 4);
	    s_info.h.creattime = n_systime;
	    s_info.h.length_s = sizeof(N_ST_RI) + sizeof(N_UI4)
		+ sizeof(N_SI4) + (*ibyte);
	    s_info.h.available = s_info.h.length_s - 2 * sizeof(N_SI4);
	    if (fseek(n_fp[fpn], offset, SEEK_SET) != 0) {
		N_ERTN(-1);
	    }
	    if (fwrite_fmt(&s_info.h, N_ST_RI_FORMAT, n_fp[fpn]) != sizeof(N_ST_RI)) {
		N_ERTN(-1);
	    }
	    fwrite_native(igname, sizeof(N_UI4), 1, n_fp[fpn]);
	    if (fwrite_native(info, 1, k, n_fp[fpn]) != k) {
		N_ERTN(-1);
	    }
	    fwrite_native(&s_info.h.length_s, sizeof(N_SI4), 1, n_fp[fpn]);
	    n_nusd[fpn].rec_num++;
	    n_nusd[fpn].irec_num++;
	    n_nusd[fpn].filesize += s_info.h.length_s;
	    n_next_offset[fpn] = offset + s_info.h.length_s;
	    if (n_io_cntl & N_IO_MARK_END)
		if ((i = n_mark_end(fpn)) < 0) {
		    N_ERTN(-64 + i);
		}
	} else {
	    s_info.h.creattime = n_systime;
	    offset = (long) (sizeof(N_ST_RI) + sizeof(N_UI4)) * (-1);
	    if (fseek(n_fp[fpn], offset, SEEK_CUR) != 0) {
		N_ERTN(-1);
	    }
	    if (fwrite_fmt(&s_info.h, N_ST_RI_FORMAT, n_fp[fpn]) != sizeof(N_ST_RI)) {
		N_ERTN(-1);
	    }
	    j = s_info.h.available - 16;
	    k = (*ibyte > j) ? j : *ibyte;
	    fwrite_native(igname, sizeof(N_UI4), 1, n_fp[fpn]);
	    if (fwrite_native(info, 1, k, n_fp[fpn]) != k) {
		N_ERTN(-1);
	    }
	}
	if ((n_io_cntl & N_IO_W_FCLOSE) == N_IO_W_FCLOSE)
	    n_check_fileclose(fpn, N_FOPEN_WRITE);
	rt = k;
    }
	else if (strncmp(action, "GET", 3) == 0
		 || strncmp(action, "get", 3) == 0) {
	if (n_fp[fpn] != NULL) {	/* disk file case */
	    i = 1;
	    while (1) {
		if (n_search_record(n_fp[fpn], "INFO", i, &s_info.h) != 0) {
		    j = 0;
		    break;
		}
		fread_swab(&sgname, sizeof(N_UI4), 1, n_fp[fpn]);
		if (memcmp((char *) &sgname, igname, 4) == 0) {
		    j = 1;
		    break;
		}
		i++;
	    }
	    if (j == 0) {
		N_ERP2("target information record is not found\n");
		N_ERTN(-1);
	    }
	    j = s_info.h.available - 16;
	    k = (*ibyte - 1 > j) ? j : *ibyte - 1;
	    if (fread_swab(info,1 , k, n_fp[fpn]) != k) {
		N_ERTN(-1);
	    }
	    *(info + *ibyte - 1) = '\0';
	    rt = k + 1;
	    if ((n_io_cntl & N_IO_R_FCLOSE) == N_IO_R_FCLOSE)
		n_check_fileclose(fpn, N_FOPEN_READ);
	} else {		/* ESF case */
	    irec = 1;
	    is_buf = (n_esf_bufsize[fpn] - 1) / 4 + 1;
	    js_buf = n_esf_bufsize[fpn] % 4;
	    if (n_esf_nowbuf[fpn] != 1) {
		N_ESF_READ(&n_esf[fpn], &irec, (N_SI4 *) n_ed[fpn],
			   &is_buf, &js_buf, &rt);
		if (rt != 0) {
		    N_ERP2("ESF <%d:%s> INFO read error!\n",
			   n_esf[fpn], &n_opened_file[fpn][10]);
		    n_check_esfclose(fpn, n_fopen_type[fpn]);
		    N_ERTN(-72);
		}
	    }
	    ap = n_frlen[fpn] * 2;
	    memcpy((void *) &s_info.h, (const void *) (n_ed[fpn]
						       + ap),
		   sizeof(N_ST_RI));
	    memcpy((void *) &sgname,
		   (const void *) (n_ed[fpn] + ap + sizeof(N_ST_RI)), 4);
	    if (memcmp((void *) igname, (void *) &sgname, 4) != 0) {
		n_check_esfclose(fpn, n_fopen_type[fpn]);
		return (-2);
	    }
	    j = s_info.h.available - 16;
	    k = (*ibyte - 1 > j) ? j : *ibyte - 1;
	    memcpy(info, (const void *) (n_ed[fpn] + ap + sizeof(N_ST_RI)
					 + sizeof(N_UI4)), k);
	    *(info + *ibyte - 1) = '\0';
	    rt = k + 1;
	    if ((n_io_cntl & N_IO_R_FCLOSE) == N_IO_R_FCLOSE)
		n_check_esfclose(fpn, N_FOPEN_READ);
	}
    }

    n_routine_d--;
    return (rt);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_info(const char *utype1, const char *utype2, const char *utype3,
	    N_SI4 * basetime, const char *udescriptor, N_SI4 * validtime1,
	    char *igname, char *info, N_SI4 * ibyte, const char *action)
/* -------------------------------------------------------------------------- */
{
    N_SI4 validtime2 = 1;
    return (nusdas_info2(utype1, utype2, utype3, basetime, udescriptor,
			 validtime1, &validtime2, igname, info, ibyte,
			 action));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_grid2(const char *utype1, const char *utype2, const char *utype3,
	     N_SI4 * basetime, const char *udescriptor, N_SI4 * validtime1,
	     N_SI4 * validtime2, char *projection, N_SI4 * g_size,
	     float *g_info, char *g_mean, const char *action)
/* -------------------------------------------------------------------------- */
/*  both :  projection = projection (char*4)                                  */
/*          g_size     = grid size (N_SI4*2)                                  */
/*          g_info     = projection information (float*14)                    */
/*          g_mean     = mean of grid value (char*4)                          */
/*  input:  action     = "put" or "get"                                       */
/* -------------------------------------------------------------------------- */
{
    N_ST_RI s_ri;
    N_ST_END s_end;
    N_SI4 i, j, k, fpn, rt, esfflag, is_buf, js_buf, irt, irec, newop;
    long offset;
    char flag;
    strcpy(n_routine_name[n_routine_d++], "nusdas_grid");

    flag = (strncmp(action, "PUT", 3) == 0 || strncmp(action, "put",
						      3) == 0) ? 'w'
	: (strncmp(action, "GET", 3) == 0 || strncmp(action, "get", 3)
	   == 0) ? 'r' : 'a';
    if (flag == 'a') {
	N_ERP2("action parameter <%s> is invalid!\n", action);
	N_ERTN(-5);
    }
    fpn = n_set_fpn(utype1, utype2, utype3, basetime,
		    udescriptor, validtime1, validtime2, flag, &esfflag,
		    &newop);
    if (fpn < 0) {
	N_ERTN(fpn);
    }

    if (n_fp[fpn] != NULL) {	/* disk file case */
	if (n_search_record(n_fp[fpn], "CNTL", 1, &s_ri) != 0) {
	    N_ERP2("CNTL record is not found\n");
	    N_ERTN(-2);
	}
	offset = 16 + 12 + 4 * 6;
	if (fseek(n_fp[fpn], offset, SEEK_CUR) != 0) {
	    N_ERTN(-1);
	}
	if (strncmp(action, "PUT", 3) == 0
	    || strncmp(action, "put", 3) == 0) {
	    fwrite_native(projection, sizeof(char), 4, n_fp[fpn]);
	    fwrite_native(g_size, sizeof(N_SI4), 2, n_fp[fpn]);
	    fwrite_native(g_info, sizeof(float), 14, n_fp[fpn]);
	    fwrite_native(g_mean, sizeof(char), 4, n_fp[fpn]);
	    fflush(n_fp[fpn]);
	    if ((n_io_cntl & N_IO_W_FCLOSE) == N_IO_W_FCLOSE)
		n_check_fileclose(fpn, N_FOPEN_WRITE);
	}
	    else if (strncmp(action, "GET", 3) == 0 || strncmp(action,
							       "get",
							       3) == 0) {
	    fread_swab(projection, sizeof(char), 4, n_fp[fpn]);
	    fread_swab(g_size, sizeof(N_SI4), 2, n_fp[fpn]);
	    fread_swab(g_info, sizeof(float), 14, n_fp[fpn]);
	    fread_swab(g_mean, sizeof(char), 4, n_fp[fpn]);
	    if ((n_io_cntl & N_IO_R_FCLOSE) == N_IO_R_FCLOSE)
		n_check_fileclose(fpn, N_FOPEN_READ);
	}
    } else {			/* ESF case */
	if (n_fopen_type[fpn] == N_FOPEN_WRITE) {
	    is_buf = (n_esf_bufsize[fpn] - 1) / 4 + 1;
	    js_buf = n_esf_bufsize[fpn] % 4;
	    N_ESF_WRITE(&n_esf[fpn], &n_esf_nowbuf[fpn],
			(N_SI4 *) n_ed[fpn], &is_buf, &js_buf, &irt);
	    if (irt == 71) {
		N_ERP2( "ESF <%d:%s> flush write failed. recnum=%d\n",
		       n_esf[fpn], &n_opened_file[fpn][10],
		       n_esf_nowbuf[fpn]);
		N_ERTN(-71);
	    }
	}
	irec = 1;
	is_buf = (n_esf_bufsize[fpn] - 1) / 4 + 1;
	js_buf = n_esf_bufsize[fpn] % 4;
	if (n_esf_nowbuf[fpn] != 1) {
	    N_ESF_READ(&n_esf[fpn], &irec, (N_SI4 *) n_ed[fpn],
		       &is_buf, &js_buf, &rt);
	    if (rt != 0) {
		N_ERP2("ESF <%d:%s> CNTL read error!\n",
		       n_esf[fpn], &n_opened_file[fpn][10]);
		n_check_esfclose(fpn, n_fopen_type[fpn]);
		N_ERTN(-72);
	    }
	    n_esf_nowbuf[fpn] = 1;
	}
	offset = 16 + 16 + 12 + 4 * 6;
	if (strncmp(action, "PUT", 3) == 0
	    || strncmp(action, "put", 3) == 0) {
	    memcpy((N_UI1 *) (n_ed[fpn] + offset), projection, 4);
	    memcpy((N_UI1 *) (n_ed[fpn] + offset + 4), g_size, 4 * 2);
	    memcpy((N_UI1 *) (n_ed[fpn] + offset + 12), g_info, 4 * 14);
	    memcpy((N_UI1 *) (n_ed[fpn] + offset + 68), g_mean, 4);
	    N_ESF_WRITE(&n_esf[fpn], &irec, (N_SI4 *) n_ed[fpn],
			&is_buf, &js_buf, &rt);
	    if ((n_io_cntl & N_IO_W_FCLOSE) == N_IO_W_FCLOSE)
		n_check_esfclose(fpn, N_FOPEN_WRITE);
	    if (rt != 0) {
		N_ERP2("ESF <%d:%s> CNTL write error!\n",
		       n_esf[fpn], &n_opened_file[fpn][10]);
		N_ERTN(-71);
	    }
	}
	    else if (strncmp(action, "GET", 3) == 0 || strncmp(action,
							       "get",
							       3) == 0) {
	    memcpy(projection, (N_UI1 *) (n_ed[fpn] + offset), 4);
	    memcpy(g_size, (N_UI1 *) (n_ed[fpn] + offset + 4), 4 * 2);
	    memcpy(g_info, (N_UI1 *) (n_ed[fpn] + offset + 12), 4 * 14);
	    memcpy(g_mean, (N_UI1 *) (n_ed[fpn] + offset + 68), 4);
	    if ((n_io_cntl & N_IO_R_FCLOSE) == N_IO_R_FCLOSE)
		if (esfflag == N_ON)
		    n_check_esfclose(fpn, n_fopen_type[fpn]);
		else if (esfflag == N_OFF)
		    n_check_fileclose(fpn, N_FOPEN_READ);
	}
    }

    n_routine_d--;
    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_grid(const char *utype1, const char *utype2, const char *utype3,
	    N_SI4 * basetime, const char *udescriptor, N_SI4 * validtime1,
	    char *projection, N_SI4 * g_size,
	    float *g_info, char *g_mean, const char *action)
/* -------------------------------------------------------------------------- */
{
    N_SI4 validtime2 = 1;
    return (nusdas_grid2(utype1, utype2, utype3, basetime, udescriptor,
			 validtime1,
			 &validtime2, projection, g_size, g_info, g_mean,
			 action));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_make_mask(N_UI1 * d, const char *dtype,
		 N_SI4 * ds, N_UI1 * m, N_SI4 * ms)
/* -------------------------------------------------------------------------- */
{
    float *d_f;
    double *d_d;
    N_SI4 *d_i, i, j, je, k;
    N_SI2 *d_s;
    N_UI1 n2[8];
    strcpy(n_routine_name[n_routine_d++], "nusdas_make_mask");

    for (i = 0; i < 8; i++)
	n2[i] = (N_UI1) n_ipow(2, 7 - i);

    if ((*ds % 8 == 0 && *ms < *ds / 8)
	|| (*ds % 8 != 0 && *ms <= *ds / 8)) {
	N_ERP2("size of array for mask-bit <%d> is insufficient\n",
	       *ms);
	N_ERTN(-1);
    }
    if (strncmp(dtype, N_R4, 2) == 0) {
	d_f = (float *) d;
	for (i = 0; i < *ds; i += 8) {
	    *(m + i / 8) = 0;
	    je = (i > *ds - 8) ? *ds - i : 8;
	    for (j = 0; j < je; j++)
		if (*(d_f + (i / 8) * 8 + j) != n_miss_r4)
		    *(m + i / 8) |= n2[j];
	}
    } else if (strncmp(dtype, N_R8, 2) == 0) {
	d_d = (double *) d;
	for (i = 0; i < *ds; i += 8) {
	    *(m + i / 8) = 0;
	    je = (i > *ds - 8) ? *ds - i : 8;
	    for (j = 0; j < je; j++)
		if (*(d_d + (i / 8) * 8 + j) != n_miss_r8)
		    *(m + i / 8) |= n2[j];
	}
    } else if (strncmp(dtype, N_I4, 2) == 0) {
	d_i = (N_SI4 *) d;
	for (i = 0; i < *ds; i += 8) {
	    *(m + i / 8) = 0;
	    je = (i > *ds - 8) ? *ds - i : 8;
	    for (j = 0; j < je; j++)
		if (*(d_i + (i / 8) * 8 + j) != n_miss_si4)
		    *(m + i / 8) |= n2[j];
	}
    } else if (strncmp(dtype, N_I2, 2) == 0) {
	d_s = (N_SI2 *) d;
	for (i = 0; i < *ds; i += 8) {
	    *(m + i / 8) = 0;
	    je = (i > *ds - 8) ? *ds - i : 8;
	    for (j = 0; j < je; j++)
		if (*(d_s + (i / 8) * 8 + j) != n_miss_si2)
		    *(m + i / 8) |= n2[j];
	}
    } else if (strncmp(dtype, N_I1, 2) == 0) {
	for (i = 0; i < *ds; i += 8) {
	    *(m + i / 8) = 0;
	    je = (i > *ds - 8) ? *ds - i : 8;
	    for (j = 0; j < je; j++)
		if (*(d + (i / 8) * 8 + j) != n_miss_uc1)
		    *(m + i / 8) |= n2[j];
	}
    }

    n_routine_d--;
    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_get_size2(const char *utype1, const char *utype2,
		 const char *utype3, N_SI4 * basetime,
		 const char *udescriptor, N_SI4 * validtime1,
		 N_SI4 * validtime2, N_SI4 * n_size)
/* -------------------------------------------------------------------------- */
{
    N_SI4 fpn, esfflag, newop;
    long offset;
    N_ST_RI s_ri;
    strcpy(n_routine_name[n_routine_d++], "nusdas_grid");

    fpn = n_set_fpn(utype1, utype2, utype3, basetime,
		    udescriptor, validtime1, validtime2, 'r', &esfflag,
		    &newop);
    if (fpn < 0) {
	N_ERTN(fpn);
    }

    if (n_search_record(n_fp[fpn], "CNTL", 1, &s_ri) != 0) {
	N_ERP2("CNTL record is not found\n");
	N_ERTN(-2);
    }
    offset = 16 + 12 + 4 * 2;
    if (fseek(n_fp[fpn], offset, SEEK_CUR) != 0) {
	N_ERTN(-1);
    }
    fread_swab(n_size, sizeof(N_SI4), 4, n_fp[fpn]);
    if ((n_io_cntl & N_IO_R_FCLOSE) == N_IO_R_FCLOSE)
	if (esfflag == N_ON)
	    n_check_esfclose(fpn, n_fopen_type[fpn]);
	else if (esfflag == N_OFF)
	    n_check_fileclose(fpn, N_FOPEN_READ);

    n_routine_d--;
    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_get_size(const char *utype1, const char *utype2,
		const char *utype3, N_SI4 * basetime,
		const char *udescriptor, N_SI4 * validtime1,
		N_SI4 * n_size)
/* -------------------------------------------------------------------------- */
{
    N_SI4 validtime2 = 1;
    return (nusdas_get_size2(utype1, utype2, utype3, basetime, udescriptor,
			     validtime1, &validtime2, n_size));
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_inq_def(const char *utype1, const char *utype2,
	       const char *utype3, N_SI4 param, void *data, N_SI4 * dnum)
/* -------------------------------------------------------------------------- */
/*  input  :  param = parameter for inquire data kind                         */
/*  output :  data  = pointer for set data                                    */
/*  input  :  dnum  = item number of data ( not byte )                        */
/*  return :  > 0   = set item number                                         */
/*            < 0   = allocate data area is too small for set data            */
/* -------------------------------------------------------------------------- */
{
    char type1[9], type2[5], type3[5], descriptor[5], *d_c;
    N_SI4 i, j, *d_4, defn;
    float *d_f;
    strcpy(n_routine_name[n_routine_d++], "nusdas_inq_def");

    n_copy_type(utype1, utype2, utype3, "    ", type1, type2, type3,
		descriptor);
    if ((defn = n_set_defn(type1, type2, type3)) < 0) {
	N_ERTN(defn);
    }
    if (data == NULL) {
	N_ERTN(-2);
    }

    d_4 = (N_SI4 *) data;
    d_c = (char *) data;
    d_f = (float *) data;
    switch (param) {
    case N_MEMBER_NUM:
	j = 1;
	if (*dnum < j) {
	    N_ERTN(-1);
	}
	*d_4 = n_def[defn].n_dc;
	break;
    case N_MEMBER_LIST:
	if ((j = n_def[defn].n_dc) > *dnum) {
	    N_ERTN(-1);
	}
	for (i = 0; i < j; i++)
	    memcpy((char *) (d_c + 4 * i), (N_UI4 *) (n_def[defn].dc + i),
		   4);
	break;
    case N_VALIDTIME_NUM:
	j = 1;
	if (*dnum < j) {
	    N_ERTN(-1);
	}
	*d_4 = n_def[defn].n_vt;
	break;
    case N_VALIDTIME_LIST:
	if ((j = n_def[defn].n_vt) > *dnum) {
	    N_ERTN(-1);
	}
	for (i = 0; i < j; i++)
	    *(d_4 + i) = *(n_def[defn].vt1 + i);
	break;
    case N_PLANE_NUM:
	j = 1;
	if (*dnum < j) {
	    N_ERTN(-1);
	}
	*d_4 = n_def[defn].n_lv;
	break;
    case N_PLANE_LIST:
	if ((j = n_def[defn].n_lv) > *dnum) {
	    N_ERTN(-1);
	}
	for (i = 0; i < j; i++)
	    memcpy((char *) (d_c + 6 * i), (N_UI8 *) (n_def[defn].lv1 + i),
		   6);
	break;
    case N_ELEMENT_NUM:
	j = 1;
	if (*dnum < j) {
	    N_ERTN(-1);
	}
	*d_4 = n_def[defn].n_el;
	break;
    case N_ELEMENT_LIST:
	if ((j = n_def[defn].n_el) > *dnum) {
	    N_ERTN(-1);
	}
	for (i = 0; i < j; i++)
	    memcpy((char *) (d_c + 6 * i), (N_UI8 *) (n_def[defn].el + i),
		   6);
	break;
    case N_ELEMENT_MAP:
	j = n_def[defn].n_dc * n_def[defn].n_vt
	    * n_def[defn].n_lv * n_def[defn].n_el;
	if (*dnum < j) {
	    N_ERTN(-1);
	}
	memcpy((char *) d_c, (N_UI1 *) (n_def[defn].elmap), j);
	break;
    case N_GRID_SIZE:
	memcpy(d_4, &(n_def[defn].xs), sizeof(N_SI4));
	memcpy((N_SI4 *) (d_4 + 1), &(n_def[defn].ys), sizeof(N_SI4));
	j = 2;
	break;
    case N_GRID_DISTANCE:
	memcpy(d_f, &(n_def[defn].xd), sizeof(float));
	memcpy((float *) (d_f + 1), &(n_def[defn].yd), sizeof(float));
	j = 2;
	break;
    case N_GRID_BASEPOINT:
	memcpy(d_f, &(n_def[defn].x0), sizeof(float));
	memcpy((float *) (d_f + 1), &(n_def[defn].y0), sizeof(float));
	memcpy((float *) (d_f + 2), &(n_def[defn].lat_0), sizeof(float));
	memcpy((float *) (d_f + 3), &(n_def[defn].lon_0), sizeof(float));
	j = 4;
	break;
    case N_VALIDTIME_UNIT:
	memcpy(d_c, &(n_def[defn].time_unit), 4);
	j = 1;
	break;
      defaults:
	j = -3;
	break;
    }
    n_routine_d--;
    return (j);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_inq_cntl2(const char *utype1, const char *utype2,
		 const char *utype3, N_SI4 * basetime,
		 const char *udescriptor, N_SI4 * validtime1,
		 N_SI4 * validtime2, N_SI4 param, void *data, N_SI4 * dnum)
/* -------------------------------------------------------------------------- */
/*  input  :  param = parameter for inquire data kind                         */
/*  output :  data  = pointer for set data                                    */
/*  input  :  dnum  = item number of data ( not byte )                        */
/* -------------------------------------------------------------------------- */
{
    N_SI4 fpn;
    long offset;
    N_SI4 i, j, *d_4, esfflag, newop;
    N_ST_RI s_ri;
    char *d_c;
    strcpy(n_routine_name[n_routine_d++], "nusdas_inq_cntl");

    fpn = n_set_fpn(utype1, utype2, utype3, basetime,
		    udescriptor, validtime1, validtime2, 'r', &esfflag,
		    &newop);
    if (fpn < 0) {
	N_ERTN(fpn);
    }

    if (data == NULL) {
	N_ERTN(-2);
    }

    d_4 = (N_SI4 *) data;
    d_c = (char *) data;
    switch (param) {
    case N_MEMBER_NUM:
	j = 1;
	if (*dnum < j) {
	    N_ERTN(-1);
	}
	*d_4 = n_cntl[fpn].f.n_dc;
	break;
    case N_MEMBER_LIST:
	if ((j = n_cntl[fpn].f.n_dc) > *dnum) {
	    N_ERTN(-1);
	}
	for (i = 0; i < j; i++)
	    memcpy((char *) (d_c + 4 * i), (N_UI4 *) (n_cntl[fpn].dc + i),
		   4);
	break;
    case N_VALIDTIME_NUM:
	j = 1;
	if (*dnum < j) {
	    N_ERTN(-1);
	}
	*d_4 = n_cntl[fpn].f.n_vt;
	break;
    case N_VALIDTIME_LIST:
	if ((j = n_cntl[fpn].f.n_vt) > *dnum) {
	    N_ERTN(-1);
	}
	for (i = 0; i < j; i++)
	    *(d_4 + i) = *(n_cntl[fpn].vt1 + i);
	break;
    case N_VALIDTIME2_LIST:
	if ((j = n_cntl[fpn].f.n_vt) > *dnum) {
	    N_ERTN(-1);
	}
	for (i = 0; i < j; i++)
	    *(d_4 + i) = *(n_cntl[fpn].vt2 + i);
	break;
    case N_PLANE_NUM:
	j = 1;
	if (*dnum < j) {
	    N_ERTN(-1);
	}
	*d_4 = n_cntl[fpn].f.n_lv;
	break;
    case N_PLANE_LIST:
	if ((j = n_cntl[fpn].f.n_lv) > *dnum) {
	    N_ERTN(-1);
	}
	for (i = 0; i < j; i++)
	    memcpy((char *) (d_c + 6 * i), (N_UI8 *) (n_cntl[fpn].lv1 + i),
		   6);
	break;
    case N_PLANE2_LIST:
	if ((j = n_cntl[fpn].f.n_lv) > *dnum) {
	    N_ERTN(-1);
	}
	for (i = 0; i < j; i++)
	    memcpy((char *) (d_c + 6 * i), (N_UI8 *) (n_cntl[fpn].lv2 + i),
		   6);
	break;
    case N_ELEMENT_NUM:
	j = 1;
	if (*dnum < j) {
	    N_ERTN(-1);
	}
	*d_4 = n_cntl[fpn].f.n_el;
	break;
    case N_ELEMENT_LIST:
	if ((j = n_cntl[fpn].f.n_el) > *dnum) {
	    N_ERTN(-1);
	}
	for (i = 0; i < j; i++)
	    memcpy((char *) (d_c + 6 * i), (N_UI8 *) (n_cntl[fpn].el + i),
		   6);
	break;
      defaults:
	j = -3;
	break;
    }
    n_routine_d--;
    return (j);
}


/* -------------------------------------------------------------------------- */
N_SI4
nusdas_inq_cntl(const char *utype1, const char *utype2,
		const char *utype3, N_SI4 * basetime,
		const char *udescriptor, N_SI4 * validtime1,
		N_SI4 param, void *data, N_SI4 * dnum)
/* -------------------------------------------------------------------------- */
{
    N_SI4 validtime2 = 1;
    return (nusdas_inq_cntl2(utype1, utype2, utype3, basetime, udescriptor,
			     validtime1, &validtime2, param, data, dnum));
}

/* fortran90 interface moved to wrap*.c */
