#define N_DEF_NUSSUB_SOURCE
#include "nusdas_sys.h"
#include "nusdas_com.h"

extern char n_opened_file[][N_LINE_MAX * 2];
extern char n_def_type1[][8], n_def_type2[][4], n_def_type3[][4];
extern FILE *n_fp[];
extern long n_next_offset[];
extern N_UI1 *n_ed[];
extern N_SI4 n_nrd_num, n_esf_xx;
extern N_SI4 n_fopen_type[], *n_esf_irec[], n_esf[];
extern N_SI4 n_esf_bufsize[], n_esf_nowbuf[];
extern N_SI4 n_nid[], n_frlen[], n_subc_flag, n_n_subc[];
extern N_UI4 n_pack[], n_miss[], n_pack_override;
extern N_ST_NUSD n_nusd[];
extern N_ST_CNTL n_cntl[];
extern N_ST_INDX n_indx[];
extern N_ST_END n_end[];
extern N_ST_SUBC n_w_subc[][N_SUBC_MAX];

/* -------------------------------------------------------------------------- */
N_SI4 n_set_esfirec(N_SI4 ** s_esf_irec, N_ST_DEF * s_def)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, j, k, l, m, n, recnum;
    l = s_def->n_dc * s_def->n_vt * s_def->n_lv * s_def->n_el;
    if ((*s_esf_irec = (N_SI4 *) malloc(sizeof(N_SI4) * l)) == NULL) {
	N_ERP2("malloc for esf_rec failed. size=%d\n", l
	       * sizeof(N_SI4));
	return (-1);
    }
    for (l = 0, recnum = 3; l < s_def->n_dc; l++)
	for (k = 0; k < s_def->n_vt; k++)
	    for (j = 0; j < s_def->n_el; j++)
		for (i = 0; i < s_def->n_lv; i++) {
		    m =
			i + s_def->n_lv * (j +
					   s_def->n_el * (k +
							  s_def->n_vt *
							  l));
		    n =
			j + s_def->n_el * (i +
					   s_def->n_lv * (k +
							  s_def->n_vt *
							  l));
		    *(*s_esf_irec + m) =
			(*(s_def->elmap + n) == 1) ? ++recnum : 0;
		}
    return (recnum);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_set_bufsize(N_SI4 n_frlen, N_SI4 recnum, N_SI4 * maxrec)
/* -------------------------------------------------------------------------- */
/* return buffer size and set maxrec                                          */
/* -------------------------------------------------------------------------- */
{
    N_SI4 bufsize;
    long ll_bufsize, m;
    m = (long) recnum *n_frlen;	/* bufsize = filesize/10 */
    ll_bufsize = ((long) (recnum / 10)) * n_frlen;
    if (ll_bufsize < N_ESBUFFER_SIZE / 10)	/*         >= 10mb       */
	bufsize = (N_SI4) ((N_ESBUFFER_SIZE / 10 / n_frlen)) * n_frlen;
    else if (ll_bufsize > N_ESBUFFER_SIZE)	/*         <= 100mb      */
	bufsize = (N_SI4) (N_ESBUFFER_SIZE / n_frlen) * n_frlen;
    else
	bufsize = (N_SI4) ll_bufsize;
    *maxrec = (N_SI4) (m / bufsize + 1);
    return (bufsize);
}


/* -------------------------------------------------------------------------- */
N_SI4
n_check_register(N_ST_CNTL * s_cntl, N_SI4 kind,
		 void *uparam1, void *uparam2)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i;
    char s1[256], s2[256];

    switch (kind) {
    case N_CNTL_MEMBER:
	for (i = 0; i < s_cntl->f.n_dc; i++) {
	    if (memcmp((char *) (s_cntl->dc + i), uparam1, 4) == 0)
		break;
	}
	if (i == s_cntl->f.n_dc) {
	    N_ERP1("specified member <%4.4s> is not registered\n",
		   (char *) uparam1);
	    if (n_io_cntl & N_IO_WARNING_OUT) {
		for (i = 0; i < s_cntl->f.n_dc; i++) {
		    errprintf( "registered No.%2.2d : %4.4s\n",
			    i, (char *) (s_cntl->dc + i));
		}
	    }
	    return (-2);
	}
	break;
    case N_CNTL_VALIDTIME:
	for (i = 0; i < s_cntl->f.n_vt; i++)
	    if (memcmp((char *) (s_cntl->vt1 + i), uparam1, 4)
		== 0
		&& memcmp((char *) (s_cntl->vt2 + i), uparam2,
			  4) == 0) break;
	if (i == s_cntl->f.n_vt) {
	    n_timeprint(s1, *((N_SI4 *) uparam1));
	    n_timeprint(s2, *((N_SI4 *) uparam2));
	    N_ERP1( "specified validtime <%s,%s> is not registered\n", s1,
		   s2);
	    if (n_io_cntl & N_IO_WARNING_OUT) {
		for (i = 0; i < s_cntl->f.n_vt; i++) {
		    n_timeprint(s1, (N_SI4) * (s_cntl->vt1 + i));
		    n_timeprint(s2, (N_SI4) * (s_cntl->vt2 + i));
		    errprintf( "registered No.%2.2d : %s,%s\n",
			    i, s1, s2);
		}
	    }
	    return (-2);
	}
	break;
    case N_CNTL_PLANE:
	for (i = 0; i < s_cntl->f.n_lv; i++)
	    if (memcmp((char *) (s_cntl->lv1 + i), uparam1, 6)
		== 0
		&& memcmp((char *) (s_cntl->lv2 + i), uparam2,
			  6) == 0) break;
	if (i == s_cntl->f.n_lv) {
	    N_ERP1( "specified plane <%6.6s,%6.6s> is not registered\n",
		   (char *) uparam1, (char *) uparam2);
	    if (n_io_cntl & N_IO_WARNING_OUT) {
		for (i = 0; i < s_cntl->f.n_lv; i++)
		    errprintf( "registered No.%2.2d : %6.6s,%6.6s\n",
			    i, (char
				*) (s_cntl->lv1 + i), (char *) (s_cntl->lv2
								+ i));
	    }
	    return (-2);
	}
	break;
    case N_CNTL_ELEMENT:
	for (i = 0; i < s_cntl->f.n_el; i++)
	    if (memcmp((char *) (s_cntl->el + i), uparam1, 6) == 0)
		break;
	if (i == s_cntl->f.n_el) {
	    N_ERP1("specified element <%6.6s> is not registered\n",
		   (char *) uparam1);
	    if (n_io_cntl & N_IO_WARNING_OUT) {
		for (i = 0; i < s_cntl->f.n_el; i++)
		    errprintf( "registered No.%2.2d : %6.6s\n",
			    i, (char *) (s_cntl->el + i));
	    }
	    return (-2);
	}
	break;
      defaults:
	return (-2);
    }
    return (i);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_rcal_bt_vt(N_SI4 * validtime1, N_SI4 defn, N_SI4 k)
/* -------------------------------------------------------------------------- */
{
    N_SI4 basetime, i;
    char *c;

    for (i = 0; i < n_tunit_num; i++)
	if (memcmp(&n_def[defn].time_unit, n_tunit_string[i], 4) == 0)
	    break;
    if (i == N_TU_HOUR || N_TU_MIN || i == N_TU_DAY || i == N_TU_WEEK ||
	i == n_tunit_num)
	basetime = *validtime1 - n_tunit_min[i] * (*(n_def[defn].vt1 + k));
    else {
	c = (char *) &n_def[defn].time_unit;
	N_ERP2("Now %4s is not supported for no basetime read!\n",
	       c);
    }
    return (basetime);
}


/* -------------------------------------------------------------------------- */
void n_check_esfclose(N_SI4 fpn, N_SI4 type)
/* -------------------------------------------------------------------------- *//* close file and clear memories                                              *//*  input:  fpn  = opened file number                                         *//*          type = target file open type                                      *//* -------------------------------------------------------------------------- */
{
    N_SI4 irt;

    if (n_fopen_type[fpn] == type) {
	N_ESF_CLOSE(&n_esf[fpn], &irt);
	free(n_ed[fpn]);
	n_ed[fpn] = NULL;
	free(n_esf_irec[fpn]);
	n_clear_cntl_mem(&n_cntl[fpn]);
	if (n_indx[fpn].offset != NULL) {
	    free(n_indx[fpn].offset);
	    n_indx[fpn].offset = NULL;
	}
	strcpy(n_opened_file[fpn], "");
	n_fopen_type[fpn] = N_FOPEN_NOT;
    }
}


/* -------------------------------------------------------------------------- */
void n_check_fileclose(N_SI4 fpn, N_SI4 type)
/* -------------------------------------------------------------------------- *//* close file and clear memories                                              *//*  input:  fpn  = opened file number                                         *//*          type = target file open type                                      *//* -------------------------------------------------------------------------- */
{
    if (n_fopen_type[fpn] == type) {
	fclose(n_fp[fpn]);
	n_fp[fpn] = NULL;
	n_clear_cntl_mem(&n_cntl[fpn]);
	if (n_indx[fpn].offset != NULL) {
	    free(n_indx[fpn].offset);
	    n_indx[fpn].offset = NULL;
	}
	strcpy(n_opened_file[fpn], "");
	n_fopen_type[fpn] = N_FOPEN_NOT;
    }
}


/* -------------------------------------------------------------------------- */
N_SI4 n_check_fileopen(const char *path, const char *filename, N_SI4 * fpn)
/* -------------------------------------------------------------------------- */
/* search and return file number for input path/filename                      */
/*  input:  path     = target path                                            */
/*          filename = target filename                                        */
/*  output:      fpn = file number                                            */
/*  return:       0  = already opened                                         */
/*                1  = new open                                               */
/*               -1  = error! exceed the limit of opened file                 */
/* -------------------------------------------------------------------------- */
{
    char s[N_LINE_MAX];
    N_SI4 i, j, k;

    sprintf(s, "%s/%s", path, filename);
    for (i = 0, k = -1; i < N_FOPEN_MAX; i++) {
	if (strcmp(s, n_opened_file[i]) == 0)
	    break;
	if (strlen(n_opened_file[i]) == 0 && k == -1)
	    k = i;
    }
    if (i != N_FOPEN_MAX) {
	*fpn = i;
	return (0);
    } else if (k == -1) {
	N_ERP2("data file open exceed the limit\n");
	return (-1);
    } else {
	strcpy(n_opened_file[k], s);
	*fpn = k;
	return (1);
    }
}


/* -------------------------------------------------------------------------- */
N_SI4
n_check_defopen(const char *type1, const char *type2, char *type3,
		N_SI4 * defn)
/* -------------------------------------------------------------------------- */
/* search and return define file number for input type1/type2/type3           */
/*  input:  type1  = target type1                                             */
/*          type2  = target type2                                             */
/*          type3  = target type3                                             */
/*  output:  defn  = define file number                                       */
/*  return:     0  = already opened                                           */
/*              1  = new open                                                 */
/*             -1  = error! exceed the limit of opened file                   */
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, j, k, l, m;

    for (i = 0, k = -1; i < N_DEF_MAX; i++) {
	for (j = 0; j < 8; j++)
	    if (*(type1 + j) != n_def_type1[i][j])
		break;
	for (l = 0; l < 4; l++)
	    if (*(type2 + l) != n_def_type2[i][l])
		break;
	for (m = 0; m < 4; m++)
	    if (*(type3 + m) != n_def_type3[i][m])
		break;
	if (l == 4 && j == 8 && m == 4) {
	    if (n_nrd_num == -1)
		break;
	    else if (n_nid[i] == n_nrd_num)
		break;
	}
	if (strlen(n_def_type1[i]) == 0 && k == -1)
	    k = i;
    }
    if (i != N_DEF_MAX) {
	*defn = i;
	return (0);
    } else if (k == -1) {
	N_ERP2("define file open exceed the limit\n");
	return (-1);
    } else {
	memcpy(n_def_type1[k], type1, 8);
	memcpy(n_def_type2[k], type2, 4);
	memcpy(n_def_type3[k], type3, 4);
	*defn = k;
	return (1);
    }
}


/* -------------------------------------------------------------------------- */
N_SI4
n_search_record(FILE * fp, const char *recname, N_SI4 n, N_ST_RI * ri)
/* -------------------------------------------------------------------------- */
/* search the record and read the header of record                            */
/*  input:  fp       = file pointer                                           */
/*          recname  = target record name                                     */
/*          n        = sequential number of recname RECORD                    */
/*  output: ri       = record header structure                                */
/*  return: -1       = target record name is not found in this file           */
/* -------------------------------------------------------------------------- */
{
    N_SI4 i_recname, k = 0;
    long offset;

    memcpy(&i_recname, recname, 4);
    rewind(fp);
    while (1) {
	if (fread_fmt(ri, N_ST_RI_FORMAT, fp) != sizeof(N_ST_RI))
	    break;
	if (i_recname == ri->recname)
	    if (++k == n)
		break;
	offset = ri->length_s - sizeof(N_ST_RI);
	if (fseek(fp, offset, SEEK_CUR) != 0)
	    break;
    }
    if (k != n) {
	N_ERP1("<%4.4s No.%-d> record is not recorded.\n", recname,
	       n);
	return (-1);
    }

    return (0);
}


/* -------------------------------------------------------------------------- */
long n_set_next_offset(FILE * fp, N_ST_END * s_end, N_SI4 cflag)
/* -------------------------------------------------------------------------- *//* return the offset for next new record                                      *//*  input:  fp     = file pointer                                             *//*          s_end  = END record structure                                     *//*          cflag  = call this for 1: END check only, 0: set offset           *//*  return: -1     = file read error                                          *//*          1      = END record is not found                                  *//*          offset = offset from SEEK_SET                                     *//* -------------------------------------------------------------------------- */
{
    char s[] = "END ";
    long offset;

    offset = -4;
    if (fseek(fp, offset, SEEK_END) != 0)
	return (-1);
    if (fread_native(&s_end->length_e, sizeof(N_SI4), 1, fp) != 1)
	return (-1);
    offset = (-1) * s_end->length_e;
    if (fseek(fp, offset, SEEK_END) != 0)
	return (-1);
    offset = ftell(fp);
    if (fread_fmt(s_end, N_ST_END_FORMAT, fp) != (sizeof(N_ST_END) - sizeof(N_SI4)))
	return (-1);
    if (memcmp(&s_end->h.recname, s, 4) != 0) {
	if (cflag == 0)
	    N_ERP2("END record is not correct.\n");
	return (1);
    }

    return (offset);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_get_rlen(FILE * fp, long offset)
/* -------------------------------------------------------------------------- */
/* get record length from the record pointered by offset                      */
/*  input:  fp      = file pointer                                            */
/*          offset  = offset to the record head                               */
/*  return: -1      = file access error                                       */
/*          -2      = record is not authorized                                */
/*          >0      = record length                                           */
/* -------------------------------------------------------------------------- */
{
    N_ST_RI ri;

    if (fseek(fp, offset, SEEK_SET) != 0)
	return (-1);
    if (fread_native(&ri, sizeof(N_ST_RI), 1, fp) != 1)
	return (-1);
    if (memcmp(&ri.recname, "NUSD", 4) != 0 && memcmp(&ri.recname, "INDX",
						      4) != 0 &&
	memcmp(&ri.recname, "CNTL", 4) != 0 && memcmp(&ri.recname, "SUBC",
						      4) != 0 &&
	memcmp(&ri.recname, "DATA", 4) != 0 && memcmp(&ri.recname, "INFO",
						      4) != 0 &&
	memcmp(&ri.recname, "END ", 4) != 0)
	return (-2);

    return (ri.length_s);
}


/* -------------------------------------------------------------------------- */
N_SI4
n_read_subc(FILE * fp, const char *gname, N_SI4 dsize, N_UI1 * d,
	    N_SI4 fpn)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i = 1, j, is_buf, js_buf, irec, rt, ap;
    N_UI4 s_gname;
    N_ST_SUBC s_subc;

    if (fp != NULL) {		/* disk file case */
	while (1) {
	    if (n_search_record(fp, "SUBC", i, &(s_subc.h)) != 0)
		return (-2);
	    fread_swab(&s_gname, 1,sizeof(N_UI4), fp);
	    if (memcmp(&s_gname, gname, 4) == 0)
		break;
	    i++;
	}
    } else {			/* ESF case */
	if (n_esf_nowbuf[fpn] != 1) {
	    irec = 1;
	    is_buf = (n_esf_bufsize[fpn] - 1) / 4 + 1;
	    js_buf = n_esf_bufsize[fpn] % 4;
	    N_ESF_READ(&n_esf[fpn], &irec, n_ed[fpn], &is_buf, &js_buf,
		       &rt);
	    if (rt != 0) {
		N_ERP2("ESF <%d:%s> SUBC read error!\n",
		       n_esf[fpn], &n_opened_file[fpn][10]);
		return (-72);
	    }
	    n_esf_nowbuf[fpn] = 1;
	}
	ap = n_frlen[fpn];
	memcpy(&s_subc.h, (const void *) (n_ed[fpn] + ap),
	       sizeof(N_ST_RI));
	if (memcmp(gname, (N_UI1 *) (n_ed[fpn] + ap + sizeof(N_ST_RI)), 4)
	    != 0) {
	    return (-2);
	}
    }
    j = s_subc.h.available - sizeof(N_ST_RI);
    if (dsize < j) {
	N_ERP2( "size of subc <%d> is insufficient to set data <%d>\n",
	       dsize, j);
	return (-3);
    }
    if (fp != NULL) {
	N_SI4	nword_variable;
	char	format[256];
  /* debug 2002.06.07 Obayash   cause error in little endian */	
  /* 	nword_variable = (j - 4) / 4;                        */
  /*    printf(format, "4c%ldi", (long)nword_variable);      */
	nword_variable = j  / 4;
	sprintf(format, "%ldi", (long)nword_variable);
	if ((i = fread_fmt(d, format, fp)) != j) {
	    errprintf( "nusdas: fread error in n_read_subc. rt=%d\n",
		    i);
	    return (-1);
	}
    } else {
	memcpy(d, (N_UI1 *) (n_ed[fpn] + ap + sizeof(N_ST_RI) +
			     sizeof(N_SI4)), j);
    }

    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4
n_write_subc(FILE * fp, const char *gname, N_SI4 dsize, N_UI1 * d,
	     N_SI4 fpn)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i = 1, j, is_buf, js_buf, irec, rt, ap;
    long offset;
    N_UI4 s_gname;
    N_ST_SUBC s_subc;

    if (fp != NULL) {		/* disk file case */
	while (1) {
	    if (n_search_record(fp, "SUBC", i, &(s_subc.h)) != 0)
		return (-2);
	    fread_swab(&s_gname, 1,sizeof(N_UI4), fp);
	    if (memcmp(&s_gname, gname, 4) == 0)
		break;
	    i++;
	}
    } else {			/* ESF case */
	irec = 1;
	is_buf = (n_esf_bufsize[fpn] - 1) / 4 + 1;
	js_buf = n_esf_bufsize[fpn] % 4;
	if (n_esf_nowbuf[fpn] != 1) {
	    N_ESF_READ(&n_esf[fpn], &irec, n_ed[fpn], &is_buf, &js_buf,
		       &rt);
	    if (rt != 0) {
		N_ERP2("ESF READ error! ft=%d\n", n_esf[fpn]);
		return (-72);
	    }
	    n_esf_nowbuf[fpn] = 1;
	}
	ap = n_frlen[fpn];
	memcpy(&s_subc.h, (const void *) (n_ed[fpn] + ap),
	       sizeof(N_ST_RI));
	if (memcmp
	    (gname, (const void *) (n_ed[fpn] + ap + sizeof(N_ST_RI)),
	     4) != 0)
	    return (-2);
    }
    j = sizeof(N_ST_RI) + sizeof(N_UI4) + dsize + sizeof(N_SI4);
    if (j > s_subc.h.length_s) {
	N_ERP2("size of subc <%d> exceed the definition!\n",
	       dsize);
	return (-3);
    }
    time(&n_systime);
    s_subc.h.creattime = n_systime;
    if (fp != NULL) {		/* disk file case */
	offset = (-1) * (long) (sizeof(N_ST_RI) + sizeof(N_UI4));
	if ((i = fseek(fp, offset, SEEK_CUR)) != 0) {
	    errprintf( "nusdas: fseek error in n_write_subc. rt=%d\n",
		    i);
	    return (-1);
	}
	fwrite_fmt(&(s_subc.h), N_ST_RI_FORMAT, fp);
	offset = sizeof(N_UI4);
	fseek(fp, offset, SEEK_CUR);
	fwrite_native(d, 4, dsize/4, fp); /* data: 4byte  2002.06 M.O.*/
	if (fflush(fp) != 0)
	    return (-1);
    } else {			/* ESF case */
	memcpy((void *) (n_ed[fpn] + ap), &s_subc.h, sizeof(N_ST_RI));
	memcpy((void *) (n_ed[fpn] + ap + sizeof(N_ST_RI) + sizeof(N_UI4)),
	       d, dsize);
	N_ESF_WRITE(&n_esf[fpn], &irec, (N_SI4 *) n_ed[fpn], &is_buf,
		    &js_buf, &rt);
	if (rt != 0) {
	    N_ERP2("ESF <%d:%s> SUBC write error!\n",
		   n_esf[fpn], &n_opened_file[fpn][10]);
	    return (-71);
	}
    }

    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4
n_write_end(FILE * fp, N_ST_NUSD * s_nusd, N_ST_END * s_end, long s_offset)
/* -------------------------------------------------------------------------- */
/* create END record                                                          */
/*  input:  fp      = file pointer                                            */
/*          s_nusd  = NUSD record structure                                   */
/*  both:   s_end   = END record structure                                    */
/*  input:  s_offset= next new record offset                                  */
/*  return: -1      = file access error                                       */
/*          -2      = offset control fail                                     */
/* -------------------------------------------------------------------------- */
{
    N_SI4 i;
    long offset;
    N_UI1 dum = 0;

    s_end->filesize = s_nusd->filesize;
    s_end->rec_num = s_nusd->rec_num;
    offset = 0;
    if (fseek(fp, offset, SEEK_END) != 0)
	return (-1);
    offset = ftell(fp);
    if (offset != s_offset) {
	N_ERP2("offset control error occured.\n");
	N_ERP2("END start offset <%ld>  next offset <%ld>\n",
	       offset, s_offset);
	return (-2);
    }
    if (fwrite_fmt(s_end, N_ST_END_FORMAT, fp) !=
	(sizeof(N_ST_END) - sizeof(N_SI4))) {
	return -1;
    }
    for (i = sizeof(N_ST_END) - sizeof(N_SI4); i < s_end->h.length_s
	 - sizeof(N_SI4); i++)
	fwrite(&dum, 1, 1, fp);
    if (fwrite_native(&s_end->length_e, sizeof(N_SI4), 1, fp) != 1)
	return (-1);
    if (fflush(fp) != 0)
	return (-1);

    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_write_nusd(FILE * fp, N_ST_NUSD * s_nusd)
/* -------------------------------------------------------------------------- */
/* update NUSD record                                                         */
/*  input:  fp      = file pointer                                            */
/*          s_nusd  = NUSD record structure                                   */
/*  return: -1      = file access error                                       */
/*          -2      = NUSD record can not be found                            */
/* -------------------------------------------------------------------------- */
{
    long offset;

    if (n_search_record(fp, "NUSD", 1, &(s_nusd->h)) != 0)
	return (-2);
    offset = (-1) * (long) sizeof(N_ST_RI);
    if (fseek(fp, offset, SEEK_CUR) != 0)
	return (-1);
    if (fwrite_fmt(s_nusd, N_ST_NUSD_FORMAT_WITHOUTLEN, fp) !=
	(sizeof(N_ST_NUSD) - sizeof(N_SI4))) {
	return -1;
    }
    if (fflush(fp) != 0)
	return (-1);

    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_read_nusd(FILE * fp, N_ST_NUSD * s_nusd)
/* -------------------------------------------------------------------------- */
/* read NUSD record                                                           */
/*  input:  fp      = file pointer                                            */
/*          s_nusd  = NUSD record structure                                   */
/*  return: -1      = file access error                                       */
/*          -2      = NUSD record can not be found                            */
/*          -3      = record length is not consistent                         */
/* -------------------------------------------------------------------------- */
{
    if (n_search_record(fp, "NUSD", 1, &(s_nusd->h)) != 0)
	return (-2);
    if (fread_fmt(&(s_nusd->creator), N_ST_NUSD_FORMAT, fp) !=
	(sizeof(N_ST_NUSD) - sizeof(N_ST_RI))) {
	return -1;
    }
    if (s_nusd->h.length_s != s_nusd->length_e)
	return (-3);

    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_write_indx(FILE * fp, N_ST_INDX * s_indx, N_SI4 num)
/* -------------------------------------------------------------------------- */
/* update INDX record. now time stamp is used.                                */
/*  input:  fp      = file pointer                                            */
/*          s_indx  = INDX record structure                                   */
/*          num     = number of index                                         */
/*  return: -1      = file access error                                       */
/*          -2      = INDX record can not be found                            */
/* -------------------------------------------------------------------------- */
{
    long offset;

    if (n_search_record(fp, "INDX", 1, &(s_indx->h)) != 0)
	return (-2);
    time(&n_systime);
    s_indx->h.creattime = n_systime;
    offset = (-1) * (long) sizeof(N_ST_RI);
    if (fseek(fp, offset, SEEK_CUR) != 0)
	return (-1);
    if (fwrite_fmt(&s_indx->h, N_ST_RI_FORMAT, fp) != sizeof(N_ST_RI))
	return -1;
    if (fwrite_native(s_indx->offset, sizeof(N_SI4), num, fp) != num)
	return (-1);
    if (fflush(fp) != 0)
	return (-1);

    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_read_indx(FILE * fp, N_ST_INDX * s_indx, N_SI4 num)
/* -------------------------------------------------------------------------- */
/* read INDX record.                                                          */
/*  input:  fp      = file pointer                                            */
/*          s_indx  = INDX record structure                                   */
/*          num     = number of index                                         */
/*  return: -1      = file access error                                       */
/*          -2      = INDX record can not be found                            */
/*          -3      = record length is not consistent                         */
/*          -10     = malloc error                                            */
/* -------------------------------------------------------------------------- */
{
    if (n_search_record(fp, "INDX", 1, &(s_indx->h)) != 0)
	return (-2);
    if ((s_indx->offset = (N_SI4 *) malloc(sizeof(N_SI4) * num)) == NULL) {
	N_ERP2("malloc failed <index:%d>\n", num);
	return (-10);
    }
    if (fread_native(s_indx->offset, sizeof(N_SI4), num, fp) != num)
	return (-1);
    if (fread_native(&s_indx->length_e, sizeof(N_SI4), 1, fp) != 1)
	return (-1);
    if (s_indx->h.length_s != s_indx->length_e)
	return (-3);

    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_read_cntl(FILE * fp, N_ST_CNTL * s_cntl)
/* -------------------------------------------------------------------------- */
/* read CNTL record.                                                          */
/*  input:  fp      = file pointer                                            */
/*          s_cntl  = CNTL record structure                                   */
/*  return: -1      = file access error                                       */
/*          -2      = CNTL record can not be found                            */
/*          -3      = record length is not consistent                         */
/*          -10     = malloc error                                            */
/* -------------------------------------------------------------------------- */
{
    N_SI4 i;

    if (n_search_record(fp, "CNTL", 1, &(s_cntl->f.h)) != 0)
	return (-2);
    if (fread_fmt(&(s_cntl->f.type), N_ST_CF_FORMAT, fp) !=
	(sizeof(N_ST_CF) - sizeof(N_ST_RI))) {
	return -1;
    }
    if ((s_cntl->dc = (N_UI4 *) malloc(sizeof(N_UI4) * s_cntl->f.n_dc))
	== NULL) {
	N_ERP2("malloc failed <descriptor:%d>\n", s_cntl->f.n_dc);
	return (-10);
    }
    if (fread(s_cntl->dc, sizeof(N_UI4), s_cntl->f.n_dc, fp) !=
	s_cntl->f.n_dc) return (-1);
    if ((s_cntl->vt1 = (N_SI4 *) malloc(sizeof(N_SI4) * s_cntl->f.n_vt))
	== NULL ||
	(s_cntl->vt2 = (N_SI4 *) malloc(sizeof(N_SI4) * s_cntl->f.n_vt))
	== NULL) {
	N_ERP2("malloc failed <validtime:%d>\n", s_cntl->f.n_vt);
	return (-10);
    }
    if (fread_native(s_cntl->vt1, sizeof(N_SI4), s_cntl->f.n_vt, fp) !=
	s_cntl->f.n_vt) return (-1);
    if (fread_native(s_cntl->vt2, sizeof(N_SI4), s_cntl->f.n_vt, fp) !=
	s_cntl->f.n_vt) return (-1);
    if ((s_cntl->lv1 = (N_UI8 *) malloc(sizeof(N_UI8) * s_cntl->f.n_lv))
	== NULL ||
	(s_cntl->lv2 = (N_UI8 *) malloc(sizeof(N_UI8) * s_cntl->f.n_lv))
	== NULL) {
	N_ERP2("malloc failed <level:%d>\n", s_cntl->f.n_lv);
	return (-10);
    }
    for (i = 0; i < s_cntl->f.n_lv; i++)
	if (fread_fmt((N_UI8 *) (s_cntl->lv1 + i), "6c", fp) != 6)
	    return (-1);
    for (i = 0; i < s_cntl->f.n_lv; i++)
	if (fread_fmt((N_UI8 *) (s_cntl->lv2 + i), "6c", fp) != 6)
	    return (-1);
    if ((s_cntl->el = (N_UI8 *) malloc(sizeof(N_UI8) * s_cntl->f.n_el))
	== NULL) {
	N_ERP2("malloc failed <element:%d>\n", s_cntl->f.n_el);
	return (-10);
    }
    for (i = 0; i < s_cntl->f.n_el; i++)
	if (fread_fmt((N_UI8 *) (s_cntl->el + i), "6c", fp) != 6)
	    return (-1);
    if (fread_native(&(s_cntl->length_e), sizeof(N_SI4), 1, fp) != 1)
	return (-1);
    if (s_cntl->f.h.length_s != s_cntl->length_e)
	return (-3);

    return (0);
}


/* -------------------------------------------------------------------------- */
N_SI4
n_indx_p(N_ST_CNTL * s_cntl, const char *fname, char *descriptor,
	 N_SI4 * validtime1, N_SI4 * validtime2, char *level1,
	 char *level2, char *element, N_SI4 esfflag)
/* -------------------------------------------------------------------------- */
/* return the subscript number of offset table in INDX record                 */
/*  input:  s_cntl  = CNTL record structure                                   */
/*          fname   = target file name < for error print >                    */
/*          descriptor, validtime1, validtime2, level1, level2, element       */
/*                  = target parameters                                       */
/*  return: -2      = target is not registered in this file                   */
/*          p       = subscript number of offset table                        */
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, dc, vt, lv, el, p;
    char s1[256], s2[256], *c1, *c2;

    if ((dc = n_check_register(s_cntl, N_CNTL_MEMBER, descriptor, NULL)) <
	0) return (-2);
    if (
	(vt =
	 n_check_register(s_cntl, N_CNTL_VALIDTIME, validtime1,
			  validtime2)) < 0) return (-2);
    if ((lv = n_check_register(s_cntl, N_CNTL_PLANE, level1, level2)) < 0)
	return (-2);
    if ((el = n_check_register(s_cntl, N_CNTL_ELEMENT, element, NULL)) < 0)
	return (-2);
    if (esfflag == N_ON)
	p =
	    lv + s_cntl->f.n_lv * (el +
				   s_cntl->f.n_el * (vt +
						     s_cntl->f.n_vt * dc));
    else
	p =
	    el + s_cntl->f.n_el * (lv +
				   s_cntl->f.n_lv * (vt +
						     s_cntl->f.n_vt * dc));

    return (p);
}


/* -------------------------------------------------------------------------- */
N_SI4 n_mark_end(N_SI4 fpn)
/* -------------------------------------------------------------------------- */
/* update NUSD & INDX record and add END record                               */
/* -------------------------------------------------------------------------- */
{
    N_SI4 rt, offnum;

    offnum = n_cntl[fpn].f.n_dc * n_cntl[fpn].f.n_vt
	* n_cntl[fpn].f.n_lv * n_cntl[fpn].f.n_el;
    if (n_write_nusd(n_fp[fpn], &n_nusd[fpn]) < 0) {
	N_ERP2("nusdas file <%s> write NUSD failed.\n",
	       n_opened_file[fpn]);
	rt = -1;
    } else if (n_write_indx(n_fp[fpn], &n_indx[fpn], offnum) < 0) {
	N_ERP2("nusdas file <%s> write INDX failed.\n",
	       n_opened_file[fpn]);
	rt = -2;
    }
	else if (n_write_end(n_fp[fpn], &n_nusd[fpn], &n_end[fpn],
			     n_next_offset[fpn])) {
	N_ERP2("nusdas file <%s> write END failed.\n",
	       n_opened_file[fpn]);
	rt = -3;
    } else
	rt = 0;

    return (rt);
}


/** type1, type2, type3, descriptor ̕ʁB
 * :
 *  utype1, utype2, utype3, udescriptor ͂ꂼ꒷ 8, 4, 4, 4 
 *  C ܂ Fortran Btype1, type2, type3, descriptor ɂ
 *  ꂼ 9, 5, 5, 5 oCg̗̈vB
 * :
 *  type ̃Rs[͍ŏ ' ' ܂ '\0' őł؂B
 *  descriptor ̃Rs[͂傤 4 sȂB
 */
void
n_copy_type(const char *utype1, const char *utype2, const char *utype3,
	    const char *udescriptor, char *type1, char *type2, char *type3,
	    char *descriptor)
{
    N_SI4 i, j;

    for (i = 0; i < 9; i++)
	*(type1 + i) = '\0';
    for (i = 0; i < 5; i++)
	*(type2 + i) = '\0';
    for (i = 0; i < 5; i++)
	*(type3 + i) = '\0';
    strcpy(descriptor, "    ");
    for (i = 0; i < 8; i++) {
	if (*(utype1 + i) == ' ' || *(utype1 + i) == '\0')
	    break;
	*(type1 + i) = *(utype1 + i);
    }
    for (i = 0; i < 4; i++) {
	if (*(utype2 + i) == ' ' || *(utype2 + i) == '\0')
	    break;
	*(type2 + i) = *(utype2 + i);
    }
    for (i = 0; i < 4; i++) {
	if (*(utype3 + i) == ' ' || *(utype3 + i) == '\0')
	    break;
	*(type3 + i) = *(utype3 + i);
    }
    for (i = 0; i < 4; i++) {
	if (*(udescriptor + i) == '\0')
	    break;
	*(descriptor + i) = *(udescriptor + i);
    }
}


/* -------------------------------------------------------------------------- */
void
n_copy_char(const char *ulevel1, const char *ulevel2, const char *uelem,
	    char *level1, char *level2, char *elem)
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, j;

    for (i = 0; i < 7; i++)
	*(level1 + i) = '\0';
    for (i = 0; i < 7; i++)
	*(level2 + i) = '\0';
    for (i = 0; i < 7; i++)
	*(elem + i) = '\0';
    for (i = 0; i < 6; i++) {
	if (*(ulevel1 + i) == '\0')
	    break;
	*(level1 + i) = *(ulevel1 + i);
    }
    for (i = 0; i < 6; i++) {
	if (*(ulevel2 + i) == '\0')
	    break;
	*(level2 + i) = *(ulevel2 + i);
    }
    for (i = 0; i < 6; i++) {
	if (*(uelem + i) == '\0')
	    break;
	*(elem + i) = *(uelem + i);
    }
}


/** `t@C̎擾
 * type ɑΉ`t@C n_def[ԋpl] 瓾B
 * l̓G[B
 */
N_SI4 n_set_defn(char *type1, char *type2, char *type3)
{
    FILE *fp;
    N_SI4 defn, rt;

    if ((rt = n_default_type(type1, type2)) < 0)
	return (-10 + rt);
    if ((rt = n_check_defopen(type1, type2, type3, &defn)) < 0) {
	return (-20);
    } else if (rt > 0) {
	if ((fp = n_open_def(n_nrd_num, n_nrd[defn], &n_nid[defn],
			     type1, type2, type3)) == NULL) {
	    return (-21);
	}
	if ((rt = n_read_def(fp, &n_def[defn])) < 0)
	    return (-30 + rt);
	else if (rt > 0)
	    return (-40 - rt);
	fclose(fp);
    }

    return (defn);
}

/* -------------------------------------------------------------------------- */
N_SI4
n_set_fpn(const char *utype1, const char *utype2, const char *utype3,
	  N_SI4 * ubasetime, const char *udescriptor, N_SI4 * validtime1,
	  N_SI4 * validtime2, char uflag, N_SI4 * esfflag, N_SI4 * newop)
/* -------------------------------------------------------------------------- */
/* set fpn. If necessary, new open. But not create.                           */
/*  input  uflag = 'r':for read, 'w':for write, 'c':for close                 */
/* -------------------------------------------------------------------------- */
{
    char path[N_LINE_MAX], fname[N_LINE_MAX], flag[3];
    char type1[9], type2[5], type3[5], descriptor[5], s1[256], s2[256];
    N_SI4 rt, id, ide, i, j, k, l, m, fpn, defn, basetime, offnum, icflag;
    N_SI4 is = 0, js = 0, is_buf, js_buf, rw_flag, maxrec, recnum, csize,
	csize2;
    N_UI1 *sp;
    FILE *fp;

    *newop = 0;
    n_copy_type(utype1, utype2, utype3, udescriptor,
		type1, type2, type3, descriptor);
    if ((defn = n_set_defn(type1, type2, type3)) < 0)
	return (defn);
    if (uflag == 'w' && n_nid[defn] >= 50) {
	N_ERP2("no write permission for NUSDAS%2.2d\n",
	       n_nid[defn]);
	errprintf( "NUSDAS50 - NUSDAS99 is read only!\n");
	N_ERTN(-69);
    }

    id = 0;
    ide = (uflag == 'r') ? ((*ubasetime == -1) ? n_def[defn].n_vt : 1) : 1;
    while (id < ide) {
	basetime =
	    (*ubasetime != -1) ? *ubasetime : n_rcal_bt_vt(validtime1,
							   defn, id);
	if (
	    (rt =
	     n_setpath('r', n_nrd[defn], &n_def[defn], type1, type2, type3,
		       &basetime, descriptor, validtime1, path,
		       fname)) < 0) {
	    if (*ubasetime != -1) {
		return (-49 + rt);
	    }
	    id++;
	    continue;
	}
	rt = n_check_fileopen(path, fname, &fpn);
	if (rt < 0 || (uflag == 'c' && rt != 0)) {
	    strcpy(n_opened_file[fpn], "");
	    return (-52);
	}

	if (rt == 0 && uflag == 'w' && n_fopen_type[fpn] == N_FOPEN_READ) {
	    N_ERP2("write action for read open file<%s>\n",
		   n_opened_file[fpn]);
	    strcpy(n_opened_file[fpn], "");
	    return (-68);
	}
	if (rt > 0) {		/* new file creation case */
	    if (strcmp(path, "n_nwp_esf") == 0) {	/* ESF case */
		if (strlen(fname) == 2 && isdigit((int) fname[0])
		    && isdigit((int) fname[1])) {
		    n_esf[fpn] = atoi(fname);
		    csize = 0;
		} else {
		    if (n_esf_xx == -1) {
			if ((fp = fopen("NUSDAS_FTXX",
					"r")) == NULL ||
			    fscanf(fp, "%d", &n_esf_xx) != 1) {
			    N_ERP2( "Can't read ESF device number from NUSDAS_FTXX!\n");
			    N_ERTN(-77);
			} else
			    fclose(fp);
		    }
		    n_esf[fpn] = n_esf_xx;
		    csize = strlen(fname);
		}
		n_frlen[fpn] = n_def[defn].forced_rlen;
		if ((recnum = n_set_esfirec(&n_esf_irec[fpn],
					    &n_def[defn])) < 0) {
		    N_ERTN(-79);
		}
		n_esf_bufsize[fpn] = n_set_bufsize(n_frlen[fpn],
						   recnum, &maxrec);
		rw_flag = 0;
		icflag = 0;
		if ((n_ed[fpn] = (N_UI1 *) malloc(sizeof(N_UI1)
						  * n_esf_bufsize[fpn])) ==
		    NULL) {
		    N_ERP2("malloc failed\n");
		    N_ERTN(-10);
		}
		is_buf = (n_esf_bufsize[fpn] - 1) / 4 + 1;
		js_buf = n_esf_bufsize[fpn] % 4;
		N_ESF_OPEN(&n_esf[fpn], (N_SI4 *) n_ed[fpn],
			   &is_buf, &js_buf,
			   &n_esf_bufsize[fpn], &maxrec, &rw_flag,
			   &icflag, &rt, &(n_nid[defn]),
			   fname, &csize, &csize);
		if (rt != 0) {
		    N_ERP2( "ESF <%d:%s> read for initialize failed.\n",
			   n_esf[fpn], fname);
		    free(n_ed[fpn]);
		    rt *= -1;
		    return (rt);
		}
		*newop = 1;
		n_fopen_type[fpn] = (uflag == 'r') ? N_FOPEN_READ :
		    N_FOPEN_WRITE;
		n_get_spcntl(&n_cntl[fpn], n_ed[fpn]);
		n_indx[fpn].offset = (N_SI4 *) malloc(sizeof(N_SI4) * 1);	/* dummy alloc */
		n_esf_nowbuf[fpn] = 1;
	    } else {		/* disk file case */
		strcpy(flag, (uflag == 'r') ? "r" : "r+");
		if ((n_fp[fpn] = fopen(n_opened_file[fpn], flag)) == NULL) {
		    if (*ubasetime != -1) {
			if (uflag == 'r') {
			    N_ERP1("Can't open file <%s>\n",
				   n_opened_file[fpn]);
			    strcpy(n_opened_file[fpn], "");
			    return (-1);
			} else {
			    errsys("");
			    N_ERP2("Can't open file <%s>\n",
				   n_opened_file[fpn]);
			    strcpy(n_opened_file[fpn], "");
			    return (-53);
			}
		    } else {
			id++;
			strcpy(n_opened_file[fpn], "");
			continue;
		    }
		}
		*newop = 1;
		n_fopen_type[fpn] = (uflag == 'r') ? N_FOPEN_READ :
		    N_FOPEN_WRITE;
		if (n_read_nusd(n_fp[fpn], &n_nusd[fpn]) != 0) {
		    N_ERP2("file <%s> read NUSD failed.\n",
			   n_opened_file[fpn]);
		    n_check_fileclose(fpn, n_fopen_type[fpn]);
		    return (-54);
		}
		if (n_read_cntl(n_fp[fpn], &n_cntl[fpn]) != 0) {
		    N_ERP2("file <%s> read CNTL failed.\n",
			   n_opened_file[fpn]);
		    n_check_fileclose(fpn, n_fopen_type[fpn]);
		    return (-55);
		}
		if (n_cntl[fpn].f.basetime_t != basetime) {
		    n_check_fileclose(fpn, n_fopen_type[fpn]);
		    id++;
		    continue;
		}
		offnum = n_cntl[fpn].f.n_dc * n_cntl[fpn].f.n_vt
		    * n_cntl[fpn].f.n_lv * n_cntl[fpn].f.n_el;
		if (
		    (rt =
		     n_read_indx(n_fp[fpn], &n_indx[fpn], offnum) != 0)) {
		    N_ERP2("file <%s> read INDX failed. rt=%d\n",
			   n_opened_file[fpn], rt);
		    n_check_fileclose(fpn, N_FOPEN_WRITE);
		    return (-56);
		}
	    }
	}
	break;
    }
    if (id == ide) {
	n_timeprint(s1, *ubasetime);
	n_timeprint(s2, *validtime1);
	N_ERP2( "file including basetime<%s> validtime<%s> is not exist!\n",
	       s1, s2);
	return (-58);
    }
    *esfflag = (strcmp(path, "n_nwp_esf") == 0) ? 1 : 0;

    return (fpn);
}


/* -------------------------------------------------------------------------- */
N_SI4
n_write_data(N_SI4 * basetime, char *descriptor,
	     N_SI4 * validtime1, N_SI4 * validtime2, char *level1,
	     char *level2, char *element, void *data,
	     const char *dtype, const N_SI4 * dnum, N_SI4 fpn,
	     N_SI4 * use_offset, N_UI1 * esf)
/* -------------------------------------------------------------------------- */
/*  input:  basetime, descriptor, validtime1, validtime2,                     */
/*          level1, level2, element                                           */
/*                = target parameters                                         */
/*          data  = user data pointer for write the nusdas file               */
/*          dtype = variable type for user data pointer                       */
/*          dnum  = item number of user data array (not byte)                 */
/*          fpn   = target file number                                        */
/*  return: <0    = write DATA error                                          */
/*          0     = not registered or recorded                                */
/*          ng    = item number of recorded data (not byte)                   */
/* -------------------------------------------------------------------------- */
{
    N_SI4 i, offp, addbyte, rt, ng, esfflag;
    N_UI4 s_pack;
    char s1[256], s2[256];

    s_pack = (n_pack_override == 0) ? n_pack[fpn] : n_pack_override;
    esfflag = (esf == NULL) ? N_OFF : N_ON;

    if ((offp = n_indx_p(&n_cntl[fpn], n_opened_file[fpn], descriptor,
			 validtime1,
			 validtime2, level1, level2, element,
			 esfflag)) < 0) return (-2);
    if ((esfflag == N_OFF && n_indx[fpn].offset[offp] < 0)
	|| (esfflag == N_ON && *(n_esf_irec[fpn] + offp) == 0)) {
	N_ERP1( "requested data <el:%s lv:%s vt:%d, offp:%d> is not registered\n",
	       element, level1, *validtime1, offp);
	if (n_io_cntl & N_IO_WARNING_OUT) {
	    n_timeprint(s1, *validtime1);
	    n_timeprint(s2, *validtime2);
	    errprintf( "this DATA is not writed on <%s>\n",
		    n_opened_file[fpn]);
	    errprintf( "member      : %4.4s\n", descriptor);
	    errprintf( "validtime1,2: %s,%s\n", s1, s2);
	    errprintf( "level1,2    : %6.6s,%6.6s\n", level1, level2);
	    errprintf( "element     : %6.6s\n", element);
	}
	return (-2);
    }
    if (esfflag == N_OFF) {
	if (
	    (addbyte =
	     n_put_data(n_fp[fpn], use_offset, n_indx[fpn].offset[offp],
			n_next_offset[fpn], &n_cntl[fpn], descriptor,
			validtime1, validtime2, level1, level2, element,
			data, dtype, dnum, s_pack, n_miss[fpn],
			n_frlen[fpn], &ng)) < 0) {
	    N_ERP2("nusdas file <%s> write DATA failed.\n",
		   n_opened_file[fpn]);
	    return (addbyte);
	}
	if (*use_offset == 1) {
	    n_indx[fpn].offset[offp] = (N_SI4) n_next_offset[fpn];
	    n_next_offset[fpn] += addbyte;
	    n_nusd[fpn].filesize += addbyte;
	    n_nusd[fpn].rec_num++;
	}
    } else {
	if ((addbyte = n_put_esf(esf, use_offset, n_indx[fpn].offset[offp],
				 n_next_offset[fpn], &n_cntl[fpn],
				 descriptor,
				 validtime1, validtime2, level1, level2,
				 element, data, dtype, dnum, s_pack,
				 n_miss[fpn], n_frlen[fpn], &ng)) < 0) {
	    N_ERP2("nusdas file <%s> write DATA failed.\n",
		   n_opened_file[fpn]);
	    return (addbyte);
	}
	*use_offset = *(n_esf_irec[fpn] + offp);
    }

    return (ng);
}


/* -------------------------------------------------------------------------- */
N_SI4
n_subc_eta_sigm(const char *utype1, const char *utype2, const char *utype3,
		N_SI4 * basetime, const char *udescriptor,
		N_SI4 * validtime1, N_SI4 * validtime2, char *gname,
		N_SI4 * s_lv, float *a, float *b, float *c, char *action)
/* -------------------------------------------------------------------------- */
{
    N_SI4 s, k, fpn, rt, esfflag, w_lv, newop;
    N_UI1 *uc;
    char flag;
    strcpy(n_routine_name[n_routine_d++], "nusdas_subc_eta_sigm");

    flag = (strncmp(action, "PUT", 3) == 0 || strncmp(action, "put",
						      3) == 0) ? 'w'
	: (strncmp(action, "GET", 3) == 0 || strncmp(action, "get", 3)
	   == 0) ? 'r' : 'a';
    if (flag == 'a') {
	N_ERP2("action parameter <%s> is invalid!\n", action);
	N_ERTN(-5);
    }
    fpn = n_set_fpn(utype1, utype2, utype3, basetime,
		    udescriptor, validtime1, validtime2, flag, &esfflag,
		    &newop);
    if (fpn < 0) {
	N_ERTN(fpn);
    }
    s = sizeof(N_SI4) + sizeof(float) * (2 * (*s_lv + 1) + 1);
    if ((uc = (N_UI1 *) malloc(s)) == NULL) {
	N_ERP2("malloc error!");
	N_ERTN(-10);
    }
    if (strncmp(action, "PUT", 3) == 0 || strncmp(action, "put", 3) == 0) {
	k = 0;
	s = sizeof(N_SI4);
	memcpy(uc, s_lv, s);
	k += s;
	s = sizeof(float) * (*s_lv + 1);
	memcpy((N_UI1 *) (uc + k), a, s);
	k += s;
	s = sizeof(float) * (*s_lv + 1);
	memcpy((N_UI1 *) (uc + k), b, s);
	k += s;
	s = sizeof(float);
	memcpy((N_UI1 *) (uc + k), c, s);
	rt = n_write_subc(n_fp[fpn], gname, s, uc, fpn);
	if ((n_io_cntl & N_IO_W_FCLOSE) == N_IO_W_FCLOSE)
	    n_check_fileclose(fpn, N_FOPEN_WRITE);
    }
	else if (strncmp(action, "GET", 3) == 0
		 || strncmp(action, "get", 3) == 0) {
	if ((rt = n_read_subc(n_fp[fpn], gname, s, uc, fpn)) == 0) {
	    k = 0;
	    s = sizeof(N_SI4);
	    memcpy(&w_lv, uc, s);
	    if (w_lv > *s_lv) {
		N_ERP2( "input level <%d> is insufficient for the level in file <%d>\n",
		       *s_lv, w_lv);
		rt = -4;
	    } else {
		memcpy(s_lv, &w_lv, 4);
		k += s;
		s = sizeof(float) * (*s_lv + 1);
		memcpy(a, (N_UI1 *) (uc + k), s);
		k += s;
		s = sizeof(float) * (*s_lv + 1);
		memcpy(b, (N_UI1 *) (uc + k), s);
		k += s;
		s = sizeof(float);
		memcpy(c, (N_UI1 *) (uc + k), s);
	    }
	}
	if ((n_io_cntl & N_IO_R_FCLOSE) == N_IO_R_FCLOSE)
	    n_check_fileclose(fpn, N_FOPEN_READ);
    }
    free(uc);
    n_routine_d--;
    return (rt);
}
