/* nus_utlfunc.c */

static char rcsid[] =
    "$Header: /cvsroot/pandora/pnusdas/src/nus_utlfunc.c,v 1.31 2002/03/12 13:12:06 suuchi29 Exp $";

#define N_DEF_UTLFUNC_SOURCE
#include "nusdas_sys.h"
#include "nusdas_com.h"

#define SUBENTER(routine) strcpy(n_routine_name[n_routine_d++], routine)
#define SUBEXIT		  n_routine_d--;

#ifndef PATH_MAX
#define PATH_MAX 265
#endif

#ifndef DEBUG_UTLFUNC
#define debug
#else
#define debug errprintf
#endif

/* ̕\. ӂꂽꍇ next ȉɘAĂ */
#define BTTABLE_CLUSTER 100
struct st_bttable {
    N_SI4 bt[BTTABLE_CLUSTER];
    struct st_bttable *next;
};

/* T */
struct st_scan {
    int mode;
    unsigned long found;
    N_SI4 max, min;
    struct st_bttable table;
};

/** st_scan ւ̓o^
 */

int register_time(struct st_scan *scan, N_SI4 basetime)
{
    long n, ofs, hit;
    struct st_bttable *pbt;
    debug( "#time %d\n", basetime);
    hit = -1;
    if (basetime >= scan->min && basetime <= scan->max) {
	debug( "#basetime search %d %d\n", scan->min, scan->max);
	pbt = &(scan->table);
	for (n = ofs = 0; n < scan->found; n++, ofs++) {
	    if (ofs >= BTTABLE_CLUSTER) {
		pbt = pbt->next;
		ofs = 0;
	    }
	    if (pbt->bt[ofs] == basetime) {
		debug( "#hit %d\n", n);
		hit = n;
	    }
	}
    } else {
	pbt = &(scan->table);
	while (pbt->next)
	    pbt = pbt->next;
    }
    if (hit == -1) {
	ofs = scan->found % BTTABLE_CLUSTER;
	(scan->found)++;
	if (ofs == BTTABLE_CLUSTER - 1) {
	    if ((pbt->next = malloc(sizeof(*pbt))) == NULL) {
		return -32;
	    }
	    pbt = pbt->next;
	    pbt->next = NULL;
	    ofs = 0;
	}
	debug( "#basetime regd %d\n", ofs);
	pbt->bt[ofs] = basetime;
	if (basetime < scan->min)
	    scan->min = basetime;
	if (basetime > scan->max)
	    scan->max = basetime;
    }
    return 0;
}

#define PATH_LENGTH 256

char *memcpy_fill(char *dest, const char *source, size_t n)
{
    size_t i;
    for (i = 0; i < n; i++) {
	if (source[i] == '\0')
	    break;
	dest[i] = source[i];
	if (dest[i] == ' ')
	    dest[i] = '_';
    }
    while (i < n) {
	dest[i++] = '_';
    }
    return dest + n;
}

/** `t@C path  filename ۂ̃fBNgւ̎ʑB
 * basetime, validtime ͂킩Ȃ̂ŁǍ̊Kw *unresolved_depth
 * Ɋi[B
 */
void
replace_path(char *realized, size_t size, const char *template,
	     const char *type1, const char *type2, const char *type3,
	     const char *member, N_SI4 * basetime, int *unresolved_depth)
{
    char *p = realized;
    const char *t = template;
    char *last_slash = NULL;

    *unresolved_depth = 0;

    while (*t) {
	if (p - realized > size - 13)
	    break;
	if (*t == '/') {
	    if (t[1] == '/' || t[1] == 0) {
		t++;
		continue;
	    }
	    if (*unresolved_depth)
		(*unresolved_depth)++;
	    else
		last_slash = p;
	}
	if (*t != '_') {
	    *p++ = *t++;
	} else if (strncmp(t, "_model", 6) == 0) {
	    p = memcpy_fill(p, type1, 4);
	    t += 6;
	} else if (strncmp(t, "_space", 6) == 0) {
	    p = memcpy_fill(p, type1 + 4, 4);
	    t += 6;
	} else if (strncmp(t, "_2D", 3) == 0) {
	    p = memcpy_fill(p, type1 + 4, 2);
	    t += 3;
	} else if (strncmp(t, "_3D", 3) == 0) {
	    p = memcpy_fill(p, type1 + 6, 2);
	    t += 3;
	} else if (strncmp(t, "_attribute", 10) == 0) {
	    p = memcpy_fill(p, type2, 2);
	    t += 10;
	} else if (strncmp(t, "_time", 5) == 0) {
	    p = memcpy_fill(p, type2 + 2, 2);
	    t += 5;
	} else if (strncmp(t, "_name", 5) == 0) {
	    p = memcpy_fill(p, type3, 4);
	    t += 5;
	} else if (strncmp(t, "_member", 7) == 0) {
	    p = memcpy_fill(p, member, 4);
	    t += 7;
	} else if (strncmp(t, "_basetime", 9) == 0) {
	    if (basetime) {
		char btbuf[20];
		int y, m, d, h, mi;
		extern int nwp_seq2ymdhm(int *, int *, int *, int *, int *,
					 int);
		nwp_seq2ymdhm(&y, &m, &d, &h, &mi, *basetime);
		sprintf(btbuf, "%04d%02d%02d%02d%02d", y, m, d, h, mi);
		p = memcpy_fill(p, btbuf, 12);
	    } else {
		*last_slash = '\0';
		if (*unresolved_depth == 0)
		    *unresolved_depth = 1;
		*p++ = '*';
	    }
	    t += 9;
	} else if (strncmp(t, "_validtime", 10) == 0) {
	    *last_slash = '\0';
	    if (*unresolved_depth == 0)
		*unresolved_depth = 1;
	    *p++ = '*';
	    t += 10;
	} else {
	    *p++ = *t++;
	}
    }
    *p = '\0';
    if (*unresolved_depth && !last_slash)
	strcpy(realized, ".");
}


/** ċAIt@CT basetime Xg̎擾
 */
int
btime_sub(const char *path, int depth, struct st_scan *scan, N_SI4 pflag)
{
    DIR *dir;
    struct dirent *entry;
    char subpath[PATH_MAX];
    N_ST_CNTL control_record;
    N_SI4 r;

    if (pflag) {
	errprintf("#btime_sub %s %d %c\n", path, depth,
		(scan->mode == 'B') ? 'B' : 'V');
    }

    if ((dir = opendir(path)) == NULL) {
	FILE *nusfile;
	if ((nusfile = fopen(path, "rb")) == NULL) {
	    if (pflag)
		errsys(path);
	    return 0;
	}
	if ((r = n_read_cntl(nusfile, &control_record)) < 0)
	    goto error;
	if (scan->mode == 'B') {
	    if ((r = register_time(scan, control_record.f.basetime_t)) < 0)
		goto error;
	} else {
	    int i;
	    for (i = 0; i < control_record.f.n_vt; i++) {
		r = register_time(scan, control_record.vt1[i]);
		if (r < 0)
		    goto error;
	    }
	}
      error:
	fclose(nusfile);
	return r;
    }

    while ((entry = readdir(dir)) != NULL) {
	if (entry->d_name[0] == '.' || 
	    strncmp(entry->d_name, "dummy", 5) == 0)
	    continue;
	n_make_subpath(subpath, sizeof subpath, path, entry->d_name);

	debug( "# dir '%s'\n", subpath);
	/*
	 * { depth > 1 ̂Ƃł悢AÔ.
	 */
	if (depth > 0) {
	    r = btime_sub(subpath, depth - 1, scan, pflag);
	    if (r < 0)
		return r;
	}

    }
    closedir(dir);
    return 0;
}

/** qsort pr֐
 */
int n_si4_diff(const void *a, const void *b)
{
    return *((N_SI4 *) a) - *((N_SI4 *) b);
}

/**
 * Xg܂͑ΏێXg̖₢킹
 * utype1, utype2, utype3 Ŏw肳f[^Zbg(|Ώ)ꗗ
 * btlist Ɏ擾Bmode == 'B' ̂ƂAmode == 'V' ̂Ƃ
 * Ώێ擾B
 * btlist ɂ͍őł btmax ݂̏sȂȂB
 * ԋpl͎݂łB
 */
int
scan_root_gettime(const char *utype1, const char *utype2,
		  const char *utype3, N_SI4 * btlist, N_SI4 * btmax,
		  int mode, N_SI4 * basetime, N_SI4 pflag)
{
    N_SI4 defn;			/* index for deffile table */
    char type1[9], type2[5], type3[5], member[5];
    char umember[5] = "fake";
    char template[PATH_LENGTH];
    struct st_scan scan;
    int i_member, r;

    /* [Uw̎ʂO
     * ł͂܂ member ͎ɂ͂Ȃ */
    n_copy_type(utype1, utype2, utype3, umember, type1, type2, type3,
		member);
    /* `t@C[h */
    defn = n_set_defn(type1, type2, type3);
    if (defn < 0) {
	N_ERTN(defn);
    }

    /* t@CT template ̃ZbgAbv */
    switch (n_def[defn].path) {
    case N_NWP_PATH_S:
    case N_NWP_PATH_VM:
	n_make_subpath(template, PATH_LENGTH, n_nrd[defn],
		       "./_3D_name/_validtime");
	break;
    case N_NWP_PATH_M:
	n_make_subpath(template, PATH_LENGTH, n_nrd[defn],
		       "./_3D_name/_member/_validtime");
	break;
    case N_NWP_PATH_BS:
	n_make_subpath(template, PATH_LENGTH, n_nrd[defn],
		       "./_3D_name/_basetime");
	break;
    case N_RELATIVE_PATH:
	n_make_subpath(template, PATH_LENGTH, n_nrd[defn],
		       n_def[defn].pathname);
	n_make_subpath(template, PATH_LENGTH, NULL, n_def[defn].filename);
	break;
    case N_DEFAULT:
    default:
	n_make_subpath(template, PATH_LENGTH, n_nrd[defn],
		       "./_model/_attribute/_space/_time/_name/_basetime");
	break;
    }

    scan.found = 0;
    scan.max = INT_MIN;
    scan.min = INT_MAX;
    scan.table.next = NULL;
    scan.mode = mode;

    if (pflag)
	errprintf("#template='%s'\n", template);
    for (i_member = 0; i_member < n_def[defn].n_dc; i_member++) {
	char realized[PATH_LENGTH];
	char *unknown;
	int unresolved_depth;

	strncpy(member, (char *) (n_def[defn].dc + i_member), 4);
	member[4] = '\0';
	debug( "#member=<%4.4s>\n", member);

	replace_path(realized, sizeof realized, template,
		     type1, type2, type3, member, basetime,
		     &unresolved_depth);
	debug( "#replaced=<%s> unresolved=%d\n", realized,
	      unresolved_depth);

	r = btime_sub(realized, unresolved_depth, &scan, pflag);
	if (r < 0)
	    break;
    }

    if (scan.found) {
	unsigned ibt, nbt, ofs;
	struct st_bttable *pbt;
	nbt = scan.found;
	if (nbt > *btmax)
	    nbt = *btmax;
	pbt = &(scan.table);
	for (ibt = ofs = 0; ibt < nbt; ibt++, ofs++) {
	    if (ofs >= BTTABLE_CLUSTER) {
		pbt = pbt->next;
		ofs = 0;
	    }
	    btlist[ibt] = pbt->bt[ofs];
	}

	qsort(btlist, nbt, sizeof btlist[0], n_si4_diff);

	pbt = scan.table.next;
	while (pbt) {
	    struct st_bttable *pbt2;
	    pbt2 = pbt->next;
	    free(pbt);
	    pbt = pbt2;
	}
    }

    if (scan.found == 0)
	return r;
    return scan.found;
}

/**
 * Xg̖₢킹 (JC^[tFCX)
 * utype1, utype2, utype3 Ŏw肳f[^Zbg̊ꗗ
 * btlist Ɏ擾Bbtlist ɂ͍őł btmax ݂̏
 * sȂȂBԋpl͎݂łB
 */
int
nusdas_inq_nrdbtime(const char *utype1, const char *utype2,
		    const char *utype3, N_SI4 * btlist, N_SI4 * btmax,
		    N_SI4 pflag)
{
    int r;
    SUBENTER("nusdas_inq_nrdbtime");
    r = scan_root_gettime(utype1, utype2, utype3, btlist, btmax,
			  'B', NULL, pflag);
    SUBEXIT;
    return r;
}

/**
 * ΏێXg̖₢킹
 * ̈Ӗ nusdas_inq_nrdbtime ƂقƂǓB basetime 
 * NULL łȂΒTΏۂ *basetime Ɍ肳B
 */
int
nusdas_inq_nrdvtime(const char *utype1, const char *utype2,
		    const char *utype3, N_SI4 * btlist, N_SI4 * btmax,
		    N_SI4 * basetime, N_SI4 pflag)
{
    int r;
    SUBENTER("nusdas_inq_nrdvtime");
    r = scan_root_gettime(utype1, utype2, utype3, btlist, btmax, 'V',
			  basetime, pflag);
    SUBEXIT;
    return r;
}


/* -------------------------------------------------------------------------- */
N_SI4 n_round_i4_r4(float fl4)
/* -------------------------------------------------------------------------- */
{
    return ((fl4 >= 0) ? (N_SI4) (fl4 + 0.5) : (N_SI4) (fl4 - 0.5));
}


/* -------------------------------------------------------------------------- */
N_SI2 n_round_i2_r4(float fl4)
/* -------------------------------------------------------------------------- */
{
    return ((fl4 >= 0) ? (N_SI2) (fl4 + 0.5) : (N_SI2) (fl4 - 0.5));
}


/* -------------------------------------------------------------------------- */
N_SI4 n_ipow(const N_SI4 i, const N_SI4 j)
/* -------------------------------------------------------------------------- */
{
    N_SI4 k, rt;
    for (k = 0, rt = 1; k < j; k++)
	rt *= i;
    return (rt);
}
