#include <limits.h>
#include <float.h>

typedef unsigned char	N_UI1;
typedef short	N_SI2;
typedef unsigned short	N_UI2;
typedef long	N_SI4;
typedef unsigned long	N_UI4;
typedef struct { 
	unsigned char	c[8]; 
} N_SI8;
typedef struct { 
	unsigned char	c[8]; 
} N_UI8;

	/* added in v2.0 */
struct nus_type_t {
	/* they are NOT null-terminated string */
	char	type1[8];
	char	type2[4];
	char	type3[4];
};

	/* added in v2.0 */
struct nus_dims_t {
	/* bit fields for validity of following dimensions */
        int       		stat;
#define	NUSDIM_TYPE		(1 << 0)
#define	NUSDIM_BASE		(1 << 1)
#define	NUSDIM_MEMBER		(1 << 2)
#define	NUSDIM_VALID		(1 << 3)
#define	NUSDIM_VALID2		(1 << 4)
#define	NUSDIM_PLANE		(1 << 5)
#define	NUSDIM_PLANE2		(1 << 6)
#define	NUSDIM_ELEMENT		(1 << 7)
        struct nus_type_t       type;
        long                    base;
	/* this is NOT null-terminated string */
        char                    member[4];
        long                    valid;
        long                    valid2;
	/* they are NOT null-terminated string */
        char                    plane[6];
        char                    plane2[6];
        char                    element[6];
};

#ifndef N_DEF_NUSDAS_SOURCE
N_SI4 nusdas_write2(const char *, const char *, const char *, N_SI4 *,
const char *, N_SI4 *, N_SI4 *, const char *, const char *,
const char *, void *, const char *, const N_SI4 *);
N_SI4 nusdas_write(const char *, const char *, const char *, N_SI4 *,
const char *, N_SI4 *, const char *,
const char *, void *, const char *, const N_SI4 *);
#ifdef FILE
N_SI4 nusdas_read_direct2(char *, N_SI4 *, N_SI4 *,
char *, char *, char *, void *,
const char *, const N_SI4 *, N_SI4, FILE *);
#endif
N_SI4 nusdas_read2(const char *, const char *, const char *, N_SI4 *,
const char *, N_SI4 *, N_SI4 *, const char *, const char *,
const char *, void *, const char *, const N_SI4 *);
N_SI4 nusdas_read(const char *, const char *, const char *, N_SI4 *,
const char *, N_SI4 *, const char *,
const char *, void *, const char *, const N_SI4 *);
N_SI4 nusdas_iocntl(N_SI4, N_SI4);
N_SI4 nusdas_parameter_change(N_SI4, void *);
N_SI4 nusdas_allfile_close(N_SI4);
N_SI4 nusdas_close_esfflush(const char *, const char *, const char *, N_SI4 *,
                              const char *, N_SI4 *, N_SI4 *, const char);
N_SI4 nusdas_onefile_close(const char *, const char *, const char *, N_SI4 *,
                             const char *, N_SI4 *);
N_SI4 nusdas_onefile_close2(const char *, const char *, const char *, N_SI4 *,
                              const char *, N_SI4 *, N_SI4 *);
N_SI4 nusdas_esf_flush(const char *, const char *, const char *, N_SI4 *,
                         const char *, N_SI4 *);
N_SI4 nusdas_esf_flush2(const char *, const char *, const char *, N_SI4 *,
                          const char *, N_SI4 *, N_SI4 *);
N_SI4 nusdas_subc_preset1(const char *, const char *, const char *, char *,
                           N_SI4 *, float *, float *, float*);
N_SI4 nusdas_subc_sigm(const char *, const char *, const char *, N_SI4 *,
                        const char *, N_SI4 *, N_SI4 *, float *, float *,
                        float *, char *);
N_SI4 nusdas_subc_sigm2(const char *, const char *, const char *, N_SI4 *,
                         const char *, N_SI4 *, N_SI4 *, N_SI4 *, float *,
                         float *, float *, char *);
N_SI4 nusdas_subc_eta(const char *, const char *, const char *, N_SI4 *,
                        const char *, N_SI4 *, N_SI4 *, float *, float *,
                        float *, char *);
N_SI4 nusdas_subc_eta2(const char *, const char *, const char *, N_SI4 *,
                         const char *, N_SI4 *, N_SI4 *, N_SI4 *, float *,
                         float *, float *, char *);
N_SI4 nusdas_subc_tdif(const char *, const char *, const char *, N_SI4 *,
                         const char *, N_SI4 *, N_SI4 *, N_SI4 *, char *);
N_SI4 nusdas_subc_tdif2(const char *, const char *, const char *, N_SI4 *,
                          const char *, N_SI4 *, N_SI4 *,
N_SI4 *, N_SI4 *, char *);
N_SI4 nusdas_subc_srf(const char *, const char *, const char *, N_SI4 *,
                        const char *, N_SI4 *, const char *, const char *,
                        const char *, N_SI4 *, char *);
N_SI4 nusdas_subc_srf2(const char *, const char *, const char *, N_SI4 *,
                         const char *, N_SI4 *, N_SI4 *, const char *, 
const char *, const char *, const char *,
N_SI4 *, char *);
N_SI4 nusdas_info(const char *, const char *, const char *, N_SI4 *,
const char *, N_SI4 *, char *, char *, N_SI4 *,
const char *);
N_SI4 nusdas_info2(const char *, const char *, const char *, N_SI4 *,
const char *, N_SI4 *, N_SI4 *, char *, char *, N_SI4 *,
const char *);
N_SI4 nusdas_grid(const char *, const char *, const char *, N_SI4 *,
const char *, N_SI4 *, char *, N_SI4 *, float *,
char *, const char *);
N_SI4 nusdas_grid2(const char *, const char *, const char *, N_SI4 *,
const char *, N_SI4 *, N_SI4 *, char *, N_SI4 *, float *,
char *, const char *);
N_SI4 nusdas_get_size(const char *, const char *, const char *, N_SI4 *,
                        const char *, N_SI4 *, N_SI4 *);
N_SI4 nusdas_get_size2(const char *, const char *, const char *, N_SI4 *,
                         const char *, const char *, N_SI4 *, N_SI4 *, N_SI4 *);
N_SI4 nusdas_make_mask(N_UI1 *, const char *, N_SI4 *, N_UI1 *, N_SI4 *);
N_SI4 nusdas_inq_def(const char *, const char *, const char *,
N_SI4, void *, N_SI4 *);
N_SI4 nusdas_inq_cntl(const char *, const char *, const char *, N_SI4 *,
                        const char *, N_SI4 *, N_SI4, void *, N_SI4 *);
N_SI4 nusdas_inq_cntl2(const char *, const char *, const char *, N_SI4 *,
                        const char *, N_SI4 *, N_SI4 *, N_SI4, void *, N_SI4 *);
#endif

/* --- glue.c --- */
extern int      split_type(const char *type, struct nus_type_t *result);
extern int      split_dims(const char *dimsspec, const char *opt_base,
                const char *opt_member, const char *opt_valid,
                struct nus_dims_t *result);

/* --- panpath.c --- */
extern char *nusdims_to_path(const struct nus_dims_t *dp);
extern int path_to_nusdims(const char *path, struct nus_dims_t *dp);

/* --- listing.c --- */
/*
 * x (0, 0, 0, 0) ŌĂяoăZbgB
 * Ō type1, type2, type3 ŌĂяo *defnamep 𓾂B
 * 0 ԂĂ͎ĝɂȂf[^ԂĂ͂łB
 */
extern int nusdas_list_type(char *type1, char *type2, char *type3,
	char **defnamep);
extern int nusdas_find_root(const struct nus_type_t *tp, char **rootname);

/* --- listing2.c --- */
/*  nusdir ̂߂Ɏg悤ɂĂ APIB
 * w肳ꂽ NuSDaS  dp ̉ʗvfXg擾B
 * Yx^Ȃ inthandler A^Ȃ charhandler Ă΂B
 */
extern int nusdas_list_dims(const struct nus_dims_t *dp,
	void *hint,
	int (*inthandler)(void *hint, N_SI4 i),
	int (*charhandler)(void *hint, char *c, size_t len),
	int debug);

/* --- inq.c --- */
/*
 * ꗗȂǂ̖₢킹sȂBꗗɂĂ͒`t@Cł͂Ȃ
 * CNTL / DATA R[h݂邩ۂɂĂB
 * dp Ŏw肳 NuSDaS ؂ɂ query Ŏw₢킹
 * sBdp ̒̎̂₢킹ɕsvȂ͖̂̂ŁA
 * ƂΑww肵Ăw 1 Ɍ肳ȂƂB
 * ʂ query Ɉˑ₢킹vf buf Ɋi[B
 * ʂ size zĊi[邱Ƃ͂ȂB
 * ԋpl͐l̏ꍇʂ̌Al̏ꍇG[łB
 */
	extern int
nusdas_inq_bydims(const struct nus_dims_t *dp,
	int query, void *buf, size_t size);

/* --- getlist.c --- */
/*
 * ꗗ̖₢킹sB
 */
	extern 	int
nusdas_getlist_bydims(const struct nus_dims_t *dp,
	int query,			/* NUSDIMS }N̘_a */
	struct nus_dims_t **dimslist,	/* malloc ĕԂ */
	int	debug);

/* --- getlist_la.c --- */
	int
nusdas_elemlist_ladess(const struct nus_dims_t *dp,
	unsigned char	**dimslist,
	int		debug);

/* --- strerror.c --- */
/*
 * NuSDaS C^[tFCX̕ԂG[R[hɑΉ
 * bZ[WԂB
 */
extern const char *nusdas_strerror(int errcode);

/*
 === macros ===
 */

#define N_ON	1
#define N_OFF	0

#define N_FOPEN_NOT	0
#define N_FOPEN_READ	1
#define N_FOPEN_WRITE	2
#define N_FOPEN_ALL	3

#define N_PC_MISSING_UI1	1
#define N_PC_MISSING_SI2	2
#define N_PC_MISSING_SI4	3
#define N_PC_MISSING_R4		4
#define N_PC_MISSING_R8		5
#define N_PC_MASK_BIT		6
#define N_PC_ID_SET		7
#define N_PC_PACKING		8
#define N_PC_SIZEX              9
#define N_PC_SIZEY             10

#define N_IO_MARK_END    0001
#define N_IO_W_FCLOSE    0003
#define N_IO_WARNING_OUT 0004
#define N_IO_R_FCLOSE    0010

#define N_IO_PUT        "put"
#define N_IO_GET        "get"
#define N_MV_UI1	UCHAR_MAX
#define N_MV_SI2	SHRT_MIN
#define N_MV_SI4	LONG_MIN
#define N_MV_R4		FLT_MAX
#define N_MV_R8		DBL_MAX

#define N_I1	"I1"
#define N_I2	"I2"
#define N_I4	"I4"
#define N_R4	"R4"
#define N_R8	"R8"
#define N_NC    "NC"
#define N_P_1PAC        "1PAC"
#define N_P_2PAC        "2PAC"
#define N_P_4PAC        "4PAC"
#define N_P_R4          "R4  "
#define N_P_R8          "R8  "
#define N_P_I1          "I1  "
#define N_P_I2          "I2  "
#define N_P_I4          "I4  "
#define N_P_N1I2        "N1I2"
#define N_P_GRIB        "GRIB"
#define N_P_RLEN        "RLEN"

/* nusdas_inq* ֐̖₢킹ԍ */
#define N_MEMBER_NUM     0
#define N_MEMBER_LIST    1
#define N_VALIDTIME_NUM  2
#define N_VALIDTIME_LIST 3
#define N_PLANE_NUM      4
#define N_PLANE_LIST     5
#define N_ELEMENT_NUM    6
#define N_ELEMENT_LIST   7
#define N_ELEMENT_MAP    8
#define N_GRID_SIZE      9
#define N_GRID_DISTANCE 10
#define N_GRID_BASEPOINT 11
#define N_VALIDTIME_UNIT 12
#define N_VALIDTIME2_LIST 13
#define N_PLANE2_LIST     14
#define N_BASETIME_NUM	15
#define	N_BASETIME_LIST	16

#define NUSERR_NOMEM		 -10
#define NUSERR_EMPTYTYPE	 -11
#define NUSERR_BADPATHCHAR	 -12
#define NUSERR_BADTYPE	 	-13
#define NUSERR_NOTYPETAB	 -19
#define NUSERR_MAXFILES		-20
#define NUSERR_NODEF		 -21
#define NUSERR_DEFSIZE		-31
/* -32: memory shortage */
#define NUSERR_DEFEMAP		-33
#define	NUSERR_EMPTYTYPE1	-40
#define	NUSERR_EMPTYTYPE2	-41
#define NUSERR_NOTUNIQUE	 -100
#define NUSERR_BADQUERY		-101
#define	NUSERR_NODATA		-102
#define	NUSERR_BUFSHORT		-103
#define	NUSERR_INTERNAL		-104
#define	NUSERR_UNKNOWNELEM	-105
