/* -------------------------------------------------------------------------- */
/* main include file for NuSDaS program                                       */
/* -------------------------------------------------------------------------- */
/*  Ver.0.0 2000  2 10: New created                                by N.Fuji  */
/* -------------------------------------------------------------------------- */
/* -------------------------- */
/* system header file include */
/* -------------------------- */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <memory.h>
#include <malloc.h>
#include <dirent.h>
#include <errno.h>
#include <ctype.h>
#include <time.h>
#include <limits.h>
#include <float.h>

typedef unsigned char	N_UI1;
typedef short	N_SI2;
typedef unsigned short	N_UI2;
typedef int	N_SI4;
typedef unsigned int	N_UI4;
typedef struct { 
	unsigned char	c[8];
}     N_SI8;
typedef struct { 
	unsigned char	c[8];
}     N_UI8;

#define N_INFOC_MAX     10
#define N_SUBC_MAX      10

/* ------------------- */
/* NuSDaS typedef      */
/* ------------------- */

typedef struct {
	N_SI4	length_s;
	N_UI4	recname;
	N_SI4	available;
	N_SI4	creattime;
} N_ST_RI;
#define N_ST_RI_FORMAT "i4c2i"

typedef struct {
	N_ST_RI h;
	N_UI4	gname;
	N_SI4   size;
	N_UI1   * d;
	N_SI4	length_e;
} N_ST_INFO;

typedef struct {
	N_ST_RI	h;
	char	creator[80];
	N_SI4	version;
	N_UI4	filesize;
	N_SI4	rec_num;
	N_SI4	irec_num;
	N_SI4	srec_num;
	N_SI4	length_e;
} N_ST_NUSD;

   /* not including  N_ST_RI */
#define N_ST_NUSD_FORMAT "80c6i"
#define N_ST_NUSD_FORMAT_WITHOUTLEN N_ST_RI_FORMAT "80c5i"

typedef struct {
	N_ST_RI	h;
	N_UI4	filesize;
	N_SI4	rec_num;
	N_SI4	length_e;
} N_ST_END;

/* trailing length_e not included */
#define N_ST_END_FORMAT N_ST_RI_FORMAT "1f1i"

typedef struct {
	N_ST_RI	h;
	N_UI1	type[16];
	N_UI4	basetime[3];
	N_SI4	basetime_t;
	N_UI4	time_unit;
	N_SI4	n_dc;		/* descriptor */
	N_SI4	n_vt;		/* valid time */
	N_SI4	n_lv;		/* level */
	N_SI4	n_el;		/* element */
	N_UI4	projection;	/* projection method */
	N_SI4	xs, ys;		/* grid size */
	float	x0, y0;		/* base point coordinate */
	float	lat_0, lon_0;	/* base point latlon */
	float	xd, yd;		/* grid distance */
	float	lat_s1, lon_s1;	/* first standard latlon */
	float	lat_s2, lon_s2;	/* second standard latlon */
	float	lat_1, lon_1;	/* spare latlon1 */
	float	lat_2, lon_2;	/* spare latlon2 */
	N_UI4	gpv_mean;
	N_UI4	reserved_1[2];
	N_UI4	reserved_2[6];
} N_ST_CF;

    /* N_ST_RI not included */
#define N_ST_CF_FORMAT "28ci4c4i4c2i14f4c8i"
#define N_ST_CF_ALLFORMAT N_ST_RI_FORMAT "28ci4c4i4c2i14f4c8i"

typedef struct {
	N_ST_CF	f;
	N_UI4	 * dc;
	N_SI4 	 * vt1, *vt2;
	N_UI8	 * lv1, *lv2;	/* use 6 byte only */
	N_UI8	 * el;		/* use 6 byte only */
	N_SI4 	length_e;
} N_ST_CNTL;

    /* N_ST_RI not included */
#define N_ST_CNTL_FORMAT "28ci4c4i4c2i14f4c8i4c2i24ci"

typedef struct {
	N_ST_RI	h;
	N_SI4	 * offset;
	N_SI4	length_e;
} N_ST_INDX;

typedef struct {
	N_ST_RI	h;
	N_SI8	 * offset;
	N_SI4	length_e;
} N_ST_INDX_E;				/* extension for 64bit offset */

typedef struct {
	N_ST_RI	h;
	N_UI4	dc;
	N_SI4	vt1, vt2;
	N_UI1   lvel[20];	/* level[6]*2+elem[6]+yobi[2] */
	N_SI4   xs, ys;
	N_UI4	pack;
	N_UI4	miss;
	unsigned char	*d;
	N_SI4	length_e;
} N_ST_DATA;
#define N_SIZE_STDATA 64
#define N_ST_DATA_FORMAT (N_ST_RI_FORMAT "4c2i20c2i8c")

typedef struct {
	N_ST_RI h;
	N_UI4	gname;
	N_SI4	size;
	N_UI1	 * d;
	N_SI4	length_e;
} N_ST_SUBC;

typedef struct {
	N_SI4	version;
	N_SI4	path;
	char	pathname[256], filename[256];
	char	type1[256], type2[256], type3[256];
	char	creator[256];
	N_SI4	basetime_t;
	N_SI4	infile_dc;
	N_SI4	infile_vt;
	N_UI4	time_unit;
	N_SI4	n_dc;		/* descriptor */
	N_SI4	n_vt;		/* valid time */
	N_SI4	n_lv;		/* level */
	N_SI4	n_el;		/* element */
	N_UI4	projection;	/* projection */
	N_SI4	xs, ys;		/* grid size */
	float	x0, y0;		/* base point coordinate */
	float	lat_0, lon_0;	/* base point latlon */
	float	xd, yd;		/* grid distance */
	float	lat_s1, lon_s1;	/* first standard latlon */
	float	lat_s2, lon_s2;	/* second standard latlon */
	float	lat_1, lon_1;	/* spare latlon1 */
	float	lat_2, lon_2;	/* spare latlon2 */
	N_UI4 	gpv_mean;
	N_UI4	pack;
	N_UI4	miss;
	N_UI4	 * dc;
	N_SI4	 * vt1, *vt2;
	N_UI8	 * lv1, *lv2;	/* use only 6 bytes */
	N_UI8	 * el;		/* use only 6 bytes */
	N_UI1	 * elmap;		/* elmap[n_dc][n_vt][n_lv][n_el] */
	N_SI4	n_infoc;
	N_UI4	info[N_INFOC_MAX];
	char	info_file[N_INFOC_MAX][256];
	char	grib_info_file[256];
	N_SI4	n_subc;
	N_UI4	subc[N_SUBC_MAX];
	N_SI4	subc_size[N_SUBC_MAX];
	N_SI4	forced_rlen;
} N_ST_DEF;

#include "n_define.h"

extern int	errno;

#ifdef N_DEF_FILESYS_SOURCE
N_SI4	n_char_set, n_routine_d = 0;
char	n_spscanf_string[256], n_routine_name[50][40];
#else
extern N_SI4 n_char_set, n_routine_d;
extern char	n_spscanf_string[], n_routine_name[][40];
#endif

#ifdef N_DEF_RECORD_SOURCE
time_t	n_systime;
extern N_ST_SUBC n_w_subc[][N_SUBC_MAX];
extern N_SI4	 n_n_subc[];
#else
extern time_t n_systime;
#endif

#define DEBUGMARK fprintf(stderr, "#DBG %s:%d\n", __FILE__, __LINE__);
