/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    l\WCu 
 
   vfϊ֐Q

   ŏIXV | ŏIXV
   -----------+----------------------------------
   1999.07.   | l\ۃvO y

   lF
     elemsub.fɊ܂܂Tu[`QɑΉĂC֐

   QlF
     ×͊wt̎  o/  |*
     ԕ      o  *qd*sv
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "nwpl_nwpcst.h"
#include "nwpl_retcode.h"
#include "nwpl_elemsub.h"

/* --------------------------------------------------------------------------
    Cx␳
   -------------------------------------------------------------------------- */
double nwp_prsvadj(double p,double tv,double z,double gamma) {

/* 
  double p     : nC
  double tv    : ␳xł̉x
  double z     : W
  double gamma : C */

  double c,e,pp;

  c = (tv-gamma*z)/tv;
  e = grv/(Rd*gamma);
  return p*pow(c,e);
}

/* --------------------------------------------------------------------------
    C䁨x
   -------------------------------------------------------------------------- */
double nwp_rp2dz(double rp,double tv,double gamma) {

/*                                        
  double rp    : QwԂ̋C  rp=p(A)/p(B)
  double tv    : w̉x
  double gamma : C */

  double e;

  if(gamma==0.0) {               /*  */
    return Rd*tv/grv*log(rp);
  } else {
    e = -gamma*Rd/grv;
    return tv/gamma*(1-pow(rp,e));
  }
}

/* --------------------------------------------------------------------------
    xC
   -------------------------------------------------------------------------- */
double nwp_dz2rp(double dz,double tv,double gamma) {

/*                                        
  double dz    : QwԂ̍x  dz=z(B)-z(A)
  double tv    : w̉x
  double gamma : C */

  double e;

  if(gamma==0.0) {               /*  */
    return exp(grv*dz/(Rd*tv));
  } else {
    e = -grv/(Rd*gamma);
    return pow((1-gamma*dz/tv),e);
  }
}

/* --------------------------------------------------------------------------
    wx
   -------------------------------------------------------------------------- */
double nwp_th2tv(double th,double pl,double ph) {

/* F
  double th : w
  double pl : [̋C
  dobule ph : [̋C */

  double lnp;

  lnp = log(pl/ph);
  return grv*th/(Rd*lnp);
}
  
/* --------------------------------------------------------------------------
    xw
   -------------------------------------------------------------------------- */
double nwp_tv2th(double tv,double pl,double ph) {

/* F
  double tv : w
  double pl : [̋C
  dobule ph : [̋C */

  double lnp;

  lnp = log(pl/ph);
  return Rd*lnp*tv/grv;
}

/* --------------------------------------------------------------------------
    (U,V)
   -------------------------------------------------------------------------- */
void nwp_df2uv(double *u,double *v,double d,double f) {

/* F
   ȂĂ킩邾I */

  double t;

  t = d*pi/180.0;
  *u = -f*sin(t);
  *v = -f*cos(t);
}

/* --------------------------------------------------------------------------
    (U,V)
   -------------------------------------------------------------------------- */
void nwp_uv2df(double *d,double *f,double u,double v) {

/* F
   ƓI */

  double t;

  *f = sqrt(pow(u,2.0)+pow(v,2.0));
  if(*f==0.0) { 
    *d = 0.0;
  } else {
    t = asin(fabs(u)/(*f));
    if(u>=0.0 && v>=0.0) { t =   pi+t; }
    if(u>=0.0 && v< 0.0) { t = 2*pi-t; }
    if(u< 0.0 && v>=0.0) { t =   pi-t; }
    *d = t*180.0/pi;
  }
}

/* --------------------------------------------------------------------------
    ʏ(U,V)QWܐxgeʏ(U,V)
   -------------------------------------------------------------------------- */
void nwp_uv2lm(double *ul,double *vl,double u,double v,double lon,double slon, \
           double slate,double slatp) {

/* F
  (OUT) double *ul   : xgʏ̂t
  (OUT) double *vl   : xgʏ̂u
  (IN)  double u     : ʏ̂t
  (IN)  double v     : ʏ̂u
  (IN)  double lon   : n_ox
  (IN)  double slon  : xgʏł̕Wox
  (IN)  dobule slate : ԓ̕Wܐ
  (IN)  dobule slatp : ɑ̕Wܐ */

  double rad,l,t,slater,slatpr;
  rad = pi/180.0;
  slater = slate*rad;
  slatpr = slatp*rad;
  l = log(sin(slater)/sin(slatpr))/log(tan(slater/2.0)/tan(slatpr/2.0));
  t = (lon-slon)*rad*l;

  *ul = u*cos(t)-v*sin(t);
  *vl = u*sin(t)+v*cos(t);
}

/* --------------------------------------------------------------------------
    QWܐxgeʏ(U,V)ʏ(U,V)
   -------------------------------------------------------------------------- */
void nwp_lm2uv(double *u,double *v,double ul,double vl,double lon,double slon, \
           double slate,double slatp) {

/* F
  (OUT) double *u    : ʏ̂t
  (OUT) double *v    : ʏ̂u
  (IN)  double ul    : xgʏ̂t
  (IN)  double vl    : xgʏ̂u
  (IN)  double lon   : n_ox
  (IN)  double slon  : xgʏł̕Wox
  (IN)  dobule slate : ԓ̕Wܐ
  (IN)  dobule slatp : ɑ̕Wܐ */

  double rad,l,t,slater,slatpr;

  rad = pi/180.0;
  slater = slate*rad;
  slatpr = slatp*rad;
  l = log(sin(slater)/sin(slatpr))/log(tan(slater/2.0)/tan(slatpr/2.0));
  t = (lon-slon)*rad*l;

  *u =  ul*cos(t)+vl*sin(t);
  *v = -ul*sin(t)+vl*cos(t);
}

/* --------------------------------------------------------------------------
    C^OaC(Teten ̎)
   -------------------------------------------------------------------------- */
double nwp_teten(double t) {

  const double e0=6.11,al=17.3,bl=237.3,ai=21.9,bi=265.3;
  double tc;

  tc = t-t0;
  if(tc>=0.0) {             /* ɑ΂OaC */
    return e0*exp(al*tc/(bl+tc));
  } else if(tc<=-15.0) {    /* Xɑ΂OaC */
    return e0*exp(ai*tc/(bi+tc));
  } else {                  /* ƕX */
    return e0*(exp(al*tc/(bl+tc))*(15.0+tc)/15.0\
              +exp(ai*tc/(bi+tc))*(    -tc)/15.0);
  }
}

double nwp_rvteten(double e) {

  const double e0=6.11,al=17.3,bl=237.3,ai=21.9,bi=265.3;
  double el,ei,tc,em15,cc,t;
  double ee[151],tt[151];
  int i;

  em15 = nwp_teten(t0-15.0);
  for (i=0; i<151; i++) {
    tt[i] = -0.1*i;
    el = e0*exp(al*tt[i]/(bl+tt[i]));
    ei = e0*exp(ai*tt[i]/(bi+tt[i]));
    ee[i] = (el*(15.0+tt[i])-ei*tt[i])/15.0;
  }
  if(e<=em15) {              /* X */
    cc = log(e/e0);
    t = bi*cc/(ai-cc)+t0;
  } else if(e>=e0) {         /*  */
    cc = log(e/e0);
    t = bl*cc/(al-cc)+t0;
  } else {                   /* X */
    for (i=1; i<151; i++) {
      if(ee[i]<e) {
        t = tt[i]-(tt[i-1]-tt[i])*(ee[i-1]-e)/(ee[i-1]-ee[i])+t0;
        break;
      }
    }
  }
  return t;
}

/* --------------------------------------------------------------------------
    x^C
   -------------------------------------------------------------------------- */
double nwp_tv2t(double tv,double q) {
  return tv/(1.0+0.608*1.0e-3*q);
}
double nwp_t2tv(double t,double q) {
  return (1.0+0.608*1.0e-3*q)*t;
}

/* --------------------------------------------------------------------------
    x^䎼
   -------------------------------------------------------------------------- */
double nwp_tv2q(double tv,double t) {
  return (tv/t-1.0)/0.608*1.0e+3;
}
double nwp_q2tv(double q,double t) {
  return (1.0+0.608*q*1.0e-3)*t;
}

/* --------------------------------------------------------------------------
    ^䎼
   -------------------------------------------------------------------------- */
double nwp_r2q(double r) {
  return r/(1.0+r*1.0e-3);
}
double nwp_q2r(double q) {
  return q/(1.0-q*1.0e-3);
}

/* --------------------------------------------------------------------------
    C^䎼
   -------------------------------------------------------------------------- */
double nwp_vp2q(double e,double p) {
  return e*MvMd/(p-(1.0-MvMd)*e)*1.0e+3;
}
double nwp_q2vp(double q,double p) {
  return p*q*1.0e-3/(MvMd+q*1.0e-3*(1.0-MvMd));
}

/* --------------------------------------------------------------------------
    C^
   -------------------------------------------------------------------------- */
double nwp_vp2r(double e,double p) {
  return e*MvMd/(p-e)*1.0e+3;
}
double nwp_r2vp(double r,double p) {
  return p*r*1.0e-3/(MvMd+r*1.0e-3);
}

/* --------------------------------------------------------------------------
    I_x^Ύx
   --------------------------------------------------------------------------*/
double nwp_td2rh(double td,double t) {
  return nwp_teten(td)/nwp_teten(t)*100.0;
}
  
double nwp_rh2td(double rh,double t) {
  double es,e;
  es = nwp_teten(t);
  e = es*rh/100.0;
  return nwp_rvteten(e);
}

/* --------------------------------------------------------------------------
    䎼^I_x
   -------------------------------------------------------------------------- */
double nwp_q2td(double q,double p) {
  return nwp_rvteten(nwp_q2vp(q,p));
}
double nwp_td2q(double td,double p) {
  return nwp_vp2q(nwp_teten(td),p);
}
/* --------------------------------------------------------------------------
    䎼^Ύx
   -------------------------------------------------------------------------- */
double nwp_q2rh(double q,double t,double p) {
  double es,e;
  es = nwp_teten(t);
  e = nwp_q2vp(q,p);
  return e/es*100.0;
}
double nwp_rh2q(double rh,double t,double p) {
  double e;
  e = rh/100.0*nwp_teten(t);
  return nwp_vp2q(e,p);
}
/* --------------------------------------------------------------------------
    ^Ύx
   -------------------------------------------------------------------------- */
double nwp_r2rh(double r,double t,double p) {
  double es,e;
  es = nwp_teten(t);
  e = nwp_r2vp(r,p);
  return e/es*100.0;
}
double nwp_rh2r(double rh,double t,double p) {
  double e;
  e = rh/100.0*nwp_teten(t);
  return nwp_vp2r(e,p);
}
/* --------------------------------------------------------------------------
    C^Ύx
   -------------------------------------------------------------------------- */
double nwp_vp2rh(double e,double t) {
  return e/nwp_teten(t)*100.0;
}
double nwp_rh2vp(double rh,double t) {
  return rh/100.0*nwp_teten(t);
}
/* --------------------------------------------------------------------------
    x^Ύx
   -------------------------------------------------------------------------- */
double nwp_tv2rh(double tv,double t,double p) {
  double q,es,e;
  q = nwp_tv2q(tv,t);
  e = nwp_q2vp(q,p);
  es = nwp_teten(t);
  return e/es*100.0;
}
double nwp_rh2tv(double rh,double t,double p) {
  double e,q;
  e = rh/100.0*nwp_teten(t);
  q = nwp_vp2q(e,p);
  return nwp_t2tv(t,q);
}
/* --------------------------------------------------------------------------
    I_x^x
   -------------------------------------------------------------------------- */
double nwp_td2tv(double td,double t,double p) {
  double e,q;
  e = nwp_teten(td);
  q = nwp_vp2q(e,p);
  return nwp_t2tv(t,q);
}
double nwp_tv2td(double tv,double t,double p) {
  double q,e;
  q = nwp_tv2q(tv,t);
  e = nwp_q2vp(q,p);
  return nwp_rvteten(e);
}
/* --------------------------------------------------------------------------
    C^
   -------------------------------------------------------------------------- */
double nwp_t2pt(double t,double p) {
  return t*pow((1000.0/p),Rd/Cpd);
}
double nwp_pt2t(double pt,double p) {
  return pt*pow((1000.0/p),-Rd/Cpd);
}
/* --------------------------------------------------------------------------
    CE䎼
   -------------------------------------------------------------------------- */
double nwp_t2ept(double t,double q,double p) {
  double r,te;
  r = nwp_q2r(q)*1.0e-3;
  te = t*exp(Lv*r/(Cpd*t));
  return nwp_t2pt(te,p);
}
