/*
** jdsqcv.c (include Fortran I/F) ** 95.5.16-
**	NPD/JMA
**
**	$Header: /cvsroot/pandora/pnusdas/src/nwpl_jikken_lib.c,v 1.2 2002/03/27 10:13:40 suuchi43 Exp $
**	$Source: /cvsroot/pandora/pnusdas/src/nwpl_jikken_lib.c,v $
**
** iseq = nwp_ymdhm2seq (iy,im,id,ih,imn)
** iseq = nwp_ymdh2seq  (iy,im,id,ih)
** iseq = nwp_ymd2seq   (iy,im,id)
** void   nwp_seq2ymdhm (py,pm,pd,ph,pmn, iseq)
** void   nwp_seq2ymdh  (py,pm,pd,ph,     iseq)
** void   nwp_seq2ymd   (py,pm,pd,        iseq)
*/

#include <stdio.h>
/* #include "nwpl_timecnv.h" */

/**/

int
nwp_ymd2seq (int iy, int im, int id)
{
  int  iseq;
  if (im<=2) { --iy; im+=12; }
  iseq=(int)(365.25*(iy-1800)-306);
  iseq=iseq-((((iy-1500)/100)*3/4)-2);
  iseq=iseq+(int)(30.6*(im-3)+0.5)+id;
  return (iseq);
}

int
nwp_ymdh2seq (int iy, int im, int id, int ih)
{ return ((nwp_ymd2seq(iy,im,id)-1)*24+ih); }

int
nwp_ymdhm2seq (int iy, int im, int id, int ih, int imn)
{ return (nwp_ymdh2seq(iy,im,id,ih)*60+imn); }

/*
*/

void
nwp_seq2ymd (int *py, int *pm, int *pd, int iseq)
{
  int k;

  for ( *py=(int)((iseq+306-0.1)/365.25)+1802;
       (k=((int)(365.25*(*py-1801)-306))-((((*py-1501)/100)*3/4)-2)) >= iseq;
        --*py)
  ;
  iseq-=k;  *pm=(int)((iseq-0.5)/30.6)+3;
  k=(int)(30.6*(*pm-3)+0.5);  *pd=iseq-k;
  if (*pm>12) { *pm-=12; ++*py; }
  --*py;
  return;
}

void
nwp_seq2ymdh (int *py, int *pm, int *pd, int *ph, int iseq)
{ *ph=iseq%24; nwp_seq2ymd(py,pm,pd, iseq/24+1); return; }

void
nwp_seq2ymdhm (int *py, int *pm, int *pd, int *ph, int *pmn, int iseq)
{ *pmn=iseq%60; nwp_seq2ymdh(py,pm,pd,ph, iseq/60); return; }

/*
** Fortran I/F
*/

void NWP_YMDHM2SEQ (int *py, int *pm, int *pd, int *ph, int *pmn, int *pseq)
{*pseq=nwp_ymdhm2seq(*py,*pm,*pd,*ph,*pmn);}

void NWP_YMDH2SEQ (int *py, int *pm, int *pd, int *ph, int *pseq)		
{*pseq=nwp_ymdh2seq (*py,*pm,*pd,*ph);}

void NWP_YMD2SEQ (int *py, int *pm, int *pd, int *pseq)
{*pseq=nwp_ymd2seq  (*py,*pm,*pd);}

void NWP_SEQ2YMDHM (int *py, int *pm, int *pd, int *ph, int *pmn, int *pseq)
{nwp_seq2ymdhm(py,pm,pd,ph,pmn, *pseq);}

void NWP_SEQ2YMDH (int *py, int *pm, int *pd, int *ph, int *pseq)
{nwp_seq2ymdh (py,pm,pd,ph, *pseq);}

void NWP_SEQ2YMD (int *py, int *pm, int *pd, int *pseq)
{nwp_seq2ymd  (py,pm,pd, *pseq);}

