/*
 * NuSDaS [gċAIɒTĖR[hs߂̃[`
 */

#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include "nwpl_string.h"
#include "recursive.h"


/** (ɂׂł͂Ȃ)
 * NuSDaS t@CXg[ fp  1 R[hǂ݂ƂB
 */
	unsigned char *
nus_read_record(FILE *fp, size_t *recl)
{
	unsigned char head[8];
	unsigned char *buf, *tail;
	size_t	reclen, readsize;

	if (recl)
		*recl = 0;
	if (fread(head, 1, 8, fp) < 8)
		return NULL;

	reclen = btol(head);
	buf = malloc(reclen);
	if (buf == NULL)
		return NULL;
	memcpy(buf, head + 4, 4);

	readsize = reclen - 8;
	if (fread(buf + 4, 1, readsize, fp) < (readsize)) {
		errprintf("# file too short for %d\n", (int)reclen);
		free(buf);
		return NULL;
	}

	tail = buf + reclen - 8;
	if (memcmp(head, tail, 4) != 0) {
		errprintf("# head %d not match to tailer %ld\n", (int)reclen, btol(tail));
		free(buf);
		return NULL;
	}
	if (recl)
		*recl = reclen - 8;
	return buf;
}

/*
 * t@CɌĂяo
 */

	static int
file_search(const char *filename, void *sp,
	int (*rh)(const char *filename, const unsigned char *rec, void *sp))
{
	FILE *fp;
	unsigned char *rec, *p;
	size_t	recl;
	int	r;

	fp = fopen(filename, "rb");
	if (fp == NULL) {
		errprintf("unreadable file '%s' ignored\n", filename);
		return 0;
	}

	r = 0;
	while ((rec = nus_read_record(fp, &recl)) != NULL) {
		r = rh(filename, rec, sp);
		free(rec);
		if (r)
			break;
	}
	fclose(fp);
	if (r == RET_SKIPFILE)
		r = 0;
	return r;
}

/*
 * fBNgT[`čċATsB
 */
	int
recursive_search(const char *path, void *sp,
	int (*rh)(const char *filename, const unsigned char *rec, void *sp))
{
	DIR	*dir;
	int	r;

	if ((dir = opendir(path)) != NULL) {
		struct dirent *entry;
		r = 0;
		while ((entry = readdir(dir)) != NULL) {
			char	*fnam = entry->d_name;
			char	*subpath;
			if (fnam[0] == '.' || strncmp(fnam, "dummy", 5) == 0)
				continue;
			subpath = strdup3(path, "/", fnam);
			r = recursive_search(subpath, sp, rh);
			free(subpath);
			if (r == RET_BADSUBDIR)
				r = 0;
			if (r == RET_BADDIR)
				r = RET_BADSUBDIR;
			if (r)
				break;
		}
		closedir(dir);
		return r;
	} else {
		r = file_search(path, sp, rh);
		return r;
	}
}
