/* rmatch - ɂ߂ĊȈՂȐK\pbP[W
 * Copyright (C) by GFD-Dennou Club, 2002.  All rights reserved.
 */

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include "nwpl_string.h"

static char rcsid[] = "$Id: regmatch.c,v 1.1 2002/03/28 00:39:07 suuchi43 Exp $";

#define streq(a, b) (strcmp((a), (b)) == 0)

#ifdef DEBUG
#define DPRINT printf
#else
#define DPRINT
#endif

/**
 * ԋpl: }b`΃}b`, łȂ -1.
 */
	static long
match_here(const char *pattern, const char *text)
{
	int	c;
	long	i, n, hitmax, hitmin, hitcount;

	DPRINT("local \"%s\" \"%s\"\n", pattern, text);
	/* p^[ɂ͉ł}b` */
	if (*pattern == '\0') {
		DPRINT("accepted with empty pattern\n");
		return 0;
	}
	/* Œw`FbN */
	if (streq(pattern, "$")) {
		DPRINT("termination check\n");
		return (*text == '\0') ? 0 : -1;
	}
	if (*text == '\0') {
		DPRINT("end of text\n");
		return -1;
	}

	/* 1o */
	if (*pattern == '\\')
		pattern++;
	c = (unsigned char)*pattern;
	pattern++;

	/* ȗ\ȗʉqo */
	switch (*pattern) {
	case '+':
		hitmax = strlen(text);
		hitmin = 1;
		pattern++;
		break;
	case '*':
		hitmax = strlen(text);
		hitmin = 0;
		pattern++;
		break;
	case '?':
		hitmax = 1;
		hitmin = 0;
		pattern++;
		break;
	default:
		hitmax = 1;
		hitmin = 1;
		break;
	}

	/* qbg`FbN */
	hitcount = i = 0;
	while (i < hitmax) {
		if (text[i] != c)
			break;
		hitcount = i + 1;
		i++;
	}
	
	/* qbg1ȏオvĂĖqbgȂ΂Ŏs */
	if (hitcount < hitmin) {
		DPRINT("no hit\n");
		return -1;
	}

	/* Œ */
	for (i = hitcount; i >= hitmin; i--) {
		n = match_here(pattern, text + i);
		DPRINT(" where=%d offset=%d\n", (int)n, (int)i);
		if (n >= 0) {
			return i + n;
		}
	}
	return -1;
}

/**
 * ԋpl: }b` (}b`ʒu + 1), łȂ 0.
 * length: NULL łȂꍇA*length Ƀ}b` (or -1) i[
 */
	long
regmatch(const char *pattern, const char *text, long *length)
{
	long	len;
	long	ofs;

	DPRINT("MATCH \"%s\" \"%s\"\n", pattern, text);
	/* NULL ɂ̓}b`Ȃ */
	if (pattern == NULL || text == NULL) {
		len = -1;
		ofs = -1;
		goto End;
	}
	/* 󕶎͋󕶎Ƀ}b` */
	if (*pattern == '\0') {
		len = 0;
		ofs = 0;
		goto End;
	}

	/* 񂹎ŵꍇ */
	if (*pattern == '^') {
		len = match_here(pattern + 1, text);
		DPRINT(" len = %d\n", (int)len);
		ofs = (len < 0) ? -1 : 0;
		goto End;
	}

	/* ō */
	for (ofs = 0; ofs < strlen(text); ofs++) {
		len = match_here(pattern, text + ofs);
		DPRINT(" len = %d\n", (int)len);
		if (len >= 0)
			goto End;
	}
	len = -1;
	ofs = -1;

End:
	if (len < 0) ofs = -1;
	if (length)
		*length = len;
	return ofs + 1;
}

	char *
regreplace(const char *pattern, const char *replace, const char *text)
{
	long	where, len, replen, taillen, alllen;
	char	*new;

	where = regmatch(pattern, text, &len) - 1;
	if (where < 0) {
		new = malloc(strlen(text) + 1);
		if (new == NULL) return NULL;
		strcpy(new, text);
		return new;
	}

	replen = strlen(replace);
	taillen = strlen(text) - where - len;
	alllen = where + replen + taillen;
	new = malloc(alllen + 1);
	if (new == NULL) return NULL;
	if (where)
		memcpy(new + 0, text, where);
	if (replen)
		memcpy(new + where, replace, replen);
	if (taillen)
		memcpy(new + where + replen, text + where + len, taillen);
	new[alllen] = '\0';

	return new;
}


#ifdef DEBUG_MAIN
	int
main(int argc, char **argv)
{
	if (argc > 2 && streq(argv[1], "grep")) {
		char	buf[1002];
		long	len, where;
		printf("grep: <%s>\n", argv[2]);
		while (fgets(buf, 1000, stdin) != NULL) {
			char *p;
			p = strchr(buf, '\n');
			if (p) *p = '\0';
			where = regmatch(argv[2], buf, &len) - 1;
			if (where < 0)
				continue;
			printf("%02d:%02d: %s\n", (int)where, (int)len, buf);
		}
	} else if (argc > 3 && streq(argv[1], "sub")) {
		char	buf[1002];
		long	len, where;
		while (fgets(buf, 1000, stdin) != NULL) {
			char *p;
			p = strchr(buf, '\n');
			if (p) *p = '\0';
			if (p = regreplace(argv[2], argv[3], buf)) {
				printf("%s\n", p);
				free(p);
			}
		}
	} else {
		printf("usage: \n"
			"a.out grep <pattern>\n"
			"a.out sub <pattern> <replace>\n");
	}

	return 0;
}
#endif
