#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "nusdas.h"
#include "nwpl_string.h"

static char rcsid[] = "$Id: str.c,v 1.10 2002/04/05 11:48:32 suuchi43 Exp $";

/* streqi - 啶𖳎̓
 */
	int
streqi(const char *a, const char *b)
{
	int	ia, ib;
	for (;;) {
		ia = toupper(*a);
		ib = toupper(*b);
		if ((ia == 0) && (ib == 0))
			return 1;
		if (ia != ib)
			return 0;
		a++;
		b++;
	}
}

/* memeqi - 啶𖳎̓
 */
	int
memeqi(const char *a, const char *b, size_t n)
{
	int	ia, ib;
	size_t	i;
	for (i = 0; i < n; i++) {
		ia = toupper(*a);
		ib = toupper(*b);
		if ((ia == 0) && (ib == 0))
			return 1;
		if (ia != ib)
			return 0;
	}
	return 1;
}

/* strdup3 - ̘AƊt
 * ő3CAAmalloc ŊẗɊi[ĕԂB
 * i|C^͋󕶎ƓꎋB
 */
	char *
strdup3(const char *a, const char *b, const char *c) {
	char 		*result;
	unsigned	la, lb, lc;
	if (a == NULL) a = "";
	if (b == NULL) b = "";
	if (c == NULL) c = "";
	la = strlen(a);
	lb = strlen(b);
	lc = strlen(c);
	result = malloc(la + lb + lc + 1);
	if (!result) return NULL;
	strncpy(result, a, la);
	strncpy(result + la, b, lb);
	strncpy(result + la + lb, c, lc);
	result[la + lb + lc] = '\0';
	return result;
}

/* indexc - Fortran  INDEX ֐̑Ή
 * C  string ̒ɕ c ΁A̍ŏ̏oʒũItZbg
 * ԂB݂Ȃ΁A邢 string i|C^A
 * -1 ԂB
 * Fortran  INDEX ƈقȂAԋpl 0 ́uŏ̕ c vłB
 */

	int
indexc(const char *string, char c)
{
	char	*p;
	if (string == NULL) return -1;
	p = strchr(string, c);
	if (p == NULL) return -1;
	return p - string;
}

/* string_copy - S strncpy(3)
 * src  size-1 oCg dest ɕʂAK NUL ~߂B
 * { C ̕Rs[ƂĎgׂC^[tFCXB
 */
	char *
string_copy(char *dest, size_t size, const char *src)
{
	size_t	len;
	len = strlen(src);
	if (len > size - 1)
		len = size - 1;
	strncpy(dest, src, len);
	dest[len] = '\0';
	return dest + len;
}

/* string_to_fstring - C 񂩂 Fortran ւ̕ϊ
 * C  src 璷 size  Fortran  dest ɕʂB
 * Fortran ̕ƓlAsrc Z΃Xy[X𖄂߁A
 * src ΉE؂̂ĂB
 */
	void
string_to_fstring(char *dest, size_t size, const char *src)
{
	size_t len;
	len = strlen(src);
	if (len > size)
		len = size;
	strncpy(dest, src, len);
	if (len < size)
		memset(dest + len, ' ', size - len);
}

/* fstring_to_fstring - Fortran ǂ̕
 *  ssize  Fortran  src 璷 dsize ̗̈ dest ɕʂB
 * Fortran ̕ƓlAsrc Z΃Xy[X𖄂߁A
 * src ΉE؂̂ĂB
 */
	void
fstring_to_fstring(char *dest, const size_t dsize, const char *src, const size_t ssize)
{
	size_t len;
	len = ssize;
	if (len > dsize)
		len = dsize;
	memmove(dest, src, len);
	if (dsize > len)
		memset(dest + len, ' ', dsize - len);
}

/* fstring_to_string - Fortran 񂩂 C ւ̕ϊ
 *  ssize  Fortran  src 璷 dsize ̗̈ dest ɕʂB
 * src ̋󔒂͐؂̂ĂANUL ~߂ C ƂȂB
 * src ΉE؂̂ĂBԋpl dest [̃|C^B
 */
	char *
fstring_to_string(char *dest, const size_t dsize, const char *src, const size_t ssize)
{
	size_t		len, ofs;
	int		spc;
	len = dsize - 1;
	if (len > ssize)
		len = ssize;
	dest[len] = '\0';
	ofs = len - 1;
	spc = 1;
	while (1) {
		if (!spc) {
			dest[ofs] = src[ofs];
		} else if (src[ofs] == ' ') {
			dest[ofs] = '\0';
			len = ofs;
		} else {
			spc = 0;
			dest[ofs] = src[ofs];
		}
		if (ofs == 0) break;
		ofs--;
	}
	return dest + len;
}

/* replace_space - Fortran 񂩂\p C ւ̂̏ϊ
 * buf  len ͈̔͂̔}` '_' ɕϊANUL ~߂B
 * buf ɂ len + 1 ̏݉\̈悪Ȃ΂ȂȂB
 */
	int
replace_space(char *buf, unsigned len)
{
	char	*p;
	for (p = buf; p < (buf + len); p++) {
		if (*p == '\0') break;
		if (!isgraph(*p)) *p = '_';
	}
	while (p < buf + len) {
		 *p++ = '_';
	}
	buf[len] = '\0';
	return 0;
}

/* fmatch - VFK\pbP[W
 * text  pattern Ƀ}b`Ȃ^()Ԃ
 */

	/* fmatch p̍ƗpTu[` */
	static int
match_star(const char *pattern, const char *text)
{
	for (;;) {
		if (fmatch(pattern, text))
			return 1;
		if (*text == '\0')
			return 0;
		text++;
	}
}

	int
fmatch(const char *pattern, const char *text)
{
	int	r;
	if (pattern[0] == '\0')
		return *text == '\0';
	if (pattern[0] == '*')
		return match_star(pattern+1, text);
	if (*text == '\0')
		return 0;
	if (*pattern == '?' || *pattern == *text) {
		r = fmatch(pattern+1, text+1);
		return r;
	}
	return 0;
}
