#line 1 "wrapf90.ca"

# include "nusdas_sys.h"
# include "config_fortran.h"
# define CHAR char
# define INTEGER int
# define REAL float
# define DOUBLE double

#line 1385 "wrapf90.ca"

int

#ifdef C_FORTRAN_UPPER
NWPD_MF_PS
#else
#  ifdef C_FORTRAN_LOWER_
nwpd_mf_ps_
#  else
fnwpd_mf_ps
#  endif
#endif

#line 1389 "wrapf90.ca"
(DOUBLE *mf,DOUBLE *lat,INTEGER *im,INTEGER *jm,DOUBLE *slat) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL) {
    printf("NWP_MF_PS: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL) {
      printf("NWP_MF_PS: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp2[j][i] = lat[ij++];
    }
  } 

  nwp_mf_ps(tmp1,tmp2,*im,*jm,*slat);

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      mf[ij++] = tmp1[j][i];
    }
  } 
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
  }
  free(tmp1);
  free(tmp2);
}

