#line 1 "wrapf90.ca"

# include "nusdas_sys.h"
# include "config_fortran.h"
# define CHAR char
# define INTEGER int
# define REAL float
# define DOUBLE double

#line 900 "wrapf90.ca"

int

#ifdef C_FORTRAN_UPPER
NWPD_MPROJ_LL2LM
#else
#  ifdef C_FORTRAN_LOWER_
nwpd_mproj_ll2lm_
#  else
fnwpd_mproj_ll2lm
#  endif
#endif

#line 904 "wrapf90.ca"
(DOUBLE *fi,DOUBLE *fj,DOUBLE *lat,DOUBLE *lon,INTEGER *im, 
 INTEGER *jm,DOUBLE *dels,DOUBLE *slate,DOUBLE *slatp,DOUBLE *slon,DOUBLE *xi,
 DOUBLE *xj,DOUBLE *xlat,DOUBLE *xlon) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2,**tmp3,**tmp4;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  tmp3 = (double **)malloc(sizeof(double *)*(*jm));
  tmp4 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL || tmp3==NULL || tmp4==NULL) {
    printf("NWP_MPROJ_LL2LM: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    tmp3[j] = (double *)malloc(sizeof(double)*(*im));
    tmp4[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL || tmp3[j]==NULL || tmp4[j]==NULL) {
      printf("NWP_MPROJ_LL2LM: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }
  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      tmp3[j][i] = lat[ij];
      tmp4[j][i] = lon[ij];
      ij++;
    }
  }

  nwp_mproj_ll2lm(tmp1,tmp2,tmp3,tmp4,*im,*jm,*dels,*slate,*slatp,*slon,*xi,  \
      *xj,*xlat,*xlon);

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      fi[ij] = tmp1[j][i];
      fj[ij] = tmp2[j][i];
      ij++;
    }
  } 
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
    free(tmp3[j]);
    free(tmp4[j]);
  }
  free(tmp1);
  free(tmp2);
  free(tmp3);
  free(tmp4);
}


