#line 1 "wrapf90.ca"

# include "nusdas_sys.h"
# include "config_fortran.h"
# define CHAR char
# define INTEGER int
# define REAL float
# define DOUBLE double

#line 762 "wrapf90.ca"

int

#ifdef C_FORTRAN_UPPER
NWPS_MPROJ_PS2LL
#else
#  ifdef C_FORTRAN_LOWER_
nwps_mproj_ps2ll_
#  else
fnwps_mproj_ps2ll
#  endif
#endif

#line 766 "wrapf90.ca"
(REAL *lat,REAL *lon,INTEGER *im,INTEGER *jm,REAL *dels,     \
    REAL *slat,REAL *slon,REAL *xi,REAL *xj,REAL *xlat,REAL *xlon) {

#include "nwpl_retcode.h"

  double **tmp1,**tmp2;
  int i,j,ij;

  tmp1 = (double **)malloc(sizeof(double *)*(*jm));
  tmp2 = (double **)malloc(sizeof(double *)*(*jm));
  if(tmp1==NULL || tmp2==NULL) {
    printf("NWP_MPROJ_PS2LL: Memory allocate error.\n");
    return NWPL_ERROR_MALLOC;
  }
  for(j=0; j<(*jm); j++) {
    tmp1[j] = (double *)malloc(sizeof(double)*(*im));
    tmp2[j] = (double *)malloc(sizeof(double)*(*im));
    if(tmp1[j]==NULL || tmp2[j]==NULL) {
      printf("NWP_MPROJ_PS2LL: Memory allocate error.\n");
      return NWPL_ERROR_MALLOC;
    }
  }

  nwp_mproj_ps2ll(tmp1,tmp2,*im,*jm,(double)(*dels),(double)(*slat), \
     (double)(*slon),(double)(*xi),(double)(*xj),(double)(*xlat), \
     (double)(*xlon));

  ij=0;
  for(j=0; j<(*jm); j++) {
    for(i=0; i<(*im); i++) {
      lat[ij] = tmp1[j][i];
      lon[ij] = tmp2[j][i];
      ij++;
    }
  } 
  for(j=0; j<(*jm); j++) {
    free(tmp1[j]);
    free(tmp2[j]);
  }
  free(tmp1);
  free(tmp2);
}

